import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.HashMap;
import java.sql.SQLException;
import java.math.BigDecimal;

public class AcctFullPaid
{
 private JFrame frame;
 private JTable table;
 private int action = 0;
 private tableData td = null;
 private String sendContent = null;
 private StringBuffer error = new StringBuffer();
 private JLabel labelTotal = new JLabel();
 private JLabel labelTotal2= new JLabel();
 private JButton refreshB = new JButton("Refresh");
 private JButton closeB = new JButton("Close");
 private BigDecimal totalBal = null;
 private MultipleCurrency mc = new MultipleCurrency();
 private JList head = null;
 private SortedColumnHeaderRenderer schr = null;
 private SortedTableModel sortedModel = null;

 public AcctFullPaid(int act,String cont)
 { 
  if(act>0) action = act; 
  else error.append("Received no value for Action\n");
  if(cont!=null) sendContent = new String(cont);
  else error.append("Received null value for Content\n");
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR RECEIVING");
   error.delete(0,error.length());
   System.gc(); 
   return;
  }
  Vector v = getPaid(action,sendContent);
  if(v == null || error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   error.delete(0,error.length());
   System.gc();
   return;
  }
  frame = new JFrame();
  switch(action)
  {
   case Module7.SARREF : 
    frame.setTitle("Detail A/R by Ref No. "+sendContent);
    break;
   case Module7.PSAPREF: 
    frame.setTitle("Detail A/P by Ref No. "+sendContent); 
    break;
   case Module7.SARNM  : 
    frame.setTitle("Detail A/R by Customer Name "+sendContent);
    break;
   case Module7.PSAPNM : 
    frame.setTitle("Detail A/P by Trucking Name "+sendContent); 
    break;
   default : 
    Module7.errorDisplay("No service avail for action: "+action,"ERROR");
    return;
  }
  td = new tableData(v);
  sortedModel = new SortedTableModel(td);
  head = new JList(new ListMod(v.size()));
  table = new JTable(); 
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(td);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  schr = new SortedColumnHeaderRenderer(sortedModel,mlhr);
  int len = td.colLength;
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i==td.RFNO||i==td.TYPE||i==td.CURR)
    column=new TableColumn(i,10,render,editor);
   else
    column=new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(schr);
   table.addColumn(column);
  }
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(table),BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(act),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Close in the panel instead","Info");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain(JTable tab)
 {
  JPanel panel = new JPanel();
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(tab);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  addHeaderListener();
  return panel;
 }

 private JPanel createBottom(int act)
 {
  ButtonListener bl = new ButtonListener();
  refreshB.addActionListener(bl);
  closeB.addActionListener(bl);

  JPanel panel = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill   = GridBagConstraints.BOTH;
  gbc.gridx  = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  gbc.gridwidth = 3;
  gbc.gridy = 0;
  if(act == Module7.SPARREF || act == Module7.SPARNM)
  {
   panel.add(new JLabel("Total A/R Paid :"),gbc);
   labelTotal.setText(mc.getCurr(0)+" "+
    Module7.formNumDelimiter(mc.getSumAR(0).toString()));
   labelTotal2.setText(mc.getCurr(1)+" "+
    Module7.formNumDelimiter(mc.getSumAR(1).toString()));
  }
  else
  {
   panel.add(new JLabel("Total A/P Paid :"),gbc);
   labelTotal.setText(mc.getCurr(0)+" "+
    Module7.formNumDelimiter(mc.getSumAP(0).toString()));
   labelTotal2.setText(mc.getCurr(1)+" "+
    Module7.formNumDelimiter(mc.getSumAP(1).toString()));
  }
  panel.add(labelTotal,gbc);
  panel.add(labelTotal2,gbc);
  gbc.gridy++;
  gbc.gridwidth = 2;
  panel.add(refreshB,gbc);
  panel.add(closeB,gbc);
  return panel;
 }

 private String formQuery(int act,String str)
 {
  StringBuffer q = new StringBuffer(128);
  if(act == Module7.SARREF)
  {
   q.append("LEFT JOIN accountReceivable ON (accountReceivable.");
   q.append("acctRecFromRefKey=transRecord.transRefKey) ");
   q.append("LEFT JOIN customer ON (customer.customerKey=");
   q.append("transRecord.transCustKey) ");
   q.append("WHERE transRecord.transRefKey="+str+" AND ");
   q.append("acctRecPaidFull=\"Y\";");
  }
  else if(act == Module7.PSAPREF)
  {
   q.append("LEFT JOIN accountPayable ON (accountPayable.");
   q.append("acctPayToRefKey=transRecord.transRefKey) ");
   q.append("LEFT JOIN truckingCompany ON (truckingCompany.");
   q.append("truckingCompanyKey=transRecord.transTrucking) ");
   q.append("WHERE transRecord.transRefKey="+str+" AND ");
   q.append("acctPayPaidFull=\"Y\";");
  }
  else if(act == Module7.SARNM)
  {
   q.append("LEFT JOIN transRecord ON (transRecord.");
   q.append("transCustKey=customer.customerKey) ");
   q.append("LEFT JOIN accountReceivable ON (accountReceivable.");
   q.append("acctRecFromRefKey=transRecord.transRefKey) ");
   q.append("WHERE customerName=\""+str+"\" AND ");
   q.append("acctRecPaidFull=\"Y\";");
  }
  else
  {
   q.append("LEFT JOIN transRecord ON (transRecord.");
   q.append("transTrucking=truckingCompany.truckingCompanyKey) ");
   q.append("LEFT JOIN accountPayable ON (accountPayable.");
   q.append("acctPayToRefKey=transRecord.transRefKey) ");
   q.append("WHERE truckingName=\""+str+"\" AND ");
   q.append("acctPayPaidFull=\"Y\";");
  }
  return q.toString();
 }

 public Vector getPaid(int act,String str)
 {
  DBConnect db = new DBConnect();
  String query = null;
  Vector v = null;
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   query = formQuery(act,str);
   if(act == Module7.SARREF || act == Module7.PSAPREF)
    v = db.QueryMulti("transRecord","*",query);
   else if(act == Module7.SARNM)
    v = db.QueryMulti("customer","*",query);
   else if(act == Module7.PSAPNM)
    v = db.QueryMulti("truckingCompany","*",query);
   if(v == null)
   {
    error.append("No data available for the request\n");
    error.append("Or The account has not been fully paid.\n");
    error.append("Try View Info Payment instead.\n");
   }
   else
   {
    System.out.println("size of v: "+v.size());
    v = refineResult(act,v,db);
    calculateTotal(v);
    v = prepare(v);
   }
  }
  catch(SQLException sqle)
  {
   error.append(sqle.getMessage());
   sqle.printStackTrace(System.out);
  }
  finally
  {
   db.close();
  }
  return v;
 }

 public Vector refineResult(int act,Vector v,DBConnect db) 
	throws SQLException
 {
  if(v == null)
   throw new SQLException("Received null vector in refineResult\n");
  Encap e = null;
  Encap t = null;
  Vector v2 = new Vector();
  int v2size = 0;
  int size = v.size();
  int index;
  StringBuffer msg = new StringBuffer(128);
  for(int i=0;i<size;i++)
  {
   e = (Encap)((Encap)v.elementAt(i)).clone();
   if(e.extractString("transType",null).equalsIgnoreCase("IMP"))
   {
    msg.append("WHERE impFromRefKey="+e.extractInteger("transRefKey",0)+";");
    t = db.QuerySingle("impInfoRecord","*",msg.toString());
    e.setNameVal("impGateOut",t.extractString("impGateOut",null));
   }
   else
   {
    msg.append("WHERE expFromRefKey="+e.extractInteger("transRefKey",0)+";");
    t = db.QuerySingle("expInfoRecord","*",msg.toString());
    e.setNameVal("expStuffingDate",t.extractString("expStuffingDate",null));
    e.setNameVal("expDestName",t.extractString("expDestName",null));
   }
   t.clear();
   v2 = db.QueryMulti("transVol","*","WHERE transVolRefKey="+
    e.extractInteger("transRefKey",0)+";");
   if(v2!=null)
   {
    v2size = v2.size();
    index = 1;
    e.setNameVal("transVolSize",v2size); 
    while(!v2.isEmpty()) 
    {
     t = (Encap)v2.remove(0);
     e.setNameVal("transVolVolume"+index,t.extractInteger("transVolVolume",0));
     e.setNameVal("transVolStowage"+index,t.extractAll("transVolStowage"));
     t.clear();
     index++;
    }
   }
   else
    throw new SQLException("No transaction Volume found\n");
   v.setElementAt(e.clone(),i);
   e.clear();
   msg.delete(0,msg.length());
  }
  return v;
 }

 public void calculateTotal(Vector v)
 {
  int size = v.size();
  Encap e = null;
  mc.clearVariable();
  for(int i=0;i<size;i++)
  {
   e = (Encap)((Encap)v.elementAt(i)).clone();
   if(action == Module7.SARREF || action == Module7.SARNM)
    mc.sumAR(e.extractAll("acctRecCurr"),e.extractAll("acctRecAmt"));
   else
    mc.sumAP(e.extractAll("acctPayCurr"),e.extractAll("acctPayAmt"));
   e.clear();
  }	
 }

 public Vector prepare(Vector v)
 {
  Vector v2 = new Vector(v.size());
  Encap e = null;
  int size = 0;
  StringBuffer msg = new StringBuffer(32);
  do
  {
   APOutData apodata = new APOutData();
   e = (Encap)v.remove(0);
   DBConnect.viewEncap(e);
   apodata.setRefNo(e.extractInteger("transRefKey",0));
   apodata.setOutType(e.extractString("transType",null));
   if(action==Module7.SARREF||action==Module7.SARNM)
   {
    apodata.setName(e.extractString("customerName",null));
    apodata.setCurrency(e.extractString("acctRecCurr",null));
    apodata.setBalance(Module7.formNumDelimiter(e.extractAll("acctRecAmt")));
   }
   else
   {
    apodata.setName(e.extractString("truckingName",null));
    apodata.setCurrency(e.extractString("acctPayCurr",null));
    apodata.setBalance(Module7.formNumDelimiter(e.extractAll("acctPayAmt")));
   }
   size = e.extractInteger("transVolSize",0);
   System.out.println("size ===" + size);
   for(int j=1;j<=size;j++)
   {
    if(j>1) msg.append(",");
    msg.append(e.extractInteger("transVolVolume"+j,0)+"x"+
    e.extractString("transVolStowage"+j,null));
    System.out.println("msg: "+msg.toString());
   }
   apodata.setVolStowage(msg.toString());
   msg.delete(0,msg.length());
   if(e.extractString("transType",null).equalsIgnoreCase("IMP"))
   {
    apodata.setDestLoc(e.extractString("transLoadingPort",null));
    apodata.setGateStuff(
     Module7.formNDate(e.extractString("impGateOut",null)));
   }
   else
   {
    apodata.setDestLoc(e.extractString("expDestName",null));
    apodata.setGateStuff(
     Module7.formNDate(e.extractString("expStuffingDate",null)));
   }
   apodata.setDoorLoc(e.extractString("transDoorLocation",null));
   apodata.setInvDate(
    Module7.formNDate(e.extractString("transInvoiceDate",null)));
   v2.add(apodata);
   e.clear();
  } while(v.size()>0);
  return v2;
 }

 public void close()
 {
  frame.dispose();
  System.gc();
 }

 public void addHeaderListener()
 {
  table.getTableHeader().addMouseListener(new MouseAdapter()
  {
   JTableHeader header;
   public void mousePressed(MouseEvent event)
   {
    header = (JTableHeader)(event.getSource());
    int index = header.columnAtPoint(event.getPoint());
    int sortCol = header.getTable().convertColumnIndexToModel(index);
    schr.setPressedColumn(index);
    schr.setSelectedColumn(index);
    header.repaint();
    if(header.getTable().isEditing())
     header.getTable().getCellEditor().stopCellEditing();
    boolean isAscent = false;
    if(schr.DOWN == schr.getState(index))
     isAscent = true;
    ((SortedTableModel)header.getTable().getModel()).sortByColumn(
      sortCol,td.getColumnType(sortCol),isAscent);
   }

   public void mouseReleased(MouseEvent event) 
   {
    int col = header.columnAtPoint(event.getPoint());
    schr.setPressedColumn(-1);
    header.repaint();
   }
  });
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   Vector v = null;
   if(jb == refreshB)
   {
    v = getPaid(action,sendContent); 
    if(v == null)
     error.append("No more outstanding account open\n");
    if(error.length()==0)
    {
     td.initData(v);
     sortedModel.clearSort();
     sortedModel.renewModel(td);
     calculateTotal(v);
     head.setModel(new ListMod(v.size()));
     if(action == Module7.SARREF || action == Module7.SARNM)
     {
      labelTotal.setText(mc.getCurr(0)+" "+
      Module7.formNumDelimiter(mc.getSumAR(0).toString()));
      labelTotal2.setText(mc.getCurr(1)+" "+
      Module7.formNumDelimiter(mc.getSumAR(1).toString()));
     }
     else
     {
      labelTotal.setText(mc.getCurr(0)+" "+
      Module7.formNumDelimiter(mc.getSumAP(0).toString()));
      labelTotal2.setText(mc.getCurr(1)+" "+
      Module7.formNumDelimiter(mc.getSumAP(1).toString()));
     }
     SwingUtilities.updateComponentTreeUI(labelTotal);
     SwingUtilities.updateComponentTreeUI(labelTotal2);
     table.revalidate();
     table.repaint();
     frame.invalidate();
     frame.validate();
     frame.repaint();
    }
   }
   else
    close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
    close();
   }
  }
 }

 private class tableData extends AbstractTableModel
 {
  public final int RFNO = 0;
  public final int TYPE = 1;
  public final int NAME = 2;
  public final int VSTW = 3;
  public final int DELC = 4;
  public final int DOLC = 5;
  public final int INDT = 6;
  public final int GTST = 7;
  public final int CURR = 8;
  public final int BAL  = 9;

  public int rowLength = 0;
  public int colLength = 0;
  private Vector dataRow = null;
  private Vector colNames= null;

  public tableData(Vector v)
  { 
   initColumn();
   rowLength = v.size();
   colLength = colNames.size();
   initData(v);
  }
  public void initColumn()
  {
   if(colNames == null) colNames = new Vector();
   colNames.add(new String("Ref\nNo."));
   colNames.add(new String("Imp\nExp"));
   if(action == Module7.SARREF || action == Module7.SARNM)
    colNames.add(new String("Customer"));
   else
    colNames.add(new String("Trucking"));
   colNames.add(new String("Volume\nStowage"));
   colNames.add(new String("Loading\nDestination"));
   colNames.add(new String("Door\nLocation"));
   colNames.add(new String("Invoice\nDate"));
   colNames.add(new String("GateOut\nStuffing"));
   colNames.add(new String("Currency"));
   colNames.add(new String("Total\nAmount"));
  }
  public void initData(Vector v)
  { dataRow = v; }
  public int getRowCount()
  { return rowLength; }
  public int getColumnCount()
  { return colNames.size(); }
  public String getColumnName(int col)
  { return (String)colNames.elementAt(col); }
  public Class getColumnClass(int col)
  { return getValueAt(0,col).getClass(); }
  public boolean isCellEditable(int row,int col)
  { return false; }
  public int getColumnType(int col)
  {
   if(col == RFNO) return TableSorter.INTEGER;
   if(col == BAL) return TableSorter.BIGDEC;
   if(col == VSTW) return TableSorter.STRCOMMA;
   if(col == INDT || col == GTST) return TableSorter.DATE;
   return TableSorter.STRING;
  }
  public Object getValueAt(int row,int col)
  { 
   if(row<0 || row>=getRowCount()) return " ";
   APOutData apod = (APOutData)dataRow.elementAt(row);
   switch(col)
   {
    case RFNO : return apod.getRefNo(); 
    case TYPE : return apod.getOutType();
    case NAME : return apod.getName();
    case VSTW : return apod.getVolStowage();
    case DELC : return apod.getDestLoc();
    case DOLC : return apod.getDoorLoc();
    case INDT : return apod.getInvDate();
    case GTST : return apod.getGateStuff();
    case CURR : return apod.getCurrency();
    case BAL  : return apod.getBalance();
   }
   return null; 
  }
  public void setValueAt(Object val,int row,int col)
  {  
   APOutData apod = (APOutData)dataRow.elementAt(row);
   switch(col)
   {
    case RFNO : apod.setRefNo(((Integer)val).intValue()); break;
    case TYPE : apod.setOutType((String)val); break;
    case NAME : apod.setName((String)val); break;
    case VSTW : apod.setVolStowage((String)val); break;
    case DELC : apod.setDestLoc((String)val); break;
    case DOLC : apod.setDoorLoc((String)val); break;
    case INDT : apod.setInvDate((String)val); break;
    case GTST : apod.setGateStuff((String)val); break;
    case CURR : apod.setCurrency((String)val); break;
    case BAL  : apod.setBalance((String)val); break;
   }	
   dataRow.setElementAt(apod,row);
   fireTableCellUpdated(row,col);
  }
 } // end of tableData

 private class APOutData
 {
  private int apOutRefNo = 0; // ref no
  private StringBuffer apOutType = new StringBuffer(3); // Import Export
  private StringBuffer apOutName = new StringBuffer(32); // Trucking 
  private StringBuffer apOutStowage = new StringBuffer(10); // Stowage
  private StringBuffer apOutDestLoc = new StringBuffer(32); //Dest Loading
  private StringBuffer apOutDoorLoc = new StringBuffer(32); // Door Location
  private StringBuffer apOutInvDate = new StringBuffer(10); // inv date
  private StringBuffer apOutGateStuff = new StringBuffer(10); // gate stuffing
  private StringBuffer apOutCurr = new StringBuffer(3); // Currency
  private StringBuffer apOutBalance = new StringBuffer(15); // Balance
  
  public APOutData() { }
  public APOutData(int r,String ty,String co,String st,String dst,
   String dl,String id,String go,String cur,String b)
  {
   setRefNo(r);
   setOutType(ty);
   setName(co);
   setVolStowage(st);
   setDestLoc(dst);
   setDoorLoc(dl);
   setInvDate(id);
   setGateStuff(go);
   setCurrency(cur);
   setBalance(b);
  }
  public void setRefNo(int r)
  { apOutRefNo = r; }
  public void setOutType(String ty)
  { 
   if(apOutType.length()>0) 
    apOutType.delete(0,apOutType.length());
   apOutType.append(ty); 
  }
  public void setName(String co)
  {
   if(apOutName.length()>0) 
    apOutName.delete(0,apOutName.length());
   apOutName.append(co);
  }
  public void setVolStowage(String st)
  {
   if(apOutStowage.length()>0) 
    apOutStowage.delete(0,apOutStowage.length());
   apOutStowage.append(st);
  }
  public void setDestLoc(String dst)
  {
   if(apOutDestLoc.length()>0) 
    apOutDestLoc.delete(0,apOutDestLoc.length());
   apOutDestLoc.append(dst);
  }
  public void setDoorLoc(String dl)
  {
   if(apOutDoorLoc.length()>0) 
    apOutDoorLoc.delete(0,apOutDoorLoc.length());
   apOutDoorLoc.append(dl);
  }
  public void setInvDate(String id)
  {
   if(apOutInvDate.length()>0) 
    apOutInvDate.delete(0,apOutInvDate.length());
   apOutInvDate.append(id);
  }
  public void setGateStuff(String go)
  {
   if(apOutGateStuff.length()>0)
    apOutGateStuff.delete(0,apOutGateStuff.length());
   apOutGateStuff.append(go);
  }
  public void setCurrency(String cur)
  {
   if(apOutCurr.length()>0)
    apOutCurr.delete(0,apOutCurr.length());
   apOutCurr.append(cur);
  }
  public void setBalance(String b)
  {
   if(apOutBalance.length()>0)
    apOutBalance.delete(0,apOutBalance.length());
   apOutBalance.append(b);
  }
  public Integer getRefNo()
  { return new Integer(apOutRefNo); }
  public String getOutType()
  { return apOutType.toString(); }
  public String getName()
  { return apOutName.toString(); }
  public String getVolStowage()
  { return apOutStowage.toString(); }
  public String getDestLoc()
  { return apOutDestLoc.toString(); }
  public String getDoorLoc()
  { return apOutDoorLoc.toString(); }
  public String getInvDate()
  { return apOutInvDate.toString(); }
  public String getGateStuff()
  { return apOutGateStuff.toString(); }
  public String getCurrency()
  { return apOutCurr.toString(); }
  public String getBalance()
  { return apOutBalance.toString(); }
 } // end of APOutData class
}
