import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.math.BigDecimal;
import java.sql.SQLException;

public class AddDatabase
{
 private JTable table = null;
 private JFrame frame = null;
 private tableData td = null;
 private JButton cancelB = null;
 private JButton commitB = null;
 private Vector masterCont = null;
 private Vector masterData = null;
 private Vector collector = null;
 private Vector masterInsert = new Vector();
 private StringBuffer error = new StringBuffer();
 private boolean importFlag = true; // assume import
 private boolean insertFlag = false; // signal insert operation
 private HashMap map = new HashMap();
 private MultipleCurrency mc = new MultipleCurrency();
 private int refNo = 0;
 private int importantKey = 0;

 public AddDatabase(String content)
 {
  if(content == null || content.length()==0)
  {
   Module7.errorDisplay("Received null condition\n","ERROR");
   return;
  }
  refNo = Integer.parseInt(content);
  masterData = fetchData();
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  if(importFlag)
   frame = new JFrame("Add Import by Ref No."+refNo);
  else
   frame = new JFrame("Add Export by Ref No."+refNo);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Cancel in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel(new FlowLayout());
  ButtonListener bl = new ButtonListener();
  commitB = new JButton("Continue");
  cancelB = new JButton("Cancel");
  commitB.addActionListener(bl);
  cancelB.addActionListener(bl);
  panel.add(commitB);
  panel.add(cancelB);
  return panel;
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  td = new tableData(masterData);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(td);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  int len = td.getColumnCount();
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(masterData.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  return panel;
 }

 public class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   DBConnect db = new DBConnect();
   if(jb == commitB)
   {
    try
    {
     if(!db.makeConnection("LKB"))
      throw new SQLException("Failure to make connection\n");
     if(addChanges(collect(db),db))
     {
      if(map.size()==0)
       Module7.infoDisplay("Successfully Add info to database\n","Info");
      else
       new ProcessOther(map,Module7.ADDRN);
      close();
      if(!masterInsert.isEmpty())
       masterInsert.removeAllElements();
     }
    }
    catch(SQLException sqle)
    {
     sqle.printStackTrace(System.out);
     error.append(sqle.getMessage()+"\n");
    }
    finally
    {
     db.close();
    }
   }
   else
    close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
    if(!masterInsert.isEmpty())
     masterInsert.removeAllElements();
   }
  }
 }

 public boolean addChanges(Vector v,DBConnect db) throws SQLException
 {
  if(v == null) return false;
  if(error.length()>0) return false;
  if(v.size()==0 && masterInsert.size()==0 && map.size()==0)
  {
   error.append("You have not enter anything\n");
   return false;
  }
  boolean flag = true;
  Encap e = new Encap();
  try
  {
   if(error.length()==0)
   {
    if(v.size()>0)
    {
     System.out.println("-------view Update--------");
     for(int i=0;i<v.size();i++)
      db.viewEncap((Encap)v.get(i));
     db.UpdateMulti(v);
    }
    if(masterInsert.size()>0)
    {
     System.out.println("-------view Insert--------");
     for(int i=0;i<masterInsert.size();i++)
      db.viewEncap((Encap)masterInsert.get(i));
     db.InsertMulti(masterInsert);
    }
    if(map.size()>0)
     map.put("AddRefKey",String.valueOf(refNo));
    System.out.println("--rebalance start--");
    BalanceAccount.rebalance(refNo,db);
    System.out.println("--finish rebalance-");
   }
   else
    flag = false;
  }
  catch(SQLException sqle)
  {
   error.append(sqle.getMessage());
   flag = false;
  }
  return flag;
 }

 public Vector collect(DBConnect db) throws SQLException 
 {
  Vector v = new Vector();
  Encap e = new Encap();
  Encap e2= null;
  int size = masterData.size(); 
  int lastPos = -1;
  StringBuffer val = new StringBuffer(32);
  boolean currFlag = false;
  boolean commitFlag = true;
  for(int i=0;i<size;i++)
  {
   Data data = td.getData(i);
   val.append(data.getValue());
   if(val.length()>=1)
   {
    e = checkAndStore(i,(String)masterCont.get(i),val.toString(),db);
    if(e!=null)
    {
//     System.out.println("Not null circle: check what is e");
//     DBConnect.viewEncap((Encap)e.clone());
     for(int j=0;j<e.getSize();j++)
     {
      if(e.getName(j).endsWith("Curr"))
      {
       currFlag = true;
       if(e.getStringValue(j).length()!=3)
	      error.append("Currency row["+(i+1)+"] must be 3 characters long\n");
       break;
      }
      else currFlag = false;
     }
     if(!commitFlag && currFlag)
     {
      error.append("You have not filled the amount for currency at");
      error.append(" row["+(lastPos+1)+"]\n");
     }
     if(currFlag)
     {
      lastPos = i;
      e2 = (Encap)e.clone();
      commitFlag = false;
     }
     else // not a currency
     {
      System.out.println("--- else part ---");
//      DBConnect.viewEncap(e);
//      System.out.println("-----------------");
      if(e.getName(0).startsWith("cost") || 
         e.getName(0).startsWith("claimable") || 
	 e.getName(0).startsWith("invoice"))
      {
       if(!currFlag && !commitFlag)
       {
	for(int x=0;x<e2.getSize();x++)
        {
	 if(e2.getName(x).endsWith("Curr"))
	 {
          e.setNameVal(e2.getName(x),e2.getValue(x)); // merge
 	  if(e.getName(0).startsWith("cost")) // sum AP cost
	  {
           if(e.getTable().equalsIgnoreCase("otherCost"))
	   {
            if(e.extractAll("costOthDesc").equalsIgnoreCase("Overnight Trucking Cost"))
	    {
	     System.out.println("costOth - sum");
             mc.sumAP(e2.getValue(x),
	     e.extractAll("costOthAmt"));
	     System.out.println("Get Overnight! :"+mc.getSumAP(0).toString());
   	    }
	    else System.out.println("Missed Overnight: "+e.extractAll("costOthDesc"));
	   }
	  }
	  if(e.getName(0).startsWith("claimable")) // sum AR claimable
	  {
	   if(e.getTable().equalsIgnoreCase("claimableCharges"))
	   {
	    if(e.getName(0).startsWith("claimableTotalLiftOn"))
	    {
	     System.out.println("claimableTotalLiftOn - sum");
	     mc.sumAR(e2.getValue(x),e.extractAll("claimableTotalLiftOnAmt"));
   	    }
  	    else
	    {
	     System.out.println("claimableTotalLiftOff - sum");
	     mc.sumAR(e2.getValue(x),e.extractAll("claimableTotalLiftOffAmt"));
	    }
	   } // must be claimable other charges
	   else if(e.getTable().equalsIgnoreCase("claimableOtherCharges"))
	   {
	    System.out.println("claimableOtherCharges - sum");
	    mc.sumAR(e2.getValue(x),e.extractAll("claimableOthAmt"));
	   }
	  }
	  else if(e.getName(0).startsWith("invoice")) // sum AR invoice
	  {
	   if(e.getTable().equalsIgnoreCase("invoiceRecord"))
	   {
	    System.out.println("invoiceRecord - sum");
	    mc.sumAR(e2.getValue(x),e.extractAll("invoiceHandleAmt"));
	   }
	   else // must be invoice other charges
	   {
	    System.out.println("invoice Other Charges");
            mc.sumAR(e2.getValue(x),
	    e.extractAll("invoiceOthAmt"));
	   }
	  }
	  e2.clear();
	 }
	}
        lastPos = -1;
        commitFlag = true;
       }
       else if(commitFlag && lastPos<0)
        error.append("You must filled the currency for row["+(i+1)+"]\n"); 
      } // not currency - end
     }
     if(!insertFlag)
     {
      if(!currFlag)
      {
       v.add(e.clone());
      }
     }
     else 
     {
      System.out.println("--else part insertFlag: "+insertFlag);
      if(!currFlag)
      {
       System.out.println("--into masterInsert element of:");
       masterInsert.add(e.clone());
       DBConnect.viewEncap(e);
       insertFlag = false;
      }
      else System.out.println("Rejected");
     }
    } // end of if - Not Null 
    else System.out.println("e is declare null");
   } // end of if - has content
   if(e!=null)e.clear();
   val.delete(0,val.length());
  } // end of for-loop that collect 
  return v;
 }

 public Encap checkAndStore(int row,String con,String val,DBConnect db)
	throws SQLException
 {
  Encap e = new Encap();
  boolean special = false;
  System.out.println("checkAndStore : "+con+" val: "+val);
  if(con.startsWith("exp")) // check whether it is export
  {
   System.out.println("enter exp group");
   e.setTable("expInfoRecord");
   if(con.equalsIgnoreCase("expVesselName"))
   {
    if(val.length()<=32)
     e.setNameVal(con,val);
    else
     error.append("Vessel Name/No.Voyage max length = 32 characters\n");
   }
   else
   {
    if(Module7.checkDate(val))
     e.setNameVal(con,Module7.formDate(val));
    else
     error.append(con+" is not a valid date\n");
   }
   e.setCondition("WHERE expFromRefKey="+refNo+";");
  }
  else if(con.startsWith("imp")) // check whether it is import
  {
   System.out.println("enter imp group");
   if(Module7.checkDate(val))
   {
    e.setTable("impInfoRecord");
    e.setNameVal(con,Module7.formDate(val));
    e.setCondition("WHERE impFromRefKey="+refNo+";");
   }
   else
    error.append(con+" is not a valid date\n");
  }
  else if(con.startsWith("costOth")) // check whether it is cost other
  {
   System.out.println("enter costOth group");
   if(con.equalsIgnoreCase("costOthAdd"))
   {
    if(Module7.checkInt(val,1) && val.charAt(0)!='0')
    {
     map.put("AddNumberOthCost",val);
     special = true;
    }
    else
     error.append("Only digit allowed for Add more other cost\n");
   }
   else
   {
    String tmp = con.substring(con.length()-3,con.length());
    String tmp2= con.substring(0,con.length()-3);
    e.setTable("otherCost");
    if(tmp.equalsIgnoreCase("Red"))
     e.setNameVal("costOthDesc","Red Zone Cost");
    else if(tmp.equalsIgnoreCase("POM"))
     e.setNameVal("costOthDesc","POM Cost");
    else if(tmp.equalsIgnoreCase("OTC"))
     e.setNameVal("costOthDesc","Overnight Trucking Cost");
    else if(tmp.equalsIgnoreCase("Fac"))
     e.setNameVal("costOthDesc","Facility Cost");
    else error.append("Unknown category of cost other at row["+(row+1)+"]\n");
    if(tmp2.endsWith("Curr"))
    {
     System.out.println("Cost Other > Check Currency : "+val);
     if(Module7.checkValidCurrency(val))
      e.setNameVal(tmp2,val);
     else error.append("currency at ["+(row+1)+"] is not listed\n");
    }
    else if(tmp2.endsWith("Amt"))
    {
     System.out.println("Cost Other > Check Amount : "+val);
     if(Module7.checkInt(val,3)&&Module7.checkMax(val))
      e.setNameVal(tmp2,val);
     else error.append("Invalid amount input at row["+(row+1)+"]\n");
    }
    else error.append("Failed to process other cost at row["+(row+1)+"]\n");
    e.setNameVal("costOthRefKey",refNo);
    insertFlag = true;
    System.out.println("inside check - set insertFlag "+insertFlag);
   }
  }
  else if(con.startsWith("claimableOth")) // check whether it is claimble other
  {
   System.out.println("enter claimableOth group");
   if(con.equalsIgnoreCase("claimableOthAdd"))
   {
    if(Module7.checkInt(val,1) && val.charAt(0)!='0')
    {
     map.put("AddNumberOthCharges",val);
     special = true;
    }
    else
     error.append("Only digit allowed for Add more other claimable\n");
   }
   else
   {
    String tmp = con.substring(con.length()-3,con.length());
    String tmp2= con.substring(0,con.length()-3);
    e.setTable("claimableOtherCharges");
    if(tmp.equalsIgnoreCase("QUA"))
     e.setNameVal("claimableOthDesc","Quarantine");
    else if(tmp.equalsIgnoreCase("BEH"))
     e.setNameVal("claimableOthDesc","Bahandle");
    else if(tmp.equalsIgnoreCase("DEM"))
     e.setNameVal("claimableOthDesc","Demurrage");
    else if(tmp.equalsIgnoreCase("DET"))
     e.setNameVal("claimableOthDesc","Detention");
    else if(tmp.equalsIgnoreCase("OCF"))
     e.setNameVal("claimableOthDesc","Ocean Freight");
    else if(tmp.equalsIgnoreCase("THC"))
     e.setNameVal("claimableOthDesc","THC");
    else if(tmp.equalsIgnoreCase("INS"))
     e.setNameVal("claimableOthDesc","Insurance");
    else if(tmp.equalsIgnoreCase("DOC"))
     e.setNameVal("claimableOthDesc","Doc");
    else if(tmp.equalsIgnoreCase("CLN"))
     e.setNameVal("claimableOthDesc","Cleaning");
    else if(tmp.equalsIgnoreCase("COL"))
     e.setNameVal("claimableOthDesc","Coloader");
    else if(tmp.equalsIgnoreCase("CTD"))
     e.setNameVal("claimableOthDesc","Container Deposit");
    else if(tmp.equalsIgnoreCase("COD"))
     e.setNameVal("claimableOthDesc","Container Damage");
    else 
    {
     error.append("Unknown category of claimable other ");
     error.append("charges at row["+(row+1)+"]\n");
    }
    if(tmp2.endsWith("Curr"))
    {
     System.out.println("claimable Other > Check Currency "+tmp2+"  "+val);
     if(Module7.checkValidCurrency(val))
      e.setNameVal(tmp2,val);
     else error.append("currency at ["+(row+1)+"] is not listed\n");
    }
    else if(tmp2.endsWith("Amt"))
    {
     System.out.println("claimable Other > Check Amt "+tmp2+"  "+val);
     if(Module7.checkInt(val,3)&&Module7.checkMax(val))
      e.setNameVal(tmp2,val);
     else error.append("Invalid amount input at row["+(row+1)+"]\n");
    }
    else error.append("Failed to process other cost at row["+(row+1)+"]\n");
    e.setNameVal("claimableOthRefKey",refNo);
    insertFlag = true;
   }
  }
  else if(con.startsWith("invoiceOth")) // check whether it is invoice other
  {
   System.out.println("enter invoiceOth group");
   if(con.equalsIgnoreCase("invoiceOthAdd"))
   {
    if(Module7.checkInt(val,1) && val.charAt(0)!='0')
    {
     map.put("AddNumberOthInvoice",val);
     special = true;
    }
    else
     error.append("Only digit allowed for Add more other invoice charges\n");
   }
   else
   {
    String tmp = con.substring(con.length()-3,con.length());
    String tmp2= con.substring(0,con.length()-3);
    e.setTable("invoiceOtherCharges");
    if(tmp.equalsIgnoreCase("STP"))
     e.setNameVal("invoiceOthDesc","Stamp Charge");
    else if(tmp.equalsIgnoreCase("PPN")&&importFlag)
     e.setNameVal("invoiceOthDesc","Import PPN");
    else if(tmp.equalsIgnoreCase("PPN")&&!importFlag)
     e.setNameVal("invoiceOthDesc","Export PPN");
    else if(tmp.equalsIgnoreCase("OTC"))
     e.setNameVal("invoiceOthDesc","Overnight Trucking Charge");
    else 
    { 
     error.append("Unknown category of Invoice Other Charges at row");
     error.append(" ["+(row+1)+"]\n");
    }
    if(tmp2.endsWith("Curr"))
    {
     System.out.println("invoiceOther > check Currency : "+val);
     if(Module7.checkValidCurrency(val))
      e.setNameVal(tmp2,val);
     else error.append("currency at ["+(row+1)+"] is not listed\n");
    }
    else if(tmp2.endsWith("Amt"))
    {
     System.out.println("invoiceOther > check Amount : "+val);
     if(Module7.checkInt(val,3)&&Module7.checkMax(val))
      e.setNameVal(tmp2,val);
     else error.append("Invalid amount input at row["+(row+1)+"]\n");
    }
    else error.append("Failed to process other cost at row["+(row+1)+"]\n");
    e.setNameVal("invoiceOthRefKey",refNo);
    insertFlag = true;
   }
  }
  else if(con.startsWith("invoice")) // check whether it is invoice
  {
   System.out.println("enter invoice group");
   e.setTable("invoiceRecord");
   if(con.endsWith("Curr"))
   {
    if(Module7.checkValidCurrency(val))
     e.setNameVal(con,val);
    else
     error.append("currency at ["+(row+1)+"] is not listed\n");
   }
   else
   {
    if(Module7.checkInt(val,3)&&Module7.checkMax(val))
      e.setNameVal(con,val);
    else error.append("Invalid amount input at row["+(row+1)+"]\n"); 
   }
   e.setCondition("WHERE invoiceRefKey="+refNo+";");
  }
  else if(con.startsWith("claimable")) // check whether it is claimable
  {
   System.out.println("enter claimable group");
   e.setTable("claimableCharges");
   if(con.endsWith("Curr"))
   {
    System.out.println("claimable charge - check currency");
    if(Module7.checkValidCurrency(val))
     e.setNameVal(con,val);
    else
     error.append("currency at ["+(row+1)+"] is not listed\n");
   }
   else
   {
    System.out.println("claimable charge - check Amount");
    if(Module7.checkInt(val,3)&&Module7.checkMax(val))
     e.setNameVal(con,val);
    else error.append("Invalid amount input at row["+(row+1)+"]\n"); 
   }
   e.setCondition("WHERE claimableRefKey="+refNo+";");
  }
  else if(con.startsWith("cost")) // check whether it is cost
  {
   System.out.println("enter cost group");
   e.setTable("costRecord");
   if(con.endsWith("Curr"))
    e.setNameVal(con,val);
   else if(Module7.checkInt(val,3))
    e.setNameVal(con,val);
   else error.append("Cost : "+val+" is invalid input\n");
   e.setCondition("WHERE costFromRefKey="+refNo+";");
  }
  else if(con.equalsIgnoreCase("transInvoiceRemarks"))
  {
   System.out.println("enter transInvoiceRemarks group");
   e.setTable("transRecord");
   e.setNameVal("transInvoiceRemarks",val);
   e.setCondition("WHERE transRefKey="+refNo+";");
  }
  else if(con.equalsIgnoreCase("transDebitNoteRemarks"))
  {
   System.out.println("enter transDebitNoteRemarks group");
   e.setTable("transRecord");
   e.setNameVal("transDebitNoteRemarks",val);
   e.setCondition("WHERE transRefKey="+refNo+";");
  }
  else if(con.equalsIgnoreCase("transVol"))
  {
   int number = Integer.parseInt(val);
   int run = 0;
   boolean flag = false;
   String tmp = null;
   do
   {
    tmp = Module7.displayQuestion("Enter "+number+" Volume x Stowage Factor\n"+
          "Example: 1x20D,3x40FRK,2x40D","Enter Volume x Stowage Factor");
    if(tmp!=null)
    {
     run =  process(number,tmp,con,db);
     if(run<0) { }
     else if(run<number)
      number-=run;
     else flag = true;
    }
    else flag = true;
   }while(!flag);
   e = null;
  }
  else
   System.out.println("What group are you? "+con);

  if(error.length()>0 || special) 
  {
   if(e!=null) e.clear();
   return null;
  }
  return e; 
 }

 private int process(int n,String cond, String c,DBConnect db)
	throws SQLException
 {
  if(cond == null||c == null)
  {
   Module7.errorDisplay("in process received null value\n","ERROR");
   return -1;
  }
  if(cond.indexOf(',')<0 && n>1)
  {
   Module7.errorDisplay("Expecting "+n+" inputs seperated by comma (,)\n","ERROR");
   return -1;
  }
  Encap e1 = new Encap();
  StringBuffer bf = new StringBuffer(16);
  int index= 0;
  int run = 0;
  int count = 1;
  StringBuffer msg = new StringBuffer(10);
  if(c.equalsIgnoreCase("transVol"))
  {
   System.out.println("-- process transVol : "+cond+" ? "+cond.indexOf('x'));
   StringTokenizer cut = new StringTokenizer(cond);
   do
   {
    if(run == n) break;
    bf.append(cut.nextToken(","));
    if((bf.toString()).indexOf('x')<0)
    {
     Module7.errorDisplay("Expecting a delimiter character: x\n"+
     "In the input of ["+bf.toString()+"]\nExample: 1x20D","ERROR");
     return run;
    }
    else if(!Module7.checkInt(
     (bf.toString()).substring(0,(bf.toString()).indexOf('x')),1))
    {
     Module7.errorDisplay("Expecting volume in the position before x\n"+
     "In the input of ["+bf.toString()+"]\nExample: 1x20D","ERROR");
     return run;
    }
    e1.setTable("transVol");
    StringTokenizer cut2 = new StringTokenizer(bf.toString(),"x");
    while(cut2.hasMoreElements())
    {
     if(index == 0)
      e1.setNameVal("transVolVolume",Integer.parseInt(cut2.nextToken()));
     else
     {
      msg.append(cut2.nextToken());
      if(Module7.checkStowage(msg.toString()))
       e1.setNameVal("transVolStowage",msg.toString());
      else
      {
       Module7.errorDisplay("Stowage Factor of "+msg.toString()+" is not in the list\n",
       "ERROR");
       return run;
      }
     }
     index++;
    }
    index = 0;
    e1.setNameVal("transVolRefKey",refNo);
    if(!Module7.checkStowageException(msg.toString()))
     e1.setVariable("SET @transVolKey"+count+" = LAST_INSERT_ID();");
    masterInsert.add(e1.clone());
    if(!Module7.checkStowageException(msg.toString()))
     processAddContainer(e1.extractInteger("transVolVolume",0),count);
    e1.clear();
    run++;
    count+=1;
    bf.delete(0,bf.length());
    msg.delete(0,msg.length());
   }while(cut.hasMoreElements()); 
   insertFlag = false;
  }
  return run;
 } // end of process' method 

 private void processAddContainer(int vol,int c)
 {
  boolean goOn = false;
  String tmp = null;
  int crun   = 0;
  System.out.println("enter processAddContainer --->");
  do
  {
   tmp = Module7.displayQuestion("Enter "+vol+" pair of Container No."+
   "and Seal No.\n For Example: ContNo1+SealNo1,ContNo2+SealNo2\n",
   "Enter pair of Cont No and Seal No");
   if(tmp != null)
   {
    crun = phraseInsert(vol,c,tmp);
    if(crun == vol) goOn = true;
    else if(crun < vol) vol-=crun;
   }
  }while(!goOn);
  System.out.println("exit processAddContainer --->");
 }

 private int phraseInsert(int number,int count,String tmp)
 {
  System.out.println("enter phrase Insert -----");
  int run = 0; 
  int index = 0;
  Encap e = null;
  StringBuffer bmp = new StringBuffer(16);
  if(tmp.indexOf(',')<0 && number == 1)
  {
   System.out.println(" --- enter single comma delimiter ---");
   if(tmp.indexOf('+')<0)
   {
    Module7.errorDisplay("Expecting a delimiter character: +\n"+
    "In the input of["+tmp.toString()+"]\n"+"Example: ContNo1+SealNo1\n","ERROR");
    return -1;
   }
   StringTokenizer put = new StringTokenizer(tmp,"+");
   e = new Encap("transContainer");
   do
   {
    if(index>1) break;
    if(index == 0)
     e.setNameVal("transContNo",put.nextToken());
    else
     e.setNameVal("transContSealNo",put.nextToken());
    index++;
   }while(put.hasMoreElements());
   run = number;
   e.setNameVal("transContVolKey","@transVolKey"+count);
   e.setNameVal("transContRefNo",refNo);
   masterInsert.add(e.clone());
   e.clear();
   System.out.println("--- exit single comma delimiter --- ");
  }
  else if(tmp.indexOf(',')>0)
  {
   System.out.println("--- enter multiple comma delimiter ---");
   StringTokenizer put = new StringTokenizer(tmp);
   do
   {
    if(number == run) break; // get out
    bmp.append(put.nextToken(","));
    if((bmp.toString()).indexOf('+')<0)
    {
     Module7.errorDisplay("Expecting a delimiter character: +\n"+
     "In the input of["+bmp.toString()+"]\n"+"Example: ContNo1+SealNo1\n","ERROR");
     return run;
    }
    else
    {
     e.setTable("transContainer");
     StringTokenizer put2 = new StringTokenizer(bmp.toString(),"+");
     while(put2.hasMoreElements())
     {
      if(index == 0)
       e.setNameVal("transContNo",put2.nextToken());
      else
       e.setNameVal("transContSealNo",put2.nextToken());
      index++;
     }
     index = 0;
     e.setNameVal("transContVolKey","@transVolKey"+count);
     e.setNameVal("transContRefNo",refNo);
     masterInsert.add(e.clone());
     e.clear();
    }
    bmp.delete(0,bmp.length());
    run++;
   }while(put.hasMoreElements());
   System.out.println("--- exit multiple comma delimiter ---");
  }
  else // not found delimiter
  {
   Module7.errorDisplay("Expecting a comma delimiter in: "+tmp+"\n"+
   "For example: ContNo1+SealNo1,ContNo2+SealNo2\n","ERROR");
   run = -1;
  }
  System.out.println("exit phrase Insert delimiter ----");
  return run;
 }

 public void close()
 {
  frame.dispose();
  System.gc();
 } 

 public Vector fetchData()
 {
  DBConnect db = new DBConnect();
  collector = new Vector();
  Vector v = new Vector();
  Vector v2= null;
  Encap e = null;
  Encap e2= null;
  masterCont = new Vector();
  StringBuffer q = new StringBuffer(128);
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database");
   q.append("LEFT JOIN costRecord ON (costRecord.costFromRefKey=");
   q.append("transRecord.transRefKey) ");
   q.append("LEFT JOIN invoiceRecord ON (invoiceRecord.invoiceRefKey=");
   q.append("transRecord.transRefKey) ");
   q.append("LEFT JOIN claimableCharges ON (claimableCharges.");
   q.append("claimableRefKey=transRecord.transRefKey) ");
   q.append("WHERE transRefKey="+refNo+";");
   e = db.QuerySingle("transRecord","*",q.toString()); 
   System.out.println("---now? --");
   if(e == null)
   {
    error.append("No Info with Ref No."+refNo+" found\n");
    return null;
   }
   System.out.println("-- fetchData["+e.getSize()+"] --");
   if(e.extractAll("transPaidFull").equalsIgnoreCase("Y"))
   {
    error.append("You can longer add data into finish transaction\n");
    return null;
   }
   if(e.extractAll("transType").equalsIgnoreCase("EXP"))
   {
    importFlag = false;
    System.out.print("transType = Export for "+refNo);
    System.out.println(" - "+e.extractAll("transType"));
    e2 = db.QuerySingle("expInfoRecord","*","WHERE expFromRefKey="+refNo+";");
    if(e2.extractString("expSINo",null).equalsIgnoreCase("none"))
    {
     collector.add("Export S/I No.");
     masterCont.add("expSINo");
    }
    if(e2.extractString("expVesselName",null).equalsIgnoreCase("none"))
    {
     collector.add("Export Vessel Name/No.Voyage");
     masterCont.add("expVesselName");
    }
    if(e2.extractString("expETD",null).equalsIgnoreCase("0000-00-00"))
    {
     collector.add("Export ETD [date]");
     masterCont.add("expETD");
    }
    if(e2.extractString("expStuffingDate",null).equalsIgnoreCase("0000-00-00"))
    {
     collector.add("Export Stuffing Date");
     masterCont.add("expStuffingDate");
    }
   }
   else // IMPORT
   {
    System.out.print("transType = Import for "+refNo);
    System.out.println(" - "+e.extractAll("transType"));
    e2 = db.QuerySingle("impInfoRecord","*","WHERE impFromRefKey="+refNo+";");
    if(e2.extractString("impBLNo",null).equalsIgnoreCase("none"))
    {
     collector.add("Import Bill of Lading No.");
     masterCont.add("impBLNo");
    }
    if(e2.extractString("impGateOut",null).equalsIgnoreCase("0000-00-00"))
    {
     collector.add("Import Gate Out Date"); 
     masterCont.add("impGateOut");
    }
    if(e2.extractString("impArrival",null).equalsIgnoreCase("0000-00-00"))
    {
     collector.add("Import Arrival Date");
     masterCont.add("impArrival");
    }
    if(e2.extractString("impContReturnDate",null).equalsIgnoreCase("0000-00-00"))
    {
     collector.add("Import Container Return Date"); 
     masterCont.add("impContReturnDate");
    }
   }
   e2.clear();

   collector.add("Add number of Different Storage");
   masterCont.add("transVol");

   if(e.extractAll("transInvoiceRemarks").equalsIgnoreCase("none"))
   {
    collector.add("Invoice Remarks");
    masterCont.add("transInvoiceRemarks");
   }
   if(e.extractAll("transDebitNoteRemarks").equalsIgnoreCase("none"))
   {
    collector.add("Debit Note Remarks");
    masterCont.add("transDebitNoteRemarks");
   }
   if(e.extractAll("costCommission").equalsIgnoreCase("0.00"))
   {
    collector.add("Cost : Commission Currency");
    collector.add("Cost : Commission Amount");
    masterCont.add("costCommissionCurr");
    masterCont.add("costCommission");
   }
  
   // -- Other Cost --
   v2 = db.QueryMulti("otherCost","*","WHERE costOthRefKey="+refNo+";");
   if(v2!=null)
   {
    System.out.println("size of v2 = "+v2.size());
    if(importFlag)
    {
     if(!checkVector(v2,"costOthDesc","Red Zone Cost"))
     {
      collector.add("Cost Other : Red Zone Cost Currency");
      collector.add("Cost Other : Red Zone Cost Amount");
      masterCont.add("costOthCurrRed");
      masterCont.add("costOthAmtRed");
     }
     if(!checkVector(v2,"costOthDesc","POM Cost"))
     {
      collector.add("Cost Other : POM Cost Currency");
      collector.add("Cost Other : POM Cost Amount");
      masterCont.add("costOthCurrPOM");
      masterCont.add("costOthAmtPOM");
     }
     if(!checkVector(v2,"costOthDesc","Overnight Trucking Cost"))
     {
      collector.add("Cost Other : Overnight Trucking Cost Currency");
      collector.add("Cost Other : Overnight Trucking Cost Amount");
      masterCont.add("costOthCurrOTC");
      masterCont.add("costOthAmtOTC");
     }
    }
    else // EXPORT
    {
     if(!checkVector(v2,"costOthDesc","Facility Cost"))
     {
      collector.add("Cost Other : Facility Cost Currency");
      collector.add("Cost Other : Facility Cost Amount");
      masterCont.add("costOthCurrFac");
      masterCont.add("costOthAmtFac");
     }
     if(!checkVector(v2,"costOthDesc","Overnight Trucking Cost"))
     {
      collector.add("Cost Other : Overnight Trucking Cost Currency");
      collector.add("Cost Other : Overnight Trucking Cost Amount");
      masterCont.add("costOthCurrOTC");
      masterCont.add("costOthAmtOTC");
     }
    }
   }
   else // There is absolutely no other cost in database
   {
    System.out.println("--------- this is null section!");
    collector.add("Cost Other : Overnight Trucking Cost Currency");
    collector.add("Cost Other : Overnight Trucking Cost Amount");
    masterCont.add("costOthCurrOTC");
    masterCont.add("costOthAmtOTC");
    if(importFlag)
    {
     collector.add("Cost Other : Red Zone Cost Currency");
     collector.add("Cost Other : Red Zone Cost Amount");
     collector.add("Cost Other : POM Cost Currency");
     collector.add("Cost Other : POM Cost Amount");
     masterCont.add("costOthCurrRed");
     masterCont.add("costOthAmtRed");
     masterCont.add("costOthCurrPOM");
     masterCont.add("costOthAmtPOM");
    }
    else
    {
     collector.add("Cost Other : Facility Cost Currency");
     collector.add("Cost Other : Facility Cost Amount");
     masterCont.add("costOthCurrFac");
     masterCont.add("costOthAmtFac");
    }
   }
   collector.add("Cost Other : Add more other cost");
   masterCont.add("costOthAdd");

//    db.viewEncap(e);
   if(e.extractAll("claimableTotalLiftOffAmt").equalsIgnoreCase("0.00"))
   {
    collector.add("Claimable Charge : Total Lift Off Currency");
    collector.add("Claimable Charge : Total Lift Off Amount");
    masterCont.add("claimableTotalLiftOffCurr");
    masterCont.add("claimableTotalLiftOffAmt");
   }
   
   if(e.extractAll("claimableTotalLiftOnAmt").equalsIgnoreCase("0.00"))
   {
    collector.add("Claimable Charge : Total Lift On Currency");
    collector.add("Claimable Charge : Total Lift On Amount");
    masterCont.add("claimableTotalLiftOnCurr");
    masterCont.add("claimableTotalLiftOnAmt");
   }
	
   // --- claimableOtherCharges ---
   if(v2!=null&&!v2.isEmpty()) 
     v2.removeAllElements();
   v2 = db.QueryMulti("claimableOtherCharges","*","WHERE claimableOthRefKey="+refNo+";");

   if(v2!=null)
   {
    if(importFlag)
    {
     if(!checkVector(v2,"claimableOthDesc","Quarantine"))
     {
      collector.add("Claimable Other Charge : Quarantine Currency");
      collector.add("Claimable Other Charge : Quarantine Amount");
      masterCont.add("claimableOthCurrQUA");
      masterCont.add("claimableOthAmtQUA");
     }
     if(!checkVector(v2,"claimableOthDesc","Bahandle"))
     {
      collector.add("Claimable Other Charge : Bahandle Currency");
      collector.add("Claimable Other Charge : Bahandle Amount");
      masterCont.add("claimableOthCurrBEH");
      masterCont.add("claimableOthAmtBEH");
     }
     if(!checkVector(v2,"claimableOthDesc","Demurrage"))
     {
      collector.add("Claimable Other Charge : Demurrage Currency");
      collector.add("Claimable Other Charge : Demurrage Amount");
      masterCont.add("claimableOthCurrDEM");
      masterCont.add("claimableOthAmtDEM");
     }
     if(!checkVector(v2,"claimableOthDesc","Detention"))
     {
      collector.add("Claimable Other Charge : Detention Currency");
      collector.add("Claimable Other Charge : Detention Amount");
      masterCont.add("claimableOthCurrDET");
      masterCont.add("claimableOthAmtDET");
     }
     if(!checkVector(v2,"claimableOthDesc","Ocean Freight"))
     {
      collector.add("Claimable Other Charge : Ocean Freight Currency");
      collector.add("Claimable Other Charge : Ocean Freight Amount");
      masterCont.add("claimableOthCurrOCF");
      masterCont.add("claimableOthAmtOCF");
     }
     if(!checkVector(v2,"claimableOthDesc","THC"))
     {
      collector.add("Claimable Other Charge : THC Currency");
      collector.add("Claimable Other Charge : THC Amount");
      masterCont.add("claimableOthCurrTHC");
      masterCont.add("claimableOthAmtTHC");
     }
     if(!checkVector(v2,"claimableOthDesc","Insurance"))
     {
      collector.add("Claimable Other Charge : Insurance Currency");
      collector.add("Claimable Other Charge : Insurance Amount");
      masterCont.add("claimableOthCurrINS");
      masterCont.add("claimableOthAmtINS");
     }
     if(!checkVector(v2,"claimableOthDesc","Doc"))
     {
      collector.add("Claimable Other Charge : Doc Currency");
      collector.add("Claimable Other Charge : Doc Amount");
      masterCont.add("claimableOthCurrDOC");
      masterCont.add("claimableOthAmtDOC");
     }
     if(!checkVector(v2,"claimableOthDesc","Cleaning"))
     {
      collector.add("Claimable Other Charge : Cleaning Currency");
      collector.add("Claimable Other Charge : Cleaning Amount");
      masterCont.add("claimableOthCurrCLN");
      masterCont.add("claimableOthAmtCLN");
     }
     if(!checkVector(v2,"claimableOthDesc","Coloader"))
     {
      collector.add("Claimable Other Charge : Coloader Currency");
      collector.add("Claimable Other Charge : Coloader Amount");
      masterCont.add("claimableOthCurrCOL");
      masterCont.add("claimableOthAmtCOL");
     }
     if(!checkVector(v2,"claimableOthDesc","Container Deposit"))
     {
      collector.add("Claimable Other Charge : Container Deposit Currency");
      collector.add("Claimable Other Charge : Container Deposit Amount");
      masterCont.add("claimableOthCurrCTD");
      masterCont.add("claimableOthAmtCTD");
     }
     if(!checkVector(v2,"claimableOthDesc","Container Damage"))
     {
      collector.add("Claimable Other Charge : Container Damage Currency");
      collector.add("Claimable Other Charge : Container Damage Amount");
      masterCont.add("claimableOthCurrCOD");
      masterCont.add("claimableOthAmtCOD");
     }
    }
   }
   else // there is no claimable Other Charges in database
   {
    if(importFlag)
    {
     collector.add("Claimable Other Charge : Quarantine Currency");
     collector.add("Claimable Other Charge : Quarantine Amount");
     masterCont.add("claimableOthCurrQUA");
     masterCont.add("claimableOthAmtQUA");
     collector.add("Claimable Other Charge : Bahandle Currency");
     collector.add("Claimable Other Charge : Bahandle Amount");
     masterCont.add("claimableOthCurrBEH");
     masterCont.add("claimableOthAmtBEH");
     collector.add("Claimable Other Charge : Demurrage Currency");
     collector.add("Claimable Other Charge : Demurrage Amount");
     masterCont.add("claimableOthCurrDEM");
     masterCont.add("claimableOthAmtDEM");
     collector.add("Claimable Other Charge : Detention Currency");
     collector.add("Claimable Other Charge : Detention Amount");
     masterCont.add("claimableOthCurrDET");
     masterCont.add("claimableOthAmtDET");
     collector.add("Claimable Other Charge : Ocean Freight Currency");
     collector.add("Claimable Other Charge : Ocean Freight Amount");
     masterCont.add("claimableOthCurrOCF");
     masterCont.add("claimableOthAmtOCF");
     collector.add("Claimable Other Charge : THC Currency");
     collector.add("Claimable Other Charge : THC Amount");
     masterCont.add("claimableOthCurrTHC");
     masterCont.add("claimableOthAmtTHC");
     collector.add("Claimable Other Charge : Insurance Currency");
     collector.add("Claimable Other Charge : Insurance Amount");
     masterCont.add("claimableOthCurrINS");
     masterCont.add("claimableOthAmtINS");
     collector.add("Claimable Other Charge : Doc Currency");
     collector.add("Claimable Other Charge : Doc Amount");
     masterCont.add("claimableOthCurrDOC");
     masterCont.add("claimableOthAmtDOC");
     collector.add("Claimable Other Charge : Cleaning Currency");
     collector.add("Claimable Other Charge : Cleaning Amount");
     masterCont.add("claimableOthCurrCLN");
     masterCont.add("claimableOthAmtCLN");
     collector.add("Claimable Other Charge : Coloader Currency");
     collector.add("Claimable Other Charge : Coloader Amount");
     masterCont.add("claimableOthCurrCOL");
     masterCont.add("claimableOthAmtCOL");
     collector.add("Claimable Other Charge : Container Deposit Currency");
     collector.add("Claimable Other Charge : Container Deposit Amount");
     masterCont.add("claimableOthCurrCTD");
     masterCont.add("claimableOthAmtCTD");
     collector.add("Claimable Other Charge : Container Damage Currency");
     collector.add("Claimable Other Charge : Container Damage Amount");
     masterCont.add("claimableOthCurrCOD");
     masterCont.add("claimableOthAmtCOD");
    }
   }
   collector.add("Claimable Other Charge : Add more other claimable");
   masterCont.add("claimableOthAdd");
	 
   if(e.extractAll("invoiceHandleAmt").equalsIgnoreCase("0.00"))
   {
    collector.add("Invoice Charge : Handling Currency");
    collector.add("Invoice Charge : Handling Amount");
    masterCont.add("invoiceHandleCurr");
    masterCont.add("invoiceHandleAmt");
   }

   // -- invoice Other Charge --
   if(v2!=null&&!v2.isEmpty()) 
     v2.removeAllElements();
   v2 = db.QueryMulti("invoiceOtherCharges","*","WHERE invoiceOthRefKey="+refNo+";");
   if(v2!=null)
   {
    if(importFlag)
    {
     if(!checkVector(v2,"invoiceOthDesc","Stamp Charge"))
     {
      collector.add("Invoice Other Charge : Stamp Currency");
      collector.add("Invoice Other Charge : Stamp Amount");
      masterCont.add("invoiceOthCurrSTP");
      masterCont.add("invoiceOthAmtSTP");
     }
     if(!checkVector(v2,"invoiceOthDesc","Import PPN Charge"))
     {
      collector.add("Invoice Other Charge : Import PPN Currency");
      collector.add("Invoice Other Charge : Import PPN Amount");
      masterCont.add("invoiceOthCurrPPN");
      masterCont.add("invoiceOthAmtPPN");
     }
    }
    else // Export
    {
     if(!checkVector(v2,"invoiceOthDesc","Export PPN Charge"))
     {
      collector.add("Invoice Other Charge : Export PPN Currency");
      collector.add("Invoice Other Charge : Export PPN Amount");
      masterCont.add("invoiceOthCurrPPN");
      masterCont.add("invoiceOthAmtPPN");
     }
    }
    if(!checkVector(v2,"invoiceOthDesc","Overnight Trucking Charge"))
    {
     collector.add("Invoice Other Charge : Overnight Trucking Currency");
     collector.add("Invoice Other Charge : Overnight Trucking Amount");
     masterCont.add("invoiceOthCurrOTC");
     masterCont.add("invoiceOthAmtOTC");
    }
   }
   else // there is no invoice other charges in database
   {
    if(importFlag)
    {
     collector.add("Invoice Other Charge : Stamp Currency");
     collector.add("Invoice Other Charge : Stamp Amount");
     collector.add("Invoice Other Charge : Import PPN Currency");
     collector.add("Invoice Other Charge : Import PPN Amount");
     masterCont.add("invoiceOthCurrSTP");
     masterCont.add("invoiceOthAmtSTP");
     masterCont.add("invoiceOthCurrPPN");
     masterCont.add("invoiceOthAmtPPN");
    }
    else
    {
     collector.add("Invoice Other Charge : Export PPN Currency");
     collector.add("Invoice Other Charge : Export PPN Amount");
     masterCont.add("invoiceOthCurrPPN");
     masterCont.add("invoiceOthAmtPPN");
    }
    collector.add("Invoice Other Charge : Overnight Trucking Currency");
    collector.add("Invoice Other Charge : Overnight Trucking Amount");
    masterCont.add("invoiceOthCurrOTC");
    masterCont.add("invoiceOthAmtOTC");
   }
   collector.add("Invoice Other Charge : Add more invoice other charges"); 
   masterCont.add("invoiceOthAdd");
   v = rearrange(v,collector);
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage()+"\n");
   if(v!=null&&!v.isEmpty()) v.removeAllElements();
   v = null;
  }
  finally
  {
   db.close();
  }
  if(v2!=null && !v2.isEmpty()) v2.removeAllElements();
  return v;
 }

 public Vector rearrange(Vector v,Vector silo)
 {
  int size = silo.size();
  for(int i=0;i<size;i++)
   v.add(new Data((String)silo.get(i),""));
  return v;
 }

 public boolean checkVector(Vector vin,String query,String check)
 {
  int pos = 0;
  int size = vin.size();
  boolean flag = false;
  Encap e = null;
  for(int i=0;i<size;i++)
  {
   e = (Encap)((Encap)vin.get(i)).clone();
   pos = e.getPosition(query);
   if(pos>=0 && e.getValue(pos).equalsIgnoreCase(check)) 
    flag = true;
   e.clear();
   if(flag) break;
  }
  return flag;
 }

 private class tableData extends AbstractTableModel
 {
  public final int LABEL = 0;
  public final int VALUE = 1;
  public Vector dataRow = null;
  public final String[] colNames = {"Description","Value"};
	
  public tableData(Vector v)
  { initData(v); }
  public void initData(Vector v)
  { dataRow = v; }
  public int getRowCount()
  { return dataRow.size(); }
  public Data getData(int row)
  { 
   if(row<0 || row>getRowCount()) return null;
   return (Data)dataRow.get(row); 
  }
  public int getColumnCount()
  { return colNames.length; }
  public String getColumnName(int column)
  { return colNames[column]; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { 
   if(column==VALUE) return true;
   return false; 
  }
  public Object getValueAt(int row,int column)
  {
   if(row<0||row>=getRowCount()) return " ";
   Data data = (Data)dataRow.get(row);
   switch(column)
   {
    case LABEL : return data.getLabel();
    case VALUE : return data.getValue();
   }
   return "";
  }
  public void setValueAt(Object obj,int row,int column)
  {
   if(row<0||row>=getRowCount()) return;
   Data data = (Data)dataRow.get(row);
   switch(column)
   {
    case LABEL : data.setLabel((String)obj); break;
    case VALUE : data.setValue((String)obj); break;
   }
   dataRow.setElementAt(data,row);
   fireTableCellUpdated(row,column);
  }
 }

 private class Data
 {
  StringBuffer label = new StringBuffer(56);
  StringBuffer value = new StringBuffer(56);
  public Data() { }
  public Data(String s1,String s2)
  {
   setLabel(s1);
   setValue(s2);
  }
  public void setLabel(String s1)
  { 
   if(label.length()>0) label.delete(0,label.length());
    label.append(s1);
  }
  public void setValue(String s2)
  {
   if(value.length()>0) value.delete(0,value.length());
   value.append(s2);
  }
  public String getLabel()
  { return label.toString(); }
  public String getValue()
  { return value.toString(); }
 }
}
