import java.sql.SQLException;
import java.io.*;

public class DBFunction
{
 private int action = 0;
 private Runtime rt = null;
 private String dbname = null;
 private boolean success = true;
 private StringBuffer error = new StringBuffer(128);
 private final String copyCMD = new String("copy");
 private final String stopCMD = new String("NET STOP MySql");
 private final String startCMD = new String("NET START MySql");
 private final String defPath = new String("C:"+File.separator+"mysql"+
	 File.separator+"data"+File.separator);
 private final String defibdata = new String("C:"+File.separator+
	 "ibdata"+File.separator);
 private final String defiblogs = new String("C:"+File.separator+
	 "iblogs"+File.separator);
 private final String defconf = new String("C:"+File.separator+
	 "my.cnf");
 private String folderLocation = null;
 private String folderData = null;
 private String folderIBLOGS = null;
 private String folderIBDATA = null;

 public DBFunction(int act,String db,String fold)
 {
  if(act!=Module7.DBCREATE&&act!=Module7.DBUSE&&
		 act!=Module7.DBDROP&&act!=Module7.DBBACKUP)
  {
   error.append("No support for the requested action: "+act+"\n");
	 success = false;
	}
	if(db== null || db.length()<3)
	{
   error.append("Received invalid database name: "+db+"\n");
	 success = false;
	}
	if(fold == null || fold.length()<3)
	{
   error.append("Received invalid folder location: "+fold+"\n");
	 success = false;
	}

	if(!success)
	{
   Module7.errorDisplay(error.toString(),"ERROR");
	 return;
	}
	action = act;
  dbname = new String(db);
	folderLocation = new String(fold);
  folderData = new String(fold+File.separator+"data"+File.separator);
  folderIBLOGS = new String(fold+File.separator+"iblogs"+File.separator);
  folderIBDATA = new String(fold+File.separator+"ibdata"+File.separator);

	try
	{
	 rt = Runtime.getRuntime();
	 checkCreateFolder();
	 switch(act)
	 {
	  case Module7.DBUSE    : proceedUse(); break;
	  case Module7.DBDROP   : proceedDrop(); break;
    case Module7.DBCREATE : proceedCreate(); break;
	  case Module7.DBBACKUP : proceedBackup(); break;
	 }
  }
	catch(Exception ex)
	{
   ex.printStackTrace(System.out);
	 error.append(ex.getMessage());
	 Module7.errorDisplay(error.toString(),"ERROR");
	}
	finally
	{
   rt = null;
	 System.gc();
	}
  
 }

 public void shutdown() throws IOException 
 {
  rt.exec(stopCMD);
 }

 public void start() throws IOException 
 {
  rt.exec(stopCMD);
 }

 public void checkCreateFolder() throws IOException
 {
  File directory = new File(folderLocation);
	if(!directory.exists()) directory.mkdirs();
 }

 public void proceedUse() throws IOException 
 {

 }

 public void proceedDrop() throws IOException 
 {

 }

 public void proceedCreate() throws IOException 
 {

 }

 public void proceedBackup() throws IOException 
 {
  checkCreateFolder();
  StringBuffer cmd = new StringBuffer("mysqldump --tab=");
	cmd.append(folderLocation+" --opt "+dbname);
	rt.exec(cmd.toString());
	shutdown();
	cmd.delete(0,cmd.length());
	cmd.append(copyCMD+" "+defPath+"*.* "+folderData);
	rt.exec(cmd.toString());
	cmd.delete(0,cmd.length());
	cmd.append(copyCMD+" "+defibdata+"*.* "+folderIBDATA);
	rt.exec(cmd.toString());
	cmd.delete(0,cmd.length());
	cmd.append(copyCMD+" "+defiblogs+"*.* "+folderIBLOGS);
	rt.exec(cmd.toString());
	cmd.delete(0,cmd.length());
	cmd.append(copyCMD+" "+defconf+" "+folderLocation);
  rt.exec(cmd.toString());
	cmd.delete(0,cmd.length());
	start();
 }

}
