import java.io.*;
import java.sql.*;
import javax.sql.*;
import java.util.Vector;
import java.util.HashMap;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.math.BigDecimal;

public class DataKeeper
{
 // Action
 private final static int IMP = 1;
 private final static int EXP = 2;
 private final static int DPF = 3;
 private final static int RPF = 4;
 private int action;
 // Map
 private MultipleCurrency mc = new MultipleCurrency();

 private StringBuffer error = new StringBuffer();
 private boolean skipFlag = false;

 public DataKeeper(HashMap map, int dkaction)
 {
  if(map == null)
  {
   Module7.errorDisplay("Receive an empty data","Error");
   System.gc();
   return;
  }
  action = dkaction;
  System.out.println("DataKeeper constructor");
  int r = 0;
  DBConnect dbcon = new DBConnect();
  try
  {
   if(!dbcon.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   switch(action)
   {
    case IMP : r = setImport(map,dbcon); break;
    case EXP : r = setExport(map,dbcon); break;
    case DPF : setDPF(map,dbcon); break;
    case RPF : setRPF(map,dbcon); break;
    default  : throw new SQLException("No service available for this action!");
   }
   if((error.length()==0)&&!skipFlag)
   {
    if(action == IMP || action == EXP)
    Module7.infoDisplay(
    "Your data has successfully entered into database with Ref No."+r,
    "Confirmation");
    else
     Module7.infoDisplay(
     "Your data has successfully entered into database","Confirmation");
   }
   else if(!skipFlag)
    throw new SQLException(error.toString()+"\n");
  }
  catch(Exception e)
  {
   e.printStackTrace(System.out); 
   System.out.println("Exception in DataKeeper");
   Module7.errorDisplay((String)e.getMessage(),"ERROR");
  }
  finally
  {
   dbcon.close();
   map.clear();
   mc.clearVariable();
   System.gc();
  }
  return;
 }

/**
 * setImportInfo's method is to set Import Information. It does the input 
 * verification and it is an error, it will store the error message to
 * Vector to be display later on the calling class
 * @param HashMap map contains all the import info with name-value pair
 * @return Vector contains error messages to be display if any error occured
 */
 public int setImport(HashMap map,DBConnect dbcon) throws SQLException
 {
  int len = 0;
  int len1= 0;
  int len2= 0;
  int number = 0;
  Encap db2 = null; 
  Encap db  = new Encap();
  HashMap tmp = new HashMap();
  Vector setIMP = new Vector();
  StringBuffer msg = new StringBuffer();
  StringBuffer msg1= new StringBuffer();
  StringBuffer msg2= new StringBuffer();
  System.out.println("----Enter setImport------");
  // check the database for existing customer 
  msg.append("WHERE customerName=\""+(String)map.get("CosignName")+"\";");
  db2 = dbcon.QuerySingle("customer","*",msg.toString());
  int pos1 = 0;
  if(db2 == null)
  {
   db.setTable("customer");
   db.setNameVal("customerName",(String)map.get("CosignName"));
   if(map.containsKey("CosignAddr"))
    db.setNameVal("customerAddr",(String)map.get("CosignAddr"));
   db.setVariable("SET @customerKey = LAST_INSERT_ID();");
   setIMP.add(db.clone());
   db.clear();
  }
  else
  {
   pos1 = db2.getPosition("customerKey");
   tmp.put("customerKey",db2.getValue(pos1));
   if(map.containsKey("CosignAddr"))
   {
    if(!((String)map.get("CosignAddr")).equalsIgnoreCase(
			 db2.extractAll("customerAddr")))
    {
     db.setTable("customer");
     db.setNameVal("customerAddr",(String)map.get("CosignAddr"));
     db.setCondition("WHERE customerKey="+db2.extractAll("customerKey"));
     System.out.println("Going to update : ");
     dbcon.viewEncap(db); 
     dbcon.UpdateData((Encap)db.clone());
     db.clear();
    }
   }
  }
  
  int refNo = Integer.parseInt((String)map.get("ImportRefNo"));
  while(dbcon.QuerySingle("transRecord","transRefKey",
		 "WHERE transRefKey="+refNo+";")
   != null)
  {
   refNo++; 
  }

  if(db2!= null) db2.clear();
  msg.delete(0,msg.length());
  msg.append("WHERE truckingName=\"");
  msg.append((String)map.get(new String("ImportTruckName"))+"\";");
  db2 = dbcon.QuerySingle("truckingCompany","*",msg.toString());
  if(db2 == null)
  {
   db.setTable("truckingCompany");
   db.setNameVal("truckingName",(String)map.get("ImportTruckName")); 
   db.setVariable("SET @truckingKey = LAST_INSERT_ID();");
   setIMP.add(db.clone());
   db.clear();
  }
  else
  {
   pos1 = db2.getPosition("truckingCompanyKey");
   tmp.put("truckingKey",db2.getValue(pos1));
  }

  msg.delete(0,msg.length());
  if(db2!=null) db2.clear();

  //transRecord
  db.setTable("transRecord");
  db.setNameVal("transType","IMP");
  db.setNameVal("transRefKey",refNo);
  db.setName("transCustKey");
  if(tmp.containsKey("customerKey")) // check if it is existing customer
   db.setValue(Integer.parseInt((String)tmp.get("customerKey")));
  else
   db.setValue("@customerKey");
  db.setName("transTrucking");
  if(tmp.containsKey("truckingKey")) // check if trucking co existed
   db.setValue(Integer.parseInt((String)tmp.get("truckingKey")));
  else
   db.setValue("@truckingKey");
  db.setNameVal("transDoorLocation",(String)map.get("ImportDoorLoc"));
  db.setNameVal("transLoadingPort",(String)map.get("ImportLoadPort"));
  db.setNameVal("transDate","CURRENT_DATE");
  setIMP.add(db.clone());
  db.clear();

  //impInfoRecord
  db.setTable("impInfoRecord");
  if(map.containsKey("ImportGateOutDate"))
   db.setNameVal("impGateOut",(String)map.get("ImportGateOutDate"));
  if(map.containsKey("ImportArrDate"))
   db.setNameVal("impArrival",(String)map.get("ImportArrDate"));
  if(map.containsKey("ImportContRetDate"))
   db.setNameVal("impContReturnDate",(String)map.get("ImportContRetDate"));
  if(map.containsKey("ImportBLNo"))
   db.setNameVal("impBLNo",(String)map.get("ImportBLNo"));
  db.setNameVal("impFromRefKey",refNo);
  setIMP.add(db.clone());
  db.clear();
  

  //transVol
  System.out.println("Going to transVol");
  int diffStorage = Integer.parseInt((String)map.get("ImportNumStorage"));
  boolean[] pool = new boolean[diffStorage]; 
  StringBuffer tmpStowage = new StringBuffer(16);
  for(int i=1;i<=diffStorage;i++)
  {
   tmpStowage.append((String)map.get("StowageFactor"+i));
   if(Module7.checkStowageException(tmpStowage.toString()))
    pool[i-1] = true;
   else
    pool[i-1] = false;
   db.setTable("transVol");
   db.setNameVal("transVolVolume",Integer.parseInt((String)map.get("Volume"+i)));
   db.setNameVal("transVolStowage",tmpStowage.toString());
   db.setNameVal("transVolRefKey",refNo);
   if(!pool[i-1])
    db.setVariable("SET @transVolKey"+i+" = LAST_INSERT_ID();");
   setIMP.add(db.clone());
   db.clear();
   tmpStowage.delete(0,tmpStowage.length());
  }

  //transContainer
  System.out.println("Going to transContainer");
  int volume = 0;
  String container = "Container";
  String seal = "Seal";
  for(int i=1;i<=diffStorage;i++)
  {
   if(!pool[i-1])
   {
    volume = Integer.parseInt((String)map.get("Volume"+i));
    msg.append(i+"Container");
    msg2.append(i+"Seal");
    len1 = msg.length();
    len2 = msg2.length();
    for(int j=1;j<=volume;j++)
    {
     msg.append(j); 
     msg2.append(j);
     System.out.println("container: "+msg.toString());
     db.setTable("transContainer");
     db.setNameVal("transContNo",(String)map.get(msg.toString()));
     db.setNameVal("transContSealNo",(String)map.get(msg2.toString()));
     db.setNameVal("transContVolKey","@transVolKey"+i);
     db.setNameVal("transContRefNo",refNo);
     setIMP.add(db.clone());
     db.clear();
     msg.delete(len1,msg.length());
     msg2.delete(len2,msg2.length());
    }
    msg.delete(0,msg.length());
    msg2.delete(0,msg2.length());
   }
  }

  System.out.println("----set costRecord [1]---");
  //costRecord
  db.setTable("costRecord");
  db.setNameVal("costTotalOp",new BigDecimal((String)map.get("ImportOpCost")));
  db.setNameVal("costTotalOpCurr",(String)map.get("ImportOpCostCurr"));
  db.setNameVal("costTrucking",new BigDecimal(
			  (String)map.get("ImportTruckCost")));
  db.setNameVal("costTruckingCurr",(String)map.get("ImportTruckCostCurr"));
  mc.sumAP(db.extractAll("costTruckingCurr"),
   db.extractAll("costTrucking"));

  if(map.containsKey("ImportCommCost"))
  {
   System.out.println("----set costRecord[2] Commission---");
   db.setNameVal("costCommission",new BigDecimal(
     (String)map.get("ImportCommCost"))); 
   db.setNameVal("costCommissionCurr",(String)map.get("ImportCommCostCurr"));
  }
  db.setNameVal("costFromRefKey",refNo);
  setIMP.add(db.clone());
  db.clear();

  if(map.containsKey("ImportOTruckCost"))
  {
   System.out.println("----set costRecord[3] Overnight---");
   db.setTable("otherCost");
   db.setNameVal("costOthDesc","Overnight Trucking Cost");
   db.setNameVal("costOthAmt",new BigDecimal(
     (String)map.get("ImportOTruckCost")));
   db.setNameVal("costOthCurr",(String)map.get("ImportOTruckCostCurr"));
   db.setNameVal("costOthRefKey",refNo);
   mc.sumAP(db.extractAll("costOthCurr"),
	 db.extractAll("costOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //other cost - Red Zone Cost
  if(map.containsKey("ImportRedZoneCost"))
  {
   System.out.println("---set cost: RedZone--");
   db.setTable("otherCost");
   db.setNameVal("costOthDesc","Red Zone Cost");
   db.setNameVal("costOthAmt",new BigDecimal(
    (String)map.get("ImportRedZoneCost")));
   db.setNameVal("costOthCurr",(String)map.get("ImportRedZoneCostCurr"));
   db.setNameVal("costOthRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }

  //other cost - POM Cost
  if(map.containsKey("ImportPOMCost"))
  {
   System.out.println("---set cost: POM--");
   db.setTable("otherCost");
   db.setNameVal("costOthDesc","POM Cost");
   db.setNameVal("costOthAmt",new BigDecimal(
    (String)map.get("ImportPOMCost")));
   db.setNameVal("costOthCurr",(String)map.get("ImportPOMCostCurr"));
   db.setNameVal("costOthRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }

  //check Other cost
  if(map.containsKey("ImportNumberOthCost"))
  {
   number = Integer.parseInt((String)map.get("ImportNumberOthCost"));
   System.out.println("ImportNumberOthCost: "+number);
   msg.append("ImportNumberOthCost");
   msg1.append("ImportNumberOthCostCurr");
   msg2.append("ImportNumberOthCostAmt");
   len = msg.length();
   len1= msg1.length();
   len2= msg2.length();
   for(int i=0;i<number;i++)
   {
    msg.append(i+1);
    msg1.append(i+1);
    msg2.append(i+1);
    db.setTable("otherCost");
    db.setNameVal("costOthDesc",(String)map.get(msg.toString()));
    db.setNameVal("costOthAmt",new BigDecimal(
     (String)map.get(msg2.toString())));
    db.setNameVal("costOthCurr",(String)map.get(msg1.toString()));
    db.setNameVal("costOthRefKey",refNo);
    setIMP.add(db.clone());
    db.clear();
    msg.delete(len,msg.length());
    msg1.delete(len1,msg1.length());
    msg2.delete(len2,msg2.length());
   } // end of for-loop
   msg.delete(0,msg.length());
   msg1.delete(0,msg1.length());
   msg2.delete(0,msg2.length());
  }

  System.out.println("---set invoiceRecord: Sell--");
  //invoiceRecord
  db.setTable("invoiceRecord");
  db.setNameVal("invoiceSellAmt",new BigDecimal(
   (String)map.get("ImportSellRate")));
  db.setNameVal("invoiceSellCurr",(String)map.get("ImportSellRateCurr"));
  mc.sumAR(db.extractAll("invoiceSellCurr"),
   db.extractAll("invoiceSellAmt"));

  if(map.containsKey("ImportHandleCharge"))
  {
   System.out.println("---set invoiceOther: Handle--");
   db.setNameVal("invoiceHandleAmt",new BigDecimal(
    (String)map.get("ImportHandleCharge")));
   db.setNameVal("invoiceHandleCurr",
   (String)map.get("ImportHandleChargeCurr"));
   mc.sumAR(db.extractAll("invoiceHandleCurr"),
    db.extractAll("invoiceHandleAmt"));
  }
  db.setNameVal("invoiceRefKey",refNo);
  setIMP.add(db.clone());
  db.clear(); 

  if(map.containsKey("ImportStampCharge"))
  {
   System.out.println("---set invoiceOther: Stamp--");
   db.setTable("invoiceOtherCharges");
   db.setNameVal("invoiceOthDesc","Stamp Charge");
   db.setNameVal("invoiceOthAmt",new BigDecimal(
			(String)map.get("ImportStampCharge")));
   db.setNameVal("invoiceOthCurr",(String)map.get("ImportStampChargeCurr"));
   db.setNameVal("invoiceOthRefKey",refNo);
   mc.sumAR(db.extractAll("invoiceOthCurr"),
    db.extractAll("invoiceOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  if(map.containsKey("ImportOTruckCharge"))
  {
   System.out.println("---set invoiceOther: Overnight Truck--");
   db.setTable("invoiceOtherCharges");
   db.setNameVal("invoiceOthDesc","Overnight Trucking Charge");
   db.setNameVal("invoiceOthAmt",new BigDecimal(
			(String)map.get("ImportOTruckCharge")));
   db.setNameVal("invoiceOthCurr",(String)map.get("ImportOTruckChargeCurr"));
   db.setNameVal("invoiceOthRefKey",refNo);
   mc.sumAR(db.extractAll("invoiceOthCurr"),
    db.extractAll("invoiceOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //invoiceOtherCharges
  if(map.containsKey("ImportPPNCharge"))
  {
   System.out.println("---set invoiceOther: PPN--");
   db.setTable("invoiceOtherCharges");
   db.setNameVal("invoiceOthDesc","Import PPN Charge");
   db.setNameVal("invoiceOthAmt",
     new BigDecimal((String)map.get("ImportPPNCharge")));
   db.setNameVal("invoiceOthCurr",(String)map.get("ImportPPNChargeCurr"));
   db.setNameVal("invoiceOthRefKey",refNo);
   mc.sumAR(db.extractAll("invoiceOthCurr"),
    db.extractAll("invoiceOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  // Number of Invoice Other Charges
  if(map.containsKey("ImportNumberOthInvoice"))
  {
   number = Integer.parseInt((String)map.get("ImportNumberOthInvoice"));
   msg.append("ImportNumberOthInvoice");
   msg1.append("ImportNumberOthInvoiceCurr");
   msg2.append("ImportNumberOthInvoiceAmt");
   len = msg.length();
   len1= msg1.length();
   len2= msg2.length();
   for(int i=0;i<number;i++)
   {
    msg.append(i+1);
    msg1.append(i+1);
    msg2.append(i+1);
    db.setTable("invoiceOtherCharges");
    db.setNameVal("invoiceOthDesc",(String)map.get(msg.toString()));
    db.setNameVal("invoiceOthCurr",(String)map.get(msg1.toString()));
    db.setNameVal("invoiceOthAmt",new BigDecimal(
     (String)map.get(msg2.toString())));
    db.setNameVal("invoiceOthRefKey",refNo);
    mc.sumAR(db.extractAll("invoiceOthCurr"),db.extractAll("invoiceOthAmt"));
    setIMP.add(db.clone());
    db.clear();
    msg.delete(len,msg.length());
    msg1.delete(len1,msg1.length());
    msg2.delete(len2,msg2.length());
   }
   msg.delete(0,len);
   msg1.delete(0,len1);
   msg2.delete(0,len2);
  }

  System.out.println("---set claimableCharge: TotalLiftOn & TotalLiftOff--");
  //claimableCharges -- Total Lift On  & Total Lift Off

  db.setTable("claimableCharges");
  if(map.containsKey("ImportLiftOn"))
  {
   db.setNameVal("claimableTotalLiftOnAmt",
    new BigDecimal((String)map.get("ImportLiftOn")));
   db.setNameVal("claimableTotalLiftOnCurr",
    (String)map.get("ImportLiftOnCostCurr"));
   mc.sumAR(db.extractAll("claimableTotalLiftOnCurr"),
    db.extractAll("claimableTotalLiftOnAmt"));
  }
  if(map.containsKey("ImportLiftOff"))
  {
   db.setNameVal("claimableTotalLiftOffAmt", 
    new BigDecimal((String)map.get("ImportLiftOff")));
   db.setNameVal("claimableTotalLiftOffCurr",
    (String)map.get("ImportLiftOffCostCurr"));
   mc.sumAR(db.extractAll("claimableTotalLiftOffCurr"),
    db.extractAll("claimableTotalLiftOffAmt"));
  }
  db.setNameVal("claimablePrintable","YES");
  db.setNameVal("claimableRefKey",refNo);
  setIMP.add(db.clone());
  db.clear();

  //claimableOtherCharges 
  if(map.containsKey("ImportNumberOthCharges"))
  {
   number = Integer.parseInt((String)map.get("ImportNumberOthCharges"));
   msg.append("ImportNumberOthCharges");
   msg1.append("ImportNumberOthChargesCurr");
   msg2.append("ImportNumberOthChargesAmt");
   len = msg.length();
   len1= msg1.length();
   len2= msg2.length();
   for(int i=0;i<number;i++)
   {
    msg.append(i+1);
    msg1.append(i+1);
    msg2.append(i+1);
    db.setTable("claimableOtherCharges");
    db.setNameVal("claimableOthDesc",(String)map.get(msg.toString()));
    db.setNameVal("claimableOthAmt",new BigDecimal(
			 (String)map.get(msg2.toString())));
    db.setNameVal("claimableOthCurr",(String)map.get(msg1.toString()));
    db.setNameVal("claimableOthRefKey",refNo);
    setIMP.add(db.clone());
    mc.sumAR(db.extractAll("claimableOthCurr"),
	db.extractAll("claimableOthAmt"));
    db.clear();
    msg.delete(len,msg.length());
    msg1.delete(len1,msg1.length());
    msg2.delete(len2,msg2.length());
   }
   msg.delete(0,len);
   msg1.delete(0,len1);
   msg2.delete(0,len2);
  }
 
  //claimableOtherCharges -- Quarantine
  if(map.containsKey("ImportQuarantineCost"))
  {
	 System.out.println("---set otherClaimable: Quarantine--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Quarantine");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportQuarantineCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportQuarantineCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
     db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableOtherCharges -- Bahandle
  if(map.containsKey("ImportBahandleCost"))
  {
	 System.out.println("---set otherClaimable: Behandle--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Bahandle");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportBahandleCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportBahandleCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
    db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableOtherCharges -- Demurrage
  if(map.containsKey("ImportDemurrageCost"))
  {
	 System.out.println("---set otherClaimable: Demurrage--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Demurrage");
   db.setNameVal("claimableOthAmt",new BigDecimal(
    (String)map.get("ImportDemurrageCost")));
   db.setNameVal("claimableOthCurr",
    (String)map.get("ImportDemurrageCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
    db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableOtherCharges -- Detention
  if(map.containsKey("ImportDetentionCost"))
  {
   System.out.println("---set otherClaimable: Detention--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Detention");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportDetentionCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportDetentionCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
    db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableOtherCharges -- OceanFreight
  if(map.containsKey("ImportOceanCost"))
  {
   System.out.println("---set otherClaimable: Ocean Freight--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Ocean Freight");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportOceanCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportOceanCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
    db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableOtherCharges -- THC
  if(map.containsKey("ImportTHCCost"))
  {
	 System.out.println("---set otherClaimable: THC--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","THC");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportTHCCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportTHCCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
		 db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableOtherCharges -- Insurance
  if(map.containsKey("ImportInsuranceCost"))
  {
	 System.out.println("---set otherClaimable: Insurance--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Insurance");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportInsuranceCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportInscCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
		 db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableCharges -- Doc
  if(map.containsKey("ImportDocCost"))
  {
	 System.out.println("---set otherClaimable: Doc--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Doc");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportDocCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportDocCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
		 db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableCharges -- Cleaning
  if(map.containsKey("ImportCleanCost"))
  {
   System.out.println("---set otherClaimable: Cleaning--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Cleaning");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportCleanCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportCleanCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
		 db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  //claimableCharges -- Container Deposit
  if(map.containsKey("ImportContainerDeposit"))
  {
   System.out.println("---set otherClaimable: Container Deposit--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Container Deposit");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportContainerDeposit")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportContDepCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
		 db.extractAll("claimableOthAmt"));

   setIMP.add(db.clone());
   db.clear();
  }

  //claimableCharges -- Coloader
  if(map.containsKey("ImportColoaderCost"))
  {
   System.out.println("---set otherClaimable: Coloader--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Coloader");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportColoaderCost")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportColoaderCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
		 db.extractAll("claimableOthAmt"));

   setIMP.add(db.clone());
   db.clear();
  }

  //claimableCharges -- ContainerDamage
  if(map.containsKey("ImportContainerDamage"))
  {
   System.out.println("---set otherClaimable: Container Damage--");
   db.setTable("claimableOtherCharges");
   db.setNameVal("claimableOthDesc","Container Damage");
   db.setNameVal("claimableOthAmt",new BigDecimal(
		(String)map.get("ImportContainerDamage")));
   db.setNameVal("claimableOthCurr",
		(String)map.get("ImportContDamageCostCurr"));
   db.setNameVal("claimableOthRefKey",refNo);
   mc.sumAR(db.extractAll("claimableOthCurr"),
		 db.extractAll("claimableOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  System.out.println("-- set accountReceivable");
  //set accountReceivable
  if(mc.checkAR(0))
  {
   db.setTable("accountReceivable");
   db.setNameVal("acctRecAmt",mc.getSumAR(0));
   db.setNameVal("acctRecBalance",mc.getSumAR(0));
   db.setNameVal("acctRecCurr",mc.getCurr(0));
   if(tmp.containsKey("customerKey"))
    db.setNameVal("acctRecFromCustKey",(String)tmp.get("customerKey"));
   else
    db.setNameVal("acctRecFromCustKey","@customerKey");
   db.setNameVal("acctRecFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  if(mc.checkAR(1))
  {
   db.setTable("accountReceivable");
   db.setNameVal("acctRecAmt",mc.getSumAR(1));
   db.setNameVal("acctRecBalance",mc.getSumAR(1));
   db.setNameVal("acctRecCurr",mc.getCurr(1));
   if(tmp.containsKey("customerKey"))
    db.setNameVal("acctRecFromCustKey",(String)tmp.get("customerKey"));
   else
    db.setNameVal("acctRecFromCustKey","@customerKey");
   db.setNameVal("acctRecFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  if(mc.checkAR(2))
  {
   db.setTable("accountReceivable");
   db.setNameVal("acctRecAmt",mc.getSumAR(2));
   db.setNameVal("acctRecBalance",mc.getSumAR(2));
   db.setNameVal("acctRecCurr",mc.getCurr(2));
   if(tmp.containsKey("customerKey"))
    db.setNameVal("acctRecFromCustKey",(String)tmp.get("customerKey"));
   else
    db.setNameVal("acctRecFromCustKey","@customerKey");
   db.setNameVal("acctRecFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  if(mc.checkAR(3))
  {
   db.setTable("accountReceivable");
   db.setNameVal("acctRecAmt",mc.getSumAR(3));
   db.setNameVal("acctRecBalance",mc.getSumAR(3));
   db.setNameVal("acctRecCurr",mc.getCurr(3));
   if(tmp.containsKey("customerKey"))
    db.setNameVal("acctRecFromCustKey",(String)tmp.get("customerKey"));
   else
    db.setNameVal("acctRecFromCustKey","@customerKey");
   db.setNameVal("acctRecFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }

  System.out.println("-- set accountPayable");
  //set accountPayable
  if(mc.checkAP(0))
  {
   db.setTable("accountPayable");
   db.setNameVal("acctPayAmt",mc.getSumAP(0));
   db.setNameVal("acctPayBalance",mc.getSumAP(0));
   db.setNameVal("acctPayCurr",mc.getCurr(0));
   if(tmp.containsKey("truckingKey"))
    db.setNameVal("acctPayToTruckCoKey",(String)tmp.get("truckingKey"));
   else
    db.setNameVal("acctPayToTruckCoKey","@truckingKey");
   db.setNameVal("acctPayToRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  if(mc.checkAP(1))
  {
   db.setTable("accountPayable");
   db.setNameVal("acctPayAmt",mc.getSumAP(1));
   db.setNameVal("acctPayBalance",mc.getSumAP(1));
   db.setNameVal("acctPayCurr",mc.getCurr(1));
   if(tmp.containsKey("truckingKey"))
    db.setNameVal("acctPayToTruckCoKey",(String)tmp.get("truckingKey"));
   else
    db.setNameVal("acctPayToTruckCoKey","@truckingKey");
   db.setNameVal("acctPayToRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  if(mc.checkAP(2))
  {
   db.setTable("accountPayable");
   db.setNameVal("acctPayAmt",mc.getSumAP(2));
   db.setNameVal("acctPayBalance",mc.getSumAP(2));
   db.setNameVal("acctPayCurr",mc.getCurr(2));
   if(tmp.containsKey("truckingKey"))
    db.setNameVal("acctPayToTruckCoKey",(String)tmp.get("truckingKey"));
   else
    db.setNameVal("acctPayToTruckCoKey","@truckingKey");
   db.setNameVal("acctPayToRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  if(mc.checkAP(3))
  {
   db.setTable("accountPayable");
   db.setNameVal("acctPayAmt",mc.getSumAP(3));
   db.setNameVal("acctPayBalance",mc.getSumAP(3));
   db.setNameVal("acctPayCurr",mc.getCurr(3)); 
   if(tmp.containsKey("truckingKey"))
    db.setNameVal("acctPayToTruckCoKey",(String)tmp.get("truckingKey"));
   else
    db.setNameVal("acctPayToTruckCoKey","@truckingKey");
   db.setNameVal("acctPayToRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
//  System.out.println("---Going to Insert----");
//  for(int i=0;i<setIMP.size();i++)
//   dbcon.viewEncap((Encap)setIMP.get(i)); 
  dbcon.InsertMulti(setIMP);
  System.out.println("---Going to exit setImport");
  return refNo;
 }

/**
 * setExport's method is input the export data int the database using
 * DBConnect and Encap as the vehichle.
 * @param HashMap map
 * @return none
 */
 public int setExport(HashMap map,DBConnect dbcon) throws SQLException
 {
  int number = 0;
  int len = 0;
  int len1= 0;
  int len2= 0;
  Encap db2= null;
  Encap db = new Encap();
  Vector setIMP = new Vector();
  HashMap tmp = new HashMap();
  StringBuffer msg = new StringBuffer();
  StringBuffer msg1= new StringBuffer();
  StringBuffer msg2= new StringBuffer();
  System.out.println("----Enter setExport------");

  // check the database for existing customer
  msg.append("WHERE customerName=\""+(String)map.get("ShipperName")+"\";");
  db2 = dbcon.QuerySingle("customer","*",msg.toString());
  msg.delete(0,msg.length());
  int pos1 = 0;
  System.out.println("DataKeeper : going to set customer");
  if(db2 == null)
  {
   db.setTable("customer");
   db.setNameVal("customerName",(String)map.get("ShipperName"));
   db.setVariable("SET @customerKey = LAST_INSERT_ID();");
   setIMP.add(db.clone());
   db.clear();
  }
  else
  {
   pos1 = db2.getPosition("customerKey");
   tmp.put("customerKey",db2.getValue(pos1));
  }

  System.out.println("DataKeeper : going to set trucking co");

  if(db2!=null) db2.clear();
  msg.append("WHERE truckingName=\"");
  msg.append((String)map.get(new String("ExportTruckName")));
  msg.append("\";");
  db2 = dbcon.QuerySingle("truckingCompany","*",msg.toString());
  if(db2 == null)
  {
   db.setTable("truckingCompany");
   db.setNameVal("truckingName",(String)map.get("ExportTruckName"));
   db.setVariable("SET @truckingKey = LAST_INSERT_ID();");
   setIMP.add(db.clone());
   db.clear();
  }
  else
  {
   pos1 = db2.getPosition("truckingCompanyKey");
   tmp.put("truckingKey",db2.getValue(pos1));
  }

  msg.delete(0,msg.length());
  if(db2!=null) db2.clear();
  System.out.println("DataKeeper : going to set transRecord");

  int refNo = Integer.parseInt((String)map.get("ExportRefNo")); 
  while(dbcon.QuerySingle("transRecord","transRefKey",
		 "WHERE transRefKey="+refNo+";")!= null)
  {
   refNo++;
  }

  //transRecord
  db.setTable("transRecord");
  db.setNameVal("transRefKey",refNo);
  db.setNameVal("transType","EXP");
  db.setName("transCustKey");
  if(tmp.containsKey("customerKey"))
   db.setValue(Integer.parseInt((String)tmp.get("customerKey")));
  else
   db.setValue("@customerKey");
  db.setName("transTrucking");
  if(tmp.containsKey(new String("truckingKey")))
   db.setValue(Integer.parseInt((String)tmp.get("truckingKey")));
  else
   db.setValue("@truckingKey");
  db.setNameVal("transDoorLocation",(String)map.get("ExportDoorLoc"));
  db.setNameVal("transLoadingPort",(String)map.get("ExportLoadPort")); 
  db.setNameVal("transDate","CURRENT_DATE");
  setIMP.add(db.clone());
  db.clear();

  System.out.println("DataKeeper : going to set transContainer");

  //transVol
  System.out.println("Going to transVol");
  int diffStorage = Integer.parseInt((String)map.get("ExportNumStorage"));
  boolean[] pool = new boolean[diffStorage];
  for(int i=1;i<=diffStorage;i++)
  {
   msg.append((String)map.get("StowageFactor"+i));
   if(Module7.checkStowageException(msg.toString()))
    pool[i-1] = true;
   else
    pool[i-1] = false;
   db.setTable("transVol");
   db.setNameVal("transVolVolume",
    Integer.parseInt((String)map.get("Volume"+i)));
   db.setNameVal("transVolStowage",msg.toString());
   db.setNameVal("transVolRefKey",refNo);
   if(!pool[i-1])
    db.setVariable("SET @transVolKey"+i+" = LAST_INSERT_ID();");
   setIMP.add(db.clone());
   db.clear();
   msg.delete(0,msg.length());
  }

  //transContainer
  int volume = 0;
  String container = "Container";
  String seal = "Seal";
  for(int i=1;i<=diffStorage;i++)
  {
   if(!pool[i-1])
   {
    volume = Integer.parseInt((String)map.get("Volume"+i));
    msg.append(i+"Container");
    msg2.append(i+"Seal");
    len1 = msg.length();
    len2 = msg2.length();
    for(int j=1;j<=volume;j++)
    {
     msg.append(j);
     msg2.append(j);
     System.out.println("container: "+msg.toString());
     db.setTable("transContainer");
     db.setNameVal("transContNo",(String)map.get(msg.toString()));
     db.setNameVal("transContSealNo",(String)map.get(msg2.toString()));
     db.setNameVal("transContVolKey","@transVolKey"+i);
     db.setNameVal("transContRefNo",refNo);
     setIMP.add(db.clone());
     db.clear();
     msg.delete(len1,msg.length());
     msg2.delete(len2,msg2.length());
    }
    msg.delete(0,msg.length());
    msg2.delete(0,msg2.length());
   }
  }

  System.out.println("DataKeeper : going to set expInfoRecord");

  //expInfoRecord
  if(map.containsKey("ExportSINo")||
     map.containsKey("ExportDestName") ||
     map.containsKey("ExportVessel") ||
     map.containsKey("ExportStuffingDate") ||
     map.containsKey("ExportETD"))
  {
   db.setTable("expInfoRecord");
   if(map.containsKey("ExportSINo"))
    db.setNameVal("expSINo",(String)map.get("ExportSINo"));
   if(map.containsKey("ExportDestName"))
    db.setNameVal("expDestName",(String)map.get("ExportDestName"));
   if(map.containsKey("ExportVessel"))
    db.setNameVal("expVesselName",(String)map.get("ExportVessel"));
   if(map.containsKey("ExportStuffingDate"))
    db.setNameVal("expStuffingDate",(String)map.get("ExportStuffingDate"));
   if(map.containsKey("ExportETD"))
    db.setNameVal("expETD",(String)map.get("ExportETD"));
   db.setNameVal("expFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }

  System.out.println("DataKeeper : going to set costRecord");

  //costRecord 
  db.setTable("costRecord");
  db.setNameVal("costTotalOp",new BigDecimal(
		 (String)map.get("ExportOpCost")));
  db.setNameVal("costTotalOpCurr",(String)map.get("ExportOpCostCurr"));
  db.setNameVal("costTrucking",new BigDecimal(
		 (String)map.get("ExportTruckCost"))); 
  db.setNameVal("costTruckingCurr",(String)map.get("ExportTruckCostCurr")); 
  mc.sumAP(db.extractAll("costTruckingCurr"),
  	   db.extractAll("costTrucking"));
  if(map.containsKey("ExportCommCost"))
  {
   db.setNameVal("costCommission",new BigDecimal(
		(String)map.get("ExportCommCost"))); 
   db.setNameVal("costCommissionCurr",(String)map.get("ExportCommCostCurr"));
  }
  db.setNameVal("costFromRefKey",refNo);
  setIMP.add(db.clone());
  db.clear();

  if(map.containsKey("ExportOTruckCost"))
  {
   db.setTable("otherCost");
   db.setNameVal("costOthDesc","Overnight Trucking Cost");
   db.setNameVal("costOthAmt",new BigDecimal(
      (String)map.get("ExportOTruckCost")));
   db.setNameVal("costOthCurr",(String)map.get("ExportOTruckCostCurr"));
   db.setNameVal("costOthRefKey",refNo);
   mc.sumAP(db.extractAll("costOthCurr"),
     db.extractAll("costOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  System.out.println("DataKeeper : going to set OtherCostRecord");

  //otherCost -- Facilities
  if(map.containsKey("ExportFacCost"))
  {
   db.setTable("otherCost");
   db.setNameVal("costOthDesc","Facility Cost");
   db.setNameVal("costOthAmt",(String)map.get("ExportFacCost"));
   db.setNameVal("costOthCurr",(String)map.get("ExportFacCostCurr"));
   db.setNameVal("costOthRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }

  //otherCostRecord
  if(map.containsKey("ExportNumberOthCost"))
  {
   number = Integer.parseInt((String)map.get("ExportNumberOthCost"));
   msg.append("ExportNumberOthCost");
   msg1.append("ExportNumberOthCostCurr");
   msg2.append("ExportNumberOthCostAmt");
   len = msg.length();
   len1= msg1.length();
   len2= msg2.length();
   for(int i=0;i<number;i++)
   {
    msg.append(i+1);
    msg1.append(i+1);
    msg2.append(i+1);
    db.setTable("otherCost");
    db.setNameVal("costOthDesc",(String)map.get(msg.toString()));
    db.setNameVal("costOthAmt",new BigDecimal(
			 (String)map.get(msg2.toString())));
    db.setNameVal("costOthCurr",(String)map.get(msg1.toString()));
    db.setNameVal("costOthRefKey",refNo);
    setIMP.add(db.clone());
    db.clear();
    msg.delete(len,msg.length());
    msg1.delete(len1,msg1.length());
    msg2.delete(len2,msg2.length());
   }
   msg.delete(0,len);
   msg1.delete(0,len1);
   msg2.delete(0,len2);
  }
  System.out.println("DataKeeper : going to set invoice Record");

  //invoiceRecord
  db.setTable("invoiceRecord");
  db.setNameVal("invoiceSellAmt",new BigDecimal(
		 (String)map.get("ExportSellRate"))); 
  db.setNameVal("invoiceSellCurr",(String)map.get("ExportSellRateCurr"));
  mc.sumAR(db.extractAll("invoiceSellCurr"),
		db.extractAll("invoiceSellAmt"));
  if(map.containsKey("ExportHandleCharge"))
  {
   db.setNameVal("invoiceHandleAmt",
	new BigDecimal((String)map.get("ExportHandleCharge"))); 
   db.setNameVal("invoiceHandleCurr",(String)map.get("ExportHandleChargeCurr"));
   mc.sumAR(db.extractAll("invoiceHandleCurr"),
		   db.extractAll("invoiceHandleAmt"));
  }
  db.setNameVal("invoiceRefKey",refNo);
  setIMP.add(db.clone());
  db.clear();

  if(map.containsKey("ExportOTruckCharge"))
  {
   db.setTable("invoiceOtherCharges");
   db.setNameVal("invoiceOthDesc","Overnight Trucking Charge");
   db.setNameVal("invoiceOthAmt",
		 new BigDecimal((String)map.get("ExportOTruckCharge"))); 
   db.setNameVal("invoiceOthCurr",(String)map.get("ExportOTruckChargeCurr"));
   db.setNameVal("invoiceOthRefKey",refNo);
   mc.sumAR(db.extractAll("invoiceOthCurr"),db.extractAll("invoiceOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }

  System.out.println("DataKeeper : going to set invoiceOtherCharges");
	
  //invoiceOtherCharges
  if(map.containsKey("ExportNumberOthInvoice"))
  {
   number = Integer.parseInt((String)map.get("ExportNumberOthInvoice"));
   msg.append("ExportNumberOthInvoice");
   msg1.append("ExportNumberOthInvoiceCurr");
   msg2.append("ExportNumberOthInvoiceAmt");
   len = msg.length();
   len1= msg1.length();
   len2= msg2.length();
   for(int i=0;i<number;i++)
   {
    msg.append(i+1);
    msg1.append(i+1);
    msg2.append(i+1);
    System.out.println("DataKeeper: "+msg.toString());
    db.setTable("invoiceOtherCharges");
    db.setNameVal("invoiceOthDesc",(String)map.get(msg.toString()));
    db.setNameVal("invoiceOthAmt",
	new BigDecimal((String)map.get(msg2.toString())));
    db.setNameVal("invoiceOthCurr",(String)map.get(msg1.toString()));
    db.setNameVal("invoiceOthRefKey",refNo);
    mc.sumAR(db.extractAll("invoiceOthCurr"),db.extractAll("invoiceOthAmt"));
    setIMP.add(db.clone());
    db.clear();
    msg.delete(len,msg.length());
    msg1.delete(len1,msg1.length());
    msg2.delete(len2,msg2.length());
   }
   msg.delete(0,len);
   msg1.delete(0,len1);
   msg2.delete(0,len2);
  }
  System.out.println("DataKeeper : out of invoice other");	
  if(map.containsKey("ExportPPNCharge"))
  {
   db.setTable("invoiceOtherCharges");
   db.setNameVal("invoiceOthDesc","Export PPN Charge");
   db.setNameVal("invoiceOthAmt",
		  new BigDecimal((String)map.get("ExportPPNCharge"))); 
   db.setNameVal("invoiceOthCurr",(String)map.get("ExportPPNChargeCurr"));
   db.setNameVal("invoiceOthRefKey",refNo);
   mc.sumAR(db.extractAll("invoiceOthCurr"),
	 db.extractAll("invoiceOthAmt"));
   setIMP.add(db.clone());
   db.clear();
  }
 
  System.out.println("Export going to set ExportClaimable");
  //claimableCharge -- Total Lift Off & Lift On
  db.setTable("claimableCharges");
  if(map.containsKey("ExportLiftOff"))
  {
   db.setNameVal("claimableTotalLiftOffAmt",
     new BigDecimal((String)map.get("ExportLiftOff"))); 
   db.setNameVal("claimableTotalLiftOffCurr",
    (String)map.get("ExportLiftOffCostCurr"));
   mc.sumAR(db.extractAll("claimableTotalLiftOffCurr"),
    db.extractAll("claimableTotalLiftOffAmt"));
  }
  if(map.containsKey("ExportLiftOn"))
  {
   db.setNameVal("claimableTotalLiftOnAmt",
     new BigDecimal((String)map.get("ExportLiftOn"))); 
   db.setNameVal("claimableTotalLiftOnCurr",
		 (String)map.get("ExportLiftOnCostCurr"));
   mc.sumAR(db.extractAll("claimableTotalLiftOnCurr"),
		 db.extractAll("claimableTotalLiftOnAmt"));
  }
 
  if(((String)map.get("ExportPrint")).equalsIgnoreCase("NO"))
   db.setNameVal("claimablePrintable","NO");
  else
   db.setNameVal("claimablePrintable","YES");
  db.setNameVal("claimableRefKey",refNo);
  setIMP.add(db.clone());
  db.clear();

  System.out.println("Export going to set ExportNumberOthCharges");
  //other Claimable Charges Record
  if(map.containsKey("ExportNumberOthCharges"))
  {
   number = Integer.parseInt((String)map.get("ExportNumberOthCharges"));
   msg.append("ExportNumberOthCharges");
   msg1.append("ExportNumberOthChargesCurr");
   msg2.append("ExportNumberOthChargesAmt");
   len = msg.length();
   len1= msg1.length();
   len2= msg2.length();
   for(int i=0;i<number;i++)
   {
    msg.append(i+1);
    msg1.append(i+1);
    msg2.append(i+1);
    db.setTable("claimableOtherCharges");
    db.setNameVal("claimableOthDesc",(String)map.get(msg.toString()));
    db.setNameVal("claimableOthAmt",
      new BigDecimal((String)map.get(msg2.toString())));
    db.setNameVal("claimableOthCurr",(String)map.get(msg1.toString()));
    db.setNameVal("claimableOthRefKey",refNo);
    mc.sumAR(db.extractAll("claimableOthCurr"),
	db.extractAll("claimableOthAmt"));
    setIMP.add(db.clone());
    db.clear();
    msg.delete(len,msg.length());
    msg1.delete(len1,msg1.length());
    msg2.delete(len2,msg2.length());
   }
   msg.delete(0,len);
   msg1.delete(0,len1);
   msg2.delete(0,len2);
  }
  System.out.println("Export is going to set AR 0");	
  //set accountReceivable
  if(mc.checkAR(0))
  {
   db.setTable("accountReceivable");
   db.setNameVal("acctRecAmt",mc.getSumAR(0));
   db.setNameVal("acctRecBalance",mc.getSumAR(0));
   db.setNameVal("acctRecCurr",mc.getCurr(0));
   if(tmp.containsKey("customerKey"))
    db.setNameVal("acctRecFromCustKey",
    Integer.parseInt((String)tmp.get("customerKey")));
   else
    db.setNameVal("acctRecFromCustKey","@customerKey");
   db.setNameVal("acctRecFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  System.out.println("Export is going to set AR 1");	
  if(mc.checkAR(1))
  {
   db.setTable("accountReceivable");
   db.setNameVal("acctRecAmt",mc.getSumAR(1));
   db.setNameVal("acctRecBalance",mc.getSumAR(1));
   db.setNameVal("acctRecCurr",mc.getCurr(1));
   if(tmp.containsKey("customerKey"))
    db.setNameVal("acctRecFromCustKey",
     Integer.parseInt((String)tmp.get("customerKey")));
   else
    db.setNameVal("acctRecFromCustKey","@customerKey");
   db.setNameVal("acctRecFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  System.out.println("Export is going to set AR 2");	
  if(mc.checkAR(2))
  {
   db.setTable("accountReceivable");
   db.setNameVal("acctRecAmt",mc.getSumAR(2));
   db.setNameVal("acctRecBalance",mc.getSumAR(2));
   db.setNameVal("acctRecCurr",mc.getCurr(2));
   if(tmp.containsKey("customerKey"))
    db.setNameVal("acctRecFromCustKey",
     Integer.parseInt((String)tmp.get("customerKey")));
   else
    db.setNameVal("acctRecFromCustKey","@customerKey");
   db.setNameVal("acctRecFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  System.out.println("Export is going to set AR 3");	
  if(mc.checkAR(3))
  {
   db.setTable("accountReceivable");
   db.setNameVal("acctRecAmt",mc.getSumAR(3));
   db.setNameVal("acctRecBalance",mc.getSumAR(3));
   db.setNameVal("acctRecCurr",mc.getCurr(3));
   if(tmp.containsKey("customerKey"))
    db.setNameVal("acctRecFromCustKey",
     Integer.parseInt((String)tmp.get("customerKey")));
   else
    db.setNameVal("acctRecFromCustKey","@customerKey");
   db.setNameVal("acctRecFromRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }

  System.out.println("Export is setting AP 0");	
  //set accountPayable
  if(mc.checkAP(0))
  {
   db.setTable("accountPayable");
   db.setNameVal("acctPayAmt",mc.getSumAP(0));
   db.setNameVal("acctPayBalance",mc.getSumAP(0));
   db.setNameVal("acctPayCurr",mc.getCurr(0));
   if(tmp.containsKey("truckingKey"))
    db.setNameVal("acctPayToTruckCoKey",
     Integer.parseInt((String)tmp.get("truckingKey")));
   else
    db.setNameVal("acctPayToTruckCoKey","@truckingKey");
   db.setNameVal("acctPayToRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  System.out.println("Export is setting AP 1");	
  if(mc.checkAP(1))
  {
   db.setTable("accountPayable");
   db.setNameVal("acctPayAmt",mc.getSumAP(1));
   db.setNameVal("acctPayBalance",mc.getSumAP(1));
   db.setNameVal("acctPayCurr",mc.getCurr(1));
   if(tmp.containsKey("truckingKey"))
    db.setNameVal("acctPayToTruckCoKey",
     Integer.parseInt((String)tmp.get("truckingKey")));
   else
    db.setNameVal("acctPayToTruckCoKey","@truckingKey");
   db.setNameVal("acctPayToRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  System.out.println("Export is setting AP 2");	
  if(mc.checkAP(2))
  {
   db.setTable("accountPayable");
   db.setNameVal("acctPayAmt",mc.getSumAP(2));
   db.setNameVal("acctPayBalance",mc.getSumAP(2));
   db.setNameVal("acctPayCurr",mc.getCurr(2));
   if(tmp.containsKey("truckingKey"))
    db.setNameVal("acctPayToTruckCoKey",
     Integer.parseInt((String)tmp.get("truckingKey")));
   else
    db.setNameVal("acctPayToTruckCoKey","@truckingKey");
   db.setNameVal("acctPayToRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
  System.out.println("Export is setting AP 3");	
  if(mc.checkAP(3))
  {
   db.setTable("accountPayable");
   db.setNameVal("acctPayAmt",mc.getSumAP(3));
   db.setNameVal("acctPayBalance",mc.getSumAP(3));
   db.setNameVal("acctPayCurr",mc.getCurr(3));
   if(tmp.containsKey("truckingKey"))
    db.setNameVal("acctPayToTruckCoKey",
     Integer.parseInt((String)tmp.get("truckingKey")));
   else
    db.setNameVal("acctPayToTruckCoKey","@truckingKey");
   db.setNameVal("acctPayToRefKey",refNo);
   setIMP.add(db.clone());
   db.clear();
  }
 
  boolean pass;
  while(dbcon.QuerySingle("transRecord","transRefKey",
   "WHERE transRefKey="+refNo+";")!=null)
  {
   pass = false;
   while(!pass)
   {
    String tmp2 = Module7.displayQuestion("Enter another Ref No.",
			"Enter Ref No.");
    if(Module7.checkInt(tmp2,1))
    {
     refNo = Integer.parseInt(tmp2);
     pass = true; 
    }
    else
    {
     System.out.println("--going to display Error");
     Module7.errorDisplay("You have to enter Ref No. ","ERROR");
    }
   }
  }
  System.out.println("Export going to insert");
//  for(int i=0;i<setIMP.size();i++)
//   dbcon.viewEncap((Encap)setIMP.get(i));   
  dbcon.InsertMulti(setIMP);
  System.out.println("Export: out from inserting db");
  if(!setIMP.isEmpty())
   setIMP.removeAllElements();
  return refNo;
 } // setExport's method

 public void setRPF(HashMap map,DBConnect dbcon) throws SQLException
 {
  if(!map.containsKey("RPFrefNo"))
  {
   error.append("Map contains no Ref No\n");
   return;
  }
  System.out.println("DataKeeper setRPF");
  int ref = Integer.parseInt((String)map.get("RPFrefNo"));
  BigDecimal paid = new BigDecimal((String)map.get("RPFrecvAmt"));
  BigDecimal balance = new BigDecimal((String)map.get("Balance"));
  BigDecimal difference = null;
  int comparison = balance.compareTo(paid);
  int key = Integer.parseInt((String)map.get("BalanceKey")); 
  String method = (String)map.get("RPFmethod");

  Encap en = null;
  Vector v = new Vector();
  boolean appliedBalance = false;
  if(comparison<0)
  {
   difference = new BigDecimal(paid.subtract(balance).toString());
   int respond = JOptionPane.showConfirmDialog(null,
		 "The payment amount is bigger than the remaining balance"+
		 "\n Click \"Yes\" if you like to proceed\n","The payment amount "+
		 "is bigger than the remaining balance",JOptionPane.YES_NO_OPTION);
   if(respond == JOptionPane.NO_OPTION) 
   {
    skipFlag = true;
    return;
   }
   else appliedBalance = true;
  }

  en = new Encap("transPayRecord");
  en.setNameVal("transPayCurr",(String)map.get("RPFrecvAmtCurr"));
  if(appliedBalance)
   en.setNameVal("transPayAmt",balance);
  else
   en.setNameVal("transPayAmt",paid);
  en.setNameVal("transPayMethod",method);
  en.setNameVal("transPayFromRefKey",ref);
  en.setNameVal("transPayAcctRecKey",key);
  en.setNameVal("transPayDate","CURRENT_DATE");
  if(!method.equalsIgnoreCase("CASH"))
   en.setVariable("SET @transPayKey = LAST_INSERT_ID();");
  v.add(en.clone());
  en.clear();
  if(!method.equalsIgnoreCase("CASH"))	
  {
   en.setTable("transBankRecord");
   if(!((String)map.get("RPFrecvThrough")).equalsIgnoreCase("Pilih"))
    en.setNameVal("transBankOur",(String)map.get("RPFrecvThrough"));
   if(!((String)map.get("RPFsendThrough")).equalsIgnoreCase("Pilih"))
    en.setNameVal("transBankTheir",(String)map.get("RPFsendThrough"));
   if(!method.equalsIgnoreCase("REMITTANCE"))
    en.setNameVal("transBankDocNo",(String)map.get("RPFNoDoc"));
   if(map.containsKey("RPFNoAcct"))
    en.setNameVal("transBankAcct",(String)map.get("RPFNoAcct"));
   en.setNameVal("transBankPayKey","@transPayKey");
   v.add(en.clone());
   en.clear();
  }
  
  System.out.println("========Before Inserting DB========");
  for(int i=0;i<v.size();i++)
   dbcon.viewEncap((Encap)((Encap)v.get(i)).clone());
  dbcon.InsertMulti(v);
  System.out.println("========After Inserting DB=========");	
  System.out.println(" ------ updating ------- ");
  if(comparison<0 || comparison == 0)
  {
   en.setTable("accountReceivable");
   en.setNameVal("acctRecBalance","0.00");
   en.setNameVal("acctRecPaidFull","Y");
   en.setCondition("WHERE acctRecKey="+key+";");
  }
  else
  {
   en.setTable("accountReceivable");
   en.setNameVal("acctRecBalance",balance.subtract(paid));
   en.setCondition("WHERE acctRecKey="+key+";");
  }
  dbcon.viewEncap(en);
  dbcon.UpdateData((Encap)en.clone());

  System.out.println(" ----------------------- ");
  en.clear();

  if(comparison<0 || comparison==0)
  {
   Encap en2 = dbcon.QuerySingle("accountPayable","*","WHERE acctPayToRefKey="+
    ref+";");
   if(en2 == null)
    throw new SQLException("Fail to fetch accountPayable");
   if(en2.extractAll("acctPayPaidFull").equalsIgnoreCase("Y"))
   {
    en.setTable("transRecord");
    en.setNameVal("transPaidFull","Y");
    en.setCondition("WHERE transRefKey="+ref+";");
    dbcon.viewEncap(en);
    dbcon.UpdateData((Encap)en.clone());
    en.clear();
   }
  }

  if(!v.isEmpty())
   v.removeAllElements();
  v = null;
  System.out.println("DataKeeper setRPF exit");
  return;
 }

 public void setDPF(HashMap map,DBConnect dbcon) throws SQLException
 {
  if(!map.containsKey("DPFrefNo"))
  {
   error.append("Map contains no Ref No.\n");
   return;
  }
  System.out.println("DataKeeper SETDPF");
  int ref = Integer.parseInt((String)map.get("DPFrefNo"));
  BigDecimal paid = new BigDecimal((String)map.get("DPFpaidAmt"));
  BigDecimal balance = new BigDecimal((String)map.get("Balance"));
  BigDecimal difference = null;
  int key = Integer.parseInt((String)map.get("BalanceKey"));
  int comparison = balance.compareTo(paid);
  String method = (String)map.get("DPFtransMethod");

  Encap en = null;
  Vector v = new Vector();
  boolean appliedBalance = false;
  if(comparison<0)
  {
   difference = new BigDecimal(paid.subtract(balance).toString());
   int respond = JOptionPane.showConfirmDialog(null,
		 "The payment amount is bigger than the remaining balance\n "+
		 "Click \"Yes\" if you like to proceed\n","The payment amount "+
		 "is bigger than the remaining balance",JOptionPane.YES_NO_OPTION);
   if(respond == JOptionPane.NO_OPTION)
   {
    skipFlag = true;
    return;
   }
   else appliedBalance = true;
  }

  en = new Encap("transPayRecord");
  en.setNameVal("transPayCurr",(String)map.get("DPFpaidAmtCurr"));
  if(appliedBalance)
   en.setNameVal("transPayAmt",balance);
  else
   en.setNameVal("transPayAmt",paid);
  en.setNameVal("transPayDate","CURRENT_DATE");
  en.setNameVal("transPayMethod",method);
  en.setNameVal("transPayFromRefKey",ref);
  en.setNameVal("transPayAcctPayKey",key);
  if(!method.equalsIgnoreCase("CASH"))
   en.setVariable("SET @transPayKey = LAST_INSERT_ID();");
  v.add(en.clone());
  en.clear();
  if(!method.equalsIgnoreCase("CASH"))	
  {
   en.setTable("transBankRecord");
   if(!((String)map.get("DPFourBank")).equalsIgnoreCase("Pilih"))
    en.setNameVal("transBankOur",(String)map.get("DPFourBank"));
   if(!method.equalsIgnoreCase("REMITTANCE"))
    en.setNameVal("transBankDocNo",(String)map.get("DPFNoDoc"));
   else
   {
    if(!((String)map.get("DPFtheirBank")).equalsIgnoreCase("Pilih"))
     en.setNameVal("transBankTheir",(String)map.get("DPFtheirBank"));
    en.setNameVal("transBankAcct",(String)map.get("DPFNoAcct"));
   }
   en.setNameVal("transBankPayKey","@transPayKey");
   v.add(en.clone());
   en.clear();
  }

  System.out.println("========Before Inserting DB========");
  for(int i=0;i<v.size();i++)
   dbcon.viewEncap((Encap)v.get(i));
  dbcon.InsertMulti(v);
  System.out.println("========After Inserting DB=========");	
  System.out.println(" ------ updating ------- ");
  if(comparison<0 || comparison == 0)
  {
   en.setTable("accountPayable");
   en.setNameVal("acctPayBalance","0.00");
   en.setNameVal("acctPayPaidFull","Y");
   en.setCondition("WHERE acctPayKey="+key+";");
  }
  else
  {
   en.setTable("accountPayable");
   en.setNameVal("acctPayBalance",balance.subtract(paid));
   en.setCondition("WHERE acctPayKey="+key+";");
  }
  dbcon.viewEncap(en);
  dbcon.UpdateData((Encap)en.clone());
  en.clear(); 
  System.out.println(" ----------------------- ");

  if(comparison<0 || comparison==0)
  {
   Encap en2 = dbcon.QuerySingle("accountReceivable","*",
    "WHERE acctRecFromRefKey="+ref+";");
   if(en2 == null)
    throw new SQLException("Fail to fetch accountPayable");
   if(en2.extractAll("acctRecPaidFull").equalsIgnoreCase("Y"))
   {
    en.setTable("transRecord");
    en.setNameVal("transPaidFull","Y");
    en.setCondition("WHERE transRefKey="+ref+";");
    dbcon.viewEncap(en);
    dbcon.UpdateData((Encap)en.clone());
    en.clear();
   }
  }

  if(!v.isEmpty())
   v.removeAllElements();
  v = null;
  System.out.println("DataKeeper setDPF exit");
  return;
 }

}
