import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Vector;

public class EditDatabase
{
 private int action;
 private JButton editButton;
 private JButton cancelButton;
 private StringBuffer error = new StringBuffer();
 private HashMap map = new HashMap();
 private HashMap store = new HashMap();
 private DBConnect db = new DBConnect();
 
 public EditDatabase(int act,int usrID,String str)
 {
  if(str == null)
  {
   Module7.errorDisplay("Received null String value","ERROR");
    return;
  }
  action = act;
  System.out.println("Edit Database");
  
  try
  {
   if(!db.makeConnection("LKB")) 
    throw new SQLException("Fail to connect LKB\n"); 
   if(act == Module7.EDITRN) 
    handleRefNo(str);     
   else if(act == Module7.EDITPY) 
    handlePay(str); 
   else
   {
    Module7.errorDisplay("No service available for this action ","ERROR");
    return;
   }
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage());
  }
  finally
  {
   db.close();
  }
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   error.delete(0,error.length());
  }
  else
  {
   if(action == Module7.EDITRN)
   {
    if(((String)map.get("transType")).compareToIgnoreCase("IMP")==0)
     new EditDatabaseNext((HashMap)map.clone(),"Import",usrID,str);
    else
     new EditDatabaseNext((HashMap)map.clone(),"Export",usrID,str);
   }
   else if(action == Module7.EDITPY)
    new EditPayment((HashMap)map.clone(),usrID,str);
  }
  map.clear();
  System.out.println("Exit EditDatabase");
  return;
 }

 private void handleRefNo(String str) throws SQLException
 {
  StringBuffer msg = new StringBuffer();
  msg.append("LEFT JOIN customer ON (customer.customerKey=");
  msg.append("transRecord.transCustKey) ");
  msg.append("LEFT JOIN truckingCompany ON (truckingCompany.");
  msg.append("truckingCompanyKey=transRecord.transTrucking) ");
  msg.append("LEFT JOIN costRecord ON (costRecord.costFromRefKey=");
  msg.append("transRecord.transRefKey) ");
  msg.append("LEFT JOIN invoiceRecord ON (invoiceRecord.invoiceRefKey=");
  msg.append("transRecord.transRefKey) ");
  msg.append("LEFT JOIN claimableCharges ON (claimableCharges.");
  msg.append("claimableRefKey=transRecord.transRefKey) ");
  msg.append("WHERE transRefKey="+str+";");
  Encap en = db.QuerySingle("transRecord","*",msg.toString());
  if(en == null)
  {
   error.append("No such Ref No found in database\n");
   return;
  }
  else if(en.extractString("transPaidFull",null).equalsIgnoreCase("Y"))
  {
   error.append("Transaction is complete. No further editing allowed\n");
   return;
  }
  enterMap(55,null,(Encap)en.clone());
  en.clear();
  msg.delete(0,msg.length());
  if(((String)map.get("transType")).compareToIgnoreCase("IMP")==0)
  {
   msg.append("WHERE impFromRefKey="+str+";");
   en = db.QuerySingle("impInfoRecord","*",msg.toString());
   if(en != null)
    enterMap(8,null,(Encap)en.clone());	
   else
   {
    error.append("No Import Info found with ref No."+str+"\n");
    return;
   }
  }
  else
  {
   msg.append("WHERE expFromRefKey="+str+";");
   en = db.QuerySingle("expInfoRecord","*",msg.toString());
   if(en != null)
    enterMap(9,null,(Encap)en.clone());	
   else
   {
    error.append("No Export Info found with ref No."+str+"\n");
    return;
   }
  }
  en.clear();
  msg.delete(0,msg.length());
  msg.append("WHERE transVolRefKey="+str+";");
  en = db.QuerySingle("transVol","*",msg.toString());
  if(en!=null)
  {
   enterMap(4,"NumberTransVol",(Encap)en.clone());
   en.clear();
  }
  else
  {
   error.append("No Transaction Volume found with ref No."+str+"\n");
   return;
  }
  msg.delete(0,msg.length());
  msg.append("WHERE transContRefNo="+str+";");
  en = db.QuerySingle("transContainer","*",msg.toString());
  if(en!=null)
  {
   enterMap(7,"NumberTransCont",(Encap)en.clone());
   en.clear();
  }
  msg.delete(0,msg.length());
  msg.append("WHERE costOthRefKey="+str+";");
  en = db.QuerySingle("otherCost","*",msg.toString());
  if(en!=null)
  {
   enterMap(7,"NumberOtherCost",(Encap)en.clone());
   en.clear();
  }
  msg.delete(0,msg.length());
  msg.append("WHERE invoiceOthRefKey="+str+";");
  en = db.QuerySingle("invoiceOtherCharges","*",msg.toString());
  if(en!=null)
  {
   enterMap(7,"NumberInvOtherCharges",(Encap)en.clone());
   en.clear();
  }
  msg.delete(0,msg.length());

  msg.append("WHERE claimableOthRefKey="+str+";");
  en = db.QuerySingle("claimableOtherCharges","*",msg.toString());
  if(en!=null)
  {
   enterMap(7,"NumberClaimableOtherCharges",(Encap)en.clone());
   en.clear();
  }
  msg.delete(0,msg.length());

  System.out.println("---checking---");
  System.out.println("map size: "+map.size());
  System.out.println("customerName : "+(String)map.get("customerName"));
  System.out.println("NumberTransVol : "+(String)map.get("NumberTransVol"));
  System.out.println("NumberTransCont: "+(String)map.get("NumberTransCont"));
 } 

 public void enterMap(int expect,String name,Encap en)
 {
  int index = 0;
  int size = en.getSize();
  if(size > expect)
  {
   String reference = null;
   for(int i=0;i<size;i++)
   {
    if(i == 0) reference = en.getName(i);
    if(en.getName(i).equalsIgnoreCase(reference))
     index++;	
    map.put(en.getName(i)+index,en.getValue(i));
    if(name.equalsIgnoreCase("NumberTransVol") || name.equalsIgnoreCase("NumberTransCont"))
     System.out.println("put["+index+"]: "+en.getName(i)+" "+en.getValue(i));
   }
   map.put(name,String.valueOf(index)); 
  }
  else // the expected size
  {
   for(int i=0;i<size;i++)
    map.put(en.getName(i),en.getValue(i));
  }
 }

 private void handlePay(String str) throws SQLException
 {
  StringBuffer msg = new StringBuffer();
  msg.append("LEFT JOIN transRecord ON (transRecord.transRefKey=");
  msg.append("transPayRecord.transPayFromRefKey) ");
  msg.append("WHERE transPayKey="+str+";");
  Encap en2 = null;
  Encap en = db.QuerySingle("transPayRecord","*",msg.toString());
  if(en == null)
  {
   error.append("No such Pay ID found in database\n");
   return;
  }
  else if(en.extractString("transPaidFull",null).equalsIgnoreCase("Y"))
  {
   error.append("Transaction is complete. No further editing allowed\n");
   return;
  }
  enterMap(23,"NumberOfPayment",en);

  if(!en.extractAll("transPayMethod").equalsIgnoreCase("CASH"))
  {
   msg.delete(0,msg.length());
   msg.append("WHERE transBankPayKey="+str+";");
   en2 = db.QuerySingle("transBankRecord","*",msg.toString());
   if(en2 == null)
   {
    error.append("No Bank Record found on this Pay ID\n");
    return;
   }
   enterMap(8,null,(Encap)en2.clone());
   if(en2!=null) en2.clear();
  }

  if(!en.extractAll("transPayAcctRecKey").equalsIgnoreCase("0"))
  {
   en2 = db.QuerySingle("accountReceivable","*","WHERE acctRecKey="+
   en.extractAll("transPayAcctRecKey")+";");
   if(en2!=null)
    enterMap(9,null,(Encap)en2.clone());
   else
   {
    error.append("The Account Receivable for the Pay ID "+str+" not found\n");
    return;
   }
  }
  else
  {
   en2 = db.QuerySingle("accountPayable","*","WHERE acctPayKey="+
   en.extractAll("transPayAcctPayKey")+";");
   if(en2!=null)
    enterMap(9,null,(Encap)en2.clone());
   else
   {
    error.append("The Account Payable for the Pay ID "+str+" not found\n");
    return;
   }
  }
  en.clear();
  if(en2!=null) en2.clear();
 }

}
