import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Vector;
import java.math.BigDecimal;
import java.util.StringTokenizer;

public class EditDatabaseNext
{
 private int action;
 private JFrame frame;
 private JTable table;
 private tableData td;
 private JButton editButton;
 private JButton cancelButton;
 private Vector result = new Vector();
 private String ftitle;
 private String sendCont = null;
 private int usrID = 0;
 private int refNo = 0;

 private boolean newUser = false;
 private boolean changeUser = false;
 private boolean newTrucking = false;
 private boolean changeTrucking = false;
 private boolean changePaymentAmt = false;
 private boolean insertFlag = false;
 private boolean newBankFlag= false;
 private boolean applyToAR = true;
 private boolean amountChange = false;
 private boolean currencyChange = false;
 private boolean deleteFlag = false;

 private BigDecimal changedAmt = null;
 private int changeTruckingID = 0;
 private int changeUserID = 0;
 private boolean volFlag = false;
 private boolean stowageFlag = false;
 private Vector masterCont = new Vector(32);// index all sequence
 private Vector masterNum = new Vector(16); // index all amount sequence
 private Vector masterCurr = new Vector(16);// index all currency sequence
 private Vector masterDate = new Vector(4);// index all date sequence
 private Vector masterKey = new Vector(32); // index all keys
 protected Vector masterMap = new Vector(16); // final storage for UPDATE
 protected Vector masterInsert = new Vector(3); // final storage for INSERT
 protected Vector masterDelete = new Vector(3); // final storage for DELETE
 protected MultipleCurrency mc = new MultipleCurrency();

 private HashMap masterPos = new HashMap(16); // index of position
 private HashMap masterValue = new HashMap(16); // index all values
 private HashMap masterLength = new HashMap(); // index all name length
 public HashMap orgMap = null;

 public StringBuffer error = new StringBuffer();

 public EditDatabaseNext(HashMap map,String tl,int usr,String cont)
 {
  if(map == null)
   error.append("Received null map\n");
  if(cont == null)
   error.append("Received null content\n");
  if(usr<=0)
   error.append("Received invalid userID\n");
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  usrID = usr;
  System.out.println("---Enter EditDatabaseNext---");
  refNo = Integer.parseInt((String)map.get("transRefKey"));
  sendCont = new String(cont);
  orgMap = (HashMap)map.clone();
  ftitle = new String(tl);
  frame = new JFrame();
  frame.setTitle("Edit "+ftitle+" for Ref No."+cont);
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(map),BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Cancel in the panel instead",
     "Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain(HashMap map)
 {
  JPanel panel = new JPanel();
  retrieveNormal(map,ftitle); 
  td = new tableData(result);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i == td.OLDDESC)
    column = new TableColumn(i,30,render,editor);
   else if(i == td.OLDVAL)
    column = new TableColumn(i,10,render,editor);
   else
    column = new TableColumn(i,20,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(result.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.setLayout(new BorderLayout());
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.add(jsp,BorderLayout.CENTER);
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  editButton = new JButton("Edit");
  cancelButton = new JButton("Cancel");
  ButtonListener bl = new ButtonListener();
  editButton.addActionListener(bl);
  cancelButton.addActionListener(bl);
  panel.add(editButton);
  panel.add(cancelButton);
  return panel;
 }

 public void addToMaster(Object obj)
 {
  consolidateOther((Encap)obj);
 }

 public Encap getMaster(int index)
 {
  return (Encap)((Encap)masterMap.elementAt(index)).clone();
 }

 public void viewMaster()
 {
  int msize = masterMap.size();
  for(int i=0;i<msize;i++)
   DBConnect.viewEncap(getMaster(i));
 }

 public void clearMaster()
 {
  if(!masterMap.isEmpty())
   masterMap.removeAllElements();
  if(!masterInsert.isEmpty())
   masterInsert.removeAllElements();
  if(!masterDelete.isEmpty())
   masterDelete.removeAllElements();
 }

 public int getMasterSize()
 {
  return masterMap.size();
 }

 public void consolidateOther(Encap e)
 {
  int pos = 0;
  int esize = e.getSize();
  int msize = masterMap.size();
  boolean visibleAction = false;
//  System.out.println("------ xx enter consolidateOther xx ------");
  Encap a = null;
  for(int i=0;i<msize;i++)
  {
   a = getMaster(i);
   if(a.getTable().equalsIgnoreCase(e.getTable()))
   {
    if(a.getCondition().equalsIgnoreCase(e.getCondition()))
    {
     for(int j=0;j<esize;j++)
     {
      if(!a.getName(j).equalsIgnoreCase(e.getName(j)))
      {
       a.setNameVal(e.getName(j),e.getValue(j));
       visibleAction = true;
       pos = i;
       break;
      }
     }
     if(visibleAction) break;
    }
   }
   a.clear();
  }
  if(visibleAction)
  {
   masterMap.setElementAt(a.clone(),pos);
  }
  else
  {
   masterMap.add(e.clone());
  }
  if(a!=null) a.clear(); 
//  System.out.println("------ xx exit consolidateOther xx ------");
 }

/**
 * phaseOne's method is to phase for one delimiter and store the two 
 * results into Encap. For example it is phasing ContNo1+SealNo1
 * @param String s - to be phase, String d - the delimiter
 * @return Encap - of two result or else null
 */
 private Encap phaseOne(String s,String d,String field1,String field2)
 {
  if(s == null || d == null) return null;
  if(s.indexOf(d)<0) return null;
  int index = 0;
  Encap e = new Encap();
  StringTokenizer cut = new StringTokenizer(s,d);
  while(cut.hasMoreTokens())
  {
   if(index > 1) break;
   if(index == 0)
    e.setNameVal(field1,cut.nextToken());
   else
    e.setNameVal(field2,cut.nextToken());
   index+=1;
  }
  return e;
 }

 private Vector processVolStowage(Vector v,DBConnect db) throws SQLException 
 {
  if(v == null) return v;

  Vector v2 = new Vector(v.size());
  Encap en = null;
  Encap en2 = null;
  int run = 0;
  int index = 0;
  int vol = 0;
  int pos1= 0;
  int pos2= 0;
  String stw = null;
  while(!v.isEmpty())
  {
   en = (Encap)v.remove(0);
   if(!en.getTable().equalsIgnoreCase("transVol"))
    v2.add(en.clone());
   else
   {
    pos1 = -1;
    pos2 = -1;
    System.out.println(" --- --- ");
    DBConnect.viewEncap(en);
    index = Integer.parseInt((String)masterPos.get(String.valueOf(run))); 
//   System.out.println("index = "+index);
//    System.out.println(" = run = "+run);
    pos1 = en.getPosition("transVolVolume");
    pos2 = en.getPosition("transVolStowage");
    if(pos1>=0) vol = Integer.parseInt(en.extractAll("transVolVolume"));
    if(pos2>=0) stw = en.extractString("transVolStowage",null);
    if(pos1>0 && pos2>=0) 
     en2 = processBoth(index,vol,stw,en,db);
    else if(pos1>=0)
     processVol(index,vol,en,db);
    else if(pos2>=0)
     en2 = processStowage(index,stw,en,db); 
    if(en2 != null)
    {
     if(en2.getSize()>1)
     {
      v2.add(en2.clone());
      en2.clear();
     }
    }
   }
   run+=1;
   en.clear();
  }
  return v2;
 }

 private Encap processBoth(int index,int vol,
  String stowage,Encap ex,DBConnect db) throws SQLException
 {
  Encap en = null;
  System.out.println(" - enter processBoth - ");
  System.out.println((String)masterValue.get(String.valueOf(index)));
  int ovalue = Integer.parseInt((String)masterValue.get(String.valueOf(index-1)));
  System.out.println("ovalue: "+ovalue+" vol: "+vol);
  if(vol > ovalue)
  {
   Module7.infoDisplay("To Add Volume Stowage, use \"Add\" feature under"+
    " the header of \"Data\".\n For now input of Volume Stowage is ignored\n",
    "Info");
   return null;
  }
  else if(ovalue == vol) // maybe stowage is changed?
  {
   System.out.println("equal to");
   String org = (String)masterValue.get(String.valueOf(index));
   if(org.equalsIgnoreCase(stowage))
   {
    System.out.println("Stowage has no change and volume is the same");
    return ex;
   }
   //Stowage changed
   en = processStowage(index,stowage,ex,db); 
  }
  else // stowage and volume are changed
  {
   System.out.println("less then");
   String org = (String)masterValue.get(String.valueOf(index));
   if(org.equalsIgnoreCase(stowage))
   {
    System.out.println("Only volume change");
    processVol(index,vol,ex,db);
   }
   else // both changed 
   {
    System.out.println("stowage and volume change");
    DBConnect.viewEncap(ex);
    if(Module7.checkStowageException(stowage))
    {
     System.out.println("Changing to Non-Container");
     Encap en2 = new Encap("transContainer");
     en2.setCondition("WHERE transContVolKey="+
     ((Integer)masterKey.get(index)).intValue()+";");
     masterDelete.add(en2.clone());
     en2.clear();
     return ex;
    }
    else
    {
     int volKey = ((Integer)masterKey.get(index)).intValue();
     int volume = Integer.parseInt(ex.extractAll("transVolVolume"));
     int run = 0;
     int srun = volume;
     Encap en2 = null;
     boolean goFlag = false;
     boolean failFlag = false;
     Vector v = db.QueryMulti("transContainer","*",
      "WHERE transContVolKey="+volKey+";");
     if(v == null) // They are null before - so we need to insert
     {
      System.out.println("it used to be null now we are inserting");
      do
      {
       failFlag = false;
       String na = Module7.displayQuestion("Enter "+srun+" pair of"+
       " Container No and Seal No.\nFor example: ContNo1+SealNo1,"+
       "ContNo2+SealNo2\n","Question");
       if(na != null)
       {
	en2 = new Encap();
	if(na.indexOf(",")<0 && vol==1)
	{
         System.out.println("HERE for 1 entries");
	 en2 = phaseOne(na,"+","transContNo","transContSealNo");
	 if(en2 != null)
	 {
          en2.setNameVal("transContVolKey",volKey);
          en2.setNameVal("transContRefNo",refNo);
          en2.setTable("transContainer");
	  masterInsert.add(en2.clone());
	  en2.clear();
	 }
	}
        else if(na.indexOf(",")>=0)
        {
	 System.out.println("HERE for multiple entries");
         StringTokenizer cut = new StringTokenizer(na,",");
	 while(cut.hasMoreTokens())
	 {
	  en2 = phaseOne(cut.nextToken(),"+","transContNo","transContSealNo");
	  if(en2 != null)
	  {
	   en2.setNameVal("transContVolKey",volKey);
	   en2.setNameVal("transContRefNo",refNo);
	   en2.setTable("transContainer");
	   masterInsert.add(en2.clone());
	   en2.clear();
	   run+=1;
	  }
	  else failFlag = true;
	 }
        } // end of na.index(",")>0
        else failFlag = true;
        if(failFlag)
	{
         if(run>0) srun-=run;
	 run = 0;
	}
	else 
	 goFlag = true;
       } // end of na != null
       else goFlag = true;
      }while(!goFlag);
     } // end of if - for null
     else
     {
      System.out.println(" --- Choice to delete? --- ");
      StringBuffer buf = new StringBuffer(32);
      StringBuffer tuf = new StringBuffer(16);
      failFlag = false;
      int[] pool;
      int count = 1;
      int tmpNo = 0;
      Vector tmpVec = null;
      Vector tv = db.QueryMulti("transContainer","*",
      "WHERE transContVolKey="+volKey+";");
      if(tv != null)
      {
       pool = new int[tv.size()];
       tmpVec = new Vector(tv.size());
       for(int c=0;c<tv.size();c++)
       {
        en2 = (Encap)((Encap)tv.get(c)).clone();
        buf.append("#"+(c+1)+" "+en2.extractAll("transContNo"));
	if(!tv.isEmpty()) buf.append("\n");
	pool[c] = en2.extractInteger("transContKey",0);
        en2.clear();
       }
       goFlag = false;
       while(!goFlag)
       {
	failFlag = false;
        String s = Module7.displayQuestion("Choose the Container No "+
	"to be deleted from the list.\n For Example, to delete "+
	"Container #1 and Container #3,\n you type: 1,3\n"+
        "Choose the Container No to be deleted:\n"+buf.toString(),	
	"Question");
	if(s != null)
	{
         if(s.indexOf(",")<0)
	 {
          if(Module7.checkInt(s,1))
	  {
           tmpNo = Integer.parseInt(s);
           if(tmpNo>tv.size() || tmpNo<1)
	    Module7.errorDisplay("Your choice is not in the list\n","ERROR");
	   else
	   {
            en2.setTable("transContainer");
	    en2.setCondition("WHERE transContKey="+pool[tmpNo-1]+";");
	    masterDelete.add(en2.clone());
	    en2.clear();
	    goFlag = true;
	   }
	  }
	  else Module7.errorDisplay("You must enter digit only","ERROR");
	 }
	 else if(s.indexOf(",")>=0)
	 {
          System.out.println("multiple delete");
	  StringTokenizer cut = new StringTokenizer(s,",");
	  while(cut.hasMoreTokens())
	  {
           tuf.append(cut.nextToken());
	   if(Module7.checkInt(tuf.toString(),1))
	   {
            tmpNo = Integer.parseInt(tuf.toString());
	    en2.setTable("transContainer");
	    en2.setCondition("WHERE transContKey="+pool[tmpNo-1]+";");
	    tmpVec.add(en2.clone());
	    en2.clear();
	   }
	   else
           {
            Module7.errorDisplay("Input must be digit only","ERROR");
	    failFlag = true;
	    tmpVec.removeAllElements();
	   }
	  }
	 }
	}
	else goFlag = true;
        if(!failFlag) 
	{
	 if(tmpVec.size()>1)
	 {
          while(!tmpVec.isEmpty()) 
	   masterDelete.add((Encap)tmpVec.remove(0));
	 }
	 goFlag = true;
        }
       }
      }
      else
      {
       Module7.errorDisplay("There is no container found for "+
       "VolumexStowage of "+ex.extractAll("transVolVolume")+" "+
       ex.extractAll("transVolStowage")+"\nThis request is ignored\n",
       "ERROR");
       return null;
      }
     } // container to container delete
    } // big else changing to container
    return ex;
   }
  }
  return null;
 }

 private void processVol(int index,int vol,Encap ex,DBConnect db)
  throws SQLException
 {
  System.out.println(" - enter processVol - ");
  Encap en = new Encap();
  int ovalue = Integer.parseInt((String)masterValue.get(String.valueOf(index)));
  System.out.println("ovalue: "+ovalue+" vol: "+vol);
  Vector v = null;
  if(vol > ovalue)
  {
   Module7.infoDisplay("To Add Volume Stowage, use \"Add\" feature under"+
    " the header of \"Data\".\n For now input of Volume Stowage is ignored\n","Info");
   return ;
  }
  else if(vol < ovalue)
  {
   int[] pool;
   Vector deletePool;
   StringBuffer t = new StringBuffer(16);
   if(vol == 0)
   {
    System.out.println("less than - DELETE ALL");
    en.setTable("transContainer");
    en.setCondition("WHERE transContVolKey="+
    ((Integer)masterKey.get(index)).intValue()+";"); 
    masterDelete.add(en.clone());
    en.clear();
    en.setTable("transVol");
    en.setCondition("WHERE transVolKey="+
    ((Integer)masterKey.get(index)).intValue()+";");
    masterDelete.add(en.clone());
    en.clear();
   }
   else
   {
    System.out.println("less than - DELETING");
    Encap en2 = db.QuerySingle("transVol","*","WHERE transVolKey="+
    ((Integer)masterKey.get(index)).intValue()+";");
    db.viewEncap(en2);
    if(Module7.checkStowageException(en2.extractAll("transVolStowage")))
    {
     System.out.println("It is exception so we donot need to delete container");
     en.setTable("transVol");
     en.setCondition("WHERE transVolKey="+
     ((Integer)masterKey.get(index)).intValue()+";");
     masterDelete.add(en.clone());
     en.clear();
    }
    else
    {
     System.out.println("It is not exception so we need to delete container");
     v = db.QueryMulti("transContainer","*","WHERE transContVolKey="+
     ((Integer)masterKey.get(index)).intValue()+";");
     if(v!=null)
     {
      if(en2!=null) en2.clear();
      pool = new int[v.size()]; // pool all the container key to delete
      deletePool = new Vector(pool.length); 
      int ipool = 0;
      t.append("Choose Container No. to be delete.\nIf more than 1,use");
      t.append(" comma as delimiter.\nExample: 1,2,3\n");
      t.append("Choose the number for the container to be delete:\n");
      while(!v.isEmpty())
      {
       en2 = (Encap)v.remove(0);
       t.append("#"+(ipool+1)+". ");
       pool[ipool] = en2.extractInteger("transContKey",0);
       t.append(en2.extractAll("transContNo"));
       if(!v.isEmpty()) t.append("\n");
       ipool+=1;
       en2.clear();
      }
      boolean passFlag = false;
      boolean failFlag;
      StringBuffer tmp = new StringBuffer(8);
      do
      {
       failFlag = false;
       String na = Module7.displayQuestion(t.toString(),"Question");
       if(na.indexOf(",")>=0)
       {
        StringTokenizer cut = new StringTokenizer(na,",");
	while(cut.hasMoreElements())
	{
	 tmp.append(cut.nextToken());
         if(Module7.checkInt(tmp.toString(),1)) 
	 {
//	  System.out.println("parse : "+tmp.toString());
//	  System.out.println("pool : "+pool[Integer.parseInt(tmp.toString())-1]);
	  int d = pool[Integer.parseInt(tmp.toString())-1];
//	  System.out.println("d = "+d);
	  deletePool.add(new Integer(d));
	 }
	 else
	 {
          deletePool.removeAllElements();
	  Module7.errorDisplay("You must enter digit only\n","ERROR");
	  failFlag = true;
	  break;
	 }
	 tmp.delete(0,tmp.length());
	}
	if(!failFlag) passFlag = true;
       }
      }while(!passFlag);
      if(en2!=null) en2.clear(); 
      while(!deletePool.isEmpty())
      {
       en2.setTable("transContainer");
       en2.setCondition("WHERE transContKey="+
        ((Integer)deletePool.remove(0)).intValue()+";");
       masterDelete.add(en2.clone());
       en2.clear();
      }
     }
     else Module7.errorDisplay("Receive null query from transContainer","ERROR");
    }
   }
  }
  else // equal to - nothing change
  {
   System.out.println("EQUAL TO - nothing change");
  }
  System.out.println("Returning ");
 }

 private Encap processStowage(int index,String stowage,
  Encap ex,DBConnect db) throws SQLException
 {
  System.out.println(" - enter processStowage- ");
  if(Module7.checkStowageException(stowage)) // change to exception
  {
   Encap en = new Encap("transContainer");
   System.out.println("drop all the container - change to non-container");
   en.setCondition("WHERE transContVolKey="+
    ((Integer)masterKey.get(index)).intValue()+";");
   masterDelete.add(en.clone());
   return ex;
  }
  else // could be container-container or non-container to container
  {
   String org = (String)masterValue.get(String.valueOf(index));
   if(Module7.checkStowageException(org))
   {
    System.out.println("non-container to container");
    int vol = Integer.parseInt((String)masterValue.get(String.valueOf(index-1)));
//    System.out.println("volume: "+vol); 
    processNonContainerToContainer(index,vol);
   }
   else
   {
    System.out.println("container to container");
    db.viewEncap(ex);
    return ex;
   }
  }
  return null;
 }

 private void processNonContainerToContainer(int index,int volume)
 {
  int srun = volume;
  int run = 0;
  int vindex = 0;
  int volKey = ((Integer)masterKey.get(index)).intValue(); 
  boolean passFlag = false;
  boolean failFlag;
  do
  {
   failFlag = false;
   String na = Module7.displayQuestion("Enter "+srun+" pairs of "+
   "Container No. and Seal No.\nFor Example: ContNo1+SealNo1,ContNo2+SealNo2\n",
   "Question");
   if(na != null && na.length()>1)
   {
    if(na.indexOf(",")<0 && volume == 1)
    {
     System.out.println("Enter -- single comma --- ");
     if(na.indexOf('+')<0)
     {
      Module7.errorDisplay("Expecting a \"+\" delimiter in: "+na+"\n"+
      "Example: ContNo1+SealNo1\n","ERROR");
      run = 0;
      failFlag = true;
     }
     else
     {
      StringTokenizer put = new StringTokenizer(na,"+");
      Encap en = new Encap("transContainer");
      while(put.hasMoreTokens())
      {
       if(vindex>1)
       {
        passFlag = true;
	break;
       }
       if(vindex == 0)
        en.setNameVal("transContNo",put.nextToken());
       else
        en.setNameVal("transContSealNo",put.nextToken());
       vindex+=1;
      }
      run+=1;
      vindex = 0;
      en.setNameVal("transContVolKey",volKey);
      en.setNameVal("transContRefNo",refNo);
      masterInsert.add(en.clone());
      en.clear();
     }
    }
    else if(na.indexOf(",")>0)
    {
     System.out.println("Enter -- multiple comma --- ");
     StringBuffer str = new StringBuffer(16);
     StringTokenizer put = new StringTokenizer(na);
     Encap en = null;
     do
     {
      if(run == srun) break;
      str.append(put.nextToken(","));
      if((str.toString()).indexOf('+')<0)
      {
       Module7.errorDisplay("Expecting a \"+\" delimiter in: "+na+"\n"+
       "Example: ContNo1+SealNo1\n","ERROR");
       failFlag = true;
       break;
      }
      else
      {
       en.setTable("transContainer");
       StringTokenizer put2 = new StringTokenizer(str.toString(),"+");
       while(put2.hasMoreTokens())
       {
        if(vindex == 0)
	 en.setNameVal("transContNo",put2.nextToken());
	else
	 en.setNameVal("transContSealNo",put2.nextToken());
	vindex++;
       }
       vindex = 0;
       en.setNameVal("transContVolKey",volKey);
       en.setNameVal("transContRefNo",refNo);
       masterInsert.add(en.clone());
       en.clear();
       run+=1;
      }
     }while(put.hasMoreTokens());
    }
    else
    {
     Module7.errorDisplay("Expecting a comma delimiter in: "+na+"\n"+
     "For Example: ContNo1+SealNo1,ContNo2+SealNo2\n","ERROR");
     if(run>0)
     {
      srun -=run;
      run = 0;
      failFlag = true;
     }
    }
   } else failFlag = true;
   if(!failFlag) passFlag = true;
  }while(!passFlag);
 }

 private class ButtonListener implements ActionListener
 {
  DBConnect db = null;
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == editButton)
   {
    db = new DBConnect();
    try
    {
     if(!db.makeConnection("LKB"))
      throw new SQLException("Failed to make connection to database\n");
     if(collectOther(db))
     { 
      if(error.length()==0) commitChanges(db); 
      clearMaster();
      if(masterInsert.size()>0) masterInsert.removeAllElements();
      close();
     }
     else
      clearMaster();
    }
    catch(SQLException sqle)
    {
     sqle.printStackTrace(System.out);
     error.append(sqle.getMessage());
    }
    finally
    {
     db = null;
    }
   }
   else
    close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
   resetFlags();
  }

  public void commitChanges(DBConnect db) throws SQLException
  {
   try
   {
    if(volFlag || stowageFlag)
     masterMap = processVolStowage(masterMap,db);
    if(masterInsert.size()>0)
    {
     int i = masterInsert.size();
     System.out.println(" --- masterInsert --- ");
     for(int j=0;j<i;j++)
      db.viewEncap((Encap)((Encap)masterInsert.get(j)).clone());
    }
    if(masterDelete.size()>0)
    {
     System.out.println(" ---- masterDelete ---- ");
     for(int x=0;x<masterDelete.size();x++)
     {
      db.viewEncap((Encap)((Encap)masterDelete.get(x)).clone());
      db.DeleteSingle((Encap)masterDelete.get(x));
     }
    }
    System.out.println(" --- masterMap --- ");
    int i = masterMap.size();
    for(int j=0;j<i;j++)
     db.viewEncap((Encap)((Encap)masterMap.get(j)).clone());
    db.InsertMulti(masterInsert);
    db.UpdateMulti(masterMap);
    if(amountChange) BalanceAccount.rebalance(refNo,db);
    Module7.infoDisplay("Successfully update the database","Update");
   }
   catch(SQLException sqle)
   {
    sqle.printStackTrace(System.out);
    error.append(sqle.getMessage());
   }
   finally
   {
    db.close();
    resetFlags();
   }
  }

  private boolean collectOther(DBConnect db) throws SQLException
  {
   System.out.println("============== collectOther ===============");
   int row = td.rowLength;
   int col = td.NEWVAL;
   StringBuffer tmp = new StringBuffer();
   StringBuffer tmpName = new StringBuffer(32);
   boolean zeroFlag;
   Encap en = null; 
   for(int i=0;i<row;i++)
   {
    zeroFlag = false;
    tmp.append(((String)td.getValueAt(i,col)).trim());
    if(tmp.length()>=1&&tmp.toString().compareToIgnoreCase(" ")!=0)
    {
     if(findMatch(masterNum,i)) // must be amount type [BigDecimal]
     { 
      if(Module7.checkMax(tmp.toString()))
      {
       if(tmp.length()==1 && (Integer.parseInt(tmp.toString()) == 0))
        zeroFlag = true;
       if(Module7.checkInt(tmp.toString(),3) || zeroFlag)
       {
	System.out.print("Check Amount: "+(String)masterCont.elementAt(i));
	System.out.println(" = "+tmp.toString());
	en = getWhole(i,(String)masterCont.elementAt(i),
  	 null,usrID,sendCont,((Integer)masterKey.get(i)).intValue());
	if(en!=null)
	{
	 System.out.println("--> amountChange : "+(String)masterCont.get(i));  
	 if(!amountChange) amountChange = true;
	 en.setNameVal((String)masterCont.elementAt(i),
	  new BigDecimal(tmp.toString()));
	 addToMaster(en.clone());
	}
        if(error.length()>0) return false;
       }
       else error.append("Row ["+(i+1)+"]: Input digit input allowed\n");
      }
      else error.append("Row ["+(i+1)+"]: Input exceed max length of 12\n");
     }
     else if(findMatch(masterDate,i)) // must be date type
     { 
      if(Module7.checkDate(tmp.toString()))
      {
       System.out.print("Check date: "+(String)masterCont.elementAt(i));
       System.out.println(" = "+tmp.toString());
       en = getWhole(i,(String)masterCont.elementAt(i),null,usrID,sendCont,
  	((Integer)masterKey.get(i)).intValue());
       if(en!=null)
       {
        en.setNameVal((String)masterCont.elementAt(i),
 	 Module7.formDate(tmp.toString()));
        addToMaster(en.clone());
       }
      if(error.length()>0) return false;
     }
     else error.append("Row ["+(i+1)+"]: Error date format DD-MM-YYYY\n");
    }
    else if(findMatch(masterCurr,i)) // must be currency type
    { 
     if(tmp.length()==3)
      if(allwords(tmp.toString()))
      {
       System.out.print("Check currency: "+(String)masterCont.elementAt(i));
       System.out.println(" = "+tmp.toString());
       if(Module7.checkValidCurrency(tmp.toString()))
       {
        en = getWhole(i,(String)masterCont.elementAt(i),
  	 null,usrID,sendCont,((Integer)masterKey.get(i)).intValue());
        if(en!=null)
        {
	 System.out.println("currency change ");
	 if(!amountChange) amountChange = true;
	 en.setNameVal((String)masterCont.elementAt(i),tmp.toString());
         addToMaster(en.clone());
        }
       }
       else error.append("currency enter at row ["+(i+1)+"] is not listed\n");
       if(error.length()>0) return false;
      }
      else error.append("Row ["+(i+1)+"]: Input must be in"+"form of alphabet\n");
     else error.append("Row ["+(i+1)+"]: Input must be only 3 characters\n");
    }
    else // must be other type of input 
    {
     System.out.println("OtherType of Input["+i+"]: "+
      (String)masterCont.elementAt(i)+" and tmp: "+tmp.toString());
     if(checkLength((String)masterCont.elementAt(i),tmp.toString()))
     {
      System.out.print("Check OthType: "+(String)masterCont.elementAt(i));
//      System.out.println(" = "+tmp.toString().trim());
      if(((String)masterCont.elementAt(i)).equalsIgnoreCase("customerAddr"))
       en = getWhole(i,(String)masterCont.elementAt(i),
	(String)orgMap.get("customerAddr"),usrID,sendCont,
	((Integer)masterKey.get(i)).intValue());
      else
       en = getWhole(i,(String)masterCont.elementAt(i),tmp.toString(),
        usrID,sendCont,((Integer)masterKey.get(i)).intValue());

      if(en!=null)
      {
       en.setNameVal((String)masterCont.elementAt(i),tmp.toString());
       addToMaster(en.clone());
       if(en.getTable().equalsIgnoreCase("transVol"))
       {
        if(((String)masterCont.get(i)).equalsIgnoreCase("transVolVolume"))
	 volFlag = true;
	else if(((String)masterCont.get(i)).equalsIgnoreCase("transVolStowage"))
	 stowageFlag = true;
        masterPos.put(String.valueOf(masterMap.size()-1),String.valueOf(i));
//	System.out.println(" = i = "+i);
       }
      }
     }
     else error.append("Your input at row["+(i+1)+"] has exceed max length of "+
      masterLength.get((String)masterCont.elementAt(i))+"\n");
    }
   }
   if(en!=null) en.clear();
   if(tmp.toString().length()>0) tmp.delete(0,tmp.length());
  } // end of bigger if
  System.out.println("======exit collectOther======");
  if(error.length()==0) 
  {
   complete(sendCont);
   return true;
  }
  return false;
 } // end of method

 private void complete(String con)
 {
  Encap en = new Encap();
  if(newUser || changeUser)
  {
   en.setTable("accountReceivable");
   if(newUser)
    en.setNameVal("acctRecFromCustKey","@customerKey");
   else
    en.setNameVal("acctRecFromCustKey",changeUserID);
   en.setCondition("WHERE acctRecFromRefKey="+con+";");
   addToMaster(en.clone());
   en.clear();
   en.setTable("transRecord");
   if(newUser)
    en.setNameVal("transCustKey","@customerKey");
   else
    en.setNameVal("transCustKey",changeUserID);
   en.setCondition("WHERE transRefKey="+con+";");
   addToMaster(en.clone());
   en.clear();
  }
  if(newTrucking || changeTrucking)
  {
   en.setTable("accountPayable");
   if(newTrucking)
    en.setNameVal("acctPayToTruckCoKey","@truckingCompanyKey");
   else
    en.setNameVal("acctPayToTruckCoKey",changeTruckingID);
   en.setCondition("WHERE acctPayToRefKey="+con+";");
   addToMaster(en.clone());
   en.clear();
//   System.out.println("--adding to transRecord--");
   en.setTable("transRecord");
   if(newTrucking)
    en.setNameVal("transTrucking","@truckingCompanyKey");
   else
    en.setNameVal("transTrucking",changeTruckingID);
   en.setCondition("WHERE transRefKey="+con+";");
   addToMaster(en.clone());
   en.clear();
  }
 } 

  public void resetFlags()
  {
   newUser = false;
   newTrucking = false;
   changeUser = false;
   changeTrucking = false;
   amountChange = false;
   insertFlag = false;
  }

  private boolean findMatch(Vector v,int rowFind)
  {
   int size = v.size();
   for(int i=0;i<size;i++)
    if(((Integer)v.elementAt(i)).intValue() == rowFind)
     return true;
   return false;
  }

  private boolean checkLength(String str1,String str2)
  {
   int orglen = Integer.parseInt((String)masterLength.get(str1));
   int len = str2.length();
   if(len>orglen) return false;
   return true;
  }
 } // end of class ButtonListener

/**
 * getData's method is to retrieve data from database.
 * @param String table - table name to query
 *        String name - name of the data
 *        String val - value of the data
 *        String query - contain query to obtain specific value
 *        DBConnect db - contain connection to database
 */
 public int getData(String table,String name,
	 String val,String query,DBConnect db) throws SQLException
 {
  Encap e = null;
  int key = 0;
  e = db.QuerySingle(table,"*","WHERE "+name+"=\""+val+"\";");
  if(e != null)
   key = e.extractInteger(query,0);
  return key;
 }

/**
 * getWhole's method is to set the encapsulation for the data that needs
 * to be changed. The completion only equips the encap with the condition
 * set where the value needs to be place outside of the method
 * @param String str - the name of the value
 *        int usrID  - the user ID who changed the value
 *        String con - the condition usually contain the RefNo
 *        String anotherCond - contains key
 * @return Encap that needs to be filled with value outside the method.
 */
 public Encap getWhole(int index,String str,String val,int usrID,String con,
	 int anotherCond)
 {
  Encap en = new Encap();
  DBConnect db = new DBConnect();
  int key = 0;
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   if(str.startsWith("claimableOth")) //claimableOtherCharges
   {
    en.setTable("claimableOtherCharges");
    if(!checkHappen("claimableOtherCharges"))
    {
     en.setNameVal("claimableOthLastChangeBy",usrID);
     en.setNameVal("claimableOthLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE claimableOthChargesKey="+anotherCond
     +" AND claimableOthRefKey="+con+";");
   }
   else if(str.startsWith("claimable")) //claimableCharges
   {
    en.setTable("claimableCharges");
    if(!checkHappen("claimableCharges"))
    {
     en.setNameVal("claimableChargeLastChangeBy",usrID);
     en.setNameVal("claimableChargeLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE claimableChargesKey="+anotherCond
     +" AND claimableRefKey="+con+";");
   }
   if(str.startsWith("customer")) //customer
   {	 
    en.setTable("customer");
    if(str.equalsIgnoreCase("customerName"))
    {
     key = getData("customer",str,val,"customerKey",db);
     if(key==0) // new customer name 
     {
      en.setTable("customer");
      en.setNameVal("customerName",val);
      en.setVariable("SET @customerKey = LAST_INSERT_ID();");
      newUser = true;
//      System.out.println(">>Inserting new customer");
      masterInsert.add(en.clone());
      db.viewEncap(en);
      db.InsertData((Encap)en.clone());
//      System.out.println(">>");
      en.clear();
      return null;
     }
     else // change the existing value
     {
      changeUserID = key;
      changeUser= true;
      en.setCondition("WHERE customerKey="+key+";");
      return null;
     }    
    }
    else // change address
    {
//     System.out.println("change addr query for "+str+" "+val);
     key = getData("customer",str,val,"customerKey",db);
     if(newUser)
      en.setCondition("WHERE customerKey=@customerKey;"); 
     else
      en.setCondition("WHERE customerKey="+changeUserID+";");
    }
   }
   else if(str.startsWith("truckingName")) //truckingCompany
   {
    key = getData("truckingCompany",str,val,"truckingCompanyKey",db);
    en.setTable("truckingCompany");
    if(key==0) // new truckingCompany
    {
     en.setTable("truckingCompany");
     en.setNameVal("truckingName",val);
     en.setVariable("SET @truckingCompanyKey = LAST_INSERT_ID();");
     newTrucking = true;
//     System.out.println(">>Inserting new trucking company");
     db.viewEncap(en);
//     System.out.println(">>");
     masterInsert.add(en.clone());
     db.InsertData((Encap)en.clone());
     en.clear();
     return null;
    }
    else // change the existing value 
    {
     changeTruckingID = key;
     changeTrucking= true;
     en.setCondition("WHERE truckingCompanyKey=\""+key+"\";");
     return null;
    }
   }
   else if(str.startsWith("transCont")) //transContainer
   {
    en.setTable("transContainer");
    if(!checkHappen("transContainer"))
    {
     en.setNameVal("transContLastChangeBy",usrID);
     en.setNameVal("transContLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE transContKey="+anotherCond+" AND "+
     "transContRefNo="+con+";");
   }
   else if(str.startsWith("transVol"))
   {
//    System.out.println("=== enter transVol");
    en.setTable("transVol");
    en.setNameVal("transVolRefKey",con);
    System.out.println("vol or stowage: "+val+" str> "+str);
    if(str.equalsIgnoreCase("transVolVolume"))
    { 
     if(Module7.checkInt(val,1))
     { }
     else if(val.length()==1 && val.equalsIgnoreCase("0"))
     { }
     else
     { 
      error.append("Volume must be a digit\n");
      return null;
     }
    }
    if(str.equalsIgnoreCase("transVolStowage"))
    {
     if(!Module7.checkStowage(val))
     {
      error.append("Stowage Factor entered is not included in the list\n");
      return null;
     }
    }
    en.setCondition("WHERE transVolKey="+anotherCond+";");
   }
   else if(str.startsWith("invoiceOth")) //invoiceOtherCharges
   {
    en.setTable("invoiceOtherCharges");
    if(!checkHappen("invoiceOtherCharges"))
    {
     en.setNameVal("invoiceOthLastChangeBy",usrID);
     en.setNameVal("invoiceOthLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE invoiceOthKey="+anotherCond+" AND "+
     "invoiceOthRefKey="+con+";");
   }
   else if(str.startsWith("costOth")) //otherCost
   {
    en.setTable("otherCost");
    if(!checkHappen("costOth"))
    {
     en.setNameVal("costOthLastChangeBy",usrID);
     en.setNameVal("costOthLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE costOthKey="+anotherCond+" AND "+
     "costOthRefKey="+con+";");
   }
   else if(str.startsWith("trans")) //transRecord
   {
    en.setTable("transRecord");
    if(str.equalsIgnoreCase("transCustKey"))
    {
     if(newUser)
      en.setNameVal("transCustKey","@customerKey");
     else
      en.setNameVal("transCustKey",changeUserID);
    }
    if(str.equalsIgnoreCase("transTrucking"))
    {
     if(newTrucking)
      en.setNameVal("transTrucking","@truckingCompanyKey");
     else
      en.setNameVal("transTrucking",changeTruckingID);
    }
    if(!checkHappen("transRecord"))
    {
     en.setNameVal("transLastChangeBy",usrID);
     en.setNameVal("transLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE transRefKey="+con+";");
   }
   else if(str.startsWith("imp")) //impInfoRecord
   {
    en.setTable("impInfoRecord");
    if(!checkHappen("impInfoRecord"))
    {
     en.setNameVal("impInfoLastChangeBy",usrID);
     en.setNameVal("impInfoLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE impInfoKey="+anotherCond+
     " AND impFromRefKey="+con+";");
   }
   else if(str.startsWith("exp")) //expInfoRecord
   {
    en.setTable("expInfoRecord");
    if(!checkHappen("expInfoRecord"))
    {
     en.setNameVal("expInfoLastChangeBy",usrID);
     en.setNameVal("expInfoLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE expInfoKey="+anotherCond+
     " AND expFromRefKey="+con+";");
   }
   //invoiceRecord
   else if(str.startsWith("invoice"))
   {
    en.setTable("invoiceRecord");
    if(!checkHappen("invoiceRecord"))
    {
     en.setNameVal("invoiceLastChangeBy",usrID);
     en.setNameVal("invoiceLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE invoiceRecKey="+anotherCond+
     " AND invoiceRefKey="+con+";");
   }
   //costRecord
   else if(str.startsWith("cost"))
   {
    en.setTable("costRecord");
    if(!checkHappen("costRecord"))
    {
     en.setNameVal("costLastChangeBy",usrID);
     en.setNameVal("costLastChange","CURRENT_DATE");
    }
    en.setCondition("WHERE costKey="+anotherCond+
     " AND costFromRefKey="+con+";");
   }
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage());
  }
  finally
  {
   db.close();
  }
  return en;
 }

 public boolean checkHappen(String tableName)
 {
  int size = getMasterSize();
  Encap e = null;
  boolean flag = false;
  for(int i=0;i<size;i++)
  {
   e = getMaster(i);
   if(e.getTable().equalsIgnoreCase(tableName))
   {
    flag = true;
    break;
   }
   e.clear();
  }
  if(e!=null && e.getSize()>0) e.clear();
  e = null;
  return flag;
 }

 public static boolean allwords(String str)
 {
  int len = str.length();
  for(int i=0;i<len;i++)
   if(!Character.isLetter(str.charAt(i)))
    return false;
  return true;
 }

 public void close()
 {
  frame.dispose();
  System.gc();
 }

/**
 * retrieveNormal's method is to retrieve data and display it to table
 * @param HashMap map - contains data from db, String title contains export/import 
 * @return none
 */
 private void retrieveNormal(HashMap map,String title)
 {
  int number = 0;
  StringBuffer msg = new StringBuffer(24);
  msg.append((String)map.get("customerKey"));
  if(title.equalsIgnoreCase("Import"))
  {
   result.addElement(new Data("info : Cosignee Name",
    (String)map.get("customerName"),""));
   masterCont.add("customerName");
   masterLength.put("customerName","32");
   masterKey.add(new Integer(msg.toString()));
   if(map.containsKey("customerAddr"))
   {
    result.addElement(new Data("info : Cosignee Address",
     (String)map.get("customerAddr"),""));
    masterCont.add("customerAddr");
    masterLength.put("customerAddr","48");
    masterKey.add(new Integer(msg.toString()));
   }
  }
  else
  {
   result.addElement(new Data("info : Shipper Name",
    (String)map.get("customerName"),""));
   masterCont.add("customerName");
   masterLength.put("customerName","32");
   masterKey.add(new Integer(msg.toString()));
  }
  if(msg.length()>0) msg.delete(0,msg.length());
  result.addElement(new Data("info : Trucking Company",
    (String)map.get("truckingName"),""));
  masterCont.add("truckingName");
  masterLength.put("truckingName","32");
  masterKey.add(new Integer((String)map.get("truckingCompanyKey")));

  if(msg.length()>0) msg.delete(0,msg.length());
  msg.append(new Integer((String)map.get("transRefKey")));

// --- Volume and Stowage 
  Vector tmpStore = null;
  int volSize = 0;
  int volKey = 0;
  StringBuffer orgValue = new StringBuffer(10);
  if(map.containsKey("NumberTransVol"))
  {
   volSize = Integer.parseInt((String)map.get("NumberTransVol"));
   tmpStore = new Vector(volSize);
   for(int i=1;i<=volSize;i++)
   {
    volKey = Integer.parseInt((String)map.get("transVolKey"+i));
    orgValue.append((String)map.get("transVolVolume"+i));
    result.addElement(new Data("info : Volume["+i+"]",orgValue.toString(),""));
    masterCont.add("transVolVolume");
    masterLength.put("transVolVolume","5");
    masterKey.add(new Integer(volKey));
    masterValue.put(String.valueOf(masterCont.size()-1),orgValue.toString());
//	  System.out.println("volume masterCont:"+(masterCont.size()-1)
//		 +" value: "+orgValue.toString());
    orgMap.put(String.valueOf(masterCont.size()-1),String.valueOf(volKey));
    orgValue.delete(0,orgValue.length());
    orgValue.append((String)map.get("transVolStowage"+i));
    result.addElement(new Data("info : Stowage Factor["+i+"]",orgValue.toString(),""));
    masterCont.add("transVolStowage");
    masterLength.put("transVolStowage","10");
    masterKey.add(new Integer(volKey));
    masterValue.put(String.valueOf(masterCont.size()-1),orgValue.toString());
//    System.out.println("stowage masterCont:"+(masterCont.size()-1)
//		 +" value: "+orgValue.toString());
    orgMap.put(String.valueOf(masterCont.size()-1),String.valueOf(volKey));
    tmpStore.add(new Integer(volKey));
    orgValue.delete(0,orgValue.length());
   }
  }
  else // for single entry 
  {
   tmpStore = new Vector(1);
   volKey = Integer.parseInt((String)map.get("transVolKey"));
   orgValue.append((String)map.get("transVolVolume"));
   result.addElement(new Data("info : Volume",orgValue.toString(),""));
   masterCont.add("transVolVolume");
   masterLength.put("transVolVolume","5");
   masterKey.add(new Integer(volKey));
   masterValue.put(String.valueOf(masterCont.size()-1),orgValue.toString());
//	 System.out.println("volume masterCont:"+(masterCont.size()-1)
//		 +" value: "+orgValue.toString());
   orgMap.put(String.valueOf(masterCont.size()-1),String.valueOf(volKey));
   orgValue.delete(0,orgValue.length());
   orgValue.append((String)map.get("transVolStowage"));
   result.addElement(new Data("info : Stowage Factor",orgValue.toString(),""));
   masterCont.add("transVolStowage");
   masterLength.put("transVolStowage","10");
   masterKey.add(new Integer(volKey));
   masterValue.put(String.valueOf(masterCont.size()-1),orgValue.toString());
//	 System.out.println("stowage masterCont:"+(masterCont.size()-1)
//		 +" value: "+orgValue.toString());
   orgMap.put(String.valueOf(masterCont.size()-1),String.valueOf(volKey));
   tmpStore.add(new Integer(volKey));
   orgValue.delete(0,orgValue.length());
  }

  int contKey = 0;
  volKey = 0;
  int numberOf = 0;
  boolean found = false;
  if(map.containsKey("NumberTransCont"))
  {
   volSize = Integer.parseInt((String)map.get("NumberTransCont"));
   for(int i=1;i<=volSize;i++)
   {
    volKey = Integer.parseInt((String)map.get("transContVolKey"+i));
    if(tmpStore.indexOf(new Integer(volKey))>=0)
    {
     numberOf = tmpStore.indexOf(new Integer(volKey)) + 1;
     found = true;
    }
    contKey = Integer.parseInt((String)map.get("transContKey"+i));
    orgValue.append((String)map.get("transContNo"+i));
    if(!found)
     result.addElement(new Data("info : Container ["+i+"] No.",
      orgValue.toString(),""));
    else
     result.addElement(new Data("info : Container ["+numberOf+"] No.",
      orgValue.toString(),""));
    masterCont.add("transContNo");
    masterLength.put("transContNo","32");
    masterKey.add(new Integer(contKey));
    orgMap.put(String.valueOf(masterCont.size()-1),String.valueOf(contKey));
    orgValue.delete(0,orgValue.length());
    orgValue.append((String)map.get("transContSealNo"+i));
    if(!found)
     result.addElement(new Data("info : Seal ["+i+"] No.",orgValue.toString(),""));
    else
     result.addElement(new Data("info : Seal ["+numberOf+"] No.",orgValue.toString(),""));
    masterCont.add("transContSealNo");
    masterLength.put("transContSealNo","32");
    masterKey.add(new Integer(contKey));
    orgMap.put(String.valueOf(masterCont.size()-1),String.valueOf(contKey));
    orgValue.delete(0,orgValue.length());
   }
  }
  else if(map.containsKey("transContKey"))// for single entry
  {
   contKey = Integer.parseInt((String)map.get("transContKey"));
   orgValue.append((String)map.get("transContNo"));
   result.addElement(new Data("info : Container No.",orgValue.toString(),""));
   masterCont.add("transContNo");
   masterLength.put("transContNo","32");
   masterKey.add(new Integer((String)map.get("transContKey")));
   orgMap.put(String.valueOf(masterCont.size()-1),String.valueOf(contKey));
   orgValue.delete(0,orgValue.length());

   orgValue.append((String)map.get("transContSealNo"));
   result.addElement(new Data("info : Seal No.",orgValue.toString(),""));
   masterCont.add("transContSealNo");
   masterLength.put("transContSealNo","32");
   masterKey.add(new Integer((String)map.get("transContKey")));
   orgMap.put(String.valueOf(masterCont.size()-1),String.valueOf(contKey));
   orgValue.delete(0,orgValue.length());
  }

  if(!tmpStore.isEmpty()) tmpStore.removeAllElements();

//------info
  result.addElement(new Data("info : Door Location",
   (String)map.get("transDoorLocation"),""));
  masterCont.add("transDoorLocation");
  masterLength.put("transDoorLocation","32");
  masterKey.add(new Integer(refNo));
  result.addElement(new Data("info : Loading Port",
   (String)map.get("transLoadingPort"),""));
  masterCont.add("transLoadingPort");
  masterLength.put("transLoadingPort","32");
  masterKey.add(new Integer(refNo));

  if(!((String)map.get("transInvoiceRemarks")).equalsIgnoreCase("none"))
  {
   result.addElement(new Data("info : Invoice Remarks",
    (String)map.get("transInvoiceRemarks"),""));
   masterCont.add("transInvoiceRemarks");
   masterLength.put("transInvoiceRemarks","128");
   masterKey.add(new Integer(refNo));
  }
  if(!((String)map.get("transDebitNoteRemarks")).equalsIgnoreCase("none"))
  {
   result.addElement(new Data("info : Debit Note Remarks",
    (String)map.get("transDebitNoteRemarks"),""));
   masterCont.add("transDebitNoteRemarks");
   masterLength.put("transDebitNoteRemarks","128");
   masterKey.add(new Integer(refNo));
  }

  if(!((String)map.get("transInvoiceDT")).equalsIgnoreCase("0000-00-00"))
  {
   result.addElement(new Data("info : Invoice Date",
    Module7.formNDate((String)map.get("transInvoiceDT")),""));
   masterCont.add("transInvoiceDT");
   masterDate.add(new Integer((masterCont.size()-1)));
  }
  if(msg.length()>0) msg.delete(0,msg.length());
  if(title.equalsIgnoreCase("Import"))
  {
   msg.append((String)map.get("impInfoKey"));
   if(!((String)map.get("impGateOut")).equalsIgnoreCase("0000-00-00"))
   {
    result.addElement(new Data("info : Gate Out Date",
     Module7.formNDate((String)map.get("impGateOut")),""));
    masterCont.add("impGateOut");
    masterDate.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
   }
   result.addElement(new Data("info : Arrival Date",
    Module7.formNDate((String)map.get("impArrival")),""));
   masterCont.add("impArrival");
   masterDate.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   if(!((String)map.get("impContReturnDate")).equalsIgnoreCase("0000-00-00"))
   {
    result.addElement(new Data("info : Container Return Date",
     Module7.formNDate((String)map.get("impContReturnDate")),""));
    masterCont.add("impContReturnDate");
    masterDate.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
   }
   if(!((String)map.get("impBLNo")).equalsIgnoreCase("none"))
   {
    result.addElement(new Data("info : Bill of Lading No",
     (String)map.get("impBLNo"),""));
    masterCont.add("impBLNo");
    masterLength.put("impBLNo","24");
    masterKey.add(new Integer(msg.toString()));
   }
  }
  else
  {
   msg.append((String)map.get("expInfoKey"));
   if(!((String)map.get("expStuffingDate")).equalsIgnoreCase("0000-00-00"))
   {
    result.addElement(new Data("info : Stuffing Date",
     Module7.formNDate((String)map.get("expStuffingDate")),""));
    masterCont.add("expStuffingDate");
    masterDate.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
   }
   if(!((String)map.get("expETD")).equalsIgnoreCase("0000-00-00"))
   {
    result.addElement(new Data("info : ETD",
     Module7.formNDate((String)map.get("expETD")),""));
    masterCont.add("expETD");
    masterDate.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
   }
   result.addElement(new Data("info : Shipping Instruction No",
    (String)map.get("expSINo"),""));
   masterCont.add("expSINo");
   masterLength.put("expSINo","24");
   masterKey.add(new Integer(msg.toString()));

   result.addElement(new Data("info : Destination Name",
    (String)map.get("expDestName"),""));
   masterCont.add("expDestName");
   masterLength.put("expDestName","32");
   masterKey.add(new Integer((String)map.get("expInfoKey")));
   masterKey.add(new Integer(msg.toString()));

   if(map.containsKey("expVesselName"))
   {
    result.addElement(new Data("info : Vessel Name",
     (String)map.get("expVesselName"),""));
    masterCont.add("expVesselName");
    masterLength.put("expVesselName","32");	
    masterKey.add(new Integer(msg.toString()));
   }
  }

  if(!((String)map.get("transInvoiceRemarks")).equalsIgnoreCase("none"))
  {
   result.addElement(new Data("info : Invoice Remarks",
    (String)map.get("transInvoiceRemarks"),""));
   masterCont.add("transInvoiceRemarks");
   masterLength.put("transInvoiceRemarks","128");
   masterKey.add(new Integer(refNo));
  }
  if(msg.length()>0) msg.delete(0,msg.length());

  if(!((String)map.get("transDebitNoteRemarks")).equalsIgnoreCase("none"))
  {
   result.addElement(new Data("info : Debit Note Remarks",
    (String)map.get("transDebitNoteRemarks"),""));
   masterCont.add("transDebitNoteRemarks");
   masterLength.put("transDebitNoteRemarks","128");
   masterKey.add(new Integer(refNo));
  }

  msg.append((String)map.get("costKey"));
  result.addElement(new Data("cost : Total Operational Cost Currency",
   (String)map.get("costTotalOpCurr"),""));
  masterCont.add("costTotalOpCurr");
  masterCurr.add(new Integer((masterCont.size()-1)));
  masterKey.add(new Integer(msg.toString()));
  result.addElement(new Data("cost : Total Operational Cost Amount",
   Module7.formNumDelimiter((String)map.get("costTotalOp")),""));
  masterCont.add("costTotalOp");
  masterNum.add(new Integer((masterCont.size()-1)));
  masterKey.add(new Integer(msg.toString()));
  result.addElement(new Data("cost : Trucking Currency",
   (String)map.get("costTruckingCurr"),""));
  masterCont.add("costTruckingCurr");
  masterCurr.add(new Integer((masterCont.size()-1)));
  masterKey.add(new Integer(msg.toString()));
  result.addElement(new Data("cost : Trucking Amount",
   Module7.formNumDelimiter((String)map.get("costTrucking")),""));
  masterCont.add("costTrucking");
  masterNum.add(new Integer((masterCont.size()-1)));
  masterKey.add(new Integer(msg.toString()));

  if(!((String)map.get("costCommission")).equalsIgnoreCase("0.00"))
  {
   result.addElement(new Data("cost : Commission Currency",
    (String)map.get("costCommissionCurr"),""));
   masterCont.add("costCommissionCurr");
   masterCurr.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   result.addElement(new Data("cost : Commission Amount",
    Module7.formNumDelimiter((String)map.get("costCommission")),""));
   masterCont.add("costCommission");
   masterNum.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
  }
  if(msg.length()>0) msg.delete(0,msg.length());

  if(map.containsKey("NumberOtherCost")) // get the 1st 
  {
   number = Integer.parseInt((String)map.get("NumberOtherCost"));
   for(int i=1;i<=number;i++)
   {
    msg.append((String)map.get("costOthKey"+i));
    result.addElement(new Data("cost Other : "+
     (String)map.get("costOthDesc"+i)
     +" Currency",(String)map.get("costOthCurr"+i),""));
    masterCont.add("costOthCurr");
    masterCurr.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
    // to put the position
    orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
    result.addElement(new Data("cost Other : "+
     (String)map.get("costOthDesc"+i),
     Module7.formNumDelimiter((String)map.get("costOthAmt"+i)),""));
    masterCont.add("costOthAmt");
    masterNum.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
    // to put the position
    orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
    msg.delete(0,msg.length());
   }
  }
  else if(map.containsKey("costOthKey"))
  {
   msg.append((String)map.get("costOthKey"));
   result.addElement(new Data("cost Other : "+(String)map.get("costOthDesc")
    +" Currency",(String)map.get("costOthCurr"),""));
   masterCont.add("costOthCurr");
   masterCurr.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   // put the position
   orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
   result.addElement(new Data("cost Other : "+(String)map.get("costOthDesc"),
    Module7.formNumDelimiter((String)map.get("costOthAmt")),""));
   masterCont.add("costOthAmt");
   masterNum.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   // put the position
   orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
   msg.delete(0,msg.length());
  }

  if(map.containsKey("claimableTotalLiftOnAmt") &&
    !((String)map.get("claimableTotalLiftOnAmt")).equalsIgnoreCase("0.00"))
  {
   msg.append((String)map.get("claimableChargesKey"));
   result.addElement(new Data("claimable : Total LiftOn Currency",
    (String)map.get("claimableTotalLiftOnCurr"),""));
   masterCont.add("claimableTotalLiftOnCurr");
   masterCurr.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   result.addElement(new Data("claimable : Total LiftOn Amount",
    Module7.formNumDelimiter((String)map.get("claimableTotalLiftOnAmt")),""));
   masterCont.add("claimableTotalLiftOnAmt");
   masterNum.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
  }

  if(map.containsKey("claimableTotalLiftOffAmt") &&
   !((String)map.get("claimableTotalLiftOffAmt")).equalsIgnoreCase("0.00"))
  {
   if(msg.length()==0)
    msg.append((String)map.get("claimableChargesKey"));
   result.addElement(new Data("claimable : Total LiftOff Currency",
    (String)map.get("claimableTotalLiftOffCurr"),""));
   masterCont.add("claimableTotalLiftOffCurr");
   masterCurr.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   result.addElement(new Data("claimable : Total LiftOff Amount",
    Module7.formNumDelimiter((String)map.get("claimableTotalLiftOffAmt")),""));
   masterCont.add("claimableTotalLiftOffAmt");
   masterNum.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
  }

  if(title.equalsIgnoreCase("Export"))
  {
   if(msg.length()==0)
    msg.append((String)map.get("claimableChargesKey"));
   result.addElement(new Data("Print to debt note",
    (String)map.get("claimablePrintable"),""));
   masterCont.add("claimablePrintable");
   masterLength.put("claimablePrintable","1");
   masterKey.add(new Integer(msg.toString()));
  }
  if(msg.length()>0) msg.delete(0,msg.length());

  if(map.containsKey("NumberClaimableOtherCharges"))
  {
   number = Integer.parseInt((String)map.get("NumberClaimableOtherCharges"));
   for(int i=1;i<=number;i++)
   {
    msg.append((String)map.get("claimableOthChargesKey"+i));
    result.addElement(new Data("claimable Other : "+
     (String)map.get("claimableOthDesc"+i)+" Currency",
     (String)map.get("claimableOthCurr"+i),""));
    masterCont.add("claimableOthCurr");
    masterCurr.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
    orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
    result.addElement(new Data("claimable Other : "+
     (String)map.get("claimableOthDesc"+i),
    Module7.formNumDelimiter((String)map.get("claimableOthAmt"+i)),""));
    masterCont.add("claimableOthAmt");
    masterNum.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
    orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
    msg.delete(0,msg.length());
   }
  }
  else if(map.containsKey("claimableOthChargesKey"))
  {
   msg.append((String)map.get("claimableOthChargesKey"));
   result.addElement(new Data("claimable Other : "+
    (String)map.get("claimableOthDesc")+" Currency",
    (String)map.get("claimableOthCurr"),""));
   masterCont.add("claimableOthCurr");
   masterCurr.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   // to put the position
   orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
   result.addElement(new Data("claimable Other : "+
    (String)map.get("claimableOthDesc"),
    Module7.formNumDelimiter((String)map.get("claimableOthAmt")),""));
   masterCont.add("claimableOthAmt");
   masterNum.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   // to put the position
   orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
   msg.delete(0,msg.length());
  }

  msg.append((String)map.get("invoiceRecKey"));
  result.addElement(new Data("invoice : Selling Rate Currency",
   (String)map.get("invoiceSellCurr"),""));
  masterCont.add("invoiceSellCurr");
  masterCurr.add(new Integer((masterCont.size()-1)));
  masterKey.add(new Integer(msg.toString()));
  result.addElement(new Data("invoice : Selling Rate",
   Module7.formNumDelimiter((String)map.get("invoiceSellAmt")),""));
  masterCont.add("invoiceSellAmt");
  masterNum.add(new Integer((masterCont.size()-1)));
  masterKey.add(new Integer(msg.toString()));

  if(map.containsKey("invoiceHandleAmt") && 
   !((String)map.get("invoiceHandleAmt")).equalsIgnoreCase("0.00"))
  {
   result.addElement(new Data("invoice : Handling Charge Currency",
    (String)map.get("invoiceHandleCurr"),""));
   masterCont.add("invoiceHandleCurr");
   masterCurr.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   result.addElement(new Data("invoice : Handling Charge",
    Module7.formNumDelimiter((String)map.get("invoiceHandleAmt")),""));
   masterCont.add("invoiceHandleAmt");
   masterNum.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
  }
  msg.delete(0,msg.length());

  if(map.containsKey("NumberInvOtherCharges"))
  {
   number = Integer.parseInt((String)map.get("NumberInvOtherCharges"));
   for(int i=1;i<=number;i++)
   {
    msg.append((String)map.get("invoiceOthKey"+i));
    result.addElement(new Data("invoice Other : "+
     (String)map.get("invoiceOthDesc"+i)+" Currency",
     (String)map.get("invoiceOthCurr"+i),""));
    masterCont.add("invoiceOthCurr");
    masterCurr.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
    // to store the position
    orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
    result.addElement(new Data("invoice Other : "+
     (String)map.get("invoiceOthDesc"+i),
      Module7.formNumDelimiter((String)map.get("invoiceOthAmt"+i)),""));
    masterCont.add("invoiceOthAmt");
    masterNum.add(new Integer((masterCont.size()-1)));
    masterKey.add(new Integer(msg.toString()));
    // to store the position
    orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
    msg.delete(0,msg.length());
   }
  }
  else if(map.containsKey("invoiceOthKey"))
  {
   msg.append((String)map.get("invoiceOthKey"));
   result.addElement(new Data("invoice Other : "+
    (String)map.get("invoiceOthDesc")+" Currency",
    (String)map.get("invoiceOthCurr"),""));
   masterCont.add("invoiceOthCurr");
   masterCurr.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   // to store the position 
   orgMap.put(String.valueOf(masterCont.size()-1),msg.toString()); 
   result.addElement(new Data("invoice Other : "+
    (String)map.get("invoiceOthDesc"),
    Module7.formNumDelimiter((String)map.get("invoiceOthAmt")),""));
   masterCont.add("invoiceOthAmt");
   masterNum.add(new Integer((masterCont.size()-1)));
   masterKey.add(new Integer(msg.toString()));
   // to store the position
   orgMap.put(String.valueOf(masterCont.size()-1),msg.toString());
   msg.delete(0,msg.length());
  }
 } // end of retrieveNormal's method

 private class tableData extends AbstractTableModel
 {
  public final int OLDDESC = 0;
  public final int OLDVAL  = 1;
  public final int NEWVAL  = 2;

  public int rowLength;
  public int colLength;
  public Vector dataRow;
  public final String[] colNames= {"Old\nDescription",
  "Old\nValue","New\nValue"};

  public tableData(Vector ve)
  {
   rowLength = ve.size();
   colLength = colNames.length;
   initData(ve);
  } // end of tableData's constructor
  public void initData(Vector ve)
  { dataRow = ve; }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colLength; }
  public String getColumnName(int column)
  { return colNames[column]; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row, int column)
  {
   if(column == NEWVAL)
    return true;
   return false; 
  }
  public Object getValueAt(int row, int column)
  { 
   if((row<0)||(row>=getRowCount()))
    return " ";
   Data dt = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case OLDDESC: return dt.getOldDesc();
    case OLDVAL : return dt.getOldVal(); 
    case NEWVAL : return dt.getNewVal();
   }
   return " "; 
  }
  public void setValueAt(Object val, int row, int column)
  {
   Data dt = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case OLDDESC : dt.setOldDesc((String)val); break;
    case OLDVAL  : dt.setOldVal((String)val); break;
    case NEWVAL  : dt.setNewVal((String)val); break;
   }
	 dataRow.setElementAt(dt,row);
   fireTableCellUpdated(row,column);
  } 
 } // end of tableData's class

 private class Data
 {
  private String oldDesc;
  private String oldVal;
  private String newVal;

  public Data()
  { } 
  public Data(String od,String ov,String nv)
  {
   setOldDesc(od);
   setOldVal(ov);
   setNewVal(nv);
  }
  public void setOldDesc(String od)
  { oldDesc = new String(od); }
  public void setOldVal(String ov)
  { oldVal = new String(ov); }
  public void setNewVal(String nv)
  { newVal = new String(nv); }
  public String getOldDesc()
  { return oldDesc.toString(); }
  public String getOldVal()
  { return oldVal.toString(); } 
  public String getNewVal()
  { return newVal.toString(); }
 }
}
