import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Vector;
import java.math.BigDecimal;

public class EditPayment
{
 private int action;
 private JFrame frame;
 private JTable table;
 private tableData td;
 private JButton editButton;
 private JButton cancelButton;
 private Vector result = null;
 private String sendCont = null;
 private int usrID = 0;
 private int refNo = 0;
 private boolean changePaymentAmt = false;
 private boolean insertFlag = false;
 private boolean newBankFlag= false;
 private boolean applyToAR = true;
 private boolean amountChange = false;
 private boolean currencyChange = false;
 private BigDecimal changedAmt = null;
 private int changeTruckingID = 0;
 private int changeUserID = 0;
 private Vector masterCont = new Vector(32);// index all sequence
 private Vector masterNum = new Vector(16); // index all amount sequence
 private Vector masterCurr = new Vector(16);// index all currency sequence
 private Vector masterDate = new Vector(4);// index all date sequence
 private HashMap masterLength = new HashMap(); // index all name length
 private Vector masterKey = new Vector(32); // index all keys
 protected Vector masterMap = new Vector(16); // final storage
 protected Vector masterInsert = new Vector(3);
 protected MultipleCurrency mc = new MultipleCurrency();

 public StringBuffer error = new StringBuffer();
 public HashMap orgMap = new HashMap();

 public EditPayment(HashMap map,int usr,String cont)
 {
  if(map == null)
   error.append("Received null map\n");
  if(cont == null)
   error.append("Received null content\n");
  if(usr<=0)
   error.append("Received invalid userID\n");
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  usrID = usr;
  System.out.println("---Enter EditPayment---");
  refNo = Integer.parseInt((String)map.get("transRefKey"));
  sendCont = new String(cont);
  orgMap = (HashMap)map.clone();
  frame = new JFrame();
  if(((String)orgMap.get("transPayAcctRecKey")).equalsIgnoreCase("0"))
    applyToAR = false;
  if(applyToAR)
   frame.setTitle("Edit Payment applied to A/R for Pay ID."+cont);
  else
   frame.setTitle("Edit Payment applied to A/P for Pay ID."+cont);
  
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(map),BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Cancel in the panel instead",
     "Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain(HashMap map)
 {
  JPanel panel = new JPanel();
  retrievePayment(map); 
  td = new tableData(result);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i == td.OLDDESC)
    column = new TableColumn(i,30,render,editor);
   else if(i == td.OLDVAL)
    column = new TableColumn(i,10,render,editor);
   else
    column = new TableColumn(i,20,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(result.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.setLayout(new BorderLayout());
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.add(jsp,BorderLayout.CENTER);
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  editButton = new JButton("Edit");
  cancelButton = new JButton("Cancel");
  ButtonListener bl = new ButtonListener();
  editButton.addActionListener(bl);
  cancelButton.addActionListener(bl);
  panel.add(editButton);
  panel.add(cancelButton);
  return panel;
 }

 public void addToMaster(Object obj)
 {
  if(action == Module7.EDITRN)
   consolidateOther((Encap)obj);
  else
   masterMap.add(obj);
 }

 public Encap getMaster(int index)
 {
  return (Encap)((Encap)masterMap.elementAt(index)).clone();
 }

 public void viewMaster()
 {
  int msize = masterMap.size();
  for(int i=0;i<msize;i++)
   DBConnect.viewEncap(getMaster(i));
 }
 public void clearMaster()
 {
  if(!masterMap.isEmpty())
   masterMap.removeAllElements();
  if(!masterInsert.isEmpty())
   masterInsert.removeAllElements();
 }

 public int getMasterSize()
 {
  return masterMap.size();
 }

 private void changePay(BigDecimal cp)
 {
  BigDecimal orgAmt = null;
  BigDecimal orgPay = new BigDecimal((String)orgMap.get("transPayAmt"));
  if(applyToAR)
   orgAmt = new BigDecimal((String)orgMap.get("acctRecBalance"));
  else
   orgAmt = new BigDecimal((String)orgMap.get("acctPayBalance"));
  System.out.println("orgAmt : "+Module7.formNumDelimiter(orgAmt.toString()));
  orgAmt = orgAmt.add(orgPay); // add back to balance
  System.out.println("adding : "+Module7.formNumDelimiter(orgPay.toString())
    +" = "+Module7.formNumDelimiter(orgAmt.toString()));
  orgAmt = orgAmt.subtract(cp); // after effect
  System.out.println("subtract: " +Module7.formNumDelimiter(cp.toString())
    +" = "+Module7.formNumDelimiter(orgAmt.toString()));
  BigDecimal small = new BigDecimal("0.00");
  if(orgAmt.compareTo(small)<0)
  {
   error.append("The value you input is greater than the current balance\n");
   if(applyToAR)
    error.append("Check the existing A/R balance for Ref No."+refNo+"\n");
   else
    error.append("Check the existing A/P balance for Ref No."+refNo+"\n");
   return;
  }
  Encap en = new Encap();
  if(applyToAR)
  {
   en.setTable("accountReceivable");
   en.setNameVal("acctRecBalance",orgAmt);
   en.setCondition("WHERE acctRecKey="+
    (String)orgMap.get("transPayAcctRecKey")+";");
  }
  else
  {
   en.setTable("accountPayable");
   en.setNameVal("acctPayBalance",orgAmt);
   en.setCondition("WHERE acctPayKey="+
    (String)orgMap.get("transPayAcctPayKey")+";");
  }
  addToMaster(en.clone());
  en.clear();
 }

 public void consolidateOther(Encap e)
 {
  int pos = 0;
  int esize = e.getSize();
  int msize = masterMap.size();
  boolean visibleAction = false;

  Encap a = null;
  for(int i=0;i<msize;i++)
  {
   a = getMaster(i);
   if(a.getTable().equalsIgnoreCase(e.getTable()))
   {
    for(int j=0;j<esize;j++)
    {
     if(!a.getName(j).equalsIgnoreCase(e.getName(j)))
     {
      a.setNameVal(e.getName(j),e.getValue(j));
      visibleAction = true;
      pos = i;
      break;
     }
    }
    if(visibleAction) break;
   }
   a.clear();
  }
  if(visibleAction)
  {
   masterMap.setElementAt(a.clone(),pos);
   System.out.println("-- visibleAction = true -- at : "+pos+" "+
    "size : "+masterMap.size());
  }
  else
  {
   masterMap.add(e.clone());
   System.out.println("-- visibleAction = false -- at : "+
    (masterMap.size()-1)+" size: "+masterMap.size());
  }
  if(a!=null) a.clear(); 
  System.out.println("------ xx exit consolidateOther xx ------");
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == editButton)
   {
    if(collectPayment())
    { 
     System.out.println("---After Collect----");
     viewMaster();
     if(masterInsert.size()>0)
     {
      System.out.println("--------------------");
      for(int b=0;b<masterInsert.size();b++)
       DBConnect.viewEncap((Encap)((Encap)masterInsert.get(b)).clone());
     }
     System.out.println("--------------------");
     if(error.length()==0) commitChanges(); 
     clearMaster();
     if(masterInsert.size()>0) masterInsert.removeAllElements();
     close();
    }
    else
     clearMaster();
   }
   else
    close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
   resetFlags();
  }

  public void commitChanges()
  {
   DBConnect db = new DBConnect();
   try
   {
    if(!db.makeConnection("LKB"))
     throw new SQLException("Failed to make connection to database\n");
    if(masterInsert.size()>0)
     db.InsertMulti(masterInsert);
    db.UpdateMulti(masterMap);
    if(amountChange) BalanceAccount.rebalance(refNo,db);
    Module7.infoDisplay("Successfully update the database","Update");
   }
   catch(SQLException sqle)
   {
    sqle.printStackTrace(System.out);
    error.append(sqle.getMessage());
   }
   finally
   {
    db.close();
    resetFlags();
   }
  }
 } // end of class ButtonListener 

 public void resetFlags()
 {
  amountChange = false;
  insertFlag = false;
  newBankFlag = false;
 }

 private boolean collectPayment()
 {
  int row = td.rowLength;
  int col = td.NEWVAL;
  StringBuffer tmp = new StringBuffer();
  Encap en = new Encap();
  System.out.println(" --- in collectPayment --- ");
  for(int i=0;i<row;i++)
  {
   tmp.append(((String)td.getValueAt(i,col)).trim());
   if(tmp.length()>=1&&tmp.toString().compareToIgnoreCase(" ")!=0)
   {
    if(findMatch(masterNum,i))
    {
     System.out.println("You are in amount: "+tmp.toString());
     if(Module7.checkMax(tmp.toString()))
      if(Module7.checkInt(tmp.toString(),3))
      {
       en = getPayment((String)masterCont.elementAt(i),null,usrID,sendCont);
       if(en!=null)
       {
        if(changedAmt!=null) changedAmt = null;
        changedAmt = new BigDecimal(tmp.toString());
        changePaymentAmt = true;
        if(changePaymentAmt) changePay(changedAmt);
        if(error.length()==0)
        {
         en.setNameVal((String)masterCont.elementAt(i),new BigDecimal(tmp.toString()));
         addToMaster(en.clone());
        }
       }
       if(error.length()>0) return false;
      }
      else error.append("Row ["+(i+1)+"]: Only Digit input allowed\n");
     else error.append("Row ["+(i+1)+"]: Input exceed max length of 12\n");
    }
    else if(findMatch(masterDate,i))
    {
     System.out.println("You are in date: "+tmp.toString());
     if(Module7.checkDate(tmp.toString()))
     {
      en = getPayment((String)masterCont.elementAt(i),null,usrID,sendCont);
      if(en!=null)
      {
       en.setNameVal((String)masterCont.elementAt(i),tmp.toString());
       addToMaster(en.clone());
      }
      if(error.length()>0) return false;
     }
     else error.append("Row ["+(i+1)+"]: Error date format DD-MM-YYYY\n");
    }
    else if(findMatch(masterCurr,i))
    {
     System.out.println("You are in currency: "+tmp.toString());
     if(tmp.length()==3)
     if(allwords(tmp.toString()))
     {
      if(Module7.checkValidCurrency(tmp.toString()))
      {
       en = getPayment((String)masterCont.elementAt(i),
        null,usrID,sendCont);
       if(en!=null)
       {
        en.setNameVal((String)masterCont.elementAt(i),tmp.toString());
        addToMaster(en.clone());
       }
      }
      else error.append("currency enter at row["+(i+1)+"] is not listed\n");
      if(error.length()>0) return false;
     }
     else error.append("Row ["+(i+1)+"]: Input must be in "+"form of alphabet\n");
    else error.append("Row ["+(i+1)+"]: Input must be only 3 characters\n");
   }
   else
   {
    System.out.println("You are  in other: "+tmp.toString());
    if(checkLength((String)masterCont.elementAt(i),tmp.toString()))
    {
     en = getPayment((String)masterCont.elementAt(i),tmp.toString(),usrID,sendCont);
     if(en!=null)
     {
      en.setNameVal((String)masterCont.elementAt(i),tmp.toString());
      addToMaster(en.clone());
     }
     if(error.length()>0) return false;
    }
   }
  }
  if(tmp.length()>0) tmp.delete(0,tmp.length());
  if(en!=null) en.clear();
 } // end of for loop
 System.out.println(" --- exit collectPayment --- ");
 if(error.length()==0)
 {
  consolidate();
  resetFlags();
  return true;
 }
 return false;
}

 private void consolidate()
 {
  if(!insertFlag) return;
  int size = masterMap.size();
  boolean recent = false;
  boolean recentPay = false;
  Vector v = new Vector(2);
  int foundBank = 0;
  int foundPay = 0;
  int esize = 0;
  int pos = 0;
  int posPay = 0;
  Encap e = null;
  Encap m = null;
  Encap a = null;
  do
  {
   e = (Encap)masterMap.remove(0);
   if(e.getTable().equalsIgnoreCase("transBankRecord")&&foundBank==0)
   {
    m = (Encap)e.clone();
    foundBank++; 
   }
   else if(e.getTable().equalsIgnoreCase("transBankRecord"))
   {
    esize = e.getSize();
    for(int j=0;j<esize;j++)
     if(!m.getName(j).equalsIgnoreCase(e.getName(j)))
      m.setNameVal(e.getName(j),e.getValue(j));
    recent = true;
   }
   else if(e.getTable().equalsIgnoreCase("transPayRecord")&&foundPay==0)
   {
    a = (Encap)e.clone();
    foundPay++;
   }
   else if(e.getTable().equalsIgnoreCase("transPayRecord"))
   {
    esize = e.getSize();
    for(int g=0;g<esize;g++)
     if(!a.getName(g).equalsIgnoreCase(e.getName(g)))
      a.setNameVal(e.getName(g),e.getValue(g));
    recentPay = true;
   }
   else v.add(e.clone());

   if(foundBank>0 && recent)
   {
    if(newBankFlag)
    {
     if(pos== 0)
     {
      masterInsert.add(m.clone());
      pos = masterInsert.size()-1;
     }
     else
      masterInsert.add(m.clone());
    }
    else if(pos == 0 && !newBankFlag)
    {
     v.add(m.clone());
     pos = v.size()-1; 
    }
    else
     v.setElementAt(m.clone(),pos);
    recent = false;
   }
   else if(foundPay>0 && recentPay)
   {
    if(posPay == 0)
    {
     v.add(a.clone());
     posPay = v.size()-1;
    }
    else
     v.setElementAt(a.clone(),posPay);
    recentPay = false;
   }
   e.clear();
  }while(masterMap.size()>0);
  masterMap = (Vector)v.clone();
  if(!v.isEmpty()) v.removeAllElements();
 }

 private boolean findMatch(Vector v,int rowFind)
 {
  int size = v.size();
  for(int i=0;i<size;i++)
   if(((Integer)v.elementAt(i)).intValue() == rowFind)
    return true;
  return false;
 }

 private boolean checkLength(String str1,String str2)
 {
  int orglen = Integer.parseInt((String)masterLength.get(str1));
  int len = str2.length();
  if(len>orglen) return false;
  return true;
 }

/**
 * getData's method is to retrieve data from database.
 * @param String table - table name to query
 *        String name - name of the data
 *        String val - value of the data
 *        String query - contain query to obtain specific value
 *        DBConnect db - contain connection to database
 */
 public int getData(String table,String name,
	 String val,String query,DBConnect db) throws SQLException
 {
  Encap e = null;
  int key = 0;
  e = db.QuerySingle(table,"*","WHERE "+name+"=\""+val+"\";");
  if(e != null)
   key = e.extractInteger(query,0);
  return key;
 }

 public Encap getPayment(String str,String val,int usrID,String con)
 {
  System.out.print("getPayment str: "+str+" val: "+val);
  System.out.print(" usr: "+usrID+" can: "+con);
  System.out.println(" sendCont: "+sendCont);
  Encap en = new Encap();
  if(str.startsWith("transPay"))
  {
   en.setTable("transPayRecord");
   en.setNameVal("transPayLastChange","CURRENT_DATE");
   en.setNameVal("transPayLastChangeBy",usrID);
   en.setCondition("WHERE transPayKey="+con+";");
  }
  else if(str.startsWith("transBank"))
  {
   en.setTable("transBankRecord");
   en.setNameVal("transBankLastChange","CURRENT_DATE");
   en.setNameVal("transBankLastChangeBy",usrID);
   if(newBankFlag)
   {
    en.setNameVal("transBankPayKey",con);
    insertFlag = true;
   }
   else
    en.setCondition("WHERE transBankPayKey="+con+";");
  }
  else
   System.out.println("Error in getPayment");
  return en;
 }

 public boolean checkHappen(String tableName)
 {
  int size = getMasterSize();
  Encap e = null;
  boolean flag = false;
  for(int i=0;i<size;i++)
  {
   e = getMaster(i);
   if(e.getTable().equalsIgnoreCase(tableName))
   {
    flag = true;
    break;
   }
   e.clear();
  }
  if(e!=null && e.getSize()>0) e.clear();
  e = null;
  return flag;
 }

 public static boolean allwords(String str)
 {
  int len = str.length();
  for(int i=0;i<len;i++)
   if(!Character.isLetter(str.charAt(i)))
    return false;
  return true;
 }

 public void close()
 {
  frame.dispose();
  System.gc();
 }

 private void retrievePayment(HashMap map)
 {
  result.addElement(new Data("Payment Currency",(String)map.get("transPayCurr"),""));
  masterCont.add("transPayCurr");
  masterCurr.add(new Integer((masterCont.size()-1)));

  result.addElement(new Data("Payment Amount",
   Module7.formNumDelimiter((String)map.get("transPayAmt")),""));
  masterCont.add("transPayAmt");
  masterNum.add(new Integer((masterCont.size()-1)));

  result.addElement(new Data("Payment Method",(String)map.get("transPayMethod"),""));
  masterCont.add("transPayMethod");
  masterLength.put("transPayMethod","3");
	
  if(map.containsKey("transBankOur"))
   result.addElement(new Data("Our Bank",(String)map.get("transBankOur"),""));
  else
   result.addElement(new Data("Our Bank","NONE",""));
  masterCont.add("transBankOur");
  masterLength.put("transBankOur","16");

  if(map.containsKey("transBankTheir"))
   result.addElement(new Data("Their Bank",(String)map.get("transBankTheir"),""));
  else
   result.addElement(new Data("Their Bank","NONE",""));
  masterCont.add("transBankTheir");
  masterLength.put("transBankTheir","16");

  if(map.containsKey("transBankAcct"))
   result.addElement(new Data("Their Bank Acct Number",(String)map.get("transBankAcct"),""));
  else
   result.addElement(new Data("Their Bank Acct Number","NONE",""));
  masterCont.add("transBankAcct");
  masterLength.put("transBankAcct","18");

  if(map.containsKey("transBankDocNo"))
   result.addElement(new Data("No Cheque/Giro",(String)map.get("transBankDocNo"),""));
  else
   result.addElement(new Data("No Cheque/Giro","NONE",""));
  masterCont.add("transBankDocNo");
  masterLength.put("transBankDocNo","18");

  if(!map.containsKey("transBankKey"))
   newBankFlag = true;
 }

 private class tableData extends AbstractTableModel
 {
  public final int OLDDESC = 0;
  public final int OLDVAL  = 1;
  public final int NEWVAL  = 2;

  public int rowLength;
  public int colLength;
  public Vector dataRow;
  public final String[] colNames= {"Old\nDescription",
  "Old\nValue","New\nValue"};

  public tableData(Vector ve)
  {
   rowLength = ve.size();
   colLength = colNames.length;
   initData(ve);
  } // end of tableData's constructor
  public void initData(Vector ve)
  { dataRow = ve; }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colLength; }
  public String getColumnName(int column)
  { return colNames[column]; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row, int column)
  {
   if(column == NEWVAL)
    return true;
   return false; 
  }
  public Object getValueAt(int row, int column)
  { 
   if((row<0)||(row>=getRowCount()))
    return " ";
   Data dt = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case OLDDESC: return dt.getOldDesc();
    case OLDVAL : return dt.getOldVal(); 
    case NEWVAL : return dt.getNewVal();
   }
   return " "; 
  }
  public void setValueAt(Object val, int row, int column)
  {
   Data dt = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case OLDDESC : dt.setOldDesc((String)val); break;
    case OLDVAL  : dt.setOldVal((String)val); break;
    case NEWVAL  : dt.setNewVal((String)val); break;
   }
	 dataRow.setElementAt(dt,row);
   fireTableCellUpdated(row,column);
  } 
 } // end of tableData's class

 private class Data
 {
  private String oldDesc;
  private String oldVal;
  private String newVal;

  public Data()
  { } 
  public Data(String od,String ov,String nv)
  {
   setOldDesc(od);
   setOldVal(ov);
   setNewVal(nv);
  }
  public void setOldDesc(String od)
  { oldDesc = new String(od); }
  public void setOldVal(String ov)
  { oldVal = new String(ov); }
  public void setNewVal(String nv)
  { newVal = new String(nv); }
  public String getOldDesc()
  { return oldDesc.toString(); }
  public String getOldVal()
  { return oldVal.toString(); } 
  public String getNewVal()
  { return newVal.toString(); }
 }
}
