import java.math.BigDecimal;
import java.util.Vector;

public class MultipleCurrency
{

 protected BigDecimal totalAP[] =
 { new BigDecimal("0.00"),  // IDR
   new BigDecimal("0.00")}; // USD 

 protected BigDecimal totalAR[] = 
 { new BigDecimal("0.00"),  // IDR
   new BigDecimal("0.00")}; // USD 
 
 protected Vector Currency = new Vector(2);

 public MultipleCurrency()
 { 
  initCurr(); 
 }

 private void initCurr()
 {
  Currency.add("IDR"); // 0 
  Currency.add("USD"); // 1
 }

 public int getCurr(String str)
 {
  if(str.equalsIgnoreCase("IDR")) return 0;
  if(str.equalsIgnoreCase("USD")) return 1;
  return -1;
 }

 public String getCurr(int i)
 {
  if(i<0 || i>Currency.size())
   return null;
  return (String)Currency.get(i);
 }

 public void sumAR(String curr,String amt)
 {
  int pos = Currency.indexOf(curr);
  if(pos == 0) 
   totalAR[0] = totalAR[0].add(new BigDecimal(amt));
  else if(pos == 1)
   totalAR[1] = totalAR[1].add(new BigDecimal(amt));
  else
  {
   System.out.println("The currency is not found! : "+curr);
	 Module7.errorDisplay("The currency [A/R] of "+curr+
		 " is not found\n","ERROR");
  } 
 }

 public void sumAP(String curr,String amt)
 {
  int pos = Currency.indexOf(curr);
  if(pos == 0)
   totalAP[0] = totalAP[0].add(new BigDecimal(amt));
  else if(pos == 1)
   totalAP[1] = totalAP[1].add(new BigDecimal(amt));
  else
  {
   System.out.println("The currency is not found!");
   Module7.errorDisplay("The currency [A/P] of "+curr+
		 " is not found\n","ERROR");
  } 
 }

 public void subAP(String curr,String amt)
 {
  int pos = Currency.indexOf(curr);
  if(pos == 0)
   totalAP[0] = totalAP[0].subtract(new BigDecimal(amt));
  else if(pos == 1)
   totalAP[1] = totalAP[1].subtract(new BigDecimal(amt));
  else
  {
   System.out.println("The currency is not found!");
   Module7.errorDisplay("The currency [A/P] of "+curr+
		 " is not found\n","ERROR");
  } 
 }

 public void subAR(String curr,String amt)
 {
  int pos = Currency.indexOf(curr);
  if(pos == 0) 
   totalAR[0] = totalAR[0].subtract(new BigDecimal(amt));
  else if(pos == 1)
   totalAR[1] = totalAR[1].subtract(new BigDecimal(amt));
  else
  {
   System.out.println("The currency is not found! : "+curr);
   Module7.errorDisplay("The currency [A/R] of "+curr+
		 " is not found\n","ERROR");
  } 
 }

 public boolean checkAP(int i)
 {
  if(i<0 || i>totalAP.length)
   return false;
  if(!(totalAP[i].toString()).equalsIgnoreCase("0.00"))
   return true;
  return false;
 }

 public boolean checkAR(int i)
 {
  if(i<0 || i>totalAR.length)
   return false;
  if(!(totalAR[i].toString()).equalsIgnoreCase("0.00"))
   return true;
  return false;
 }

 public BigDecimal getSumAR(int i)
 {
  if(i<0 || i>totalAR.length)
   return null;
  return totalAR[i];
 }

 public BigDecimal getSumAP(int i)
 {
  if(i<0 || i>totalAP.length)
   return null;
  return totalAP[i];
 }

 public BigDecimal getSumAR(String str)
 {
  if(str.equalsIgnoreCase("IDR"))
   return getSumAR(0);
  if(str.equalsIgnoreCase("USD"))
   return getSumAR(1);
  return null;
 }

 public BigDecimal getSumAP(String str)
 {
  if(str.equalsIgnoreCase("IDR"))
   return getSumAP(0);
  if(str.equalsIgnoreCase("USD"))
   return getSumAP(1);
  return null;
 }

 private void clearSumAP()
 {
  totalAP[0] = totalAP[0].subtract(totalAP[0]); // IDR
  totalAP[1] = totalAP[1].subtract(totalAP[1]); // USD
 }

 private void clearSumAR()
 {
  totalAR[0] = totalAR[0].subtract(totalAR[0]);
  totalAR[1] = totalAR[1].subtract(totalAR[1]);
 }

 public void clearVariable()
 {
  clearSumAR();
  clearSumAP();
 }

}
