import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.HashMap;
import java.util.EventObject;
import java.sql.SQLException;
import java.math.BigDecimal;

public class PaymentForm
{
 private Vector data = null;
 private JFrame frame;
 private JTable table;
 private tableData td;
 private JPanel panel;
 private static HashMap map;
 private JButton contButton;
 private JButton cancButton;
 private int action = 0;
 private int refNo = 0;
 private StringBuffer error = new StringBuffer();
 private String balanceSend = null;
 private String balanceCurr = null;
 private String balanceKey = null;
 private boolean allfalse = false;

 public PaymentForm(HashMap kmap, int act)
 {
  if(kmap == null)
  {
   Module7.errorDisplay("Empty HashMap","ERROR");
   return;
  }
  map = kmap;
  action = act;

  StringBuffer str = new StringBuffer("LEFT JOIN ");
  if(action == Module7.DEBTPAYFM)
  {
   refNo = Integer.parseInt((String)map.get("DPFrefNo"));
   str.append("truckingCompany ON (truckingCompany.");
   str.append("truckingCompanyKey=transRecord.transTrucking) ");
   str.append("LEFT JOIN accountPayable ");
   str.append("ON (accountPayable.acctPayToRefKey=transRecord.transRefKey) "); 
   str.append("WHERE accountPayable.acctPayPaidFull=\"N\" ");
//	 str.append("WHERE accountPayable.acctPayCurr=\"");
//	 str.append((String)map.get("DPFpaidAmtCurr")+"\" AND ");
   str.append("AND transRefKey="+refNo+";");
  }
  else if(action == Module7.RECVPAYFM)
  {
   refNo = Integer.parseInt((String)map.get("RPFrefNo"));
   str.append("customer ON (transRecord.transCustKey=");
   str.append("customer.customerKey) LEFT JOIN accountReceivable ON ");
   str.append("(accountReceivable.acctRecFromRefKey=transRecord.transRefKey) ");
   str.append("WHERE accountReceivable.acctRecPaidFull=\"N\" ");
//	 str.append("WHERE accountReceivable.acctRecCurr=\"");
//	 str.append((String)map.get("DPFpaidAmtCurr")+"\" AND ");
   str.append("AND transRefKey="+refNo+";");
  } 
  else
  {
   Module7.errorDisplay("No available service","ERROR");
   return;
  }
  data = retrieve(str.toString());
  if(error.length()>0 && allfalse)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   error.delete(0,error.length());
   return;
	}
  if(action == Module7.RECVPAYFM)
  {
   if(!balanceCurr.equalsIgnoreCase((String)map.get("RPFrecvAmtCurr")))
   {
    Module7.errorDisplay("Currency must match!\n","ERROR");
    return;
   }
   frame = new JFrame("Received Payment Form from Ref No. "+refNo);
  }
  else
  {
   if(!balanceCurr.equalsIgnoreCase((String)map.get("DPFpaidAmtCurr")))
   {
    Module7.errorDisplay("Currency is not matching.\n","ERROR");
    return;
   }
   frame = new JFrame("Debt Payment Form to Ref No. "+refNo);
  }
  str.delete(0,str.length());
  frame.getContentPane().setLayout(new BorderLayout());
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  td = new tableData(data);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
	 if(i == tableData.CUR)
		column = new TableColumn(i,10,render,editor);
	 else
		column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  panel = new JPanel();
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  JScrollPane jsp = new JScrollPane(table);
  panel.add(jsp,BorderLayout.CENTER);
  str.delete(0,str.length());
  if(action == Module7.RECVPAYFM)
   str.append((String)map.get("RPFrecvAmtCurr")+" "+
   Module7.formNumDelimiter((String)map.get("RPFrecvAmt")));
  else if(action == Module7.DEBTPAYFM)
   str.append((String)map.get("DPFpaidAmtCurr")+" "+
   Module7.formNumDelimiter((String)map.get("DPFpaidAmt")));
  else
   return;
  frame.getContentPane().add(panel,BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(str.toString()),BorderLayout.SOUTH);
	frame.addWindowListener(new WindowAdapter()
	{
   public void windowClosing(WindowEvent e)
	 {
    Module7.infoDisplay("Click on Cancel in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		return;
	 }
	});
  frame.pack();
  frame.setVisible(true);
 }

 private Vector retrieve(String str) 
 {
  DBConnect dbcon = new DBConnect();
  Vector v = null;
  Vector v2= new Vector();
  Vector v3= null;
  int size = 0;
  int falsecount = 0;
  boolean flag = true;
  Encap e1 = null;
  try
  {
   if(!dbcon.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   v = dbcon.QueryMulti("transRecord","*",str);
   if(v == null)
    throw new SQLException("No information available for that Ref No.\n");
   size = v.size();
   System.out.println("size = "+size);
   Encap en = null;
   int key = 0;
   StringBuffer stw = new StringBuffer();
   StringBuffer door= new StringBuffer();
   StringBuffer name= new StringBuffer();
   StringBuffer cur = new StringBuffer();
   StringBuffer bal = new StringBuffer();
   StringBuffer tot = new StringBuffer();
   do
   {
    en = (Encap)v.remove(0);
    if(action == Module7.DEBTPAYFM)
    {
     if(!en.extractAll("acctPayCurr").equalsIgnoreCase(
        (String)map.get("DPFpaidAmtCurr")))
     {
      error.append("Debt Payment Form Currency is not matching"); 
      error.append("balance for Ref No "+refNo+"\n");
      System.out.println("acctPayCurr="+en.extractAll("acctPayCurr"));
      System.out.println("DPFpaidAmtCurr="+(String)map.get("DPFpaidAmtCurr"));
      flag = false;
      falsecount++;
     }
    }
    else
    {
     if(!en.extractAll("acctRecCurr").equalsIgnoreCase(
	(String)map.get("RPFrecvAmtCurr")))
     {
      error.append("Received Payment Form Currency is not matching"); 
      error.append("balance for Ref No "+refNo+"\n");
      System.out.println("acctRecCurr="+en.extractAll("acctRecCurr"));
      System.out.println("RPFrecvAmtCurr="+(String)map.get("RPFrecvAmtCurr"));
      flag = false;
      falsecount++;
     }
    }
    if(flag)
    {
     key = en.getIntValue(en.getPosition("transRefKey"));
     if(action == Module7.DEBTPAYFM)
      name.append(en.getStringValue(en.getPosition("truckingName")));
     else if(action == Module7.RECVPAYFM)
      name.append(en.getStringValue(en.getPosition("customerName")));
     else
      throw new SQLException("Unknown action service : "+action+"\n");

     v3 = dbcon.QueryMulti("transVol","*","WHERE transVolRefKey="+
       key+";");
     if(v3!=null)
     {
      int tsize = v3.size();
      int count = 0;
      while(!v3.isEmpty())
      {
       e1 = (Encap)v3.remove(0);
       stw.append(e1.extractAll("transVolVolume")+"x"+
	e1.extractAll("transVolStowage"));
       count++;
       if(count!=tsize) stw.append(",");
       e1.clear();
      }
     }

     door.append(en.getStringValue(en.getPosition("transDoorLocation")));
     if(action == Module7.DEBTPAYFM)
     {
      balanceKey = new String(en.extractAll("acctPayKey"));
      cur.append(en.getStringValue(en.getPosition("acctPayCurr")));
      balanceCurr = cur.toString();
      bal.append(en.getValue(en.getPosition("acctPayBalance")));
      tot.append(en.getValue(en.getPosition("acctPayAmt")));
     }
     else
     {
      balanceKey = new String(en.extractAll("acctRecKey"));
      cur.append(en.getStringValue(en.getPosition("acctRecCurr")));
      balanceCurr = cur.toString();
      bal.append(en.getValue(en.getPosition("acctRecBalance")));
      tot.append(en.getDecValue(en.getPosition("acctRecAmt")));
     }
     v2.add(new encapData(key,name.toString(),stw.toString(),door.toString(),
      cur.toString(),bal.toString(),tot.toString()));
     en.clear();
     tot.delete(0,tot.length());
     bal.delete(0,bal.length());
     stw.delete(0,stw.length());
     cur.delete(0,cur.length());
     name.delete(0,name.length());
     door.delete(0,door.length());
    }
    if(!flag) flag = true;
   }while(v.size()>0);
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage()+"\n");
   if(!v2.isEmpty()) v2.removeAllElements();
   v2 = null;
   allfalse = true;
  }
  finally
  {
   dbcon.close();
  }
  if(error.length()>0 && size==falsecount)
  {
   System.out.println("--- size: "+size);
   allfalse = true;
   return null;
  }
  return v2;
 }

 public JPanel createBottom(String str)
 {
  JPanel panel = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.NORTHWEST;
  gbc.fill = GridBagConstraints.HORIZONTAL;
  gbc.insets = new Insets(2,2,2,2);
  gbc.weightx = 1.0;
  gbc.weighty = 1.0;
  gbc.gridwidth = 2;
  panel.setLayout(gbl);
  gbc.gridy = 0;
  panel.add(new JLabel("Amount to Apply",SwingConstants.RIGHT),gbc);
  panel.add(new JLabel(str,SwingConstants.LEFT),gbc);
  gbc.weightx = 2.0;
  initJButton();
  gbc.gridy++;
  panel.add(contButton,gbc);
  panel.add(cancButton,gbc);
  return panel;
 }

 private void initJButton()
 {
  contButton = new JButton("Continue");
	cancButton = new JButton("Cancel");
	ButtonListener bl = new ButtonListener();
	contButton.addActionListener(bl);
	cancButton.addActionListener(bl);
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == contButton)
   {
    map.put("Balance",balanceSend);
    map.put("BalanceKey",balanceKey);
    map.put("BalanceCurr",balanceCurr);
    new DataKeeper((HashMap)map.clone(),action);
   }
   frame.dispose();
   System.gc();
  }
 } // end of ButtonListener's class

 private class tableData extends AbstractTableModel
 {
  public final static int REF  = 0;
  public final static int SHP  = 1;
  public final static int STW  = 2;
  public final static int DRL  = 3;
  public final static int CUR  = 4;
  public final static int BAL  = 5;
  public final static int AMT  = 6; 

  public Vector colNames = null;
  public Vector dataRow = null;
  public int colLength;
  public int rowLength;

  public tableData(Vector v)
  {
   initColumn();
   colLength = colNames.size();
   initialized(v);
  }
  public void initColumn()
  {
   if(colNames == null) colNames = new Vector();
    colNames.add("Ref\nNo.");
   if(action == Module7.DEBTPAYFM)
    colNames.add("Trucking\nCo");
   else
    colNames.add("Customer\nName");
   colNames.add("Stowage\nFactor");
   colNames.add("Door\nLocation");
   colNames.add("Currency");
   colNames.add("Total\nBalance");
   if(action == Module7.DEBTPAYFM)
    colNames.add("Total\nDebt");
   else
    colNames.add("Total\nReceivable");
  }
  public void initialized(Vector v)
  { dataRow = v; } 
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.size(); }
  public String getColumnName(int column)
  { return (String)colNames.get(column); }
  public Object getValueAt(int row, int column)
  { 
   if((row<0)||(row>=getRowCount())) 
    return " ";
   encapData en = (encapData)dataRow.elementAt(row); 
   switch(column)
   {
    case REF : return en.getRef();
    case SHP : return en.getShipper();
    case STW : return en.getStowage();
    case DRL : return en.getDoorLoc();
    case CUR : return en.getCurrency();
    case BAL : balanceSend = new String(en.getBalance());
               return Module7.formNumDelimiter(en.getBalance());
    case AMT : return Module7.formNumDelimiter(en.getTotal());
   }
   return " ";
  }
  public boolean isCellEditable(int row, int column)
  { return false; }
  public void setValueAt(Object val, int row, int column)
  { 
   boolean fillFlag = true;
   encapData en = (encapData)dataRow.elementAt(row);
   switch(column)
   {
    case REF : en.setRef(((Integer)val).intValue()); break;
    case SHP : en.setShp((String)val); break;
    case STW : en.setStw((String)val); break;
    case DRL : en.setDoor((String)val); break; 
    case CUR : en.setCurrency((String)val); break;
    case BAL : en.setBalance((String)val); break;
    case AMT : en.setTot((String)val); break;
    default: fillFlag = false;
   }
   if(fillFlag)
    dataRow.setElementAt(en,row);
  }
 } // end of tableData's private class 

 private class encapData
 {
  private int refNo;
  private StringBuffer total = new StringBuffer();
  private StringBuffer balance = new StringBuffer();
  private StringBuffer door = new StringBuffer();
  private StringBuffer curr = new StringBuffer();
  private StringBuffer stowage = new StringBuffer();
  private StringBuffer shipper = new StringBuffer();

  public encapData(int r,String s,String stw,
		   String d,String cur,String b,String t)
  {
   setRef(r);
   setShp(s);
   setStw(stw);
   setDoor(d);
   setCurrency(cur);
   setBalance(b);
   setTot(t);
  }
  public void setRef(int r)
  { refNo = r; }
  public void setShp(String s)
  {
   if(shipper.length()>0) shipper.delete(0,shipper.length());
   shipper.append(s); 
  }
  public void setDoor(String d)
  {
   if(door.length()>0) door.delete(0,door.length());
   door.append(d); 
  }
  public void setCurrency(String c)
  { 
   if(curr.length()>0) curr.delete(0,curr.length());
    curr.append(c); 
  }
  public void setBalance(String b)
  {
   if(balance.length()>0) balance.delete(0,balance.length());
    balance.append(b);
  }
  public void setTot(String t)
  { 
   if(total.length()>0) total.delete(0,total.length());
    total.append(t); 
  }
  public void setStw(String s)
  { 
   if(stowage.length()>0) stowage.delete(0,stowage.length()); 
   stowage.append(s); 
  }
  public Integer getRef()
  { return new Integer(refNo); }
  public String getStowage()
  { return stowage.toString(); }
  public String getShipper()
  { return shipper.toString(); }
  public String getDoorLoc()
  { return door.toString(); }
  public String getCurrency()
  { return curr.toString(); }
  public String getBalance()
  { return balance.toString(); }
  public String getTotal()
  { return total.toString(); }
 } // end of encapData

} // end of PaymentForm's class
