import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import java.sql.SQLException;

public class PrepareDebitNotePrint
{
 private JFrame frame = null;
 public static JPanel mainP = null;
 private JButton printButton = null;
 private JButton closeButton = null;
 private Encap masterData = null;
 private StringBuffer error = new StringBuffer(128);
 private boolean exportFlag = false;
 private int refNo = 0;
 private int numberElements = 0;
 public MultipleCurrency mc = new MultipleCurrency();

 public PrepareDebitNotePrint(String str)
 {
  if(str==null)
  {
   Module7.errorDisplay("Received null in constructor\n","ERROR");
   close();
   return;
  }
  refNo = Integer.parseInt(str);
  masterData = fetchData(str);
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   close();
   return;
  }
  frame = new JFrame("Prepare Debit Note for Ref No."+str);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    JOptionPane.showMessageDialog(frame,"Click on Close in the panel instead",
     "Information",JOptionPane.INFORMATION_MESSAGE);
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  mainP = createMain();
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(mainP,BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 public static void main(String args[])
 {
  new PrepareDebitNotePrint(args[0]);
 }

 private Encap fetchData(String str)
 {
  Encap e = null;
  DBConnect db = new DBConnect();
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   e = fetching(prepareQuery(str),db);
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage());
  }
  finally
  {
   db.close();
  }
  return e;
 }

 private String prepareQuery(String str)
 {
  return new String("LEFT JOIN customer ON (customer.customerKey="+
   "transRecord.transCustKey) LEFT JOIN truckingCompany ON ("+
   "truckingCompany.truckingCompanyKey=transRecord.transTrucking) "+
   "LEFT JOIN invoiceRecord ON (invoiceRecord.invoiceRefKey="+
   "transRecord.transRefKey) "+
   "LEFT JOIN claimableCharges ON (claimableCharges.claimableRefKey="+
   "transRecord.transRefKey) WHERE transRefKey="+str+";");
 }

 private Encap fetching(String query,DBConnect db) throws SQLException
 {
  Encap e1 = db.QuerySingle("transRecord","*",query);
  Encap e2 = null;
  int count = 0;
  MultipleCurrency tempMC = new MultipleCurrency();
  if(e1 == null)
  {
   error.append("No such Ref No. exist in database\n");
   return null;
  }
  if(e1.extractAll("claimablePrintable").equalsIgnoreCase("NO"))
  {
   error.append("For Ref No."+refNo+", Debit Note is non-printable\n");
   return null;
  }
  if(e1.extractAll("transType").equalsIgnoreCase("EXP")) 
  {
   exportFlag = true;
   e2 = db.QuerySingle("expInfoRecord","*","WHERE expFromRefKey="+refNo+";");
   if(e2 == null)
   {
    error.append("Query to get Export Info resulted in null\n");
    return null;
   }
   e1.setNameVal("expSINo",e2.extractAll("expSINo"));
   e1.setNameVal("expDestName",e2.extractAll("expDestName"));
   e1.setNameVal("expVesselName",e2.extractAll("expVesselName"));
  }
  else
  {
   e2 = db.QuerySingle("impInfoRecord","*","WHERE impFromRefKey="+refNo+";");
   if(e2 == null)
   {
    error.append("Query to get Import Info resulted in null\n");
    return null;
   }
   e1.setNameVal("impBLNo",e2.extractAll("impBLNo"));
  }

  mc.sumAP(e1.extractAll("invoiceSellCurr"),
   e1.extractAll("invoiceSellAmt"));
  mc.sumAP(e1.extractAll("invoiceHandleCurr"),
   e1.extractAll("invoiceHandleAmt"));

  if(!e1.extractAll("claimableTotalLiftOnAmt").equalsIgnoreCase("0.00"))
   mc.sumAR(e1.extractAll("claimableTotalLiftOnCurr"),
   e1.extractAll("claimableTotalLiftOnAmt"));
  if(!e1.extractAll("claimableTotalLiftOffAmt").equalsIgnoreCase("0.00"))
   mc.sumAR(e1.extractAll("claimableTotalLiftOffCurr"),
   e1.extractAll("claimableTotalLiftOffAmt"));
  Vector v = null;
  v = db.QueryMulti("claimableOtherCharges","*",
   "WHERE claimableOthRefKey="+refNo+";");
  if(v != null)
  {
   if(e2!=null) e2.clear();
   numberElements = v.size();
   count = 0;
   do
   {
    count++;
    e2 = (Encap)v.remove(0);
    e1.setNameVal("claimableOthDesc"+count,e2.extractAll("claimableOthDesc"));
    e1.setNameVal("claimableOthCurr"+count,e2.extractAll("claimableOthCurr"));
    e1.setNameVal("claimableOthAmt"+count,e2.extractAll("claimableOthAmt"));
    System.out.println(count+" => "+e2.extractAll("claimableOthDesc")
     +" "+e2.extractAll("claimableOthCurr")+" "+
     e2.extractAll("claimableOthAmt"));
    mc.sumAR(e2.extractAll("claimableOthCurr"),
     e2.extractAll("claimableOthAmt"));
    e2.clear();
   }while(v.size()>0);
   e1.setNameVal("NumberClaimableOther",count);
  }
  v = db.QueryMulti("invoiceOtherCharges","*",
   "WHERE invoiceOthRefKey="+refNo+";");
  if(v != null)
  {
   if(e2!=null) e2.clear();
   numberElements = v.size();
   count = 0;
   do
   {
    count++;
    e2 = (Encap)v.remove(0);
    mc.sumAP(e2.extractAll("invoiceOthCurr"),
    e2.extractAll("invoiceOthAmt"));
    e2.clear();
   }while(v.size()>0);
  }
  count = 0;

  v = db.QueryMulti("transPayRecord","*","WHERE transPayFromRefKey="+refNo+
   " AND transPayAcctRecKey > 0;");
  if(v != null)
  {
   numberElements = v.size();
   do
   {
    e2 = (Encap)v.remove(0);
    tempMC.sumAR(e2.extractAll("transPayCurr"),e2.extractAll("transPayAmt"));
    e2.clear();
   }while(v.size()>0);

   if(tempMC.checkAR(3))
   {
    count+=1;
    e1.setNameVal("transPayAmt"+count,tempMC.getSumAR(3));
    e1.setNameVal("transPayCurr"+count,tempMC.getCurr(3));
   }
   if(tempMC.checkAR(2))
   {
    count+=1;
    e1.setNameVal("transPayAmt"+count,tempMC.getSumAR(2));
    e1.setNameVal("transPayCurr"+count,tempMC.getCurr(2));
   }
   if(tempMC.checkAR(1))
   {
    count+=1;
    e1.setNameVal("transPayAmt"+count,tempMC.getSumAR(1));
    e1.setNameVal("transPayCurr"+count,tempMC.getCurr(1));
   }
   if(tempMC.checkAR(0))
   {
    count+=1;
    e1.setNameVal("transPayAmt"+count,tempMC.getSumAR(0));
    e1.setNameVal("transPayCurr"+count,tempMC.getCurr(0));
   }
   e1.setNameVal("NumberPayment",count);
  }
  count = 0;
  if(mc.checkAP(3))
  {
   count+=1;
   e1.setNameVal("sumInvoiceCurr"+count,mc.getCurr(3));
   e1.setNameVal("sumInvoiceAmt"+count,mc.getSumAP(3));
   mc.sumAR(mc.getCurr(3),mc.getSumAP(3).toString());
  }
  if(mc.checkAP(2))
  {
   count+=1;
   e1.setNameVal("sumInvoiceCurr"+count,mc.getCurr(2));
   e1.setNameVal("sumInvoiceAmt"+count,mc.getSumAP(2));
   mc.sumAR(mc.getCurr(2),mc.getSumAP(2).toString());
  }
  if(mc.checkAP(1))
  {
   count+=1;
   e1.setNameVal("sumInvoiceCurr"+count,mc.getCurr(1));
   e1.setNameVal("sumInvoiceAmt"+count,mc.getSumAP(1));
   mc.sumAR(mc.getCurr(1),mc.getSumAP(1).toString());
  }
  if(mc.checkAP(0))
  {
   count+=1;
   e1.setNameVal("sumInvoiceCurr"+count,mc.getCurr(0));
   e1.setNameVal("sumInvoiceAmt"+count,mc.getSumAP(0));
   mc.sumAR(mc.getCurr(0),mc.getSumAP(0).toString());
  }
  e1.setNameVal("NumberSumInvoice",count);
  count = 0;
  boolean existFlag = false;
  Translate translate = new Translate();
  int numTranslate = 0;
  if(mc.checkAR(3))
  {
   count+=1;
   if(tempMC.checkAR(3))
   {
    e1.setNameVal("subSumDebitNoteCurr"+count,mc.getCurr(3));
    e1.setNameVal("subSumDebitNoteAmt"+count,mc.getSumAR(3).toString());
    mc.subAR(tempMC.getCurr(3),tempMC.getSumAR(3).toString());
    existFlag = true;
   }
   e1.setNameVal("sumDebitNoteCurr"+count,mc.getCurr(3));
   e1.setNameVal("sumDebitNoteAmt"+count,mc.getSumAR(3));
  }
  if(mc.checkAR(2))
  {
   count+=1;
   if(tempMC.checkAR(2))
   {
    e1.setNameVal("subSumDebitNoteCurr"+count,mc.getCurr(2));
    e1.setNameVal("subSumDebitNoteAmt"+count,mc.getSumAR(2).toString());
    mc.subAR(tempMC.getCurr(2),tempMC.getSumAR(2).toString());
    existFlag = true;
   }
   e1.setNameVal("sumDebitNoteCurr"+count,mc.getCurr(2));
   e1.setNameVal("sumDebitNoteAmt"+count,mc.getSumAR(2));
  }
  if(mc.checkAR(1))
  {
   count+=1;
   if(tempMC.checkAR(1))
   {
    e1.setNameVal("subSumDebitNoteCurr"+count,mc.getCurr(1));
    e1.setNameVal("subSumDebitNoteAmt"+count,mc.getSumAR(1).toString());
    mc.subAR(tempMC.getCurr(1),tempMC.getSumAR(1).toString());
    existFlag = true;
   }
   e1.setNameVal("sumDebitNoteCurr"+count,mc.getCurr(1));
   e1.setNameVal("sumDebitNoteAmt"+count,mc.getSumAR(1));
   translate.determineLanguage(Translate.ENG);
   numTranslate+=1;
   e1.setNameVal("sumDebitNote"+numTranslate,
     translate.translate(mc.getSumAR(1).toString()));
  }
  if(mc.checkAR(0))
  {
   count+=1;
   if(tempMC.checkAR(0))
   {
    e1.setNameVal("subSumDebitNoteCurr"+count,mc.getCurr(0));
    e1.setNameVal("subSumDebitNoteAmt"+count,mc.getSumAR(0).toString());
    mc.subAR(tempMC.getCurr(0),tempMC.getSumAR(0).toString());
    existFlag = true;
   }
   e1.setNameVal("sumDebitNoteCurr"+count,mc.getCurr(0));
   e1.setNameVal("sumDebitNoteAmt"+count,mc.getSumAR(0));
   translate.determineLanguage(Translate.INA);
   numTranslate+=1;
   e1.setNameVal("sumDebitNote"+numTranslate,
     translate.translate(mc.getSumAR(0).toString()));
  }
  e1.setNameVal("NumberSumDebitNote",count);
  e1.setNameVal("NumberTranslate",numTranslate);
  if(existFlag)
   e1.setNameVal("NumberSubSum",count);
  return (Encap)e1.clone();
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.NORTHWEST;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);  
  panel.setBackground(Color.WHITE);
  panel.add(new JLabel("DEBIT NOTE",SwingConstants.CENTER),gbc);
  gbc.gridy = 1;
  panel.add(new JLabel("To : "+masterData.extractAll("customerName")
   ,SwingConstants.LEFT),gbc);
  gbc.gridy = 2;
  panel.add(new JLabel("Ref No."+refNo),gbc);
  gbc.gridy = 3;
  if(!exportFlag)
  {
   panel.add(new JLabel("B/L : "+masterData.extractAll("impBLNo")),gbc);
   gbc.gridy++;
  }
  int number = 1;
  panel.add(new JLabel(number+". Total from Invoice"),gbc);
  int numberElements = masterData.extractInteger("NumberSumInvoice",0);
  for(int i=1;i<=numberElements;i++)
  {
   panel.add(new JLabel(masterData.extractAll("sumInvoiceCurr"+i)),gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
    masterData.extractAll("sumInvoiceAmt"+i)),SwingConstants.RIGHT),gbc);
  }
  if(!masterData.extractAll(
   "claimableTotalLiftOnAmt").equalsIgnoreCase("0.00"))
  {
   number+=1;
   gbc.gridy++;
   panel.add(new JLabel(number+". B. Lift On + Storage"),gbc);
   panel.add(new JLabel(masterData.extractAll("claimableTotalLiftOnCurr")),gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
   masterData.extractAll("claimableTotalLiftOnAmt")),SwingConstants.RIGHT),gbc);
  }
  if(!masterData.extractAll(
   "claimableTotalLiftOffAmt").equalsIgnoreCase("0.00"))
  {
   number+=1;
   gbc.gridy++;
   panel.add(new JLabel(number+". B. Lift Off"),gbc);
   panel.add(new JLabel(masterData.extractAll("claimableTotalLiftOffCurr")),
    gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
   masterData.extractAll("claimableTotalLiftOffAmt")),
   SwingConstants.RIGHT),gbc);
  }

  if(masterData.getPosition("NumberClaimableOther")>=0)
  {
   numberElements = masterData.extractInteger("NumberClaimableOther",0);
   for(int i=1;i<=numberElements;i++)
   {
    number+=1;
    gbc.gridy++;
    panel.add(new JLabel(number+". "+
     masterData.extractAll("claimableOthDesc"+i)),gbc);
    panel.add(new JLabel(masterData.extractAll("claimableOthCurr"+i)),gbc);
    panel.add(new JLabel(Module7.formNumDelimiter(
     masterData.extractAll("claimableOthAmt"+i)),SwingConstants.RIGHT),gbc);
   }
  }
  gbc.gridy++;
  if(exportFlag)
  {
   panel.add(new JLabel("SI: "+masterData.extractAll("expSINo")),gbc);
   gbc.gridy++;
   panel.add(new JLabel("VESSEL/No.Voyage : "+
    masterData.extractAll("expVesselName")),gbc);
   gbc.gridy++;
  }
  panel.add(new JLabel("Total",SwingConstants.RIGHT),gbc);
  int count = 0;
  if(mc.checkAR(3))
  {
   count+=1;
   panel.add(new JLabel(mc.getCurr(3)),gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
    mc.getSumAR(3).toString()),SwingConstants.RIGHT),gbc);
  }
  if(mc.checkAR(2))
  {
   count+=1;
   panel.add(new JLabel(mc.getCurr(2)),gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
    mc.getSumAR(2).toString()),SwingConstants.RIGHT),gbc);
  }
  if(mc.checkAR(1))
  {
   count+=1;
   panel.add(new JLabel(mc.getCurr(1)),gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
    mc.getSumAR(1).toString()),SwingConstants.RIGHT),gbc);
  }
  count+=1;
  panel.add(new JLabel(mc.getCurr(0)),gbc);
  panel.add(new JLabel(Module7.formNumDelimiter(
   mc.getSumAR(0).toString()),SwingConstants.RIGHT),gbc);
  JPanel finalPanel = new JPanel();
  finalPanel.add(new JScrollPane(panel));
  return finalPanel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel(new FlowLayout());
  printButton = new JButton("Print");
  closeButton = new JButton("Close");
  ButtonListener bl = new ButtonListener();
  printButton.addActionListener(bl);
  closeButton.addActionListener(bl);
  panel.add(printButton);
  panel.add(closeButton);
  return panel;
 }


 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == printButton)
    new ProcessPrint(Module7.PRINTDEBTN,masterData);
   else
    close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
  }
 }

 public void close()
 {
  if(frame!=null) frame.dispose();
  if(mainP!=null) mainP = null;
  System.gc();
 }

}
