import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import java.sql.SQLException;

public class PrepareInvoicePrint
{
 private JFrame frame = null;
 private JPanel mainP = null;
 private JButton printButton = null;
 private JButton closeButton = null;
 private Encap masterData = null;
 private StringBuffer error = new StringBuffer(128);
 private boolean exportFlag = false; // assume Import
 private int refNo = 0;
 private MultipleCurrency mc = new MultipleCurrency();

 public PrepareInvoicePrint(String str)
 {
  if(str==null)
  {
   Module7.errorDisplay("Received null in constructor\n","ERROR");
   close();
   return;
  }
  refNo = Integer.parseInt(str);
  masterData = fetchData(str);
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   close();
   return;
  }
  frame = new JFrame("Prepare Invoice for Ref No."+str);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    JOptionPane.showMessageDialog(frame,"Click on Close in the panel instead",
    "Information",JOptionPane.INFORMATION_MESSAGE);
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  mainP = createMain();
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(mainP,BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 private Encap fetchData(String str)
 {
  Encap e = null;
  DBConnect db = new DBConnect();
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   e = fetching(prepareQuery(str),db);
   if(e==null)
    error.append("No such Ref No. exist in database\n");
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage());
  }
  finally
  {
   db.close();
  }
  if(e!=null)
    return (Encap)e.clone();
  return null;
 }

 private String prepareQuery(String str)
 {
  return new String("LEFT JOIN customer ON (customer.customerKey="+
   "transRecord.transCustKey) LEFT JOIN truckingCompany ON ("+
   "truckingCompany.truckingCompanyKey=transRecord.transTrucking) "+
   "LEFT JOIN invoiceRecord ON (invoiceRecord.invoiceRefKey="+
   "transRecord.transRefKey) WHERE transRefKey="+str+";");
 }

 private Encap fetching(String query,DBConnect db) throws SQLException
 {
  Encap e1 = db.QuerySingle("transRecord","*",query);
  Encap e2 = null;
  if(e1 == null)
  {
   error.append("No such Ref No. exist in database\n"); 
   return null;
  }
  if(e1.extractAll("transType").equalsIgnoreCase("EXP")) 
  {
   exportFlag = true;
   e2 = db.QuerySingle("expInfoRecord","*","WHERE expFromRefKey="+refNo+";");
   if(e2 == null)
   {
    error.append("Query to get Export Info resulted in null\n");
    return null;
   }
   e1.setNameVal("expSINo",e2.extractAll("expSINo"));
   e1.setNameVal("expDestName",e2.extractAll("expDestName"));
   e1.setNameVal("expVesselName",e2.extractAll("expVesselName"));
  }
  else
  {
   e2 = db.QuerySingle("impInfoRecord","*","WHERE impFromRefKey="+refNo+";");
   if(e2 == null)
   {
    error.append("Query to get Import Info resulted in null\n");
    return null;
   }
   e1.setNameVal("impBLNo",e2.extractAll("impBLNo"));
  }
  if(e2!=null) e2.clear();

  int count = 0;
  int numberElements = 0;
  int index = 1;
  Vector v = null;
  v = db.QueryMulti("transContainer","*","WHERE transContRefNo="+refNo+";");
  if(v!=null)
  {
   numberElements = v.size();
   e1.setNameVal("transContSize",numberElements);
   while(!v.isEmpty())
   {
    e2 = (Encap)v.remove(0);
    e1.setNameVal("transContNo"+index,e2.extractAll("transContNo"));
    e1.setNameVal("transContSealNo"+index,e2.extractAll("transContSealNo"));
    e2.clear();
    index+=1;
   }
  }

  count = 0;
  int extCount = 0;
  numberElements = 0;
  index = 1;

  if(!e1.extractAll("invoiceSellAmt").equalsIgnoreCase("0.00"))
  {
   mc.sumAR(e1.extractAll("invoiceSellCurr"),e1.extractAll("invoiceSellAmt"));
   extCount+=1;
  }
  v = db.QueryMulti("invoiceOtherCharges","*",
		    "WHERE invoiceOthRefKey="+refNo+";");
  if(v != null)
  {
   numberElements = v.size();
   do
   {
    count++;
    extCount+=1;
    e2 = (Encap)v.remove(0);
    e1.setNameVal("invoiceOthDesc"+count,e2.extractAll("invoiceOthDesc"));
    e1.setNameVal("invoiceOthCurr"+count,e2.extractAll("invoiceOthCurr"));
    e1.setNameVal("invoiceOthAmt"+count, e2.extractAll("invoiceOthAmt"));
    mc.sumAR(e2.extractAll("invoiceOthCurr"),e2.extractAll("invoiceOthAmt"));
    e2.clear();
   }while(v.size()>0);
   e1.setNameVal("NumberInvoiceOth",numberElements);
  }
  if(!e1.extractAll("invoiceHandleAmt").equalsIgnoreCase("0.00"))
   mc.sumAR(e1.extractAll("invoiceHandleCurr"),
    e1.extractAll("invoiceHandleAmt"));
  count = 0;
  if(mc.checkAR(1))
  {
   count+=1;
   e1.setNameVal("sumInvoiceCurr"+count,mc.getCurr(1));
   e1.setNameVal("sumInvoiceAmt"+count,mc.getSumAR(1));
  }
  if(mc.checkAR(0))
  {
   count+=1;
   e1.setNameVal("sumInvoiceCurr"+count,mc.getCurr(0));
   e1.setNameVal("sumInvoiceAmt"+count,mc.getSumAR(0));
  }
  e1.setNameVal("NumberSumInvoice",count);
  e1.setNameVal("NumberElements",extCount);
  return (Encap)e1.clone();
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.NORTHWEST;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);  
  panel.setBackground(Color.WHITE);
  panel.add(new JLabel("INVOICE",SwingConstants.CENTER),gbc);
  gbc.gridy = 1;
  panel.add(new JLabel("To : "+masterData.extractAll("customerName")),gbc);
  gbc.gridy = 2;
  panel.add(new JLabel("Ref No."+refNo),gbc);
  gbc.gridy++;
  if(!exportFlag)
  {
   panel.add(new JLabel("B/L: "+masterData.extractAll("impBLNo")),gbc);
   gbc.gridy++;
  }
  else
  {
   panel.add(new JLabel("S/I: "+masterData.extractAll("expSINo")),gbc);
   gbc.gridy++;
  }
  int number = 1;
  panel.add(new JLabel(number+". TRANSPORTATION"),gbc);
  panel.add(new JLabel(masterData.extractAll("invoiceSellCurr")),gbc);
  panel.add(new JLabel(Module7.formNumDelimiter(
   masterData.extractAll("invoiceSellAmt")),SwingConstants.RIGHT),gbc);
  number+=1;
  if(!masterData.extractAll("invoiceHandleAmt").equalsIgnoreCase("0.00"))
  {
   gbc.gridy++;
   panel.add(new JLabel(number+". Handling Charge"),gbc);
   panel.add(new JLabel(masterData.extractAll("invoiceHandleCurr")),gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
     masterData.extractAll("invoiceHandleAmt")),SwingConstants.RIGHT),gbc);
   number+=1;
  }
  int numberElements = masterData.extractInteger("NumberInvoiceOth",0);
  for(int i=1;i<=numberElements;i++)
  {
   gbc.gridy++;
   panel.add(new JLabel(number+". "+
    masterData.extractAll("invoiceOthDesc"+i)),gbc);
   panel.add(new JLabel(masterData.extractAll("invoiceOthCurr"+i)),gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
    masterData.extractAll("invoiceOthAmt"+i)),SwingConstants.RIGHT),gbc);
   number+=1;
  }
  gbc.gridy++;
  if(exportFlag)
  {
   panel.add(new JLabel("SI: "+masterData.extractAll("expSINo")),gbc);
   gbc.gridy++;
   panel.add(new JLabel("VESSEL : "+
    masterData.extractAll("expVesselName")),gbc);
   gbc.gridy++;
  }
  panel.add(new JLabel("Total",SwingConstants.RIGHT),gbc);
  numberElements = masterData.extractInteger("NumberSumInvoice",0);
  for(int i=1;i<=numberElements;i++)
  {
   panel.add(new JLabel(masterData.extractAll("sumInvoiceCurr"+i)),gbc);
   panel.add(new JLabel(Module7.formNumDelimiter(
    masterData.extractAll("sumInvoiceAmt"+i))),gbc);
  }
  JPanel finalPanel = new JPanel();
  finalPanel.add(new JScrollPane(panel));
  return finalPanel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel(new FlowLayout());
  printButton = new JButton("Print");
  closeButton = new JButton("Close");
  ButtonListener bl = new ButtonListener();
  printButton.addActionListener(bl);
  closeButton.addActionListener(bl);
  panel.add(printButton);
  panel.add(closeButton);
  return panel;
 }
 
 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == printButton)
   {
    new ProcessPrint(Module7.PRINTINV,masterData);
    updateDatabase(refNo);
   }
   else
    close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
  }
 }

 private void updateDatabase(int ref)
 {
  DBConnect db = new DBConnect();
  Encap e = new Encap("transRecord");
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to connect to database\n");
   e.setNameVal("transInvoiceDT","CURRENT_DATE");
   e.setCondition("WHERE transRefKey="+ref+";");
   db.UpdateData((Encap)e.clone());
  }
  catch(SQLException sqle)
  {
   Module7.errorDisplay(sqle.getMessage(),"ERROR in Updating");
   sqle.printStackTrace(System.out);
  }
  finally
  {
   db.close();
   e.clear();
  }
 }

 public void close()
 {
  if(frame!=null) frame.dispose();
  if(mainP!=null) mainP = null;
  System.gc();
 }

}
