import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import javax.swing.text.*;
import java.sql.SQLException;

public class PreparePaymentPrint
{
 private int pid = 0; 
 private int refNo = 0;
 private int action = 0;
 private JFrame frame = null;
 private JTable table = null;
 private TableData td = null;
 private String command = null;
 private Vector masterData = null;
 private Encap masterEncap = null;
 private JButton prntButton = null;
 private JButton cancButton = null;
 private JTextField printPID= null;
 private Vector collectionPID = new Vector(10);
 private StringBuffer error = new StringBuffer(32);

 public PreparePaymentPrint(int act,String str)
 {
  if(act!=Module7.PRINTRECVP && act!=Module7.PRINTDEBTP)
   error.append("No service available for the chosen command\n");
  if(str == null)
   error.append("Received null input\n");
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   error.delete(0,error.length());
   return;
  }
  action = act;
  refNo = Integer.parseInt(str);
  if(refNo<1)
  {
   Module7.errorDisplay("Ref No."+refNo+" is unacceptable input","ERROR");
   return;
  }
  masterData = fetch(act,refNo);
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  frame = new JFrame();
  if(act == Module7.PRINTRECVP)
   frame.setTitle("Print Receipt for Received Payment [A/R] for Ref No."
    +refNo);
  else
   frame.setTitle("Print Receipt for Making Payment [A/P] for Ref No."+refNo);
  frame.getContentPane().add(createMain(masterData),BorderLayout.CENTER); 
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Cancel in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 public JPanel createMain(Vector mData)
 {
  td = new TableData(mData);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column = null;
   if(i==td.PID||i==td.PMT||i==td.PCR)
    column = new TableColumn(i,8,render,editor);
   else
    column = new TableColumn(i,20,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JPanel panel = new JPanel(new BorderLayout());
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.add(new JScrollPane(table),BorderLayout.CENTER);
  return panel;
 }


 public JPanel createBottom()
 {
  JPanel panel = new JPanel();
  prntButton = new JButton("Print"); 
  cancButton = new JButton("Cancel");
  ButtonListener bl = new ButtonListener();
  prntButton.addActionListener(bl);
  cancButton.addActionListener(bl);
  panel.setLayout(new GridLayout(2,2));
  panel.add(new JLabel("Print Pay ID",SwingConstants.CENTER));
  printPID = new JTextField(8);
  panel.add(new createTextField(printPID,10));
  panel.add(prntButton);
  panel.add(cancButton);
  return panel;
 }

 public void close()
 {
  frame.dispose();
  System.gc();
 }

 public Vector fetch(int act,int ref)
 {
  Vector v = null;
  DBConnect db = new DBConnect();
  StringBuffer query = new StringBuffer("LEFT JOIN customer ON "+
   "(transRecord.transCustKey=customer.customerKey) "+
   "LEFT JOIN truckingCompany ON "+
   "(truckingCompany.truckingCompanyKey=transRecord.transTrucking) "+
   "WHERE transRefKey="+ref+";");
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failed to make connection to database\n");
   masterEncap = db.QuerySingle("transRecord","*",query.toString());
   if(masterEncap == null)
    throw new SQLException("No data with Ref No."+ref+" existed\n");
   query.delete(0,query.length());
   query.append("LEFT JOIN transBankRecord ON "+
    "(transPayRecord.transPayKey=transBankRecord.transBankKey) ");
   query.append("WHERE transPayFromRefKey="+ref);
   if(act == Module7.PRINTRECVP)
    query.append(" AND transPayRecord.transPayAcctPayKey=0;"); 
   else
    query.append(" AND transPayRecord.transPayAcctRecKey=0;"); 
   v = db.QueryMulti("transPayRecord","*",query.toString());
   if(v == null)
    throw new SQLException("The Ref No."+ref+" has no active payment record\n");
   v = convertToData(v);
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage());
  }
  finally
  {
   db.close();
  }
  return v;
 }

 public Vector convertToData(Vector v)
 {
  Encap en = null;
  int size = v.size();
  Vector v2 = new Vector(size);
  do
  {
   if(en!=null) en.clear();
   en = (Encap)v.remove(0);
   Data data = new Data();
   data.setPID(en.extractAll("transPayKey"));
   collectionPID.add(new Integer(data.getPID()));
   data.setPDT(Module7.formNDate(en.extractAll("transPayDate")));
   data.setPMT(en.extractAll("transPayMethod"));
   data.setPOB(en.extractAll("transBankOur"));
   data.setPTB(en.extractAll("transBankTheir"));
   data.setPNA(en.extractAll("transBankAcct"));
   data.setPND(en.extractAll("transBankDocNo"));
   data.setPCR(en.extractAll("transPayCurr"));
   data.setPAM(Module7.formNumDelimiter(en.extractAll("transPayAmt")));
   v2.addElement(data);
  }while(v.size()>0);
  return v2;
 }

 public boolean verifyExist(int id,Vector v)
 {
  if(v == null || v.size()==0)
  {
   error.append("The collection of Payment ID is null or size = 0\n");
   return false;
  }
  int size = v.size();
  boolean flag = false;
  for(int i=0;i<size;i++)
  {
   if(((Integer)v.get(i)).intValue() == id)
   {
    flag = true;
    break;
   }
  }
  if(!flag)
   error.append("The Pay ID you enter is not in the list\n");
  return flag;
 }	

 public Encap convertData(int id)
 {
  Encap en = null;
  Data data = findData(id);
  masterEncap.setNameVal("transPayKey",data.getPID());
  masterEncap.setNameVal("transPayCurr",data.getPCR());
  masterEncap.setNameVal("transPayAmt",data.getPAM());
  masterEncap.setNameVal("transPayDate",data.getPDT());
  masterEncap.setNameVal("transPayMethod",data.getPMT());
  if(!data.getPMT().equalsIgnoreCase("CASH"))
  {
   masterEncap.setNameVal("transBankOur",data.getPOB());
   masterEncap.setNameVal("transBankTheir",data.getPTB());
   masterEncap.setNameVal("transBankDocNo",data.getPND());
   masterEncap.setNameVal("transBankAcct",data.getPNA());
  }
  String table = null;
  String q = null;
  if(action == Module7.PRINTRECVP)
  {
   table = new String("accountReceivable");
   q = new String("WHERE acctRecCurr=\""+data.getPCR()+"\""+
    " AND acctRecFromRefKey="+refNo+";");
  }
  else
  {
   table = new String("accountPayable");
   q = new String("WHERE acctPayCurr=\""+data.getPCR()+"\""+
    " AND acctPayToRefKey="+refNo+";");
  }
  en = fetchAccount(table,q);
  if(error.length()==0)
  {
   for(int i=0;i<en.getSize();i++)
    masterEncap.setNameVal(en.getName(i),en.getValue(i));
  }
  else
  {
   Module7.errorDisplay("No account Payable/Receivable found\n","ERROR");
   masterEncap.clear();
   masterEncap = null;
  }
  return masterEncap;
 }

 private Data findData(int id)
 {
  int len = td.rowLength;
  for(int i=0;i<len;i++)
  {
   Data data = (Data)td.getRowValue(i);
   if(Integer.parseInt(data.getPID()) == id)
    return data;
  }
  return null;
 }

 private Encap fetchAccount(String table,String q)
 {
  Encap en = null;
  DBConnect db = new DBConnect();
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failed to make connection to database\n");
   System.out.println("table : "+table+" query: "+q);
   en = db.QuerySingle(table,"*",q);
   if(en == null)
    error.append("No account found\n"); 
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage());
  }
  finally
  {
   db.close();
  }
  if(en!=null)
   return (Encap)en.clone();
  return en;
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == prntButton)
   {
    if(printPID.getText().length()<1)
     error.append("You need to fill Print Pay ID\n");
    else
    {
     pid = Integer.parseInt(printPID.getText());
     if(verifyExist(pid,collectionPID))
     {
      int resp = JOptionPane.showConfirmDialog(null,"Enter Description",
	"Would you like to enter description?",JOptionPane.YES_NO_OPTION);
      if(resp == JOptionPane.YES_OPTION)
      {
       String input = null;
       do
       {
        input = JOptionPane.showInputDialog("Please input "+
   	  "description for the receipt\n [max 64 characters]");
        if(input.length()>64)
   	 Module7.errorDisplay("Input must be within 64 characters long",
  	  "ERROR");
	else if(input.length()>0 && input.length()<64)
         masterEncap.setNameVal("description",input); 
       }while(input.length()>64);
      }
      if(error.length()==0)
      {
       new ProcessPrint(action,convertData(pid));
       close();
      }
     }
    }
   }
   else close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
    return;
   }
  }
 }

 private class createTextField extends JPanel
 {
  public createTextField(JTextField text,int limit)
  {
   setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
   text.setHorizontalAlignment(SwingConstants.LEFT);
   text.setDocument(new JTextFieldLimit(limit));
   text.getDocument().addDocumentListener(new DocumentListen());
   add(text);
  }
 }

 private class JTextFieldLimit extends PlainDocument
 {
  private int limit;
  private boolean toUppercase = false;

  public JTextFieldLimit(int limit)
  {
   super();
   this.limit = limit;
  }
  public JTextFieldLimit(int limit,boolean upper)
  {
   this(limit);
   toUppercase = upper;
  }
  public void insertString(int offset,String str,AttributeSet attr)
   throws BadLocationException
  {
   if(str == null) return;
   if((getLength()+str.length())<=limit)
   {
    if(toUppercase) str = str.toUpperCase();
    super.insertString(offset,str,attr);
   }
  }
 }

 private class DocumentListen implements DocumentListener
 {
  public void changedUpdate(DocumentEvent de)
  {
   try { }
   catch(Exception e) { }
  }
  public void insertUpdate(DocumentEvent de)
  {
   try { }
   catch(Exception e) { }
  }
  public void removeUpdate(DocumentEvent de)
  {
   try { }
   catch(Exception e) { }
  }
 }

 private class TableData extends AbstractTableModel
 {
  public final String[] colNames = {"Pay\nID","Pay\nDate",
	 "Pay\nMethod","Our\nBank","Their\nBank","No.\nAcct",
	 "No.Giro\nCheque","Pay\nCurrency","Pay\nAmount"};

  public final int PID = 0; // Payment ID
  public final int PDT = 1; // Payment Date
  public final int PMT = 2; // Payment Method
  public final int POB = 3; // Payment Our Bank
  public final int PTB = 4; // Payment Their Bank
  public final int PNA = 5; // Payment No. Account
  public final int PND = 6; // Payment No. Document
  public final int PCR = 7; // Payment Currency
  public final int PAM = 8; // Payment Amount

  public Vector dataRow;
  public int colLength = colNames.length;
  public int rowLength;

  public TableData(Vector v)
  { initialized(v); }

  public void initialized(Vector v)
  {
   rowLength = v.size();
   dataRow = v;
  }
  public int getRowCount()
  { return rowLength; }
  public int getColumnCount()
  { return colLength; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public String getColumnName(int column)
  { return colNames[column]; }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public void setValueAt(Object val,int row,int column)
  {
   Data data = (Data)dataRow.elementAt(row); 
   switch(column)
   {
    case PID : data.setPID((String)val); break;
    case PDT : data.setPDT((String)val); break;
    case PMT : data.setPMT((String)val); break;
    case POB : data.setPOB((String)val); break;
    case PTB : data.setPTB((String)val); break;
    case PNA : data.setPNA((String)val); break;
    case PND : data.setPND((String)val); break;
    case PCR : data.setPCR((String)val); break;
    case PAM : data.setPAM((String)val); break;
   }
   dataRow.setElementAt(data,row);
   fireTableCellUpdated(row,column);
  }
  public Object getValueAt(int row,int column)
  {
   if(row<0 || row>=getRowCount())
     return " ";
   Data data = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case PID : return data.getPID(); 
    case PDT : return data.getPDT();
    case PMT : return data.getPMT();
    case POB : return data.getPOB();
    case PTB : return data.getPTB();
    case PNA : return data.getPNA();
    case PND : return data.getPND();
    case PCR : return data.getPCR();
    case PAM : return data.getPAM();
   }
   return " ";
  }
  public Object getRowValue(int row)
  {
   return dataRow.elementAt(row);
  }
 }

 private class Data
 {
  String paymentID = null;
  String paymentDate = null;
  String paymentMethod = null;
  String paymentOurBank= null;
  String paymentThrBank= null;
  String paymentNoAcct = null;
  String paymentNoDoc = null;
  String paymentCurrency= null;
  String paymentAmount = null;

  public Data() { }
  public Data(String pid,String pdt,String pmt,String pob,
   String ptb,String pna,String pnd,String pcr,String pam)
  {
   setPID(pid);
   setPDT(pdt);
   setPMT(pmt);
   setPOB(pob);
   setPTB(ptb);
   setPNA(pna);
   setPND(pnd);
   setPCR(pcr);
   setPAM(pam);
  }
  public void setPID(String input)
  { paymentID = new String(input); }
  public void setPDT(String input)
  { paymentDate = new String(input); }
  public void setPMT(String input)
  { paymentMethod = new String(input); }
  public void setPOB(String input)
  { paymentOurBank = new String(input); }
  public void setPTB(String input)
  { paymentThrBank = new String(input); }
  public void setPNA(String input)
  { paymentNoAcct = new String(input); }
  public void setPND(String input)
  { paymentNoDoc = new String(input); }
  public void setPCR(String input)
  { paymentCurrency = new String(input); }
  public void setPAM(String input)
  { paymentAmount = new String(input); }
  public String getPID()
  { return paymentID; }
  public String getPDT()
  { return paymentDate; }
  public String getPMT()
  { return paymentMethod; }
  public String getPOB()
  { return paymentOurBank; }
  public String getPTB()
  { return paymentThrBank; }
  public String getPNA()
  { return paymentNoAcct; }
  public String getPND()
  { return paymentNoDoc; }
  public String getPCR()
  { return paymentCurrency; }
  public String getPAM()
  { return paymentAmount; }
 }
}
