import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.HashMap;

public class ProcessOther
{
 private Data data;
 private TableData td;
 private JFrame frame; 
 private JTable table;
 private int action = 0;
 private int number = 0;
 private JButton contButton;
 private JButton cancButton;
 private static HashMap map;
 private static int flag = 0;
 private boolean continueFlag = false;
 private String title;
 private String ftitle;

 private final static String impothchg = new String("Import Other Charges");
 private final static String impothcst = new String("Import Other Cost");
 private final static String impothinv = 
	new String("Import Other Invoice Charges");
 private final static String expothcst = new String("Export Other Cost");
 private final static String expothinv = 
	new String("Export Other Invoice Charges");
 private final static String expothchg = new String("Export Other Charges");
 private final static String addothcst = new String("Add Other Cost");
 private final static String addothinv = 
	new String("Add Other Invoice Charges");
 private final static String addothchg = new String("Add Other Charges");

 public final static int IMPOTHCHARGES = 1;
 public final static int IMPOTHINVOICE = 2;
 public final static int IMPOTHCOST    = 3;
 public final static int EXPOTHCOST    = 4;
 public final static int EXPOTHINVOICE = 5;
 public final static int EXPOTHCHARGES = 6;
 public final static int ADDOTHCOST    = 7;
 public final static int ADDOTHCHARGES = 8;
 public final static int ADDOTHINVOICE = 9;

 public ProcessOther(HashMap dkMap,int act)
 {
  if(dkMap == null)
  {
   Module7.errorDisplay("Received null map","ERROR");
   return;
  }
  map = dkMap;
  action = act;
  flag = checkAction();
  frame = new JFrame(title);
  frame.getContentPane().setLayout(new BorderLayout());
  td = new TableData(number);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column = new TableColumn(i,20,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(number));
  head.setFixedCellWidth(30);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JPanel panel = new JPanel();
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  panel.setBorder(new TitledBorder(new LineBorder(Color.black,1),title));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  frame.getContentPane().add(panel,BorderLayout.CENTER); 
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Cancel in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private int checkAction()
 {
//  System.out.println("ProcessOther checkAction");
  if(action == Module7.IMPORTING)
  {
   if(map.containsKey("ImportNumberOthCost")&&
          !map.containsKey("ImpOthCostDone"))
   {
    title = impothcst;
    ftitle= new String("ImportNumberOthCost");
    number= Integer.parseInt((String)map.get("ImportNumberOthCost"));
//    System.out.println("Going to process Import Number Other Cost");
    return IMPOTHCOST;
   }
   else if(map.containsKey("ImportNumberOthCharges")&&
     !map.containsKey("ImpOthChargesDone")) 
   {
    title = impothchg;
    ftitle= new String("ImportNumberOthCharges");
    number= Integer.parseInt((String)map.get("ImportNumberOthCharges")); 
//    System.out.println("Going to process Import Other Charges");
    return IMPOTHCHARGES; 
   }
   else if(map.containsKey("ImportNumberOthInvoice")&&
          !map.containsKey("ImpOthInvoiceDone"))
   {
    title = impothinv; 
    ftitle= new String("ImportNumberOthInvoice");
    number= Integer.parseInt((String)map.get("ImportNumberOthInvoice"));
//    System.out.println("Going to process Import Invoice Other Charges");
    return IMPOTHINVOICE;
   }
  }
  else if(action == Module7.EXPORTING) // must be EXPORTING
  {
   if(map.containsKey("ExportNumberOthCost")&&
     !map.containsKey("ExpOthCostDone"))
   {
    title = expothcst;
    ftitle= new String("ExportNumberOthCost");
    number= Integer.parseInt((String)map.get("ExportNumberOthCost"));
//    System.out.println("Going to process Number Other Cost");
    return EXPOTHCOST; 
   }
   else if(map.containsKey("ExportNumberOthInvoice")&&
          !map.containsKey("ExpOthInvoiceDone"))
   {
    title = expothinv;
    ftitle= new String("ExportNumberOthInvoice");
    number= Integer.parseInt((String)map.get("ExportNumberOthInvoice"));
//    System.out.println("Going to process Export Invoice Other Charges");
    return EXPOTHINVOICE;
   }
   else if(map.containsKey("ExportNumberOthCharges")&&
          !map.containsKey("ExpOthChargesDone"))
   {
    title = expothchg;
    ftitle= new String("ExportNumberOthCharges");
    number= Integer.parseInt((String)map.get("ExportNumberOthCharges"));
//    System.out.println("Going to process Export Other Charges");
    return EXPOTHCHARGES;
   }
  }
  else // must be ADDRN
  {
   if(map.containsKey("AddNumberOthCost")&&
     !map.containsKey("AddOthCostDone"))
   {
    title = addothcst;
    ftitle= new String("AddNumberOthCost");
    number= Integer.parseInt((String)map.get("AddNumberOthCost"));
    return ADDOTHCOST;
   }
   else if(map.containsKey("AddNumberOthCharges")&&
   	  !map.containsKey("AddOthChargesDone"))
   {
    title = addothchg;
    ftitle= new String("AddNumberOthCharges");
    number= Integer.parseInt((String)map.get("AddNumberOthCharges"));
    return ADDOTHCHARGES;
   }
   else if(map.containsKey("AddNumberOthInvoice")&&
   	  !map.containsKey("AddOthInvoiceDone"))
   {
    title = addothinv;
    ftitle= new String("AddNumberOthInvoice");
    number= Integer.parseInt((String)map.get("AddNumberOthInvoice"));
    return ADDOTHINVOICE;
   }
  }
  return 0;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  panel.setLayout(new FlowLayout());
  contButton = new JButton("Continue"); 
  cancButton = new JButton("Cancel");
  ButtonListener bl = new ButtonListener();
  contButton.addActionListener(bl);
  cancButton.addActionListener(bl);
  panel.add(contButton);
  panel.add(cancButton);
  return panel;
 }

 private class ButtonListener implements ActionListener
 {
  private StringBuffer error = new StringBuffer();

  public void actionPerformed(ActionEvent e)
  {
   if((JButton)e.getSource()==contButton)
   {
    collect(ftitle);
    if(error.length() == 0)
    {
     continueFlag = determine();
     if(continueFlag)
     {
//      System.out.println("ProcessOther continues to ProcessOther");
      new ProcessOther((HashMap)map.clone(),action);
     }
     else if(action == Module7.EXPORTING || action == Module7.IMPORTING)
     {
//      System.out.println("ProcessOther continues to DataKeeper");
      if(error.length()<1)
       new DataKeeper((HashMap)map.clone(),action);
//      else
//       System.out.println("there is an error");
     }
     else
      new AddFinish((HashMap)map.clone());
     close();
    }
    else
    {
    System.out.println("Going to display Error in ProcessOther");
     Module7.errorDisplay(error.toString(),"ERROR");
    }
   }
   else
    close();
   if(error.length()>0) error.delete(0,error.length());
   System.out.println("Exit collect ProcessOther");
   return;
  }

  private void collect(String str)
  {
   HashMap tmp = new HashMap();
//   System.out.println("collect : "+str);
   StringBuffer tmp1 = new StringBuffer(str);
   StringBuffer tmp2 = new StringBuffer(str+"Curr");
   StringBuffer tmp3 = new StringBuffer(str+"Amt");
   StringBuffer tmpCon = new StringBuffer();
   int len1 = tmp1.length();
   int len2 = tmp2.length();
   int len3 = tmp3.length();
   Data data = null;
   for(int i=0;i<number;i++)
   {
    tmp1.append(i+1);
    tmp2.append(i+1);
    tmp3.append(i+1);
    data = (Data)td.getRowValue(i); 
    if(data.getDesc() == null || data.getDesc().length()==0)
     error.append("You must press ENTER or fill row: "+(i+1)+"\n");
    else
    {
//     System.out.println("-- Desc: "+data.getDesc()+" size: "+
//      data.getDesc().length());
     tmpCon.append(data.getDesc().trim());
     if(!tmpCon.toString().equalsIgnoreCase(" "))
     {
      if(tmpCon.length()<=32)
       tmp.put(tmp1.toString(),tmpCon.toString());
      else
      {
       error.append("Description at ["+(i+1)+"] can\'t be ");
       error.append("longer than 32 characters\n");
      }
     }
     else
     {
      error.append("Description at ["+(i+1)+"] has to be filled OR ");
      error.append("press ENTER\n");
     }
    }
    tmpCon.delete(0,tmpCon.length());
    if(data.getCurr() == null || data.getCurr().length()==0)
     error.append("You must press ENTER or fill row: "+(i+1)+"\n");
    else
    {
//     System.out.println("--curr : "+data.getCurr()+" size: "+
//      data.getCurr().length());
     tmpCon.append(data.getCurr().trim());
     if(!tmpCon.toString().equalsIgnoreCase(" "))
     {
      if(tmpCon.length()==3)
      {
       if(Module7.checkValidCurrency(tmpCon.toString()))
        tmp.put(tmp2.toString(),tmpCon.toString().toUpperCase());
       else
        error.append("Currency at ["+(i+1)+"] is not accepted");
      }
      else
       error.append("Currency at ["+(i+1)+"] must be 3 characters long\n");
     }
     else
     {
      error.append("Currency at ["+(i+1)+"] has to be filled OR ");
      error.append("press ENTER\n");
     }
    }
    tmpCon.delete(0,tmpCon.length());
    if(data.getAmt() == null || data.getAmt().length()==0)
     error.append("You must press ENTER or fill row: "+(i+1)+"\n"); 
    else
    {
//     System.out.println("--amt : "+data.getAmt()+" size: "+
//     data.getAmt().length());
     tmpCon.append(data.getAmt().trim());
     if(tmpCon.length()<=Module7.max)
     {
      if(!tmpCon.toString().equalsIgnoreCase(" "))
      {
       if(Module7.checkInt(tmpCon.toString(),3) && 
 	 Module7.checkMax(tmpCon.toString()))
        tmp.put(tmp3.toString(),data.getAmt().toString().trim());
       else
       {
        error.append("Amount must be digit [max: "+Module7.max);
        error.append("] and have 2 decimal points\n");
       }
      }
      else
       error.append("Press Enter at row Amount "+i);
     }
     else
     {
      error.append("Amount can't exceed "+Module7.max);
      error.append(" digits with 2 decimal points\n"); 
     }
    }
    tmpCon.delete(0,tmpCon.length());
    tmp1.delete(len1,tmp1.length());
    tmp2.delete(len2,tmp2.length());
    tmp3.delete(len3,tmp3.length());
   }
   if(error.length()==0)
   {
    for(int i=0;i<number;i++)
    {
     tmp1.append(i+1);
     tmp2.append(i+1);
     tmp3.append(i+1);
     map.put(tmp1.toString(),(String)tmp.remove(tmp1.toString()));
     map.put(tmp2.toString(),(String)tmp.remove(tmp2.toString()));
     map.put(tmp3.toString(),(String)tmp.remove(tmp3.toString()));
//    System.out.print("ProcessOther : put "+tmp1.toString());
//     System.out.println(" "+tmp2.toString()+" "+tmp3.toString());
     tmp1.delete(len1,tmp1.length());
     tmp2.delete(len2,tmp2.length());
     tmp3.delete(len3,tmp3.length());
    }
   }
   tmp.clear();
   tmp1.delete(0,tmp1.length());
   tmp2.delete(0,tmp2.length());
   tmp3.delete(0,tmp3.length());
  }

  private boolean determine()
  {
   if(action == Module7.IMPORTING)
   {
    switch(flag)
    {
     case IMPOTHCHARGES : 
      map.put("ImpOthChargesDone",new Boolean(true));
      if((map.containsKey("ImportNumberOthInvoice")) &&
        (!map.containsKey("ImpOthInvoiceDone")))
	 return true;
      if((map.containsKey("ImportNumberOthCost")) &&
	(!map.containsKey("ImpOthCostDone")))
	 return true;
      break;
     case IMPOTHINVOICE : 
      map.put("ImpOthInvoiceDone",new Boolean(true));
      if((map.containsKey("ImportNumberOthCharges")) && 
        (!map.containsKey("ImpOthChargesDone")))
	 return true;
      if((map.containsKey("ImportNumberOthCost")) &&
        (!map.containsKey("ImpOthCostDone")))
	 return true;
      break;
     case IMPOTHCOST    : 
      map.put("ImpOthCostDone",new Boolean(true));
      if((map.containsKey("ImportNumberOthCharges")) && 
	(!map.containsKey("ImpOthChargesDone")))
	 return true;
      if((map.containsKey("ImportNumberOthInvoice")) && 
        (!map.containsKey("ImpOthInvoiceDone")))
	 return true;
     break;
    }
   }
   else if(action == Module7.EXPORTING)
   {
    switch(flag)
    {
     case EXPOTHCOST    : 
      map.put("ExpOthCostDone",new Boolean(true));
      if((map.containsKey("ExportNumberOthInvoice")) && 
        (!map.containsKey("ExpOthInvoiceDone")))
	return true;
      if((map.containsKey("ExportNumberOthCharges")) && 
	(!map.containsKey("ExpOthChargesDone")))
	return true;
      break;
     case EXPOTHINVOICE : 
      map.put("ExpOthInvoiceDone",new Boolean(true));
      if((map.containsKey("ExportNumberOthCost")) && 
	(!map.containsKey("ExpOthCostDone")))
	return true;
      if((map.containsKey("ExportNumberOthCharges")) && 
	(!map.containsKey("ExpOthChargesDone")))
	return true;
      break;
     case EXPOTHCHARGES : 
      map.put("ExpOthChargesDone",new Boolean(true));
      if((map.containsKey("ExportNumberOthCharges")) &&
	(!map.containsKey("ExpOthInvoiceDone")))
	return true;
      if((map.containsKey("ExportNumberOthCost")) && 
        (!map.containsKey("ExpOthCostDone")))
	return true;
      break;
    }
   }
   else if(action == Module7.ADDRN)
   {
    switch(flag)
    {
     case ADDOTHCOST    : 
      map.put("AddOthCostDone",new Boolean(true));
      if((map.containsKey("AddNumberOthCharges")) &&
	(!map.containsKey("AddOthChargesDone")))
	return true;
      if((map.containsKey("AddNumberOthInvoice")) &&
        (!map.containsKey("AddOthInvoiceDone")))
	return true;
      break;
     case ADDOTHCHARGES : 
      map.put("AddOthChargesDone",new Boolean(true));
      if((map.containsKey("AddNumberOthInvoice")) &&
        (!map.containsKey("AddOthInvoiceDone")))
	return true;
      if((map.containsKey("AddNumberOthCost")) &&
	(!map.containsKey("AddOthCostDone")))
	return true;
      break;
     case ADDOTHINVOICE : 
      map.put("AddOthInvoiceDone",new Boolean(true)); 
      if((map.containsKey("AddNumberOthCost")) &&
        (!map.containsKey("AddOthCostDone")))
	return true;
      if((map.containsKey("AddNumberOthCharges")) &&
        (!map.containsKey("AddOthChargesDone")))
	return true;
      break;
    }
   }
   return false;
  }

  private void close()
  {
   frame.dispose();
   System.gc();
  }
 } // end of ButtonListener's class

 private class TableData extends AbstractTableModel
 {
  public final String[] colNames = {"Description","Currency","Amount"};
  public final int DESC = 0;
  public final int CURR = 1;
  public final int AMT  = 2;
  public Vector dataRow;
  public int colLength = 3;
  public int rowLength;
  public TableData(int num)
  { initialized(num); }
  public void initialized(int num)
  {
   rowLength = num;
   dataRow = new Vector(num);
   for(int i=0;i<rowLength;i++)
    dataRow.insertElementAt(new Data("","IDR",""),i);
  }
  public int getRowCount()
  { return rowLength; }
  public int getColumnCount()
  { return colLength; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public String getColumnName(int column)
  { return colNames[column]; }
  public boolean isCellEditable(int row,int column)
  { return true; }
  public void setValueAt(Object val,int row,int column)
  {
   Object obj = dataRow.elementAt(row);
   if(obj == null)
   {
    Data data = new Data();
    switch(column)
    {
     case DESC : data.setDesc((String)val); break;
     case CURR : data.setCurr((String)val); break;
     case AMT  : data.setAmt((String)val); break;
    }
    dataRow.insertElementAt(data,row);
   }
   else
   {
    Data data = (Data)obj;
    switch(column)
    {
     case DESC : data.setDesc((String)val); break;
     case CURR : data.setCurr((String)val); break;
     case AMT  : data.setAmt((String)val); break;
    }
    dataRow.setElementAt(data,row);
   }
   fireTableCellUpdated(row,column);
  }
  public Object getValueAt(int row,int column)
  {
   if(row<0 || row>=getRowCount())
     return " ";
   Data data = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case DESC : return data.getDesc();
    case CURR : return data.getCurr();
    case AMT  : return data.getAmt();
   }
   return " ";
  }
  public Object getRowValue(int row)
  {
   return dataRow.elementAt(row);
  }
 }

 private class Data
 {
  private StringBuffer desc = null;
  private StringBuffer curr = null;
  private StringBuffer amt  = null;

  public Data()
  {
   desc = new StringBuffer();
   curr = new StringBuffer();
   amt  = new StringBuffer();
  }
  public Data(String d,String c,String a)
  {
   desc = new StringBuffer();
   curr = new StringBuffer();
	 amt  = new StringBuffer();
   setDesc(d);
   setCurr(c);
   setAmt(a);
  }
  public void setDesc(String d)
  { 
   if(desc.length()>0) 
    desc.delete(0,desc.length());
   desc.append(d); 
  }
  public void setCurr(String c)
  { 
   if(curr.length()>0)
    curr.delete(0,curr.length());
   curr.append(c); 
  }
  public void setAmt(String d)
  { 
   if(amt.length()>0)
    amt.delete(0,amt.length());
   amt.append(d); 
  }
  public String getDesc()
  {
   if(desc.length()==0)
    return "";
   return desc.toString();
  }
  public String getCurr()
  {
   if(curr.length()==0)
    return "";
   return curr.toString();
  }
  public String getAmt()
  { 
   if(amt.length()==0)
    return "";
   return amt.toString(); 
  }
 } // end of data's class
} // end of ProcessOther's class
