import java.util.Vector;
import java.io.*;

public class ProcessPrint
{
 private StringBuffer error = new StringBuffer(128);
 private boolean exportFlag = false; // assume Import
 private int pageTotal = 0;
 private int refNo = 0;
 private String currentDate = null;
 private String finalname = null;
 private String importantDate = null;
 private String docNo = null; // SI No. or BL No.
 private String vessel = null;
 private int action = 0;
 private int hashTime = 0;
 private String DescWidth = null;
 private String OthWidth = null;

 public File htmlFile = null;

 public ProcessPrint(int act,Encap master)
 {
  if(act!=Module7.PRINTRECVP&&
     act!=Module7.PRINTDEBTP&&
     act!=Module7.PRINTDEBTN&&
     act!=Module7.PRINTINV)
   error.append("No service available for the command\n");
  if(master == null)
   error.append("Received null encapsulation\n");
  else if(master.getSize()<1)
   error.append("Received zero data in encapsulation\n");
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  action = act;
  refNo = master.extractInteger("transRefKey",0);	
  DateUtil du = new DateUtil();
  currentDate = du.formIntlDate();
  hashTime = du.getCurrentTime().hashCode();
  du = null;
  int size = master.getSize();
  try
  {
   if(act == Module7.PRINTINV || act == Module7.PRINTRECVP)
   {
    setParameter(master);
    if(act == Module7.PRINTINV)
     printInvoice(master);
    else if(act == Module7.PRINTDEBTN)
     printDebit(master);
   }
   else if(act == Module7.PRINTRECVP)
    printARreceipt(master);
   else if(act == Module7.PRINTDEBTP)
    printAPreceipt(master);
   else
    error.append("No service available for command\n");
  }
  catch(IOException ioex)
  {
   error.append(ioex.getMessage()+"\n");
   ioex.printStackTrace(System.out);
  }

  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   error.delete(0,error.length());
  }
 } // end of ProcessPrint's constructor

/**
 * setParameter's method is to set all the parameters for 
 * Export/Import
 * @param Encap master - contains all the data
 * @return none
 */
 private void setParameter(Encap en)
 {
  if(en.extractAll("transType").equalsIgnoreCase("EXP"))
   exportFlag = true;
  if(exportFlag) // it is export
    setExportParam(en);
  else
    setImportParam(en);
 }

/**
 * setExportParam's method is to set export parameters :
 * vessel name,stuffing date, SI No, ref No and page total
 * @param Encap en - contains data
 * @return none
 */
 private void setExportParam(Encap en)
 {
  vessel = en.extractString("expVesselName",null);
  importantDate = Module7.formNDate(
   en.extractString("expStuffingDate",null));
  docNo = en.extractString("expSINo",null);
  refNo = en.extractInteger("transRefKey",0);
 }

/**
 * setImportParam's method is to set import parameters :
 * BL No, ref No, and page total
 * @param Encap en - contains data
 * @return none
 */
 private void setImportParam(Encap en)
 {
  importantDate = Module7.formNDate(
   en.extractString("impArrival",null));
  docNo = en.extractString("impBLNo",null);
  refNo = en.extractInteger("transRefKey",0);
 }

 
/**
 * printHeading's method is to print the heading that has logo
 * and required an image at location C:\Source\LKB.jpg
 * @param PrintWriter pw - to write out to file
 * @return none 
 */
 private void printHeading(PrintWriter pw) throws IOException
 {
  pw.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 "+
             "Transitional//EN\">"); 
  pw.println("<HTML><HEAD>");
  if(action == Module7.PRINTINV) 
   pw.print("<TITLE>Invoice of Ref No."+refNo+"</TITLE>");
  else if(action == Module7.PRINTDEBTN)
   pw.print("<TITLE>Debit Note of Ref No."+refNo+"</TITLE>");

  pw.print("<meta http-equiv=\"Content-Type\" content=\"text/html;");
  pw.println(" charset=iso-8859-1\"></HEAD>");
  pw.println("<BODY BGCOLOR=WHITE TEXT=BLACK>");
  pw.print("<TABLE WIDTH=\"85%\" BORDER=\"0\""+
	   " CELLSPACING=\"1\" CELLPADDING=\"1\"><TR>"); 
  pw.print("<TD WIDTH=\"15%\" HEIGHT=\"170\"><img src=\"C:\\Shared\\wall\\"+
	   "9Zhouxun.jpeg\" width=\"118\" height=\"161\"></td>"); 
  pw.print("<TD WIDTH=\"85%\"><TABLE WIDTH=\"100%\" HEIGHT=\"162\""+
	   " BORDER=\"0\" cellpadding=\"1\" cellspacing=\"1\">"); 
  pw.println("<TR>");
  pw.print("<TD HEIGHT=\"32\"><FONT SIZE=\"5\" FACE=\"Verdana, Arial, "+
           " Helvetica, sans-serif\">PT. Lukman Kharisma Buana"+
	   "</FONT></TD></TR>");
  pw.println("<TR>");
  pw.print("<TD HEIGHT=\"26\"><FONT FACE=\"Geneva, Arial, "+
           "Helvetica, sans-serif\"><em>(Customs Broker &amp; "+
	   "Inland Transporter)</em></FONT></TD></TR>");
  pw.println("<TR>"); 	  
  pw.print("<TD HEIGHT=\"100\">");
  pw.print("<TABLE WIDTH=\"100%\" HEIGHT=\"92\" BORDER=\"0\" "+
	   " cellpadding=\"1\" cellspacing=\"1\">");
  pw.print("<TR>");
  pw.print("<TD WIDTH=\"33%\" HEIGHT=\"90\"><pre><font size=\"2\" "+
	   "FACE=\"Verdana, Arial, Helvetica, sans-serif\">");
  pw.print("Head Office:<BR>");
  pw.print("<FONT SIZE=\"1\" FACE=\"Geneva, Arial, Helvetica, sans-serif\">");
  pw.print("Jl. Malaka 2/15 J ( d/h Orpa)</FONT></FONT>");
  pw.print("<FONT SIZE=\"1\" FACE=\"Geneva, Arial, Helvetica, sans-serif\">"); 
  pw.print("Jakarta 11230 Indonesia");
  pw.print("Tel : +62-21-6912788 (Hunting)");
  pw.print("Tel : +62-21-6912672 (Direct)");
  pw.print("Fax: +62-21-6912671");
  pw.print("email lbssales@lbs.famili.com</font></pre></TD>");
  pw.print("<td width=\"67%\"><pre><font size=\"2\" face=\"Geneva, Arial, ");
  pw.print("Helvetica, sans-serif\">Semarang Office:");
  pw.print("<FONT SIZE=\"1\">Kompleks Semarang Indah");
  pw.print("Block D XV/12 A ");
  pw.print("Semarang 50144 Indonesia");
  pw.print("Tel   +62-24-7624255"); 
  pw.println("Fax: +62-24-7624254</font></font></pre>");
  pw.println("</TD></TR></TABLE>"); 
  pw.println("</TD></TR></TABLE>");
  pw.println("</TD></TR></TABLE>");
 }

/**
 * printMiddle method is to print the middle heading that contains
 * important info like client,address,vessel, etc
 * @param PrintWrite pw
 */
 private void printMiddle(PrintWriter pw) throws IOException
 {
  pw.println("<TABLE WIDTH=\"85%\" HEIGHT=\"129\" BORDER=\"0\" "+
             "cellpadding=\"1\" cellspacing=\"1\">");
  pw.println("<TR>"); 
  pw.print("<TD HEIGHT=\"38\"><DIV ALIGN=\"center\"><FONT SIZE=\"+3\" "+
           "FACE=\"Geneva, Arial, Helvetica, sans-serif\">");
  if(action == Module7.PRINTINV)
   pw.print("INVOICE");
  else if(action == Module7.PRINTDEBTN)
   pw.print("DEBIT NOTE");
  pw.print("</FONT></DIV></TD></TR>");
  pw.println("<TR>");
  pw.print("<TD HEIGHT=\"88\"><TABLE WIDTH=\"100%\" "+
           "HEIGHT=\"86\" BORDER=\"0\" cellpadding=\"1\" cellspacing=\"1\">");
  pw.println("<TR>");

  // CLIENT
  pw.print("<TD WIDTH=\"74%\" HEIGHT=\"84\" ALIGN=\"LEFT\" VALIGN=\"TOP\">"); 
  pw.print("<DIV ALIGN=\"LEFT\"><FONT SIZE=\"2\" FACE=\"Verdana, Arial, "+
           "Helvetica, sans-serif\">"); 
  pw.print("[CLIENT]");
  pw.print("</FONT></DIV></TD>");

  pw.print("<TD WIDTH=\"26%\"><TABLE WIDTH=\"100%\" HEIGHT=\"79\" "+
           "BORDER=\"0\" cellpadding=\"1\" cellspacing=\"1\">"); 

  // VESSEL 
  if(exportFlag)
  {
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"26%\" HEIGHT=\"14\"><DIV ALIGN=\"RIGHT\"> "+
           "<FONT SIZE=\"1\" FACE=\"Geneva, Arial, Helvetica, sans-serif\">"); 
   pw.print("Vessel</FONT></DIV></TD>");
   // FILL VESSEL 
   pw.print("<TD WIDTH=\"74%\"><FONT SIZE=\"1\" FACE=\"Geneva, Arial, "+
            "Helvetica, sans-serif\">");
   pw.print(vessel);
   pw.print("</FONT></TD>"); 
   pw.println("</TR>");
  }

  // STUFFING DATE OR ARRIVAL DATE
  pw.println("<TR>");
  pw.print("<TD HEIGHT=\"14\"><DIV ALIGN=\"RIGHT\"><FONT SIZE=\"1\" "+
           "FACE=\"Geneva, Arial, Helvetica, sans-serif\">"); 
  if(action == 1)
   pw.print("Stuffing");
  else
   pw.print("Arrival");
  pw.print("</FONT></DIV></TD>");
  // FILL STUFFING DATE OR ARRIVAL DATE
  pw.print("<TD><FONT SIZE=\"1\" FACE=\"Geneva, Arial, "+
           "Helvetica, sans-serif\">");
  pw.print(importantDate); 
  pw.print("</FONT></TD>");
  pw.println("</TR>");

  // SI NO. OR BL NO.
  pw.println("<TR>");
  pw.print("<TD HEIGHT=\"14\"><DIV ALIGN=\"RIGHT\"><FONT SIZE=\"1\" "+
           "FACE=\"Geneva, Arial, Helvetica, sans-serif\">"); 
  if(action == 1)
   pw.print("SI NO");
  else
   pw.print("BL NO");
  pw.print("</FONT></DIV></TD>");
  // FILL SI NO. OR BL NO.
  pw.print("<TD><FONT SIZE=\"1\" FACE=\"Geneva, Arial, "+
           "Helvetica, sans-serif\">");
  pw.print(docNo); 
  pw.print("</FONT></TD>");
  pw.println("</TR>");

  // REF NO
  pw.println("<TR>");
  pw.print("<TD HEIGHT=\"14\"><DIV ALIGN=\"RIGHT\"><FONT SIZE=\"1\" "+
           "FACE=\"Geneva, Arial, Helvetica, sans-serif\">"); 
  pw.print("REF NO");
  pw.print("</FONT></DIV></TD>");
  // FILL REF NO
  pw.print("<TD><FONT SIZE=\"1\" FACE=\"Geneva, Arial, "+
           "Helvetica, sans-serif\">");
  pw.print(refNo); 
  pw.print("</FONT></TD>");
  pw.println("</TR>");

  // PAGE
  pw.println("<TR>");
  pw.print("<TD HEIGHT=\"14\"><DIV ALIGN=\"RIGHT\"><FONT SIZE=\"1\" "+
           "FACE=\"Geneva, Arial, Helvetica, sans-serif\">"); 
  pw.print("PAGE");
  pw.print("</FONT></DIV></TD>");
  // FILL PAGE
  pw.print("<TD><FONT SIZE=\"1\" FACE=\"Geneva, Arial, "+
           "Helvetica, sans-serif\">");
  pw.print("[fill PAGE]"); 
  pw.print("</FONT></TD>");
  pw.println("</TR>");

  pw.println("</TABLE>");
  pw.println("</TD></TR>");
  pw.println("</TABLE>");
  pw.println("</TD></TR>");
  pw.println("</TABLE>");
  pw.println("<p>&nbsp;</p>"); 
 }

/**
 * printBottomInvoice's method is print the bottom of the Invoice
 * Bottom Page
 * @param PrintWriter pw
 * @return none
 */
 private void printBottomInvoice(PrintWriter pw) throws IOException
 {
  pw.println("<TABLE WIDTH=\"50%\" BORDER=\"0\" "+
             "cellspacing=\"1\" cellpadding=\"1\">");
  pw.print("<TR>");
  pw.print("<TD WIDTH=\"22%\" HEIGHT=\"36\"><FONT SIZE=\"1\" FACE=\"Geneva, "+
           " Arial, Helvetica, sans-serif\">No Container</FONT></TD>");
  pw.print("<TD WIDTH=\"78%\" ALIGN=\"LEFT\" VALIGN=\"TOP\">"+
           "<FONT SIZE=\"1\" FACE=\"Geneva, Arial, Helvetica, sans-serif\">");
  pw.print("[fill the container no]");
  pw.print("</FONT></TD>");
  pw.println("</TR>");
  pw.println("<TR>");
  pw.print("<TD HEIGHT=\"36\"><FONT SIZE=\"1\" FACE=\"Geneva, Arial, "+
           "Helvetica, sans-serif\">");
  pw.print("Remarks</FONT></TD>");
  pw.print("<TD ALIGN=\"LEFT\" VALIGN=\"TOP\">");
  pw.print("<FONT SIZE=\"1\" FACE=\"Geneva, Arial, Helvetica, sans-serif\">");
  pw.print("[fill remarks]");
  pw.print("</FONT></TD>");
  pw.print("</TR>");
  pw.print("</TABLE><p>&nbsp;</p>");
 }

 private void printContent(PrintWriter pw,int loopTime,int numIndex,
                           String middle,String curr,String amnt)
 throws IOException
 {
  pw.println("<TABLE WIDTH=\"100%\" BORDER=\"0\" "+
             "CELLSPACING=\"1\" CELLPADDING=\"1\">"); 
  pw.println("<TR>"); 

  if(numIndex > 0)
  {
   pw.println("<TD WIDTH=\"8%\"><DIV ALIGN=\"CENTER\">"+
   "<FONT SIZE=\"1\" FACE=\"Geneva, Arial, Helvetica, sans-serif\">");
   pw.print(numIndex+".</FONT></DIV></TD>");
  }
  else
  {
   pw.println("<TD WIDTH=\"8%\"></TD>");
  }

  pw.println("<TD WIDTH\""+DescWidth+"\"><FONT SIZE=\"1\" "+
  "FACE=\"Geneva, Arial, Helvetica, sans-serif\">"+middle+
  "</FONT></TD>");

  int place = determinePlace(curr);
  for(int i=1;i<=loopTime;i++)
  {
   pw.println("<TD WIDTH=\""+OthWidth+"\">");
   if(i == place)
   {
    pw.println("<TABLE WIDTH=\"100%\" BORDER=\"0\" "+
    "CELLSPACING=\"1\" CELLPADDING=\"1\">");
    pw.println("<TR>");
    pw.println("<TD WIDTH=\"20%\" ALIGN=\"LEFT\">"+
    "<FONT SIZE=\"1\" FACE=\"Geneva, Arial, Helvetica, sans-serif\">"+
    curr+"</FONT></TD>");
    pw.println("<TD WIDTH=\"80%\" ALIGN=\"LEFT\">"+
    "<FONT SIZE=\"1\" FACE=\"Geneva, Arial, Helvetica, sans-serif\">"+
    amnt+"</FONT></TD>");
    pw.println("</TR>");
   }
   pw.println("</TD>");
  }

  pw.println("</TR>"); 
  pw.println("</TABLE>"); 
 }

 private void printInvoice(Encap e) throws IOException
 {
  String filename = new String("Invoice-"+refNo+"#"
    +currentDate+"#"+hashTime+".HTML");
  htmlFile = formFile(filename);	
  if(htmlFile == null)throw new IOException(error.toString());
  FileWriter fw = new FileWriter(htmlFile);
  BufferedWriter bw = new BufferedWriter(fw);
  PrintWriter pw = new PrintWriter(bw);

  MultipleCurrency mc = new MultipleCurrency();

  // TITLE, HEADER, AND BODY
  printHeading(pw);
  printMiddle(pw);	

  // ---- Table begin
  int numElements = e.extractInteger("NumberElements",0);
  int number = e.extractInteger("NumberSumInvoice",0);

 
  if(number == 1)
  {
   DescWidth = new String("74%");
   OthWidth = new String("18%"); // one table amount
  }
  else if(number == 2)
  { 
   DescWidth = new String("62%");
   OthWidth = new String("15%"); // two table amount
  }

  pw.print("<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1 WIDTH=\"85%\">");
  pw.println("<TR>");
  pw.println("<TD BORDERCOLOR=\"#000000\">");
  pw.println("<TABLE WIDTH=\"100%\" BORDER=1 CELLPADDING=1 CELLSPACING=1>");
  pw.println("<TR>");

  pw.println("<TD WIDTH=\"8%\">"+
  "<DIV ALIGN=\"CENTER\"><FONT FACE=\"Geneva, Arial,"+
  " Helvetica, sans-serif\" SIZE=\"2\"><STRONG>"+
  "No</STRONG></FONT></DIV></TD>");

  pw.println("<TD WIDTH=\""+DescWidth+"\">"+
  "<DIV ALIGN=\"CENTER\"><FONT FACE=\"Geneva, Arial,"+
  " Helvetica, sans-serif\" SIZE=\"2\"><STRONG>"+
  "Description</STRONG></FONT></DIV></TD>");

  for(int i=0;i<number;i++)
  {
   pw.println("<TD WIDTH=\""+OthWidth+"\">"+
   "<DIV ALIGN=\"CENTER\"><FONT FACE=\"Geneva, Arial,"+
   " Helvetica, sans-serif\" SIZE=\"2\"><STRONG>"+
   "Amount</STRONG></FONT></DIV></TD>");
  }

  pw.println("</TR>");
  pw.println("</TABLE>");
  pw.println("</TD>");
  pw.println("</TR>");

  int index = 1; // for the side index number
  
  // --- Begin to fill the content
  
  pw.println("<TR><TD BORDERCOLOR=\"#000000\">");
  printContent(pw,number,index,"TRANSPORTATION",
  e.extractAll("invoiceSellCurr"),
  Module7.formNumDelimiter(e.extractAll("invoiceSellAmt")));
  pw.println("</TD></TR>");
  index+=1;

  // Next row - Handling
  if(!e.extractAll("invoiceHandleAmt").equalsIgnoreCase("0.00"))	
  {
   pw.println("<TR><TD BORDERCOLOR=\"#000000\">");
   printContent(pw,number,index,"Handling Charge",
   e.extractAll("invoiceHandleCurr"),
   Module7.formNumDelimiter(e.extractAll("invoiceHandleAmt")));
   pw.println("</TD></TR>");
   index+=1;
  }

  // Next row
  int n = 0;
  if(e.getPosition("NumberInvoiceOth")>=0)
  {
   n = e.extractInteger("NumberInvoiceOth",0);
   for(int c=1;c<=n;c++)
   {
    pw.println("<TR><TD BORDERCOLOR=\"#000000\">");
    printContent(pw,number,index,e.extractAll("invoiceOthDesc"+c),
    e.extractAll("invoiceOthCurr"+c),
    Module7.formNumDelimiter(e.extractAll("invoiceOthAmt"+c)));
    pw.println("</TD></TR>");
    index+=1;
   }
  }

  //Total Balance
  pw.print("<TR><TD><TABLE BORDER=0 WIDTH=\"100%\">");
  pw.print("<TR><TD></TD></TR></TABLE></TD>");
  pw.print("<TD WIDTH=\""+DescWidth+"\" ALIGN=CENTER>");
  pw.print("<FONT FACE=\"sans-serif\"><B>Total Balance</B></FONT></TD>");
	
  //Total Balance Amount
  String ts[] = new String[number];
  for(int i=1;i<=number;i++)
  {
   place = determinePosition(e.extractAll("sumInvoiceCurr"+i));
   String b = new String("<TD><TABLE BORDER=0 WIDTH=\"100%\"><TR>"
    +"<TD ALIGN=LEFT><B><FONT FACE=\"sans-serif\">"
    +e.extractAll("sumInvoiceCurr"+i)
    +"</FONT></B></TD>"
    +"<TD ALIGN=RIGHT><B><FONT FACE=\"sans-serif\">"
    +Module7.formNumDelimiter(e.extractAll("sumInvoiceAmt"+i))
    +"</FONT></B></TD></TR></TABLE></TD>");
   ts[place-1] = b;
  }
  for(int j=0;j<number;j++)
   pw.println(ts[j]);
  pw.println("</TR>");
  pw.println("</TABLE><BR></BR>");
  
  //--- Remarks
  if(!e.extractAll("transInvoiceRemarks").equalsIgnoreCase("none"))
  {
   pw.println("<TABLE BORDER=0 WIDTH=\"75%\">");
   pw.println("<TR><TD WIDTH=\"20%\">");
   pw.println("Remarks :</TD>");
   pw.println("<TD WIDTH=\"40%\">"+e.extractAll("transInvoiceRemarks")+"</TD>");
   pw.println("<TD WIDTH=\"40%\"></TD></TR></TABLE>");
  }
  
  //--- Container No 
  pw.println("<TABLE BORDER=0 WIDTH=\"75%\">");
  int num = e.extractInteger("transContSize",0);
  pw.println("<TR>");
  pw.println("<TD WIDTH=\"20%\">No Container :</TD><TD WIDTH=\"40%\">");
  for(int i=1;i<=num;i++)
  {
   pw.print(e.extractString("transContNo"+i,null)); 
   if(i!=num) pw.print(" , ");
  }
  pw.println("</TD><TD WIDTH=\"40%\"></TD>");
  pw.println("</TR>");

  pw.println("</TABLE>");
  pw.println("</BODY></HTML>");

  pw.flush();
  pw.close();
  bw.close();
  fw.close();
  Runtime rt = Runtime.getRuntime();
  rt.exec("C:"+File.separator+"Program Files"+File.separator+
   "Internet Explorer"+File.separator+"iexplore "+finalname);
 } // printInvoice

 private void printDebit(Encap e) throws IOException
 {
  String filename = new String("DebitNote-"+refNo+"#"
    +currentDate+"#"+hashTime+".HTML");
  htmlFile = formFile(filename);
  if(htmlFile == null) throw new IOException(error.toString());
  FileWriter fw = new FileWriter(htmlFile);
  BufferedWriter bw = new BufferedWriter(fw);
  PrintWriter pw = new PrintWriter(bw);
  pw.print("<HTML><HEAD><TITLE>DEBIT NOTE of Ref No."+refNo+"</TITLE>");
  pw.print("<meta http-equiv=\"Content-Type\" content=\"text/html;");
  pw.println(" charset=iso-8859-1\"></HEAD>");
  pw.println("<BODY BGCOLOR=WHITE TEXT=BLACK>");
  pw.print("<P><CENTER><FONT FACE=\"Courier New, Courier, mono\" ");
  pw.println("size=\"+2\"><B><U>DEBIT NOTE</U></B></FONT></P>");
  pw.println("<BR></BR><BR></BR></P>");

  pw.print("<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=2 WIDTH=\"75%\">");
  pw.println("<TR>");
  pw.print("<TD WIDTH=\"10%\"><FONT FACE=\"sans-serif\"><B>TO</B></FONT>");
  pw.print("</TD><TD WIDTH=\"40%\"><FONT FACE=\"sans-serif\">");
  pw.print(e.extractAll("customerName")+"</FONT></TD>");
  pw.println("<TD WIDTH=\"50%\"></TD></TR>");
  pw.println("<TR>");
  pw.print("<TD WIDTH=\"10%\">");
  pw.print("<FONT FACE=\"sans-serif\">");
  pw.print("<B>Ref No.</B></FONT></TD>");
  pw.print("<TD WIDTH=\"40%\">");
  pw.print("<FONT FACE=\"sans-serif\">");
  pw.print(e.extractAll("transRefKey")+"</FONT></TD>");
  pw.println("<TD WIDTH=\"50%\"></TD></TR>");
  if(e.extractAll("transType").equalsIgnoreCase("IMP"))
  {
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"10%\"><FONT FACE=\"sans-serif\">");
   pw.print("<B>B/L No.</B></FONT></TD><TD WIDTH=\"40%\">");
   pw.print("<FONT FACE=\"sans-serif\">");
   pw.print(e.extractAll("impBLNo")+"</FONT></TD>");	
   pw.println("<TD WIDTH=\"50%\"></TD></TR>");
  }
  else
  {
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"10%\"><FONT FACE=\"sans-serif\">");
   pw.print("<B>S/I No.</B></FONT></TD><TD WIDTH=\"40%\">");
   pw.print("<FONT FACE=\"sans-serif\">");
   pw.print(e.extractAll("expSINo")+"</FONT></TD>");
   pw.println("<TD WIDTH=\"50%\"></TD></TR>");
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"10%\"><FONT FACE=\"sans-serif\">");
   pw.print("<B>Vessel Name:</B></FONT></TD><TD WIDTH=\"40%\">");
   pw.print("<FONT FACE=\"sans-serif\">");
   pw.print(e.extractAll("expVesselName")+"</FONT></TD>");
   pw.println("<TD WIDTH=\"50%\"></TD></TR>");
  }
  pw.println("</TABLE><BR></BR>");

  pw.print("<TABLE BORDER=1 CELLPADDING=1 CELLSPACING=2 WIDTH=\"75%\">");
  pw.println("<TR>");
  pw.print("<TH WIDTH=\"10%\">");
  pw.print("<FONT FACE=\"sans-serif\" SIZE=\"+1\"><B>");
  pw.print("No</B></FONT></TH>");

  int number = e.extractInteger("NumberSumDebitNote",0);
  String DescWidth = null;
  String OthWidth = null;
  if(number == 1)
  {
   DescWidth = new String("70%");
   OthWidth = new String("20%");
  }
  else if(number == 2)
  {
   DescWidth = new String("50%");
   OthWidth = new String("20%");
  }
  else if(number == 3)
  {
   DescWidth = new String("45%");
   OthWidth = new String("15%");
  }
  else if(number == 4)
  {
   DescWidth = new String("50%");
   OthWidth = new String("10%");
  }
  pw.print("<TH WIDTH=\""+DescWidth+"\"><FONT FACE=\"sans-serif\""+
   " SIZE=\"+1\"><B>");
  pw.println("Description</B></TH>");
  for(int i=0;i<number;i++)
  {
   pw.print("<TH WIDTH=\""+OthWidth+"\"><FONT FACE=\"sans-serif\""+
    " SIZE=\"+1\"><B>");
   pw.print("Amount</B></FONT></TH>");
  }
  int index = 1;
  boolean exportFlag = false;
  if(e.extractAll("transType").equalsIgnoreCase("EXP"))
   exportFlag = true;

  pw.println("<TR>");
  pw.print("<TD WIDTH=\"10%\" ALIGN=CENTER>");
  pw.print("<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>");
  pw.print(index+"</TD></TR></TABLE></TD>");
  pw.print("<TD><FONT FACE=\"sans-serif\">");
  pw.print("Total From Invoice");
  pw.print("</FONT></TD>");
 
  int place = 0;
  String js[] = new String[number];
  StringBuffer tmp = new StringBuffer(64);

  for(int i=1;i<=number;i++)
  {
   tmp.append("<TD><TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=LEFT>");
   tmp.append("<FONT FACE=\"sans-serif\">");
   if(e.extractAll("sumInvoiceCurr"+i)!=null)
   {
    place = determinePosition(e.extractAll("sumInvoiceCurr"+i));
    tmp.append(e.extractAll("sumInvoiceCurr"+i));
    tmp.append("</FONT></TD><TD ALIGN=RIGHT><FONT FACE=\"sans-serif\">");
    tmp.append(Module7.formNumDelimiter(e.extractAll("sumInvoiceAmt"+i)));
    tmp.append("</FONT></TD></TR></TABLE></TD>");
    js[place-1] = new String(tmp.toString());
   }
   else
   {
    tmp.append("</TD><TD></TD></TR></TABLE></TD>");
    for(int b=0;b<js.length;b++)
    {
     if((String)js[b] == null)
      js[b] = new String(tmp.toString());
    }
   }
   tmp.delete(0,tmp.length());
  }

  for(int j=0;j<js.length;j++)
   pw.print(js[j]);
  pw.println("</TR>");
  index+=1;

  // Next row
  if(!e.extractAll("claimableTotalLiftOnAmt").equalsIgnoreCase("0.00"))
  {
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"10%\" ALIGN=CENTER>"+index+"</TD>");
   pw.print("<TD WIDTH=\""+DescWidth+"\">");
   pw.print("<FONT FACE=\"sans-serif\">Total Lift On and Storage Charge");
   pw.print("</FONT></TD>");
   place = determinePosition(e.extractAll("claimableTotalLiftOnCurr"));
   for(int i=1;i<=number;i++)
   {
    pw.print("<TD><TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=LEFT>");
    if(i == place)
    {
     pw.print("<FONT FACE=\"sans-serif\">");
     pw.print(e.extractAll("claimableTotalLiftOnCurr")+
      "</FONT></TD><TD ALIGN=RIGHT>");
     pw.print("<FONT FACE=\"sans-serif\">");
     pw.print(Module7.formNumDelimiter(e.extractAll("claimableTotalLiftOnAmt"))+
      "</FONT></TD></TR></TABLE></TD>");
    }
    else
     pw.print("</TD><TD></TD></TR></TABLE></TD>");    
   }
   pw.println("</TR>");
   index+=1;
  }

  // Next row
  if(!e.extractAll("claimableTotalLiftOffAmt").equalsIgnoreCase("0.00"))
  {
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"10%\" ALIGN=CENTER>"+index+"</TD>");
   pw.print("<TD WIDTH=\""+DescWidth+"\">");
   pw.print("<FONT FACE=\"sans-serif\">Total Lift Off Charge");
   pw.print("</FONT></TD>");
   place = determinePosition(e.extractAll("claimableTotalLiftOffCurr"));
   for(int i=1;i<=number;i++)
   {
    pw.print("<TD><TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=LEFT>");
    if(i == place)
    {
     pw.print("<FONT FACE=\"sans-serif\">");
     pw.print(e.extractAll("claimableTotalLiftOffCurr")+
      "</FONT></TD><TD ALIGN=RIGHT>");
     pw.print("<FONT FACE=\"sans-serif\">");
     pw.print(Module7.formNumDelimiter(
      e.extractAll("claimableTotalLiftOffAmt"))+
      "</FONT></TD></TR></TABLE></TD>");
    }
    else
     pw.print("</TD><TD></TD></TR></TABLE></TD>");    
   }
   pw.println("</TR>");
   index+=1;
  }

  // Next row
  int n = 0;
  if(e.getPosition("NumberClaimableOther")>=0)
  {
   n = e.extractInteger("NumberClaimableOther",0);
   for(int c=1;c<=n;c++)
   {
    pw.println("<TR>");
    pw.print("<TD WIDTH=\"10%\" ALIGN=CENTER>"+index+"</TD>");
    pw.print("<TD WIDTH=\""+DescWidth+"\">");
    pw.print("<FONT FACE=\"sans-serif\">"+e.extractAll("claimableOthDesc"+c));
    pw.print("</FONT></TD>");
    place = determinePosition(e.extractAll("claimableOthCurr"+c));
    for(int i=1;i<=number;i++)
    {
     pw.print("<TD><TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=LEFT>");
     if(i == place)
     {
      pw.print("<FONT FACE=\"sans-serif\">");
      pw.print(e.extractAll("claimableOthCurr"+c)+
       "</FONT></TD><TD ALIGN=RIGHT>");
      pw.print("<FONT FACE=\"sans-serif\">");
      pw.print(Module7.formNumDelimiter(e.extractAll("claimableOthAmt"+c))+
       "</FONT></TD></TR></TABLE></TD>");
     }
     else
      pw.print("</TD><TD></TD></TR></TABLE></TD>");    
    }
    pw.println("</TR>");
    index+=1;
   }
  }
  
  //Subtotal -- if exist
  StringBuffer h = new StringBuffer(56);
  if(e.getPosition("NumberSubSum")>=0)
  {
   pw.print("<TR><TD><TABLE BORDER=0 WIDTH=\"100%\">");
   pw.print("<TR><TD></TD></TR></TABLE></TD>");
   pw.print("<TD WIDTH=\""+DescWidth+"\" ALIGN=CENTER>");
   pw.print("<FONT FACE=\"sans-serif\"><B>SUBTOTAL</B></FONT></TD>");

   String ps[] = new String[number];
   n = e.extractInteger("NumberSubSum",0);
   for(int c=1;c<=n;c++)
   {
    if(e.getPosition("subSumDebitNoteCurr"+c)>=0)
    {
     place = determinePosition(e.extractAll("subSumDebitNoteCurr"+c));
     h.append("<TD><TABLE BORDER=0 WIDTH=\"100%\"><TR>");
     h.append("<TD ALIGN=LEFT><B>"+e.extractAll("subSumDebitNoteCurr"+c));
     h.append("</B></TD><TD ALIGN=RIGHT><B>");
     h.append(Module7.formNumDelimiter(e.extractAll("subSumDebitNoteAmt"+c)));
     h.append("</B></TD></TR></TABLE></TD>");
     ps[place-1] = new String(h.toString());
     h.delete(0,h.length());
    }
   }
   for(int pin=0;pin<number;pin++)
    if(ps[pin] != null)
     pw.println(ps[pin]);
    else
     pw.println("<TD></TD>");
   pw.println("</TR>");
  }
  //Payment -- if exist
  if(e.getPosition("NumberPayment")>=0)
  {
   pw.print("<TR><TD><TABLE BORDER=0 WIDTH=\"100%\">");
   pw.print("<TR><TD></TD></TR></TABLE></TD>");
   pw.print("<TD WIDTH=\""+DescWidth+"\" ALIGN=CENTER>");
   pw.print("<FONT FACE=\"sans-serif\"><B>TOTAL ADVANCE</B></FONT></TD>");

   String hw[] = new String[number];
   n = e.extractInteger("NumberPayment",0);
   for(int c=1;c<=n;c++)
   {
    if(e.getPosition("transPayAmt"+c)>=0)
    {
     place = determinePosition(e.extractAll("transPayCurr"+c));
     h.append("<TD><TABLE BORDER=0 WIDTH=\"100%\"><TR>");
     h.append("<TD ALIGN=LEFT><B>"+e.extractAll("transPayCurr"+c));
     h.append("</B></TD><TD ALIGN=RIGHT><B>");
     h.append(Module7.formNumDelimiter(e.extractAll("transPayAmt"+c)));
     h.append("</B></TD></TR></TABLE></TD>");
     hw[place-1] = new String(h.toString());
     h.delete(0,h.length());
    }
   }
   for(int pin=0;pin<number;pin++)
    if(hw[pin] != null)
     pw.println(hw[pin]);
    else
     pw.println("<TD></TD>");
   pw.println("</TR>");

  }

  //Total
  pw.print("<TR><TD><TABLE BORDER=0 WIDTH=\"100%\">");
  pw.print("<TR><TD></TD></TR></TABLE></TD>");
  pw.print("<TD WIDTH=\""+DescWidth+"\" ALIGN=CENTER>");
  pw.print("<FONT FACE=\"sans-serif\"><B>TOTAL</B></FONT></TD>");
	
  //Amount Total
  String ts[] = new String[number];
  StringBuffer b = new StringBuffer(56);
  for(int i=1;i<=number;i++)
  {
   place = determinePosition(e.extractAll("sumDebitNoteCurr"+i));
   b.append("<TD><TABLE BORDER=0 WIDTH=\"100%\"><TR>");
   b.append("<TD ALIGN=LEFT><B>"+e.extractAll("sumDebitNoteCurr"+i));
   b.append("</B></TD><TD ALIGN=RIGHT><B>");
   b.append(Module7.formNumDelimiter(e.extractAll("sumDebitNoteAmt"+i)));
   b.append("</B></TD></TR></TABLE></TD>");
   ts[place-1] = new String(b.toString());
   b.delete(0,b.length());
  }
  for(int j=0;j<number;j++)
   if(ts[j] != null)
    pw.println(ts[j]);
   else
    pw.println("<TD></TD>");
  pw.println("</TR>");
  pw.println("</TABLE>");

  //--- Translation
  pw.println("<P><TABLE BORDER=0 WIDTH=\"75%\">");
  pw.println("<TR><TD WIDTH=\"20%\">");
  pw.println("<B>Terbilang :</B></TD>");
  pw.println("<TD WIDTH=\"40%\" VALIGN=MIDDLE ALIGN=CENTER>"); 
  int numTrans = e.extractInteger("NumberTranslate",0);
  for(int i=1;i<=numTrans;i++)
  {
   pw.print(" # "+e.extractAll("sumDebitNote"+i));
   if(numTrans > 1) pw.print("<BR></BR>");
  }
  pw.println("</TD>");
  pw.println("<TD WIDTH=\"40%\"></TD></TR></TABLE></P>");
  pw.println("<BR></BR>");

  //--- Remarks
  if(!e.extractAll("transDebitNoteRemarks").equalsIgnoreCase("none"))
  {
   pw.println("<TABLE BORDER=0 WIDTH=\"75%\">");
   pw.println("<TR><TD WIDTH=\"20%\">");
   pw.println("Remarks :</TD>");
   pw.println("<TD WIDTH=\"40%\">"+e.extractAll("transDebitNoteRemarks")
     +"</TD>");
   pw.println("<TD WIDTH=\"40%\"></TD></TR></TABLE>");
   pw.println("<BR></BR>");
  }
  pw.print("<CENTER>"+formPaymentAddress()+"</CENTER>");
  pw.println("</BODY></HTML>");
  pw.flush();
  pw.close();
  bw.close();
  fw.close();
  Runtime rt = Runtime.getRuntime();
  rt.exec("C:"+File.separator+"Program Files"+File.separator+
   "Internet Explorer"+File.separator+"iexplore "+finalname);
 } // end of printDebit

 private int determinePosition(String currency)
 {
  if(currency.equalsIgnoreCase("USD"))
   return 1;
  return 2;
 }

 private void printARreceipt(Encap e) throws IOException
 {
  String filename = new String("ARreceipt-"+refNo+"#"
    +currentDate+"#"+hashTime+".HTML");
  htmlFile = formFile(filename);
  if(htmlFile == null) throw new IOException(error.toString());
  FileWriter fw = new FileWriter(htmlFile);
  BufferedWriter bw = new BufferedWriter(fw);
  PrintWriter pw = new PrintWriter(bw);
  pw.println("<HTML><HEAD><TITLE>Receipt for Receiving Payment [A/R] "+
   "for Ref No."+refNo+"</TITLE>");
  pw.print("<meta http-equiv=\"Content-Type\" content=\"text/html;");
  pw.println(" charset=iso-8859-1\"></HEAD>");
  pw.println("<BODY BGCOLOR=WHITE TEXT=BLACK><BR></BR><BR></BR>");
  pw.print("<P><CENTER><FONT FACE=\"Courier New, Courier, mono\" ");
  pw.print("size=\"+2\"><B><U>OFFICIAL RECEIPT</U></B></FONT>");
  pw.println("<BR></BR></P><CENTER>");
  pw.print("<BR></BR><TABLE BORDER=0 CELLSPACING=3 CELLPADDING=1 ");
  pw.println("WIDTH=\"75%\">");
  pw.println("<TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Ref No.</B></FONT></TD>");
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.println(e.extractAll("transRefKey")+"</TD></TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Received Date</B></FONT></TD>"); 
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.println(e.extractAll("transPayDate")+"</TD></TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Received From</B></FONT></TD>");
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.println(e.extractAll("customerName")+"</TD></TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Received Amount</B></FONT></TD>");
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.println(e.extractAll("transPayAmt")+"</TD></TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Received Method</B></FONT></TD>");
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.print(e.extractAll("transPayMethod"));
  if(!e.extractAll("transPayMethod").equalsIgnoreCase("CASH"))
  {
   pw.print("&nbsp;"+e.extractAll("transBankOur"));
   if(!e.extractAll("transBankTheir").equalsIgnoreCase("none"))
    pw.print("-"+e.extractAll("transBankTheir"));
   if(!e.extractAll("transBankAcct").equalsIgnoreCase("none"))
    pw.print("&nbsp;No.Account: "+e.extractAll("transBankAcct"));
   if(!e.extractAll("transBankDocNo").equalsIgnoreCase("none"))
    pw.print("&nbsp;No.Cheque/Giro: "+e.extractAll("transBankDocNo"));
  }
  pw.println("</FONT></TD></TR>");
  if(e.getPosition("description")>=0)
  {
   pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
   pw.println("<B>Description</B></FONT></TD>");
   pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
   pw.println(e.extractAll("description")+"</FONT></TD></TR>");
  }
  pw.println("</TABLE></CENTER></BODY></HTML>");
  pw.flush();
  pw.close();
  bw.close();
  fw.close();
  Runtime rt = Runtime.getRuntime();
  rt.exec("C:"+File.separator+"Program Files"+File.separator+
   "Internet Explorer"+File.separator+"iexplore "+finalname);
 }

 private void printAPreceipt(Encap e) throws IOException
 {
  String filename = new String("APreceipt-"+refNo+"#"
    +currentDate+"#"+hashTime+".HTML");
  htmlFile = formFile(filename);
  if(htmlFile == null) throw new IOException(error.toString());
  FileWriter fw = new FileWriter(htmlFile);
  BufferedWriter bw = new BufferedWriter(fw);
  PrintWriter pw = new PrintWriter(bw);
  pw.println("<HTML><HEAD><TITLE>Receipt for Making Payment [A/P] "+
   "for Ref No."+refNo+"</TITLE>");
  pw.print("<meta http-equiv=\"Content-Type\" content=\"text/html;");
  pw.println(" charset=iso-8859-1\"></HEAD>");
  pw.println("<BODY BGCOLOR=WHITE TEXT=BLACK><BR></BR><BR></BR>");
  pw.print("<P><CENTER><FONT FACE=\"Courier New, Courier, mono\" ");
  pw.print("size=\"+2\"><B><U>OFFICIAL RECEIPT</U></B></FONT>");
  pw.println("<BR></BR></P><CENTER>");
  pw.print("<BR></BR><TABLE BORDER=0 CELLSPACING=3 CELLPADDING=1 ");
  pw.println("WIDTH=\"75%\">");
  pw.println("<TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Ref No.</B></FONT></TD>");
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.println(e.extractAll("transRefKey")+"</TD></TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Pay Date</B></FONT></TD>"); 
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.println(e.extractAll("transPayDate")+"</TD></TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Pay To</B></FONT></TD>");
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.println(e.extractAll("truckingName")+"</FONT></TD></TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Pay Amount</B></FONT></TD>");
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.println(e.extractAll("transPayAmt")+"</FONT></TD></TR>");
  pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
  pw.println("<B>Pay Method</B></FONT></TD>");
  pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
  pw.print(e.extractAll("transPayMethod"));
  if(!e.extractAll("transPayMethod").equalsIgnoreCase("CASH"))
  {
   pw.print("&nbsp;"+e.extractAll("transBankOur"));
   if(!e.extractAll("transBankTheir").equalsIgnoreCase("none"))
    pw.print("-"+e.extractAll("transBankTheir"));
   if(!e.extractAll("transBankAcct").equalsIgnoreCase("none"))
    pw.print("&nbsp;No.Account: "+e.extractAll("transBankAcct"));
   if(!e.extractAll("transBankDocNo").equalsIgnoreCase("none"))
    pw.print("&nbsp;No.Cheque/Giro: "+e.extractAll("transBankDocNo"));
  }
  pw.println("</FONT></TD></TR>");
  if(e.getPosition("description")>=0)
  {
   pw.print("<TD WIDTH=\"30%\"><FONT FACE=\"sans-serif\">");
   pw.println("<B>Description</B></FONT></TD>");
   pw.print("<TD WIDTH=\"70%\"><FONT FACE=\"sans-serif\">");
   pw.println(e.extractAll("description")+"</FONT></TD></TR>");
  }
  pw.println("</TABLE></CENTER></BODY></HTML>");
  pw.flush();
  pw.close();
  bw.close();
  fw.close();
  Runtime rt = Runtime.getRuntime();
  rt.exec("C:"+File.separator+"Program Files"+
   File.separator+"Internet Explorer"+File.separator+"iexplore "+finalname);
 }

 private String formPaymentAddress()
 {
  StringBuffer msg = new StringBuffer(128);
  msg.append("<TABLE BORDER=0 WIDTH=\"75%\">");
  msg.append("<TR><TD WIDTH=\"10%\">");
  msg.append("</TD><TD ALIGN=LEFT WIDTH=\"60%\">"); 
  msg.append("Payment with Cash or Transfer to Account :"+
   "<BR>PT. Lukman Kharisma Buana"+
   "<BR>Bank Buana Indonesia"+
   "<BR>IDR A/C : 001.000.1100");
  msg.append("</TD><TD WIDTH=\"10%\"></TD></TR>");
  msg.append("<TR><TD WIDTH=\"20%\"></TD>");
  msg.append("<TD WIDTH=\"60%\"></TD><TD WIDTH=\"30%\" ALIGN=RIGHT>");
  msg.append("JAKARTA, <FONT SIZE=-1><BR>"+currentDate);
  msg.append("</FONT><BR></BR><BR></BR>");
  msg.append("FINANCE ACCT");
  msg.append("</TD></TR></TABLE>");
  return msg.toString();
 }

 public File formFile(String name) throws IOException
 {
  String tmpDir = null;
  if(action == Module7.PRINTRECVP)
   tmpDir = new String("C:"+File.separator+"LKBrecords"+
    File.separator+"ARreceipt"+File.separator);
  else if(action == Module7.PRINTDEBTP)
   tmpDir = new String("C:"+File.separator+"LKBrecords"+
    File.separator+"APreceipt"+File.separator);
  else if(action == Module7.PRINTDEBTN)
   tmpDir = new String("C:"+File.separator+"LKBrecords"+
    File.separator+"DebtNote"+File.separator);
  else if(action == Module7.PRINTINV)
   tmpDir = new String("C:"+File.separator+"LKBrecords"+
    File.separator+"Invoice"+File.separator);
  File dirName = new File(tmpDir);

  if(!dirName.exists()) dirName.mkdirs();
  int last = 0;
  int lpos = 0;
  File tmp = new File(dirName,name);
  StringBuffer str = new StringBuffer(64); 
  str.append(name);
  DateUtil du = new DateUtil();
  do
  {
   if(tmp.exists())
   {
    hashTime = du.getCurrentTime().hashCode();
    lpos = str.toString().lastIndexOf('#');
    str.delete(lpos+1,str.length());
    str.append(hashTime+".HTML");
    if(tmp.renameTo(new File(tmpDir,str.toString())))
     finalname = tmpDir+str.toString();
   }
   else
   {
    tmp.createNewFile();
    finalname = tmpDir+str.toString();
    break;
   }
  }while(tmp.exists()); 
  du = null;
  return tmp;
 }
}
