import java.sql.*;
import javax.sql.*;
import java.util.Vector;
import java.util.Calendar;
import java.util.StringTokenizer;
import java.io.*;

public class ProcessPrintProfit
{
 private StringBuffer error = new StringBuffer(128);
 private boolean exportFlag = false;
 private int refNo = 0;
 private String currentDate = null;
 private String finalname = null;
 private int action = 0;
 private String d1 = null;
 private String d2 = null;
 private String customerName = null;
 private String datum = null;
 private File htmlFile = null;
 private int hashTime = 0;
 private Vector storeVol;
 private Vector transVol;
 private  MultipleCurrency mc1 = new MultipleCurrency(); // AR and AP
 private  MultipleCurrency mc2 = new MultipleCurrency(); // Profit

 public ProcessPrintProfit(int act,String cond)
 {
  if(act!=Module7.PRPF && act!= Module7.PRSPF)
   error.append("No service available for the command : "+act+"\n");
  if(cond == null)
   error.append("Received null input\n");
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  action = act;
  System.out.println("-- enter ProcessPrintProfit");

  DateUtil du = new DateUtil();
  currentDate = du.formIntlDate();
  hashTime = du.getCurrentTime().hashCode();
  du = null;
  Vector master = null;
  DBConnect db = new DBConnect();
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make database connection to LKB");
   master = fetch(cond,db); 
   if(master!=null && master.size()>0)
    printAll(cond,master);
  }
  catch(Exception ex)
  {
   error.append(ex.getMessage()+"\n");
   ex.printStackTrace(System.out);
  }
  finally
  {
   db.close();
  }
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   error.delete(0,error.length());
  }
 } // end of ProcessPrintProfit's constructor

 private Vector fetch(String cond,DBConnect db) throws SQLException
 {
  int index = 0;
  Encap e = null;
  Encap e2= null;
  Vector tmp = null;
  Vector v2 = null;
  StringBuffer q = new StringBuffer(56);
  StringBuffer volume = new StringBuffer(32);
  if(action == Module7.PRPF)
  {
   d1 = null;
   d2 = null;
   StringTokenizer cut = new StringTokenizer(cond,",");
   while(cut.hasMoreElements())
   {
    if(index == 0) d1 = Module7.formDate(cut.nextToken());
    else d2 = Module7.formDate(cut.nextToken());
    index++;
   }
   index = 0;
   q.append("LEFT JOIN customer ON (customer.customerKey=");
   q.append("transRecord.transCustKey) ");
   q.append("LEFT JOIN truckingCompany ON (truckingCompany.");
   q.append("truckingCompanyKey=transRecord.transTrucking) ");
   q.append("WHERE transDate >=\""+d1+"\" AND transDate <=\""+d2+"\";"); 
   tmp = db.QueryMulti("transRecord","*",q.toString());
   datum = new String(d1+"-TO-"+d2);
  }
  else
  {
   q.append("LEFT JOIN customer ON (customer.customerKey=");
   q.append("transRecord.transCustKey) ");
   q.append("LEFT JOIN truckingCompany ON (truckingCompany.");
   q.append("truckingCompanyKey=transRecord.transTrucking) ");
   q.append("WHERE transDate=\""+Module7.formDate(cond)+"\";"); 
   tmp = db.QueryMulti("transRecord","*",q.toString());
   datum = new String(Module7.formDate(cond));
  }
  if(tmp == null || tmp.size()<1)
  {
   error.append("No record found to be print\n");
   return null;
  }
  int size = tmp.size(); // size of the query
  int refKey = 0;
  storeVol = new Vector(size);
  Vector t2 = new Vector(size);
  MultipleCurrency mc = new MultipleCurrency();
  MultipleCurrency mcp = new MultipleCurrency();
  mc1.clearVariable();
  mc2.clearVariable();

  System.out.println("Enter for loop : "+size);
  for(int i=0;i<size;i++)
  {
   e = (Encap)((Encap)tmp.get(i)).clone();
   refKey = e.extractInteger("transRefKey",0);
   System.out.println("transKey: "+refKey);
   v2 = db.QueryMulti("transVol","*","WHERE transVolRefKey="+
   e.extractAll("transRefKey")+";");
   if(v2!= null)
   {
    transVol = new Vector(v2.size());
    while(!v2.isEmpty())
    {
     e2 = (Encap)v2.remove(0);
     volume.append(e2.extractAll("transVolVolume")+"x"+
      e2.extractAll("transVolStowage"));
     transVol.add(new String(e2.extractAll("transVolVolume")+
       "x"+e2.extractAll("transVolStowage")));
     if(!v2.isEmpty())
      volume.append(",");
     e2.clear();
    }
    e.setNameVal("transVolVolume",volume.toString());
    storeVol.add(transVol.clone());
   }
   e2 = db.QuerySingle("costRecord","*","WHERE costFromRefKey="+refKey+";");
   if(e2!=null)
   {
    mc.sumAP(e2.extractAll("costTotalOpCurr"),e2.extractAll("costTotalOp"));
    mc.sumAP(e2.extractAll("costTruckingCurr"),e2.extractAll("costTrucking"));
    mc.sumAP(e2.extractAll("costCommissionCurr"),
    e2.extractAll("costCommission"));
    System.out.print("cost: "+e2.extractAll("costTotalOp")+"-");
    System.out.print(e.extractAll("costTrucking")+"-");
    System.out.println(e.extractAll("costComission"));
    e2.clear();
   }
	 else System.out.println("No costRecord: "+refKey);
   t2 = db.QueryMulti("otherCost","*","WHERE costOthRefKey="+refKey+";");
   if(t2!=null)
   {
    while(!t2.isEmpty())
    {
     e2 = (Encap)t2.remove(0);
     mc.sumAP(e2.extractAll("costOthCurr"),e2.extractAll("costOthAmt"));
     System.out.println("costOther: "+e2.extractAll("costOthAmt"));
     e2.clear();
    }
   }
   index = 0;
	 System.out.println("Go for cost");
   for(int p=0;p<4;p++)
   {
    if(mc.checkAP(p))
    {
     index+=1;
     mcp.sumAP(mc.getCurr(p),mc.getSumAP(p).toString());
     e.setNameVal("TotalCostCurr"+index,mc.getCurr(p));
     e.setNameVal("TotalCostAmount"+index,mc.getSumAP(p));
     mc2.sumAP(mc.getCurr(p),mc.getSumAP(p).toString());
    }
   }
   e.setNameVal("TotalCostNumber",index);
   mc.clearVariable();

   e2 = db.QuerySingle("invoiceRecord","*","WHERE invoiceRefKey="+refKey+";");
   if(e2!=null)
   {
    mc.sumAR(e2.extractAll("invoiceSellCurr"),e2.extractAll("invoiceSellAmt"));
    mc.sumAR(e2.extractAll("invoiceHandleCurr"),
    e2.extractAll("invoiceHandleAmt"));
    e2.clear();
   }

   t2 = db.QueryMulti("invoiceOtherCharges","*",
   "WHERE invoiceOthRefKey="+refKey+";");
   if(t2!=null)
   {
    while(!t2.isEmpty())
    {
     e2 = (Encap)t2.remove(0);
     mc.sumAR(e2.extractAll("invoiceOthCurr"),e2.extractAll("invoiceOthAmt"));
     e2.clear();
    }
   }
   index = 0;
   for(int j=0;j<4;j++)
   {
    if(mc.checkAR(j))
    {
     index+=1;
     mcp.sumAR(mc.getCurr(j),mc.getSumAR(j).toString());
     e.setNameVal("TotalInvoiceCurr"+index,mc.getCurr(j));
     e.setNameVal("TotalInvoiceAmt"+index,mc.getSumAR(j));
     mc1.sumAR(mc.getCurr(j),mc.getSumAR(j).toString());
    }
   }
   e.setNameVal("TotalInvoiceNumber",index);
   mc.clearVariable();

   e2 = db.QuerySingle("claimableCharges","*",
   "WHERE claimableRefKey="+refKey+";");
   if(e2!=null)
   {
    mc.sumAR(e2.extractAll("claimableTotalLiftOnCurr"),
    e2.extractAll("claimableTotalLiftOnAmt"));
    mc.sumAR(e2.extractAll("claimableTotalLiftOffCurr"),
    e2.extractAll("claimableTotalLiftOffAmt"));
    e2.clear();
   }
   t2 = db.QueryMulti("claimableOtherCharges","*",
   "WHERE claimableOthRefKey="+refKey+";");
   if(t2!=null)
   {
    while(!t2.isEmpty())
    {
     e2 = (Encap)t2.remove(0);
     mc.sumAR(e2.extractAll("claimableOthCurr"),
     e2.extractAll("claimableOthAmt"));
     e2.clear();
    }
   }
   index = 0;
   for(int b=0;b<4;b++)
   {
    if(mc.checkAR(b))
    {
     index+=1;
     mcp.sumAR(mc.getCurr(b),mc.getSumAR(b).toString());
     e.setNameVal("TotalClaimableCurr"+index,mc.getCurr(b));
     e.setNameVal("TotalClaimableAmt"+index,mc.getSumAR(b));
     mc1.sumAP(mc.getCurr(b),mc.getSumAR(b).toString());
    }
   }
   e.setNameVal("TotalClaimableNumber",index);
   mc.clearVariable();
   index = 0; 
   for(int c=0;c<4;c++)
   {
    mcp.subAR(mcp.getCurr(c),mcp.getSumAP(c).toString());
    if(mcp.checkAR(c))
    {
     index+=1;
     e.setNameVal("TotalProfitCurr"+index,mcp.getCurr(c));
     e.setNameVal("TotalProfitAmt"+index,mcp.getSumAR(c).toString());
		 mc2.sumAR(mcp.getCurr(c),mcp.getSumAR(c).toString());
    }
   }
   e.setNameVal("TotalProfitNumber",index);
   mcp.clearVariable();

   transVol.removeAllElements();
   tmp.setElementAt(e.clone(),i);
   volume.delete(0,volume.length());
   e.clear();
  }
  return (Vector)tmp.clone();
 }

 private void printAll(String c,Vector v) throws IOException
 {
  String filename;
  filename = new String("Report-"+datum+
    "#"+currentDate+"#"+hashTime+".HTML");
  htmlFile = formFile(filename);	
  if(htmlFile == null)throw new IOException(error.toString());
  FileWriter fw = new FileWriter(htmlFile);
  BufferedWriter bw = new BufferedWriter(fw);
  PrintWriter pw = new PrintWriter(bw);

  MultipleCurrency mc = new MultipleCurrency();
  pw.print("<HTML><HEAD><TITLE>Profit Report</TITLE>");
  pw.print("<meta http-equiv=\"Content-Type\" content=\"text/html;");
  pw.println(" charset=iso-8859-1\"></HEAD>");
  pw.println("<BODY BGCOLOR=WHITE TEXT=BLACK>");
  pw.print("<P><CENTER><FONT FACE=\"Courier New, Courier, mono\" ");
  pw.println("size=\"+1\">");
  if(action == Module7.PRPF)
  {
   pw.print("<B><U>Printed on "+currentDate);
   pw.println(" for "+Module7.formNDate(d1)+" to "+
	 Module7.formNDate(d2)+"</U></B></FONT></P>");
  }
  else
  {
   pw.print("<B><U>Printed on "+currentDate);
   pw.println(" for "+Module7.formNDate(datum)+"</U></B></FONT></P>");
  }
  pw.println("<BR></BR><BR></BR>");
  pw.print("<TABLE BORDER=1 CELLPADDING=1 CELLSPACING=2 WIDTH=\"90%\">");
  pw.println("<TR>");
	
  // write the header

  pw.print("<TH WIDTH=\"5%\"><FONT SIZE=-1>Ref No</FONT></TH>");
  pw.print("<TH WIDTH=\"5%\"><FONT SIZE=-1>Type</FONT></TH>");
  pw.print("<TH WIDTH=\"10%\"><FONT SIZE=-1>Customer</FONT></TH>");
  pw.print("<TH WIDTH=\"10%\"><FONT SIZE=-1>Trucking Name</FONT></TH>");
  pw.print("<TH WIDTH=\"10%\"><FONT SIZE=-1>Volume Stowage</FONT></TH>");
  pw.print("<TH WIDTH=\"15%\"><FONT SIZE=-1>Total Cost</FONT></TH>");
  pw.print("<TH WIDTH=\"15%\"><FONT SIZE=-1>Total Claimable</FONT></TH>");
  pw.print("<TH WIDTH=\"15%\"><FONT SIZE=-1>Total Invoice</FONT></TH>");
  pw.print("<TH WIDTH=\"15%\"><FONT SIZE=-1>Total Profit</FONT></TH>");

  pw.println("</TR>"); 
  int size = v.size();
  for(int i=0;i<size;i++)
   nextPrint(i,size,pw,(Encap)((Encap)v.get(i)).clone());
  pw.println("<TR>");
  pw.println("<TD WIDTH=\"5%\"><FONT SIZE=-1></FONT></TD>");
  pw.println("<TD WIDTH=\"5%\"><FONT SIZE=-1></FONT></TD>");
  pw.println("<TD WIDTH=\"10%\"><FONT SIZE=-1></FONT></TD>");
  pw.println("<TD WIDTH=\"10%\"><FONT SIZE=-1></FONT></TD>");
  pw.println("<TD WIDTH=\"10%\"><FONT SIZE=-1></FONT></TD>");

  StringBuffer p1 = new StringBuffer(16); // mc2 AP = Cost
  StringBuffer p2 = new StringBuffer(16); // mc1 AP = Claimable
  StringBuffer p3 = new StringBuffer(16); // mc1 AR = Invoice
  StringBuffer p4 = new StringBuffer(16); // mc2 AR = Profit
  for(int x=0;x<4;x++)
  {
   if(mc1.checkAR(x))
    p3.append(mc1.getCurr(x)+" "+
    Module7.formNumDelimiter(mc1.getSumAR(x).toString())+" ");
   if(mc1.checkAP(x))
    p2.append(mc1.getCurr(x)+" "+
    Module7.formNumDelimiter(mc1.getSumAP(x).toString())+" ");
   if(mc2.checkAR(x))
    p4.append(mc1.getCurr(x)+" "+
    Module7.formNumDelimiter(mc2.getSumAR(x).toString())+" ");
   if(mc2.checkAP(x))
    p1.append(mc1.getCurr(x)+" "+
    Module7.formNumDelimiter(mc2.getSumAP(x).toString())+" ");
  }
  pw.println("<TD WIDTH=\"15%\" ALIGN=CENTER><FONT SIZE=-1><B>"
  +p1.toString()+"</B></FONT></TD>");
  pw.println("<TD WIDTH=\"15%\" ALIGN=CENTER><FONT SIZE=-1><B>"
  +p2.toString()+"</B></FONT></TD>");
  pw.println("<TD WIDTH=\"15%\" ALIGN=CENTER><FONT SIZE=-1><B>"
  +p3.toString()+"</B></FONT></TD>");
  pw.println("<TD WIDTH=\"15%\" ALIGN=CENTER><FONT SIZE=-1><B>"
  +p4.toString()+"</B></FONT></TD>");

  pw.println("</TR>");
  pw.println("</TABLE></P>");
  pw.println("</BODY></HTML>");

  pw.flush();
  pw.close();
  bw.close();
  fw.close();
  Runtime rt = Runtime.getRuntime();
  rt.exec("C:"+File.separator+"Program Files"+File.separator+
   "Internet Explorer"+File.separator+"iexplore "+finalname);

  p1.delete(0,p1.length());
  p2.delete(0,p2.length());
  p3.delete(0,p3.length());
  p4.delete(0,p4.length());
 } // end of printAll's method

 private void nextPrint(int seq,int size,PrintWriter pw,Encap e)
 {
  pw.println("<TR>");
  pw.println("<TD WIDTH=\"5%\" ALIGN=CENTER><FONT SIZE=-1>"+
   e.extractAll("transRefKey")+"</FONT></TD>");
  pw.println("<TD WIDTH=\"5%\" ALIGN=CENTER><FONT SIZE=-1>"+
   e.extractAll("transType")+"</FONT></TD>");
  pw.println("<TD WIDTH=\"10%\" ALIGN=CENTER><FONT SIZE=-1>"+
   e.extractAll("customerName")+"</FONT></TD>");
  pw.println("<TD WIDTH=\"10%\" ALIGN=CENTER><FONT SIZE=-1>"+
   e.extractAll("truckingName")+"</FONT></TD>");
  transVol = (Vector)storeVol.remove(0);
  pw.print("<TD WIDTH=\"10%\"><FONT SIZE=-1><FONT SIZE=-1>");
  while(!transVol.isEmpty())
  {
   pw.print(transVol.remove(0));
   if(!transVol.isEmpty()) pw.print("<BR>");
  }
  pw.println("</FONT></TD>");

  pw.print("<TD WIDTH=\"15%\" ALIGN=CENTER><FONT SIZE=-1>");
  int number=e.extractInteger("TotalCostNumber",0);
  for(int i=1;i<=number;i++)
   pw.print(e.extractAll("TotalCostCurr"+i)+" "+
   Module7.formNumDelimiter(e.extractAll("TotalCostAmount"+i))+" ");
  pw.println("</FONT></TD>");

  pw.print("<TD WIDTH=\"15%\" ALIGN=CENTER><FONT SIZE=-1>");
	number=e.extractInteger("TotalClaimableNumber",0); 
  for(int i=1;i<=number;i++)
   pw.print(e.extractAll("TotalClaimableCurr"+i)+" "+
   Module7.formNumDelimiter(e.extractAll("TotalClaimableAmt"+i))+" ");
  pw.println("</FONT></TD>");

  pw.print("<TD WIDTH=\"15%\" ALIGN=CENTER><FONT SIZE=-1>");
  number=e.extractInteger("TotalInvoiceNumber",0);
  for(int i=1;i<=number;i++)
   pw.print(e.extractAll("TotalInvoiceCurr"+i)+" "+
   Module7.formNumDelimiter(e.extractAll("TotalInvoiceAmt"+i))+" ");
  pw.println("</FONT></TD>");

  pw.print("<TD WIDTH=\"15%\" ALIGN=CENTER><FONT SIZE=-1>");
  number=e.extractInteger("TotalProfitNumber",0);
  for(int i=1;i<=number;i++)
   pw.print(e.extractAll("TotalProfitCurr"+i)+" "+
   Module7.formNumDelimiter(e.extractAll("TotalProfitAmt"+i))+" ");
  pw.println("</FONT></TD>");

  pw.println("</TR>");
 } // end of nextPrint's method 

 public File formFile(String name) throws IOException
 {
  String tmpDir = null;
  tmpDir = new String("C:"+File.separator+"LKBrecords"+
  File.separator+"Report-Profit"+File.separator);
  File dirName = new File(tmpDir);

  if(!dirName.exists()) dirName.mkdirs();
  int last = 0;
  int lpos = 0;
  File tmp = new File(dirName,name);
  StringBuffer str = new StringBuffer(64); 
  str.append(name);
  DateUtil du = new DateUtil();
  do
  {
   if(tmp.exists())
   {
    hashTime = du.getCurrentTime().hashCode();
    lpos = str.toString().lastIndexOf('#');
    str.delete(lpos+1,str.length());
    str.append(hashTime+".HTML");
    if(tmp.renameTo(new File(tmpDir,str.toString())))
     finalname = tmpDir+str.toString();
   }
   else
   {
    tmp.createNewFile();
    finalname = tmpDir+str.toString();
    break;
   }
  }while(tmp.exists()); 
  du = null;
  return tmp;
 }
}
