import java.sql.*;
import javax.sql.*;
import java.util.Vector;
import java.util.Calendar;
import java.util.StringTokenizer;
import java.io.*;

public class ProcessPrintReport
{
 private StringBuffer error = new StringBuffer(128);
 private boolean exportFlag = false;
 private int refNo = 0;
 private String currentDate = null;
 private String finalname = null;
 private int action = 0;
 private String d1 = null;
 private String d2 = null;
 private String customerName = null;
 private String datum = null;
 private File htmlFile = null;
 private int hashTime = 0;
 private Vector storeVol;
 private Vector transVol;

 public ProcessPrintReport(int act,String cond)
 {
  if(act!=Module7.PRSD && act!= Module7.PRCN && act!=Module7.PRAD)
   error.append("No service available for the command : "+act+"\n");
  if(cond == null)
   error.append("Received null input\n");
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  action = act;
  System.out.println("-- enter ProcessPrintReport");

  DateUtil du = new DateUtil();
  currentDate = du.formIntlDate();
  hashTime = du.getCurrentTime().hashCode();
  du = null;
  Vector master = null;
  DBConnect db = new DBConnect();
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make database connection to LKB");
   master = fetch(cond,db); 
   if(master!=null && master.size()>0)
    printAll(customerName,master);
  }
  catch(Exception ex)
  {
   error.append(ex.getMessage()+"\n");
   ex.printStackTrace(System.out);
  }
  finally
  {
   db.close();
  }
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   error.delete(0,error.length());
  }
 } // end of ProcessPrintReport's constructor

 private void phraseDate(String d)
 {
  int index = 0;
  d1 = null;
  d2 = null;
  StringTokenizer cut = new StringTokenizer(d,",");
  while(cut.hasMoreElements())
  {
   if(index == 0) d1 = Module7.formDate(cut.nextToken());
   else d2 = Module7.formDate(cut.nextToken());
   index++;
  }
 }

 private Vector fetch(String cond,DBConnect db) throws SQLException
 {
  StringBuffer q = new StringBuffer(56);
  Encap e = null;
  Encap e2= null;
  Vector tmp = null;
  Vector v2 = null;
  StringBuffer volume = new StringBuffer(32);
  if(action == Module7.PRSD || action == Module7.PRAD)
  {
   phraseDate(cond);
   if(action == Module7.PRSD)
   {
    q.append("LEFT JOIN transRecord ON (transRecord.transRefKey=");
    q.append("expInfoRecord.expFromRefKey) ");
   }
   else
   {
    q.append("LEFT JOIN transRecord ON (transRecord.transRefKey=");
    q.append("impInfoRecord.impFromRefKey) ");
   }
   q.append("LEFT JOIN customer ON (customer.customerKey=");
   q.append("transRecord.transCustKey) ");
   q.append("LEFT JOIN truckingCompany ON (truckingCompany.");
   q.append("truckingCompanyKey=transRecord.transTrucking) ");
   q.append("LEFT JOIN accountReceivable ON (accountReceivable.");
   q.append("acctRecFromRefKey=transRecord.transRefKey) ");
   q.append("LEFT JOIN accountPayable ON (accountPayable.");
   q.append("acctPayToRefKey=transRecord.transRefKey) ");
   if(action == Module7.PRSD)
   {
    q.append("WHERE expStuffingDate >=\""+d1+"\" AND ");
    q.append("expStuffingDate <=\""+d2+"\";"); 
    tmp = db.QueryMulti("expInfoRecord","*",q.toString());
   }
   else
   {
    q.append("WHERE impArrival >=\""+d1+"\" AND ");
    q.append("impArrival <=\""+d2+"\";");
    tmp = db.QueryMulti("impInfoRecord","*",q.toString());
   }
   datum = new String(d1+"-TO-"+d2);
  }
  else
  {
   int p = cond.indexOf("+");
   if(p<=0)
   {
    Module7.errorDisplay("Not found the separator \"+\"","ERROR");
    return null;
   }
   
   customerName = new String(cond.substring(0,p));
   phraseDate(cond.substring(p+1,cond.length()));
   q.append("LEFT JOIN transRecord ON (customer.customerKey=");
   q.append("transRecord.transCustKey) ");
   q.append("LEFT JOIN truckingCompany ON (truckingCompany.");
   q.append("truckingCompanyKey=transRecord.transTrucking) ");
   q.append("LEFT JOIN accountReceivable ON (accountReceivable.");
   q.append("acctRecFromRefKey=transRecord.transRefKey) ");
   q.append("LEFT JOIN accountPayable ON (accountPayable.");
   q.append("acctPayToRefKey=transRecord.transRefKey) ");
   q.append("LEFT JOIN impInfoRecord ON (transRecord.transRefKey=");
   q.append("impInfoRecord.impFromRefKey) ");
   q.append("WHERE customerName=\""+customerName+"\" AND "); 
   q.append("impInfoRecord.impArrival >=\""+d1+"\" AND ");
   q.append("impInfoRecord.impArrival <=\""+d2+"\";");
   tmp = db.QueryMulti("customer","*",q.toString());
   p = q.toString().indexOf("LEFT JOIN impInfoRecord");
   q.delete(p,q.length());

   q.append("LEFT JOIN expInfoRecord ON (transRecord.transRefKey=");
   q.append("expInfoRecord.expFromRefKey) ");
   q.append("WHERE customerName=\""+customerName+"\" AND ");
   q.append("expInfoRecord.expStuffingDate >=\""+d1+"\" AND ");
   q.append("expInfoRecord.expStuffingDate <=\""+d2+"\";");
   Vector tmp2 = db.QueryMulti("customer","*",q.toString());
   if(tmp2 != null)
   {
    if(tmp == null)
    {
     tmp = new Vector((Vector)tmp2.clone());
    }
    else
    {
     tmp.addAll((Vector)tmp2.clone());
    }
    tmp2.removeAllElements();
   }
  }
  if(tmp == null || tmp.size()<1)
  {
   error.append("No record found to be print\n");
   return null;
  }
  int size = tmp.size(); // size of the query
  storeVol = new Vector(size);
  for(int i=0;i<size;i++)
  {
   e = (Encap)((Encap)tmp.get(i)).clone();
   v2 = db.QueryMulti("transVol","*","WHERE transVolRefKey="+
    e.extractAll("transRefKey")+";");
   if(v2!= null)
   {
    transVol = new Vector(v2.size());
    while(!v2.isEmpty())
    {
     e2 = (Encap)v2.remove(0);
     volume.append(e2.extractAll("transVolVolume")+"x"+
      e2.extractAll("transVolStowage"));
     transVol.add(new String(e2.extractAll("transVolVolume")+
       "x"+e2.extractAll("transVolStowage")));
     if(!v2.isEmpty())
      volume.append(",");
    }
    e.setNameVal("transVolVolume",volume.toString());
    storeVol.add(transVol.clone());
   }
   transVol.removeAllElements();
   tmp.setElementAt(e.clone(),i);
   volume.delete(0,volume.length());
   e.clear();
  }
  return (Vector)tmp.clone();
 }

 private void printAll(String c,Vector v) throws IOException
 {
  String filename;
  if(action == Module7.PRCN)
   filename = new String("Report-"+customerName+
    "#"+currentDate+"#"+hashTime+".HTML");
  else
   filename = new String("Report-"+datum+
    "#"+currentDate+"#"+hashTime+".HTML");
  htmlFile = formFile(filename);	
  if(htmlFile == null)throw new IOException(error.toString());
  FileWriter fw = new FileWriter(htmlFile);
  BufferedWriter bw = new BufferedWriter(fw);
  PrintWriter pw = new PrintWriter(bw);

  MultipleCurrency mc = new MultipleCurrency();
  pw.print("<HTML><HEAD><TITLE>Print Report");
  pw.print("for period: "+Module7.formNDate(d1)+" to "+Module7.formNDate(d2));
  if(action == Module7.PRSD)
    pw.print(" of Stuffing Date [Export]</TITLE>");
  else if(action == Module7.PRAD)
   pw.print(" of Arrival Date [Import]</TITLE>");
  else
   pw.print(" of Customer Name: "+customerName+"</TITLE>");
  pw.print("<meta http-equiv=\"Content-Type\" content=\"text/html;");
  pw.println(" charset=iso-8859-1\"></HEAD>");
  pw.println("<BODY BGCOLOR=WHITE TEXT=BLACK>");
  pw.print("<P><TABLE BORDER=0 WIDTH=\"90%\"><TR>");
  if(action == Module7.PRSD || action == Module7.PRAD)
  {
   pw.print("<TD WIDTH=\"50%\" ALIGN=LEFT></TD>");
   pw.print("<TD WIDTH=\"50%\" ALIGN=RIGHT><FONT SIZE=+1><B>");
   pw.print("Period:</B> "+Module7.formNDate(d1)+" TO ");
   pw.print(Module7.formNDate(d2)+"</FONT></TD>"); 
  }
  else
  {
   pw.print("<TD WIDTH=\"50%\" ALIGN=LEFT><FONT SIZE=+1><B>Shipper: </B>");
   pw.print(c+"</FONT></TD>");
   pw.print("<TD WIDTH=\"50%\" ALIGN=RIGHT><FONT SIZE=+1><B>Period: ");
   pw.print("<B>"+Module7.formNDate(d1)+" TO ");
   pw.print(Module7.formNDate(d2)+"</B></FONT></TD>");
  }
  pw.println("</TR></TABLE></P><BR></BR>");
  pw.print("<TABLE BORDER=1 CELLPADDING=1 CELLSPACING=2 WIDTH=\"90%\">");
  pw.print("<CAPTION><FONT SIZE=+1>");
  pw.print("Acct Receivable & Acct Payable Report</CAPTION></FONT>");
  pw.println("<TR>");
	
  // write the header

  pw.print("<TH WIDTH=\"5%\"><FONT SIZE=-1>Ref No</FONT></TH>");
  pw.print("<TH WIDTH=\"5%\"><FONT SIZE=-1>Type</FONT></TH>");

  if(action == Module7.PRSD || action == Module7.PRAD)
  {
   pw.print("<TH WIDTH=\"8%\"><FONT SIZE=-1>Customer</FONT></TH>");
   pw.print("<TH WIDTH=\"8%\"><FONT SIZE=-1>Trucking</FONT></TH>");
  }
  else
   pw.print("<TH WIDTH=\"16%\"><FONT SIZE=-1>Trucking Name</FONT></TH>");

  pw.print("<TH WIDTH=\"10%\"><FONT SIZE=-1>Volume Stowage</FONT></TH>");
  pw.print("<TH WIDTH=\"10%\"><FONT SIZE=-1>Stuffing Arrival</FONT></TH>");
  pw.print("<TH WIDTH=\"10%\"><FONT SIZE=-1>Invoice Date</FONT></TH>");
  pw.print("<TH WIDTH=\"8%\"><FONT SIZE=-1>A/R Total</FONT></TH>");
  pw.print("<TH WIDTH=\"8%\"><FONT SIZE=-1>A/R Balance</FONT></TH>");
  pw.print("<TH WIDTH=\"4%\"><FONT SIZE=-1>A/R Paid Full</FONT></TH>");
  pw.print("<TH WIDTH=\"8%\"><FONT SIZE=-1>A/P Total</FONT></TH>");
  pw.print("<TH WIDTH=\"8%\"><FONT SIZE=-1>A/P Balance</FONT></TH>");
  pw.print("<TH WIDTH=\"4%\"><FONT SIZE=-1>A/P Paid Full</FONT></TH>");

  pw.println("</TR>"); 
  int size = v.size();
  for(int i=0;i<size;i++)
   nextPrint(i,size,pw,(Encap)((Encap)v.get(i)).clone());
  pw.println("</TABLE>");
  pw.println("</BODY></HTML>");

  pw.flush();
  pw.close();
  bw.close();
  fw.close();
  Runtime rt = Runtime.getRuntime();
  rt.exec("C:"+File.separator+"Program Files"+File.separator+
   "Internet Explorer"+File.separator+"iexplore "+finalname);
 
 } // end of printAll's method

 private void nextPrint(int seq,int size,PrintWriter pw,Encap e)
 {
  pw.println("<TR>");
  pw.println("<TD WIDTH=\"5%\" ALIGN=CENTER><FONT SIZE=-2>"+
    e.extractAll("transRefKey")+"</FONT></TD>");
  pw.println("<TD WIDTH=\"5%\" ALIGN=CENTER><FONT SIZE=-2>"+
    e.extractAll("transType")+"</FONT></TD>");

  if(action == Module7.PRSD || action == Module7.PRAD)
  {
   pw.println("<TD WIDTH=\"8%\" ALIGN=CENTER><FONT SIZE=-2>"
     +e.extractAll("customerName")+"</FONT></TD>");
   pw.println("<TD WIDTH=\"8%\" ALIGN=CENTER><FONT SIZE=-2>"
     +e.extractAll("truckingName")+"</FONT></TD>");
  }
  else
   pw.println("<TD WIDTH=\"16%\" ALIGN=CENTER><FONT SIZE=-2>"
     +e.extractAll("truckingName")+"</FONT></TD>");

  transVol = (Vector)storeVol.remove(0);
  pw.print("<TD WIDTH=\"10%\"><FONT SIZE=-2>");
  while(!transVol.isEmpty())
  {
   pw.print(transVol.remove(0));
   if(!transVol.isEmpty()) pw.print("<BR>");
  }
  pw.println("</FONT></TD>");

  pw.print("<TD WIDTH=\"8%\"><FONT SIZE=-2>");
  if(e.extractAll("transType").equalsIgnoreCase("IMP"))
   pw.println(Module7.formNDate(e.extractAll("impArrival"))+"</FONT></TD>");
  else
   pw.println(Module7.formNDate(e.extractAll("expStuffingDate"))+
     "</FONT></TD>");

  pw.println("<TD WIDTH=\"10%\"><FONT SIZE=-2>"+
   Module7.formNDate(e.extractAll("transInvoiceDT"))+"</FONT></TD>");

  pw.println("<TD WIDTH=\"8%\"><FONT SIZE=-2>"+
   e.extractAll("acctRecCurr")+" "+
   Module7.formNumDelimiter(e.extractAll("acctRecAmt"))+"</FONT></TD>");

  pw.println("<TD WIDTH=\"8%\"><FONT SIZE=-2>"+
   e.extractAll("acctRecCurr")+" "+
   Module7.formNumDelimiter(e.extractAll("acctRecBalance"))+"</FONT></TD>");

  pw.println("<TD WIDTH=\"8%\" ALIGN=CENTER><FONT SIZE=-2>"+
   e.extractAll("acctRecPaidFull")+"</FONT></TD>");

  pw.println("<TD WIDTH=\"8%\"><FONT SIZE=-2>"+
   e.extractAll("acctPayCurr")+" "+
   Module7.formNumDelimiter(e.extractAll("acctPayAmt"))+"</TD>");

  pw.println("<TD WIDTH=\"8%\"><FONT SIZE=-2>"+
   e.extractAll("acctPayCurr")+" "+ 
   Module7.formNumDelimiter(e.extractAll("acctPayBalance"))+"</FONT></TD>");

  pw.println("<TD WIDTH=\"4%\" ALIGN=CENTER><FONT SIZE=-2>"+
   e.extractAll("acctPayPaidFull")+"</FONT></TD>");

  pw.println("</TR>");
 } // end of nextPrint's method 

 public File formFile(String name) throws IOException
 {
  String tmpDir = null;
  if(action == Module7.PRSD)
   tmpDir = new String("C:"+File.separator+"LKBrecords"+
    File.separator+"Report-Stuffing-Date"+File.separator);
  else if(action == Module7.PRAD)
   tmpDir = new String("C:"+File.separator+"LKBrecords"+
    File.separator+"Report-Arrival-Date"+File.separator);
  else
   tmpDir = new String("C:"+File.separator+"LKBrecords"+
    File.separator+"Report-Customer"+File.separator);
  File dirName = new File(tmpDir);

  if(!dirName.exists()) dirName.mkdirs();
  int last = 0;
  int lpos = 0;
  File tmp = new File(dirName,name);
  StringBuffer str = new StringBuffer(64); 
  str.append(name);
  DateUtil du = new DateUtil();
  do
  {
   if(tmp.exists())
   {
    hashTime = du.getCurrentTime().hashCode();
    lpos = str.toString().lastIndexOf('#');
    str.delete(lpos+1,str.length());
    str.append(hashTime+".HTML");
    if(tmp.renameTo(new File(tmpDir,str.toString())))
     finalname = tmpDir+str.toString();
   }
   else
   {
    tmp.createNewFile();
    finalname = tmpDir+str.toString();
    break;
   }
  }while(tmp.exists()); 
  du = null;
  return tmp;
 }
}
