import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.util.Vector;
import java.util.HashMap;
import java.util.StringTokenizer;

public class SummaryForm 
{
 private JTable table;
 private JFrame frame;
 private tableData td;
 private FetchData fd;
 private Vector v = null;
 private JList head = null;
 private JButton refreshButton;
 private JButton closeButton;
 private JLabel labelTotal;
 private JLabel labelTotal1;
 private static int action = 0;
 private JPanel mainPanel = null;
 private SortedColumnHeaderRenderer schr = null;
 private SortedTableModel sortedModel = null;

 public SummaryForm(String title)
 {
  if(title.equalsIgnoreCase("Summary Outstanding Account Receivable"))
   action = fd.SUMMAR;
  else if(title.equalsIgnoreCase("Summary Outstanding Account Payable"))
   action = fd.SUMMAP;
  else if(title.equalsIgnoreCase("Summary Paid Account Receivable"))
   action = fd.SUMPAR;
  else if(title.equalsIgnoreCase("Summary Paid Account Payable"))
   action = fd.SUMPAP;
  else
  {
   Module7.errorDisplay("No available service for "+title,"No Service"); 
   return;
  }
  fd = new FetchData(action);
  labelTotal = new JLabel();
  labelTotal1= new JLabel();
  v = fd.fetch(0);
  if(v == null || fd.getError().length()>0)
  {
   Module7.errorDisplay(fd.getError(),"ERROR");
   return;
  }
  labelTotal.setText(fd.mc.getCurr(0)+" "+
   Module7.formNumDelimiter(fd.mc.getSumAR(0).toString()));
  labelTotal1.setText(fd.mc.getCurr(1)+" "+
   Module7.formNumDelimiter(fd.mc.getSumAR(1).toString()));
  frame = new JFrame(title);
  initJButton();

  frame.getContentPane().setLayout(new BorderLayout());
  td = new tableData(v,action);
  sortedModel = new SortedTableModel(td);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(sortedModel);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  schr = new SortedColumnHeaderRenderer(sortedModel,mlhr);
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField()); 
   TableColumn column;
   if((i == td.IVDT)||(i == td.SHGO))
    column = new TableColumn(i,30,render,editor);
   else if(i == td.IMEX||i==td.RFNO||i==td.CURR)
    column = new TableColumn(i,8,render,editor);
   else
    column = new TableColumn(i,20,render,editor);
   column.setHeaderRenderer(schr);
   table.addColumn(column);
  }
  head = new JList(new ListMod(v.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  mainPanel = createMain(table);
  frame.getContentPane().add(mainPanel,BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Close in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });	
  frame.pack();
  frame.setVisible(true);
 } // end of SummaryForm's constructor

 private JPanel createMain(JTable table)
 {
  JPanel panel = new JPanel();
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  addHeaderListener();
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill   = GridBagConstraints.BOTH;
  gbc.gridx  = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  gbc.gridy = 0;
  panel.add(new JLabel("Total Amount :",SwingConstants.RIGHT),gbc);
  panel.add(labelTotal,gbc);
  panel.add(labelTotal1,gbc);
  gbc.gridy++;
  panel.add(refreshButton,gbc);
  panel.add(closeButton,gbc);
  return panel;
 }

 public void addHeaderListener()
 {
  table.getTableHeader().addMouseListener(new MouseAdapter()
  {
   JTableHeader header;
   public void mousePressed(MouseEvent event)
   {
    header = (JTableHeader)(event.getSource());
    int index = header.columnAtPoint(event.getPoint());
    int sortCol = header.getTable().convertColumnIndexToModel(index);
    schr.setPressedColumn(index);
    schr.setSelectedColumn(index);
    header.repaint();
    if(header.getTable().isEditing())
     header.getTable().getCellEditor().stopCellEditing();
    boolean isAscent = false;
    if(schr.DOWN == schr.getState(index))
     isAscent = true;
    ((SortedTableModel)header.getTable().getModel()).clearSort();
    ((SortedTableModel)header.getTable().getModel()).sortByColumn(
      sortCol,td.getColumnType(sortCol),isAscent);
   }

   public void mouseReleased(MouseEvent event) 
   {
    int col = header.columnAtPoint(event.getPoint());
    schr.setPressedColumn(-1);
    header.repaint();
   }
  });
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   Vector v = null;
   if(jb == refreshButton)
   {
    v = fd.fetch(0);
    if(v == null)
    {
     frame.dispose();
     System.gc();
     Module7.infoDisplay("All active account is close","Information"); 
     return;
    }
    td.initData(v);
    sortedModel.clearSort();
    sortedModel.renewModel(td);
    labelTotal.setText(fd.mc.getCurr(0)+" "+
     Module7.formNumDelimiter(fd.mc.getSumAR(0).toString()));
    labelTotal1.setText(fd.mc.getCurr(1)+" "+
     Module7.formNumDelimiter(fd.mc.getSumAR(1).toString()));
    SwingUtilities.updateComponentTreeUI(labelTotal);
    SwingUtilities.updateComponentTreeUI(labelTotal1);
    head.setModel(new ListMod(v.size()));
    table.revalidate();
    table.repaint();
   }
   else
   {
    frame.dispose();
    System.gc(); 
   }
  }
 }

 private void initJButton()
 {
  refreshButton = new JButton("Refresh");
  refreshButton.addActionListener(new ButtonListener());
  closeButton = new JButton("Close");
  closeButton.addActionListener(new ButtonListener());
 }


 public class tableData extends AbstractTableModel
 {
  public final int RFNO = 0;
  public final int IMEX = 1;
  public final int SHCO = 2;
  public final int VSTW = 3;
  public final int LDDS = 4;
  public final int DRLC = 5;
  public final int CURR = 6;
  public final int AMNT = 7;
  public final int IVDT = 8;
  public final int SHGO = 9;

  public int rowLength;
  public int colLength;
  public Vector dataRow;
  public Vector colNames= null;

  public tableData(Vector ve,int act)
  {
   initColumn(act);
   rowLength = ve.size();
   colLength = colNames.size();
   initData(ve); 
  } // end of tableData's constructor
  public void initData(Vector ve)
  { dataRow = ve; }
  public void initColumn(int act)
  {
   if(colNames == null) colNames = new Vector();
   colNames.add(new String("Ref\nNo."));
   colNames.add(new String("Import\nExport"));
   if(act == fd.SUMMAR || act == fd.SUMPAR) 
    colNames.add(new String("Customer\nName"));
   else
    colNames.add(new String("Trucking\nCompany"));
   colNames.add(new String("Volume\nStowage"));
   colNames.add(new String("Loading\nDestination"));
   colNames.add(new String("Door\nLocation"));
   colNames.add(new String("Currency"));
   colNames.add(new String("Total\nAmount"));
   colNames.add(new String("Invoice\nDate"));
   colNames.add(new String("Stuffing\nGate Out"));
  }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colLength; }
  public String getColumnName(int column)
  { return (String)colNames.elementAt(column); }
  public Class getColumnClass(int column)
  { 
   if(column == RFNO)
    return Integer.class;
   return String.class;
  }
  public int getColumnType(int column)
  {
   if(column == RFNO) return TableSorter.INTEGER; // INTEGER 
   if(column == AMNT) return TableSorter.BIGDEC; // BIG DECIMAL 
   if(column == VSTW) return TableSorter.STRCOMMA; // STRING W COMMA 
   if(column == IVDT || column == SHGO) return TableSorter.DATE; // DATE
   return TableSorter.STRING; // STRING
  }
  public boolean isCellEditable(int row, int column)
  { return false; }

  public Object getValueAt(int row, int column)
  { 
   if((row<0)||(row>=getRowCount()))
    return " ";
   SummaryData sd = (SummaryData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : return sd.getRef();
    case IMEX : return sd.getIE(); 
    case SHCO : return sd.getNm();
    case VSTW : return sd.getStw();
    case LDDS : return sd.getLoDest();
    case DRLC : return sd.getDoLoc();
    case CURR : return sd.getCurrency();
    case AMNT : return sd.getTotal();
    case IVDT : return sd.getInvDate();
    case SHGO : return sd.getShipGO();
   }
   return " "; 
  }
  public void setValueAt(Object val, int row, int column)
  {
   boolean fillFlag = true;
   SummaryData sd = (SummaryData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : sd.setRef(((Integer)val).intValue()); break;
    case IMEX : sd.setIE((String)val); break;
    case SHCO : sd.setNm((String)val); break;
    case VSTW : sd.setVolStw((String)val); break;
    case LDDS : sd.setLoDest((String)val); break;
    case DRLC : sd.setDoLoc((String)val); break;
    case CURR : sd.setCurrency((String)val); break;
    case AMNT : sd.setTotal((String)val); break;
    case IVDT : sd.setInvDate((String)val); break;
    case SHGO : sd.setShipGO((String)val); break;
    default   : fillFlag = false;
   }
   if(fillFlag)
    dataRow.setElementAt(sd,row);
   fireTableCellUpdated(row,column);
  } 
 } // end of tableData's class


} // end of SummaryForm's class
