import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.HashMap;

public class SummaryPayDateHistory
{
 private JTable table;
 private JFrame frame;
 private tableData td;
 private JButton refreshButton;
 private JButton closeButton;

 private JLabel labelAPTotal = new JLabel();
 private JLabel labelARTotal = new JLabel();
 private JLabel labelPYTotal = new JLabel();

 private JLabel labelPYTotal1= new JLabel();
 private JLabel labelARTotal1= new JLabel();
 private JLabel labelAPTotal1= new JLabel();

 private MultipleCurrency mcPY = new MultipleCurrency();
 private MultipleCurrency mcAL = new MultipleCurrency();
 private JList head = null;
 private Vector data = null;
 private String condition = null;
 private StringBuffer error = new StringBuffer();
 private SortedColumnHeaderRenderer schr = null;
 private SortedTableModel sortedModel = null;
 private HashMap masterKeyAR;
 private HashMap masterKeyAP;
 private HashMap masterKeyPID;
 
 public SummaryPayDateHistory(String con)
 {
  if(con == null|| con.length()>10 || con.length()<8)
  {
   Module7.errorDisplay("Received null string","ERROR Receiving");
   System.gc();
   return;
  }
  condition = new String(Module7.formDate(con));
  getData(condition);
  if(error.length()>0)
  {
   Module7.infoDisplay(error.toString(),"Info");
   error.delete(0,error.length());
   System.gc();
   return;
  }
  frame = new JFrame("View Payment History by "+con);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Close in the panel instead",
     "Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  td = new tableData(data);
  sortedModel = new SortedTableModel(td);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(sortedModel);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  schr = new SortedColumnHeaderRenderer(sortedModel,mlhr);
  int len = td.getColumnCount();
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i==td.RFNO||i==td.PID||i==td.PCUR||i==td.PAPP||i==td.PVOL||i==td.PMET)
    column = new TableColumn(i,8,render,editor);
   else
    column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(schr);
   table.addColumn(column);
  }
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  head = new JList(new ListMod(data.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  panel.add(new JScrollPane(table),BorderLayout.CENTER);
  addHeaderListener();
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  refreshButton = new JButton("Refresh");
  closeButton = new JButton("Close");
  ButtonListener bl = new ButtonListener();
  refreshButton.addActionListener(bl);
  closeButton.addActionListener(bl);
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.gridx = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  gbc.gridy = 0;
  panel.add(new JLabel("Total Payment",SwingConstants.RIGHT),gbc);
  labelPYTotal.setText(mcPY.getCurr(0)+" "+
   Module7.formNumDelimiter(mcPY.getSumAR(0).toString()));
  labelPYTotal1.setText(mcPY.getCurr(1)+" "+
   Module7.formNumDelimiter(mcPY.getSumAR(1).toString()));
  panel.add(labelPYTotal,gbc);
  panel.add(labelPYTotal1,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Total A/P Balance",SwingConstants.RIGHT),gbc);
  labelAPTotal.setText(mcAL.getCurr(0)+" "+
   Module7.formNumDelimiter(mcAL.getSumAP(0).toString()));
  labelAPTotal1.setText(mcAL.getCurr(1)+" "+
   Module7.formNumDelimiter(mcAL.getSumAP(1).toString()));
  panel.add(labelAPTotal,gbc);
  panel.add(labelAPTotal1,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Total A/R Balance",SwingConstants.RIGHT),gbc);
  labelARTotal.setText(mcAL.getCurr(0)+" "+
   Module7.formNumDelimiter(mcAL.getSumAR(0).toString()));
  labelARTotal1.setText(mcAL.getCurr(1)+" "+
   Module7.formNumDelimiter(mcAL.getSumAR(1).toString()));
  panel.add(labelARTotal,gbc);
  panel.add(labelARTotal1,gbc);
  gbc.gridy++;
  panel.add(refreshButton,gbc);
  panel.add(closeButton,gbc);
  return panel;
 }

 private void getData(String str)
 {
  if(str == null)
  {
   error.append("Received null String at getData\n");
   return;
  }
  String msg = new String("LEFT JOIN transRecord ON (transRecord.transRefKey"+
   "=transPayRecord.transPayFromRefKey) LEFT JOIN customer ON "+
   "(customer.customerKey=transRecord.transCustKey) "+
   "LEFT JOIN accountReceivable ON "+
   "(accountReceivable.acctRecFromRefKey=transPayRecord.transPayFromRefKey) "+
   "LEFT JOIN accountPayable ON (accountPayable.acctPayToRefKey="+
   "transPayRecord.transPayFromRefKey) WHERE transPayDate=\""+str+"\";"); 
  DBConnect db = new DBConnect();
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection\n");
   data = db.QueryMulti("transPayRecord","*",msg);
   if(data == null)
    error.append("No Pay History available on the requested date\n"); 
   else
    refineResults(db);  
  }
  catch(SQLException sqle)
  {
   error.append(sqle.getMessage());
   sqle.printStackTrace(System.out);
   if(!data.isEmpty()) data.removeAllElements();
  }
  finally
  {
   db.close();
  }
 }

 private void refineResults(DBConnect db) throws SQLException
 {
  if(data == null || data.size()==0)
  {
   error.append("Data is null or empty");
   return;
  }
  mcPY.clearVariable();
  mcAL.clearVariable();
  Encap e = null;
  int size = data.size();

  masterKeyAR = new HashMap(size);
  masterKeyAP = new HashMap(size);
  masterKeyPID = new HashMap(size);
  boolean passFlag;
  int tmpKey = 0;
  Vector v = new Vector(data.size());
  boolean flagAR = false;

  do
  {
   passFlag = false;
   e = (Encap)data.remove(0);
   if(e.extractInteger("transPayAcctRecKey",0)>0)
   {
    tmpKey = e.extractInteger("transPayAcctRecKey",0);
    if(tmpKey == e.extractInteger("acctRecKey",0))
     flagAR = true;
   }
   else
   {
    tmpKey = e.extractInteger("transPayAcctPayKey",0);
    if(tmpKey == e.extractInteger("acctPayKey",0))
     flagAR = false;
   }

   if(flagAR)
   {
    if(e.extractAll("transPayCurr").equalsIgnoreCase(e.extractAll("acctRecCurr")))
      passFlag = true;
   }
   else
   {
    if(e.extractAll("transPayCurr").equalsIgnoreCase(e.extractAll("acctPayCurr")))
     passFlag = true;
   }
   if(passFlag && masterKeyPID.containsKey(e.extractAll("transPayKey")))
     passFlag = false;

   if(passFlag)
   {
    PayData pay = new PayData();
    pay.setRFNO(e.extractInteger("transRefKey",0));
    pay.setPID(e.extractInteger("transPayKey",0));
    pay.setPVOL(fetchVolume(e.extractInteger("transRefKey",0),db));
    pay.setPIDT(Module7.formNDate(e.extractString("transInvoiceDate",null)));
    pay.setPMET(e.extractString("transPayMethod",null));
    if(e.extractInteger("transPayAcctRecKey",0)>0)
     pay.setPAPP("A/R");
    else
     pay.setPAPP("A/P");
    pay.setPNAME(e.extractString("customerName",null));
    pay.setPCUR(e.extractString("transPayCurr",null));
    pay.setPAMT(Module7.formNumDelimiter(e.extractAll("transPayAmt")));

    if(e.extractString("transPayCurr",null).equalsIgnoreCase(e.extractAll("acctPayCurr")))
     pay.setPAPB(Module7.formNumDelimiter(e.extractAll("acctPayBalance")));
    if(e.extractString("transPayCurr",null).equalsIgnoreCase(e.extractAll("acctRecCurr")))
     pay.setPARB(Module7.formNumDelimiter(e.extractAll("acctRecBalance")));

    if(!masterKeyPID.containsKey(e.extractAll("transPayKey")))
    { 
     mcPY.sumAR(e.extractAll("transPayCurr"),e.extractAll("transPayAmt"));
     masterKeyPID.put(e.extractAll("transPayKey"),e.extractAll("transPayKey"));
    }
    if(!masterKeyAR.containsKey(e.extractAll("acctRecKey")))
    {
     if(e.extractAll("acctRecCurr").equalsIgnoreCase(e.extractAll("transPayCurr")))
     {
      mcAL.sumAR(e.extractAll("acctRecCurr"),e.extractAll("acctRecBalance"));
      masterKeyAR.put(e.extractAll("acctRecKey"),e.extractAll("acctRecKey"));
     }
    }
    if(!masterKeyAP.containsKey(e.extractAll("acctPayKey")))
    {
     if(e.extractAll("acctPayCurr").equalsIgnoreCase(e.extractAll("transPayCurr")))
     {
      mcAL.sumAP(e.extractAll("acctPayCurr"),e.extractAll("acctPayBalance"));
      masterKeyAP.put(e.extractAll("acctPayKey"),e.extractAll("acctPayKey"));
     }
    }
    v.add(pay);
   }
   e.clear();
  }while(!data.isEmpty());
  data = (Vector)v.clone(); 
  masterKeyAR.clear();
  masterKeyAP.clear();
  masterKeyPID.clear();
 }

 private String fetchVolume(int ref,DBConnect db) throws SQLException
 {
  StringBuffer tmp = new StringBuffer(16);
  Encap e1 = null;
  Vector v1 = db.QueryMulti("transVol","*","WHERE transVolRefKey="+ref+";");
  if(v1 == null) return "0"; // no container found
  while(!v1.isEmpty())
  {
   e1 = (Encap)v1.remove(0);
   tmp.append(e1.extractAll("transVolVolume")+"x"+
    e1.extractAll("transVolStowage"));
   if(!v1.isEmpty()) tmp.append(",");
   e1.clear();
  }
  return tmp.toString();
 }

 public void close()
 {
  frame.dispose();
  System.gc();
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == refreshButton)
   {
    getData(condition); 
    if(error.length()==0)
    {
     td.initData(data);
     sortedModel.clearSort();
     sortedModel.renewModel(td);
     labelPYTotal.setText(mcPY.getCurr(0)+" "+
      Module7.formNumDelimiter(mcPY.getSumAR(0).toString()));
     labelAPTotal.setText(mcAL.getCurr(0)+" "+
      Module7.formNumDelimiter(mcAL.getSumAP(0).toString()));
     labelARTotal.setText(mcAL.getCurr(0)+" "+
      Module7.formNumDelimiter(mcAL.getSumAR(0).toString()));
     labelPYTotal1.setText(mcPY.getCurr(1)+" "+
      Module7.formNumDelimiter(mcPY.getSumAR(1).toString()));
     labelAPTotal1.setText(mcAL.getCurr(1)+" "+
      Module7.formNumDelimiter(mcAL.getSumAP(1).toString()));
     labelARTotal1.setText(mcAL.getCurr(1)+" "+
      Module7.formNumDelimiter(mcAL.getSumAR(1).toString()));
     SwingUtilities.updateComponentTreeUI(labelPYTotal);
     SwingUtilities.updateComponentTreeUI(labelAPTotal);
     SwingUtilities.updateComponentTreeUI(labelARTotal);
     SwingUtilities.updateComponentTreeUI(labelPYTotal1);
     SwingUtilities.updateComponentTreeUI(labelAPTotal1);
     SwingUtilities.updateComponentTreeUI(labelARTotal1);
     head.setModel(new ListMod(data.size()));
     table.revalidate();
     table.repaint();
     frame.invalidate();
     frame.validate();
     frame.repaint();
    }
   }
   else
    close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
    close();
   }
  }
 }

 public void addHeaderListener()
 {
  table.getTableHeader().addMouseListener(new MouseAdapter()
  {
   JTableHeader header;
   public void mousePressed(MouseEvent event)
   {
    header = (JTableHeader)(event.getSource());
    int index = header.columnAtPoint(event.getPoint());
    int sortCol = header.getTable().convertColumnIndexToModel(index);
    schr.setPressedColumn(index);
    schr.setSelectedColumn(index);
    header.repaint();
    if(header.getTable().isEditing())
     header.getTable().getCellEditor().stopCellEditing();
    boolean isAscent = false;
    if(schr.DOWN == schr.getState(index))
     isAscent = true;
    ((SortedTableModel)header.getTable().getModel()).sortByColumn(
      sortCol,td.getColumnType(sortCol),isAscent);
   }

   public void mouseReleased(MouseEvent event) 
   {
    int col = header.columnAtPoint(event.getPoint());
    schr.setPressedColumn(-1);
    header.repaint();
   }
  });
 }

 private class tableData extends AbstractTableModel
 {
  public final int RFNO = 0; // Reference No
  public final int PID  = 1; // Payment ID
  public final int PVOL = 2; // Volume
  public final int PIDT = 3; // Invoice Date
  public final int PNAM = 4; // Customer Name
  public final int PMET = 5; // Payment Method
  public final int PAPP = 6; // Payment Apply to [AP/AR]
  public final int PCUR = 7; // Payment Currency
  public final int PAMT = 8; // Payment Amount
  public final int PAPB = 9; // Payment Acct Payable Balance
  public final int PARB = 10; // Payment Acct Receivable Balance
  public Vector dataRow = null;
  public Vector colNames= null;
  
  public tableData(Vector ve)
  {
   initColumn();
   initData(ve);
  }
  public void initData(Vector ve)
  { dataRow = ve; }
  public void initColumn()
  {
   if(colNames == null) colNames = new Vector();
   colNames.add(new String("Ref\nNo."));
   colNames.add(new String("Pay\nID."));
   colNames.add(new String("Volume\nStowage"));
   colNames.add(new String("Invoice\nDate."));
   colNames.add(new String("Customer\nName"));
   colNames.add(new String("Pay\nMethod"));
   colNames.add(new String("Pay\nApplied"));
   colNames.add(new String("Pay\nCurrency"));
   colNames.add(new String("Pay\nAmount"));
   colNames.add(new String("A/P\nBalance"));
   colNames.add(new String("A/R\nBalance"));
  }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.size(); }
  public String getColumnName(int column)
  { return (String)colNames.elementAt(column); }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public int getColumnType(int column)
  {
   if(column==RFNO || column==PID) return TableSorter.INTEGER; // INTEGER 
   if(column==PAMT || column==PAPB || column==PARB) 
    return TableSorter.BIGDEC; // BIG DECIMAL 
   if(column==PVOL) return TableSorter.STRCOMMA; // STRING W COMMA 
   if(column==PIDT) return TableSorter.DATE; // DATE
   return TableSorter.STRING; // STRING
  }
  public Object getValueAt(int row,int column)
  {
   if(row<0 || row>=getRowCount())
    return " ";
   PayData pay = (PayData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : return pay.getRFNO();
    case PID  : return pay.getPID();
    case PVOL : return pay.getPVOL();
    case PIDT : return pay.getPIDT();
    case PNAM : return pay.getPNAME();	
    case PMET : return pay.getPMET();
    case PAPP : return pay.getPAPP();
    case PCUR : return pay.getPCUR();
    case PAMT : return pay.getPAMT();
    case PAPB : return pay.getPAPB();
    case PARB : return pay.getPARB();
   }
   return " ";
  }
  public void setValueAt(Object val,int row,int column)
  {
   if(row<0 || row>=getRowCount()) return;
   PayData pay = (PayData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : pay.setRFNO(((Integer)val).intValue()); break;
    case PID  : pay.setPID(((Integer)val).intValue()); break;
    case PVOL : pay.setPVOL((String)val); break;
    case PIDT : pay.setPIDT((String)val); break;
    case PNAM : pay.setPNAME((String)val); break;
    case PMET : pay.setPMET((String)val); break;
    case PAPP : pay.setPAPP((String)val); break;
    case PCUR : pay.setPCUR((String)val); break;
    case PAMT : pay.setPAMT((String)val); break;
    case PAPB : pay.setPAPB((String)val); break;
    case PARB : pay.setPARB((String)val); break;
   }
   dataRow.setElementAt(pay,row);
   fireTableCellUpdated(row,column);
  }
 }

 public class PayData
 {
  private int payRefNo = 0;
  private int payID = 0;
  private String payVol;
  private String payInvDate;
  private String payMethod;
  private String payName;
  private String payCurr;
  private String payAmt;
  private String payApply;
  private String payAPBalance;
  private String payARBalance;
  public PayData() { }
  public PayData(int rf,int pid,String v,String pd,String pm,String pc,
   String pa,String papp,String papb,String parb,String nm)
  {
   setRFNO(rf);
   setPID(pid);
   setPVOL(v);
   setPIDT(pd);
   setPMET(pm);
   setPNAME(nm);
   setPAPP(papp);
   setPCUR(pc);
   setPAMT(pa);
   setPAPB(papb);
   setPARB(parb);
  }
  public void setRFNO(int rf)
  { payRefNo = rf; }
  public void setPID(int pid)
  { payID = pid; }
  public void setPVOL(String v)
  { payVol = new String(v); }
  public void setPIDT(String pd)
  { payInvDate = new String(pd); }
  public void setPMET(String pm) 
  { payMethod = new String(pm); }
  public void setPCUR(String pc) 
  { payCurr = new String(pc); }
  public void setPNAME(String nm)
  { payName = new String(nm); }
  public void setPAMT(String pa) 
  { payAmt = new String(pa); }
  public void setPAPP(String papp) 
  { payApply = new String(papp); }
  public void setPAPB(String papb)
  { payAPBalance = new String(papb); }
  public void setPARB(String parb)
  { payARBalance = new String(parb); }
  public Integer getRFNO()
  { return new Integer(payRefNo); }
  public Integer getPID()
  { return new Integer(payID); }
  public String getPVOL()
  { return payVol; }
  public String getPIDT()
  { return payInvDate; }
  public String getPMET()
  { return payMethod; }
  public String getPNAME()
  { return payName; }
  public String getPCUR()
  { return payCurr; }
  public String getPAMT()
  { return payAmt; }
  public String getPAPP()
  { return payApply; }
  public String getPARB()
  { return payARBalance; }
  public String getPAPB()
  { return payAPBalance; }
 }
}
