import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.util.Vector;
import java.util.HashMap;
import java.math.BigDecimal;
import java.sql.SQLException;

public class SummaryPayHistory
{
 private JTable table;
 private JFrame frame;
 private tableData td;
 private String title = null;
 private JButton refreshButton;
 private JButton closeButton;
 private Vector v = null;
 private String con = null;
 private JList head = null;
 private int action = 0;
 private JLabel labelTotal = new JLabel();
 private JLabel labelTotAP = new JLabel();
 private JLabel labelTotAR = new JLabel();
 private JLabel labelTotal1= new JLabel();
 private JLabel labelTotAP1= new JLabel();
 private JLabel labelTotAR1= new JLabel();
 private StringBuffer error = new StringBuffer();
 private SortedColumnHeaderRenderer schr = null;
 private SortedTableModel sortedModel = null;
 private MultipleCurrency mcPY = new MultipleCurrency();
 private MultipleCurrency mcAL = new MultipleCurrency();
 private HashMap masterKeyAR;
 private HashMap masterKeyAP;
 private HashMap masterKeyPID;

 public SummaryPayHistory(int act,String content)
 {
  action = act;
  if(content == null)
  {
   Module7.errorDisplay("Received null content","ERROR");
   return;
  }
  if(content.length()<1)
  {
   Module7.errorDisplay("Received empty content","ERROR");
   return;
  }
  con = new String(content);
  v = fetchREF(con);
  if(v == null)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   System.gc();
   return;
  }
  title = new String("Pay History By Ref No. "+content);
  frame = new JFrame(title);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Close in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  td = new tableData(v,action);
  sortedModel = new SortedTableModel(td);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(sortedModel);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  schr = new SortedColumnHeaderRenderer(sortedModel,mlhr);
  int len = td.getColumnCount();
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i==td.RFNO || i==td.PID || i==td.PCUR || i==td.PAPP || i==td.PVOL)
    column = new TableColumn(i,10,render,editor);
   else
    column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(schr);
   table.addColumn(column);
  }
  head = new JList(new ListMod(v.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  addHeaderListener();
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  refreshButton = new JButton("Refresh");
  closeButton = new JButton("Close");
  ButtonListener bl = new ButtonListener();
  refreshButton.addActionListener(bl);
  closeButton.addActionListener(bl);
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.gridx = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  labelTotal.setText(mcPY.getCurr(0)+" "+
   Module7.formNumDelimiter(mcPY.getSumAR(0).toString()));
  labelTotAP.setText(mcAL.getCurr(0)+" "+
   Module7.formNumDelimiter(mcAL.getSumAP(0).toString()));
  labelTotAR.setText(mcAL.getCurr(0)+" "+
   Module7.formNumDelimiter(mcAL.getSumAR(0).toString()));
  labelTotal1.setText(mcPY.getCurr(1)+" "+
   Module7.formNumDelimiter(mcPY.getSumAR(1).toString()));
  labelTotAR1.setText(mcAL.getCurr(1)+" "+
   Module7.formNumDelimiter(mcAL.getSumAR(1).toString()));
  labelTotAP1.setText(mcAL.getCurr(1)+" "+
   Module7.formNumDelimiter(mcAL.getSumAP(1).toString()));
  gbc.gridy = 0;
  panel.add(new JLabel("Total Payment",SwingConstants.RIGHT),gbc);
  panel.add(labelTotal,gbc);
  panel.add(labelTotal1,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Total Balance A/R",SwingConstants.RIGHT),gbc);
  panel.add(labelTotAR,gbc);
  panel.add(labelTotAR1,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Total Balance A/P",SwingConstants.RIGHT),gbc);
  panel.add(labelTotAP,gbc);
  panel.add(labelTotAP1,gbc);
  gbc.gridy++;
  panel.add(refreshButton,gbc);
  panel.add(closeButton,gbc);
  return panel;
 }

 public Vector fetchREF(String content)
 {
  Vector vi = null;
  int previousRef = 0;
  StringBuffer msg = new StringBuffer();
  DBConnect db = new DBConnect();
  if(!db.makeConnection("LKB"))
  {
   Module7.errorDisplay("Failure to make connection to database\n","ERROR");
   return null;
  }
  msg.append("LEFT JOIN transRecord ON (transRecord.transRefKey=");
  msg.append("transPayRecord.transPayFromRefKey) ");
  msg.append("LEFT JOIN accountReceivable ON (accountReceivable.");
  msg.append("acctRecFromRefKey=transRecord.transRefKey) ");
  msg.append("LEFT JOIN accountPayable ON (accountPayable.acctPayToRefKey=");
  msg.append("transRecord.transRefKey) ");
  msg.append("WHERE transPayFromRefKey="+content+";");
  Vector result = new Vector();
  int t = 0;
  boolean passFlag = false;
  try
  {
   vi = db.QueryMulti("transPayRecord","*",msg.toString());
   Encap tmp = null;
   Encap tmp2= null;
   if(vi!=null)
   {
    masterKeyAR = new HashMap(vi.size());
    masterKeyAP = new HashMap(vi.size());
    masterKeyPID = new HashMap(vi.size());
    mcAL.clearVariable();
    mcPY.clearVariable();
    int tmpKey = 0;
    boolean flagAR = false;
    while(vi.size()>0)
    {
     passFlag = false;
     tmp = (Encap)vi.remove(0);
     if(tmp.extractInteger("transPayAcctRecKey",0)>0)
     {
      tmpKey = tmp.extractInteger("transPayAcctRecKey",0);
      if(tmpKey == tmp.extractInteger("acctRecKey",0)) flagAR = true;
     }
     else 
     {
      tmpKey = tmp.extractInteger("transPayAcctPayKey",0);
      if(tmpKey == tmp.extractInteger("acctPayKey",0)) flagAR = false;
     }
      
     if(flagAR)
     {
      if(tmp.extractAll("transPayCurr").equalsIgnoreCase(tmp.extractAll("acctRecCurr")))
       passFlag = true;
     }
     else
     {
      if(tmp.extractAll("transPayCurr").equalsIgnoreCase(tmp.extractAll("acctPayCurr")))
       passFlag = true;
     }
     if(passFlag && masterKeyPID.containsKey(tmp.extractAll("transPayKey")))
       passFlag = false;

     if(passFlag)
     {
      PayData pd = new PayData();
      pd.setRFNO(tmp.extractInteger("transRefKey",0));
      pd.setPID(tmp.extractInteger("transPayKey",0));
      pd.setPVOL(fetchVolume(tmp.extractInteger("transRefKey",0),db));
      pd.setPDAT(Module7.formNDate(tmp.extractString("transPayDate",null)));
      pd.setPMET(tmp.extractString("transPayMethod",null));
      pd.setPCUR(tmp.extractString("transPayCurr",null));
      pd.setPAMT(Module7.formNumDelimiter(tmp.extractAll("transPayAmt")));
      if(tmp.extractInteger("transPayAcctRecKey",0)>0)
       pd.setPAPP("A/R");
      else
       pd.setPAPP("A/P");

      if(tmp.extractAll("transPayCurr").equalsIgnoreCase(tmp.extractAll("acctPayCurr")))
        pd.setPAPB(Module7.formNumDelimiter(tmp.extractAll("acctPayBalance")));
      if(tmp.extractAll("transPayCurr").equalsIgnoreCase(tmp.extractAll("acctRecCurr")))
        pd.setPARB(Module7.formNumDelimiter(tmp.extractAll("acctRecBalance")));
     
      if(!masterKeyPID.containsKey(tmp.extractAll("transPayKey")))
      {
       mcPY.sumAR(tmp.extractAll("transPayCurr"),tmp.extractAll("transPayAmt"));
       masterKeyPID.put(tmp.extractAll("transPayKey"),
	       tmp.extractAll("transPayKey"));
      }
      if(!masterKeyAR.containsKey(tmp.extractAll("acctRecKey")))
      {
       if(tmp.extractAll("acctRecCurr").equalsIgnoreCase(
        tmp.extractAll("transPayCurr")))
       {
        mcAL.sumAR(tmp.extractAll("acctRecCurr"),tmp.extractAll("acctRecBalance"));
        masterKeyAR.put(tmp.extractAll("acctRecKey"),tmp.extractAll("acctRecKey"));
       }
      }
      if(!masterKeyAP.containsKey(tmp.extractAll("acctPayKey")))
      {
       if(tmp.extractAll("acctPayCurr").equalsIgnoreCase(
        tmp.extractAll("transPayCurr")))
       {
        mcAL.sumAP(tmp.extractAll("acctPayCurr"),tmp.extractAll("acctPayBalance"));
        masterKeyAP.put(tmp.extractAll("acctPayKey"),tmp.extractAll("acctPayKey"));
       }
      }
      result.add(pd);
     }
     tmp.clear();
    } // end of while
   }
   else 
   {
    error.append("Ref No."+content+" has not make any payment yet\n");
    result = null;
   }
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage()+"\n");
   if(result!=null) result = null;
   if(!vi.isEmpty()) vi.removeAllElements();
  }
  finally
  {
   db.close();
   masterKeyAR.clear();
   masterKeyAP.clear();
   masterKeyPID.clear();
  }
  return result;
 }

 private String fetchVolume(int ref,DBConnect db) throws SQLException
 {
  StringBuffer tmp = new StringBuffer(16);
  Encap e1 = null;
  Vector v1 = db.QueryMulti("transVol","*","WHERE transVolRefKey="+ref+";");
  if(v1 == null) return "0";
  while(!v1.isEmpty())
  {
   e1 = (Encap)v1.remove(0);
   tmp.append(e1.extractAll("transVolVolume")+"x"+
    e1.extractAll("transVolStowage"));
   if(!v1.isEmpty()) tmp.append(",");
   e1.clear();
  }
  return tmp.toString();
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == refreshButton)
   {
    v = fetchREF(con);
    if(v == null)
    {
     frame.dispose();
     System.gc();
     Module7.infoDisplay("There are no available Pay Info at the moment",
       "Information");
     return;
    }
    labelTotal.setText(mcPY.getCurr(0)+" "+
     Module7.formNumDelimiter(mcPY.getSumAR(0).toString()));
    labelTotAP.setText(mcAL.getCurr(0)+" "+
     Module7.formNumDelimiter(mcAL.getSumAP(0).toString()));
    labelTotAR.setText(mcAL.getCurr(0)+" "+
     Module7.formNumDelimiter(mcAL.getSumAR(0).toString()));
    labelTotal1.setText(mcPY.getCurr(1)+" "+
     Module7.formNumDelimiter(mcPY.getSumAR(1).toString()));
    labelTotAR1.setText(mcAL.getCurr(1)+" "+
     Module7.formNumDelimiter(mcAL.getSumAR(1).toString()));
    labelTotAP1.setText(mcAL.getCurr(1)+" "+
     Module7.formNumDelimiter(mcAL.getSumAP(1).toString()));
    SwingUtilities.updateComponentTreeUI(labelTotal1);
    SwingUtilities.updateComponentTreeUI(labelTotAP1);
    SwingUtilities.updateComponentTreeUI(labelTotAR1);
    SwingUtilities.updateComponentTreeUI(labelTotal);
    SwingUtilities.updateComponentTreeUI(labelTotAP);
    SwingUtilities.updateComponentTreeUI(labelTotAR);
    td.initData(v);
    sortedModel.clearSort();
    sortedModel.renewModel(td);
    head.setModel(new ListMod(v.size()));
    table.revalidate();
    table.repaint();
    frame.invalidate();
    frame.validate();
    frame.repaint();
   }
   else
   {
    frame.dispose();
    System.gc();
   }
  }
 }

 public void addHeaderListener()
 {
  table.getTableHeader().addMouseListener(new MouseAdapter()
  {
   JTableHeader header;
   public void mousePressed(MouseEvent event)
   {
    header = (JTableHeader)(event.getSource());
    int index = header.columnAtPoint(event.getPoint());
    int sortCol = header.getTable().convertColumnIndexToModel(index);
    schr.setPressedColumn(index);
    schr.setSelectedColumn(index);
    header.repaint();
    if(header.getTable().isEditing())
     header.getTable().getCellEditor().stopCellEditing();
    boolean isAscent = false;
    if(schr.DOWN == schr.getState(index))
     isAscent = true;
    ((SortedTableModel)header.getTable().getModel()).sortByColumn(
      sortCol,td.getColumnType(sortCol),isAscent);
   }

   public void mouseReleased(MouseEvent event) 
   {
    int col = header.columnAtPoint(event.getPoint());
    schr.setPressedColumn(-1);
    header.repaint();
   }
  });
 }

 private class tableData extends AbstractTableModel
 {
  public final int RFNO = 0;
  public final int PID  = 1;
  public final int PVOL = 2;
  public final int PDAT = 3; // Paid Date
  public final int PMET = 4; // Paid Method
  public final int PCUR = 5; // Paid Currency
  public final int PAMT = 6; // Paid Amount
  public final int PAPP = 7; // Payment Apply to
  public final int PAPB = 8; // Paid Acct Payable Balance
  public final int PARB = 9; // Paid Acct Receivable Balance
  public Vector dataRow = null;
  public Vector colNames= null;
  
  public tableData(Vector ve,int action)
  {
   initColumn(action);
   initData(ve);
  }
  public void initData(Vector ve)
  { dataRow = ve; }
  public void initColumn(int action)
  {
   if(colNames == null) colNames = new Vector();
   colNames.add(new String("Ref\nNo."));
   colNames.add(new String("Pay\nID."));
   colNames.add(new String("Volume\nStowage"));
   colNames.add(new String("Pay\nDate."));
   colNames.add(new String("Pay\nMethod"));
   colNames.add(new String("Pay\nCurrency"));
   colNames.add(new String("Pay\nAmount"));
   colNames.add(new String("Payment\nApply To"));
   colNames.add(new String("A/P\nBalance"));
   colNames.add(new String("A/R\nBalance"));
  }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.size(); }
  public String getColumnName(int column)
  { return (String)colNames.elementAt(column); }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public int getColumnType(int column)
  {
   if(column==RFNO || column==PID) return TableSorter.INTEGER; // INTEGER 
   if(column==PAMT || column==PAPB || column==PARB) 
    return TableSorter.BIGDEC; // BIG DECIMAL 
   if(column==PVOL) return TableSorter.STRCOMMA; // STRING W COMMA 
   if(column==PDAT) return TableSorter.DATE; // DATE
   return TableSorter.STRING; // STRING
  }
  public Object getValueAt(int row,int column)
  {
   if(row<0 || row>=getRowCount())
    return " ";
   PayData pay = (PayData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : return pay.getRFNO();
    case PID  : return pay.getPID();
    case PVOL : return pay.getPVOL();
    case PDAT : return pay.getPDAT();
    case PMET : return pay.getPMET();
    case PCUR : return pay.getPCUR();
    case PAMT : return pay.getPAMT();
    case PAPP : return pay.getPAPP();
    case PAPB : return pay.getPAPB();
    case PARB : return pay.getPARB();
   }
   return " ";
  }
  public void setValueAt(Object val,int row,int column)
  {
   if(row<0 || row>=getRowCount()) return;
   PayData pay = (PayData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : pay.setRFNO(((Integer)val).intValue()); break;
    case PID  : pay.setPID(((Integer)val).intValue()); break;
    case PVOL : pay.setPVOL((String)val); break;
    case PDAT : pay.setPDAT((String)val); break;
    case PMET : pay.setPMET((String)val); break;
    case PCUR : pay.setPCUR((String)val); break;
    case PAMT : pay.setPAMT((String)val); break;
    case PAPP : pay.setPAPP((String)val); break;
    case PAPB : pay.setPAPB((String)val); break;
    case PARB : pay.setPARB((String)val); break;
   }
   dataRow.setElementAt(pay,row);
   fireTableCellUpdated(row,column);
  }
 }

 private class PayData
 {
  private int payRefNo = 0;
  private int payID = 0;
  private String payVol = new String();
  private String payDate = new String();
  private String payMethod = new String();
  private String payCurr = new String();
  private String payAmt = new String();
  private String payApply = new String();
  private String payAPBalance = new String();
  private String payARBalance = new String();

  public PayData() { }
  public PayData(int rf,int pid,String v,String pd,String pm,String pc,
   String pa,String papp,String papb,String parb,String pt)
  {
   setRFNO(rf);
   setPID(pid);
   setPVOL(v);
   setPDAT(pd);
   setPMET(pm);
   setPCUR(pc);
   setPAMT(pa);
   setPAPP(papp);
   setPAPB(papb);
   setPARB(parb);
  }
  public void setRFNO(int rf)
  { payRefNo = rf; }
  public void setPID(int pid)
  { payID = pid; }
  public void setPVOL(String v)
  { payVol = v; }
  public void setPDAT(String pd)
  { payDate=pd; }
  public void setPMET(String pm) 
  { payMethod=pm; }
  public void setPCUR(String pc) 
  { payCurr=pc; }
  public void setPAMT(String pa) 
  { payAmt=pa; }
  public void setPAPP(String papp) 
  { payApply=papp; }
  public void setPAPB(String papb)
  { payAPBalance=papb; }
  public void setPARB(String parb)
  { payARBalance=parb; }
  public Integer getRFNO()
  { return new Integer(payRefNo); }
  public Integer getPID()
  { return new Integer(payID); }
  public String getPVOL()
  { return payVol; }
  public String getPDAT()
  { return payDate; }
  public String getPMET()
  { return payMethod; }
  public String getPCUR()
  { return payCurr; }
  public String getPAMT()
  { return payAmt; }
  public String getPAPP()
  { return payApply; }
  public String getPARB()
  { return payARBalance; }
  public String getPAPB()
  { return payAPBalance; }
 }
}
