import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.util.Vector;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.HashMap;

public class SummaryPayHistoryByNames
{
 private JTable table;
 private JFrame frame;
 private tableData td;
 private String title = null;
 private JButton refreshButton;
 private JButton closeButton;
 private Vector v = null;
 private int action = 0;
 private JLabel labelTotal = new JLabel();
 private JLabel labelTotAP = new JLabel();
 private JLabel labelTotAR = new JLabel();
 private JLabel labelTotal1 = new JLabel();
 private JLabel labelTotAP1 = new JLabel();
 private JLabel labelTotAR1 = new JLabel();
 private SortedColumnHeaderRenderer schr = null;
 private SortedTableModel sortedModel = null;
 private MultipleCurrency mcPY = new MultipleCurrency();
 private MultipleCurrency mcAL = new MultipleCurrency();

 private StringBuffer error = new StringBuffer();
 private String con = null;
 private JList head = null;

 public SummaryPayHistoryByNames(int act,String content)
 {
  action = act;
  if(content == null)
  {
   Module7.errorDisplay("Received null content","ERROR");
   return;
  }
  if(content.length()<1)
  {
   Module7.errorDisplay("Received empty content","ERROR");
   return;
  }
  con = new String(content);
  v = fetch(act,con);
  if(v == null)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   System.gc();
   return;
  }
  if(action == Module7.VPAYTRUCK)
   title = new String("Pay History By Trucking Company : "+content);
  else
   title = new String("Pay History By Customer Name : "+content);
  frame = new JFrame(title);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Close in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  td = new tableData(v,action);
  sortedModel = new SortedTableModel(td);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(sortedModel);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  schr = new SortedColumnHeaderRenderer(sortedModel,mlhr);
  int len = td.getColumnCount();
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i==td.RFNO || i==td.PID || i==td.PCUR || i==td.PVOL)
    column = new TableColumn(i,10,render,editor);
   else
    column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(schr);
   table.addColumn(column);
  }
  head = new JList(new ListMod(v.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  addHeaderListener();
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  refreshButton = new JButton("Refresh");
  closeButton = new JButton("Close");
  ButtonListener bl = new ButtonListener();
  refreshButton.addActionListener(bl);
  closeButton.addActionListener(bl);
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.gridx = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  gbc.gridy = 0;
  panel.add(new JLabel("Total Payment",SwingConstants.RIGHT),gbc);
  labelTotal.setText(mcPY.getCurr(0)+" "+
   Module7.formNumDelimiter(mcPY.getSumAR(0).toString()));
  labelTotal1.setText(mcPY.getCurr(1)+" "+
   Module7.formNumDelimiter(mcPY.getSumAR(1).toString()));
  panel.add(labelTotal,gbc);
  panel.add(labelTotal1,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Total A/P Balance",SwingConstants.RIGHT),gbc);
  labelTotAP.setText(mcAL.getCurr(0)+" "+
   Module7.formNumDelimiter(mcAL.getSumAP(0).toString()));
  labelTotAP1.setText(mcAL.getCurr(1)+" "+
   Module7.formNumDelimiter(mcAL.getSumAP(1).toString()));
  panel.add(labelTotAP,gbc);
  panel.add(labelTotAP1,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Total A/R Balance",SwingConstants.RIGHT),gbc);
  labelTotAR.setText(mcAL.getCurr(0)+" "+
   Module7.formNumDelimiter(mcAL.getSumAR(0).toString()));
  labelTotAR1.setText(mcAL.getCurr(1)+" "+
   Module7.formNumDelimiter(mcAL.getSumAR(1).toString()));
  panel.add(labelTotAR,gbc);
  panel.add(labelTotAR1,gbc);

  gbc.gridy++;
  panel.add(refreshButton,gbc);
  panel.add(closeButton,gbc);

  return panel;
 }

 public Vector fetch(int act,String content)
 {
  StringBuffer msg = new StringBuffer(64);
  Vector result = null;
  DBConnect db = new DBConnect();
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   switch(act)
   {
    case Module7.VPAYNM    : 
     msg.append("LEFT JOIN transRecord ON (transRecord.transCustKey=");
     msg.append("customer.customerKey) ");
     msg.append("LEFT JOIN transPayRecord ON (transPayRecord.transPayFromRefKey=");
     msg.append("transRecord.transRefKey) ");
     msg.append("WHERE customer.customerName=\""+content+"\" AND ");
     msg.append("transPayRecord.transPayAcctRecKey <> 0;");
     result = fetchData(fetchPay(act,msg.toString(),db),db); 
    break;
    case Module7.VPAYTRUCK :
     msg.append("LEFT JOIN transRecord ON (truckingCompany.");
     msg.append("truckingCompanyKey=transRecord.transTrucking) ");
     msg.append("LEFT JOIN transPayRecord ON (transPayRecord.transPayFromRefKey=");
     msg.append("transRecord.transRefKey) ");
     msg.append("WHERE truckingCompany.truckingName=\""+content+"\" AND ");
     msg.append("transPayRecord.transPayAcctPayKey <> 0;");
     result = fetchData(fetchPay(act,msg.toString(),db),db);
    break;
    default : 
     error.append("No service available for the chosen action\n");
   }
   if(result != null && result.size() == 0) 
   {
    result = null;
    error.append("There is no info payment available for: "+content+"\n");
   }
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage()+"\n");
   if(result != null && !result.isEmpty())
    result.removeAllElements();
   result = null;
  }
  finally
  {
   db.close();
  }
  if(error.length()>0)
   return null;
  return result;
 }

 public Vector fetchPay(int act,String query,DBConnect db)
	throws SQLException
 {
  Vector vi = null;
  Vector v2 = new Vector();
  Encap e1 = null;
  Encap e2 = null;
  if(act == Module7.VPAYNM)
  {
   vi = db.QueryMulti("customer","*",query);
   if(vi == null)
   {
    error.append("No customer with name : "+con+" exist in database\n"); 
    return null;
   }
   while(!vi.isEmpty())
   {
    e1 = (Encap)vi.remove(0);
    e1.setNameVal("transVolStowage",fetchVolume(
     e1.extractInteger("transRefKey",0),db));
    e2 = db.QuerySingle("accountReceivable","*",
     "WHERE acctRecKey="+e1.extractAll("transPayAcctRecKey")+";");
    if(e2 == null) throw new SQLException("Not found Account Receivable\n");
    e1.setNameVal("acctRecKey",e2.extractInteger("acctRecKey",0));
    e1.setNameVal("acctRecCurr",e2.extractAll("acctRecCurr"));
    e1.setNameVal("acctRecBalance",e2.extractAll("acctRecBalance"));
    e2.clear();
    e2 = db.QuerySingle("accountPayable","*",
     "WHERE acctPayCurr=\""+e1.extractAll("transPayCurr")+"\" AND acctPayToRefKey="+
     e1.extractAll("transRefKey")+";");
    if(e2 != null) 
    {
     e1.setNameVal("acctPayKey",e2.extractInteger("acctPayKey",0));
     e1.setNameVal("acctPayCurr",e2.extractAll("acctPayCurr"));
     e1.setNameVal("acctPayBalance",e2.extractAll("acctPayBalance"));
    }
    else
    {
     e1.setNameVal("acctPayKey",0);
     e1.setNameVal("acctPayCurr",e1.extractAll("transPayCurr"));
     e1.setNameVal("acctPayBalance","0.00");
    }
    v2.add(e1.clone());
    e1.clear();
    if(e2!=null) e2.clear();
   }
  }
  else
  {
   vi = db.QueryMulti("truckingCompany","*",query);
   if(vi == null)
   {
    error.append("No trucking company of name : "+con+" exist in database\n");
    return null;
   } 
   while(!vi.isEmpty())
   {
    e1 = (Encap)vi.remove(0);
    e1.setNameVal("transVolStowage",fetchVolume(
     e1.extractInteger("transRefKey",0),db));
    e2 = db.QuerySingle("accountPayable","*",
     "WHERE acctPayKey="+e1.extractAll("transPayAcctPayKey")+";");
    if(e2 == null) throw new SQLException("Not found Account Payable\n");
    e1.setNameVal("acctPayKey",e2.extractInteger("acctPayKey",0));
    e1.setNameVal("acctPayCurr",e2.extractAll("acctPayCurr"));
    e1.setNameVal("acctPayBalance",e2.extractAll("acctPayBalance"));
    e2.clear();
    e2 = db.QuerySingle("accountReceivable","*",
     "WHERE acctRecCurr=\""+e1.extractAll("transPayCurr")+"\" AND acctRecFromRefKey="+
     e1.extractAll("transRefKey")+";");
    if(e2 != null)
    {
     e1.setNameVal("acctRecKey",e2.extractInteger("acctRecKey",0));
     e1.setNameVal("acctRecCurr",e2.extractAll("acctRecCurr"));
     e1.setNameVal("acctRecBalance",e2.extractAll("acctRecBalance"));
    }
    else
    {
     e1.setNameVal("acctRecKey",0);
     e1.setNameVal("acctRecCurr",e1.extractAll("transPayCurr"));
     e1.setNameVal("acctRecBalance","0.00");
    }
    v2.add(e1.clone());
    e1.clear();
    e2.clear();
   }
  }
  return v2;
 }

 public Vector fetchData(Vector v,DBConnect db) throws SQLException
 {
  if(v == null) return null;
  Vector v2 = new Vector(v.size());
  Encap e = null;
  HashMap masterKeyAR = new HashMap(v.size());
  HashMap masterKeyAP = new HashMap(v.size());
  while(!v.isEmpty())
  {
   e = (Encap)v.remove(0);
   PayData pay = new PayData();
   pay.setRFNO(e.extractInteger("transRefKey",0));
   pay.setPID(e.extractInteger("transPayKey",0));
   pay.setPVOL(e.extractAll("transVolStowage"));
   pay.setPDAT(Module7.formNDate(e.extractAll("transPayDate")));
   pay.setPMET(e.extractAll("transPayMethod"));
   pay.setPCUR(e.extractAll("transPayCurr"));
   pay.setPAMT(Module7.formNumDelimiter(e.extractAll("transPayAmt")));
   pay.setPAPB(Module7.formNumDelimiter(e.extractAll("acctPayBalance")));
   pay.setPARB(Module7.formNumDelimiter(e.extractAll("acctRecBalance")));
   if(!masterKeyAP.containsKey(e.extractAll("acctPayKey")))
   {
    masterKeyAP.put(e.extractAll("acctPayKey"),e.extractAll("acctPayKey"));
    mcAL.sumAP(e.extractAll("acctPayCurr"),e.extractAll("acctPayBalance"));
   }
   if(!masterKeyAR.containsKey(e.extractAll("acctRecKey")))
   {
    masterKeyAR.put(e.extractAll("acctRecKey"),e.extractAll("acctRecKey"));
    mcAL.sumAR(e.extractAll("acctRecCurr"),e.extractAll("acctRecBalance"));
   }
   mcPY.sumAR(e.extractAll("transPayCurr"),e.extractAll("transPayAmt"));
   v2.add(pay);
   e.clear();
  }
  return v2;
 }
 
 private String fetchVolume(int ref,DBConnect db) throws SQLException
 {
  StringBuffer result = new StringBuffer(16);
  Encap e1 = null;
  Vector v1 = db.QueryMulti("transVol","*","WHERE transVolRefKey="+ref+";");
  if(v1 == null) return "0"; // no container found
  while(!v1.isEmpty())
  {
   e1 = (Encap)v1.remove(0);
   result.append(e1.extractAll("transVolVolume")+"x"+
    e1.extractAll("transVolStowage"));
   if(!v1.isEmpty()) result.append(",");
   e1.clear();
  }
  return result.toString();
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == refreshButton)
   {
    v = fetch(action,con);
    if(v == null)
    {
     Module7.infoDisplay("There are no available Pay Info at the moment",
       "Information");
     close();
     return;
    }
    labelTotal.setText(mcPY.getCurr(0)+" "+
     Module7.formNumDelimiter(mcPY.getSumAR(0).toString()));
    labelTotal1.setText(mcPY.getCurr(1)+" "+
     Module7.formNumDelimiter(mcPY.getSumAR(1).toString()));
    labelTotAP.setText(mcAL.getCurr(0)+" "+
     Module7.formNumDelimiter(mcAL.getSumAP(0).toString()));
    labelTotAP1.setText(mcAL.getCurr(1)+" "+
     Module7.formNumDelimiter(mcAL.getSumAP(1).toString()));
    labelTotAR.setText(mcAL.getCurr(0)+" "+
     Module7.formNumDelimiter(mcAL.getSumAR(0).toString()));
    labelTotAR1.setText(mcAL.getCurr(1)+" "+
     Module7.formNumDelimiter(mcAL.getSumAR(1).toString()));
 
    SwingUtilities.updateComponentTreeUI(labelTotal);
    SwingUtilities.updateComponentTreeUI(labelTotal1);
    SwingUtilities.updateComponentTreeUI(labelTotAR);
    SwingUtilities.updateComponentTreeUI(labelTotAR1);
    SwingUtilities.updateComponentTreeUI(labelTotAP);
    SwingUtilities.updateComponentTreeUI(labelTotAP1);

    td.initData(v);
    sortedModel.clearSort();
    sortedModel.renewModel(td);
    head.setModel(new ListMod(v.size()));
    table.revalidate();
    table.repaint();
   }
   else close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
  }
 }

 public void addHeaderListener()
 {
  table.getTableHeader().addMouseListener(new MouseAdapter()
  {
   JTableHeader header;
   public void mousePressed(MouseEvent event)
   {
    header = (JTableHeader)(event.getSource());
    int index = header.columnAtPoint(event.getPoint());
    int sortCol = header.getTable().convertColumnIndexToModel(index);
    schr.setPressedColumn(index);
    schr.setSelectedColumn(index);
    header.repaint();
    if(header.getTable().isEditing())
     header.getTable().getCellEditor().stopCellEditing();
    boolean isAscent = false;
    if(schr.DOWN == schr.getState(index))
     isAscent = true;
    ((SortedTableModel)header.getTable().getModel()).sortByColumn(
      sortCol,td.getColumnType(sortCol),isAscent);
   }

   public void mouseReleased(MouseEvent event) 
   {
    int col = header.columnAtPoint(event.getPoint());
    schr.setPressedColumn(-1);
    header.repaint();
   }
  });
 }


 public void close()
 {
  frame.dispose();
  System.gc();
 }

 private class tableData extends AbstractTableModel
 {
  public final int RFNO = 0;
  public final int PID  = 1;
  public final int PVOL = 2;
  public final int PDAT = 3; // Paid Date
  public final int PMET = 4; // Paid Method
  public final int PCUR = 5; // Paid Currency
  public final int PAMT = 6; // Paid Amount
  public final int PAPB = 7; // Paid Acct Payable Balance
  public final int PARB = 8; // Paid Acct Receivable Balance
  public Vector dataRow = null;
  public Vector colNames= null;
  
  public tableData(Vector ve,int action)
  {
   initColumn(action);
   initData(ve);
  }
  public void initData(Vector ve)
  { dataRow = ve; }
  public void initColumn(int action)
  {
   if(colNames == null) colNames = new Vector();
   colNames.add(new String("Ref\nNo."));
   colNames.add(new String("Pay\nID."));
   colNames.add(new String("Volume\nStowage"));
   colNames.add(new String("Pay\nDate."));
   colNames.add(new String("Pay\nMethod"));
   colNames.add(new String("Pay\nCurrency"));
   colNames.add(new String("Pay\nAmount"));
   colNames.add(new String("A/P\nBalance"));
   colNames.add(new String("A/R\nBalance"));
  }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.size(); }
  public String getColumnName(int column)
  { return (String)colNames.elementAt(column); }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public int getColumnType(int column)
  {
   if(column==RFNO || column==PID) return TableSorter.INTEGER; // INTEGER 
   if(column==PAMT || column==PAPB || column==PARB) 
    return TableSorter.BIGDEC; // BIG DECIMAL 
   if(column==PVOL) return TableSorter.STRCOMMA; // STRING W COMMA 
   if(column==PDAT) return TableSorter.DATE; // DATE
   return TableSorter.STRING; // STRING
  }
  public Object getValueAt(int row,int column)
  {
   if(row<0 || row>=getRowCount())
    return " ";
   PayData pay = (PayData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : return pay.getRFNO();
    case PID  : return pay.getPID();
    case PVOL : return pay.getPVOL();
    case PDAT : return pay.getPDAT();
    case PMET : return pay.getPMET();
    case PCUR : return pay.getPCUR();
    case PAMT : return pay.getPAMT();
    case PAPB : return pay.getPAPB();
    case PARB : return pay.getPARB();
   }
   return " ";
  }
  public void setValueAt(Object val,int row,int column)
  {
   if(row<0 || row>=getRowCount()) return;
   PayData pay = (PayData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : pay.setRFNO(((Integer)val).intValue()); break;
    case PID  : pay.setPID(((Integer)val).intValue()); break;
    case PVOL : pay.setPVOL((String)val); break;
    case PDAT : pay.setPDAT((String)val); break;
    case PMET : pay.setPMET((String)val); break;
    case PCUR : pay.setPCUR((String)val); break;
    case PAMT : pay.setPAMT((String)val); break;
    case PAPB : pay.setPAPB((String)val); break;
    case PARB : pay.setPARB((String)val); break;
   }
   dataRow.setElementAt(pay,row);
   fireTableCellUpdated(row,column);
  }
 }

 private class PayData
 {
  private int payRefNo = 0;
  private int payID = 0;
  private String payVol;
  private String payDate;
  private String payMethod;
  private String payCurr;
  private String payAmt;
  private String payAPBalance;
  private String payARBalance;

  public PayData() { }
  public PayData(int rf,int pid,String v,String pd,String pm,String pc,
   String pa,String papb,String parb,String pt)
  {
   setRFNO(rf);
   setPID(pid);
   setPVOL(v);
   setPDAT(pd);
   setPMET(pm);
   setPCUR(pc);
   setPAMT(pa);
   setPAPB(papb);
   setPARB(parb);
  }

  public void setRFNO(int rf)
  { payRefNo = rf; }
  public void setPID(int pid)
  { payID = pid; }
  public void setPVOL(String v)
  { payVol = new String(v); }
  public void setPDAT(String pd)
  { payDate = new String(pd); }
  public void setPMET(String pm) 
  { payMethod = new String(pm); }
  public void setPCUR(String pc) 
  { payCurr = new String(pc); }
  public void setPAMT(String pa) 
  { payAmt = new String(pa); }
  public void setPAPB(String papb)
  { payAPBalance = new String(papb); }
  public void setPARB(String parb)
  { payARBalance = new String(parb); }
  public Integer getRFNO()
  { return new Integer(payRefNo); }
  public Integer getPID()
  { return new Integer(payID); }
  public String getPVOL()
  { return payVol; }
  public String getPDAT()
  { return payDate; }
  public String getPMET()
  { return payMethod; }
  public String getPCUR()
  { return payCurr; }
  public String getPAMT()
  { return payAmt; }
  public String getPARB()
  { return payARBalance; }
  public String getPAPB()
  { return payAPBalance; }
 }

}
