import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.util.Vector;
import java.math.BigDecimal;
import java.sql.SQLException;

public class SummaryPayHistoryByPayID
{
 private JTable table;
 private JFrame frame;
 private tableData td;
 private String title = null;
 private JButton refreshButton;
 private JButton closeButton;
 private Vector masterData = null;
 private String con = null;
 private JList head = null;
 private StringBuffer error = new StringBuffer();
 private SortedColumnHeaderRenderer schr = null;
 private SortedTableModel sortedModel = null;
 private MultipleCurrency mcPY = new MultipleCurrency();
 private MultipleCurrency mcAL = new MultipleCurrency();

 public SummaryPayHistoryByPayID(String content)
 {
  if(content == null)
  {
   Module7.errorDisplay("Received null content","ERROR");
   return;
  }
  if(content.length()<1)
  {
   Module7.errorDisplay("Received empty content","ERROR");
   return;
  }
  con = new String(content);
  masterData = fetchREF(con);
  if(masterData == null)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   System.gc();
   return;
  }
  title = new String("Pay History By Pay ID. "+content);
  frame = new JFrame(title);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Module7.infoDisplay("Click on Close in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });

  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  td = new tableData(masterData);
  sortedModel = new SortedTableModel(td);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(sortedModel);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  schr = new SortedColumnHeaderRenderer(sortedModel,mlhr);
  int len = td.getColumnCount();
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i==td.RFNO || i==td.PCUR || i==td.PAPP)
    column = new TableColumn(i,8,render,editor);
   else
    column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(schr);
   table.addColumn(column);
  }
  head = new JList(new ListMod(masterData.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  addHeaderListener();
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  refreshButton = new JButton("Refresh");
  closeButton = new JButton("Close");
  ButtonListener bl = new ButtonListener();
  refreshButton.addActionListener(bl);
  closeButton.addActionListener(bl);
  panel.setLayout(new FlowLayout());
  panel.add(refreshButton);
  panel.add(closeButton);

  return panel;
 }

 public void addHeaderListener()
 {
  table.getTableHeader().addMouseListener(new MouseAdapter()
  {
   JTableHeader header;
   public void mousePressed(MouseEvent event)
   {
    header = (JTableHeader)(event.getSource());
    int index = header.columnAtPoint(event.getPoint());
    int sortCol = header.getTable().convertColumnIndexToModel(index);
    schr.setPressedColumn(index);
    schr.setSelectedColumn(index);
    header.repaint();
    if(header.getTable().isEditing())
     header.getTable().getCellEditor().stopCellEditing();
    boolean isAscent = false;
    if(schr.DOWN == schr.getState(index))
     isAscent = true;
    ((SortedTableModel)header.getTable().getModel()).sortByColumn(
      sortCol,td.getColumnType(sortCol),isAscent);
   }

   public void mouseReleased(MouseEvent event) 
   {
    int col = header.columnAtPoint(event.getPoint());
    schr.setPressedColumn(-1);
    header.repaint();
   }
  });
 }

 public Vector fetchREF(String content)
 {
  Vector vi = null;
  StringBuffer msg = new StringBuffer(64);
  DBConnect db = new DBConnect();
 
  msg.append("LEFT JOIN transRecord ON (transRecord.transRefKey=");
  msg.append("transPayRecord.transPayFromRefKey) ");
  msg.append("WHERE transPayKey="+content+";");
  Vector result = new Vector();
  Encap tmp = null;
  Encap tmp1= null;

  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   tmp = db.QuerySingle("transPayRecord","*",msg.toString());
   if(tmp == null)
    throw new SQLException("There is no such Pay ID exist\n");

   PayData pd = new PayData();
   pd.setRFNO(tmp.extractInteger("transRefKey",0));
   pd.setPIDT(Module7.formNDate(tmp.extractString("transInvoiceDT",null)));
   pd.setPDAT(Module7.formNDate(tmp.extractString("transPayDate",null)));
   pd.setPMET(tmp.extractString("transPayMethod",null));
   if(tmp.extractAll("transPayAcctRecKey").equalsIgnoreCase("0"))
    pd.setPAPP("A/P");
   else
    pd.setPAPP("A/R");
   pd.setPCUR(tmp.extractString("transPayCurr",null));
   pd.setPAMT(Module7.formNumDelimiter(tmp.extractAll("transPayAmt")));
   if(!tmp.extractAll("transPayMethod").equalsIgnoreCase("CASH"))
   {
    tmp1 = db.QuerySingle("transBankRecord","*",
	"WHERE transBankPayKey="+content+";");
    if(tmp1 == null)
     throw new SQLException("There is no such bank record with that pay id\n");
    pd.setPOBK(tmp1.extractAll("transBankOur"));
    pd.setPTBK(tmp1.extractAll("transBankTheir"));
    pd.setPNDC(tmp1.extractAll("transBankDocNo"));
    pd.setPNAT(tmp1.extractAll("transBankAcct"));
   }
   else
   {
    pd.setPOBK("NONE");
    pd.setPTBK("NONE");
    pd.setPNDC("NONE");
    pd.setPNAT("NONE");
   }
   if(tmp!=null) tmp.clear();
   if(tmp1!=null) tmp1.clear();
   result.add(pd);
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage()+"\n");
   if(!result.isEmpty()) result.removeAllElements();
    result = null;
  }
  finally
  {
   db.close();
  }
  return result;
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == refreshButton)
   {
    if(!masterData.isEmpty()) masterData.removeAllElements();
    masterData = fetchREF(con);
    if(masterData == null)
    {
     close();
     Module7.infoDisplay("There are no available Pay Info at the moment",
       "Information");
     return;
    }
    td.initData(masterData);
    sortedModel.clearSort();
    sortedModel.renewModel(td);
    head.setModel(new ListMod(masterData.size()));
    table.revalidate();
    table.repaint();
   }
   else close();
  }
 }

 public void close()
 {
  frame.dispose();
	System.gc();
 }

 private class tableData extends AbstractTableModel
 {
  public final int RFNO = 0;
  public final int PIDT = 1; // Invoice Date
  public final int PDAT = 2; // Paid Date
  public final int PMET = 3; // Paid Method
  public final int PAPP = 4; // Payment Apply to
  public final int PCUR = 5; // Paid Currency
  public final int PAMT = 6; // Paid Amount
  public final int POBK = 7; // Paid Our Bank
  public final int PTBK = 8; // Paid Their Bank
  public final int PNDC = 9; // Paid No Doc
  public final int PNAT =10; // Paid No Acct

  public Vector dataRow = null;
  public Vector colNames= null;
  
  public tableData(Vector ve)
  {
   initColumn();
   initData(ve);
  }
  public void initData(Vector ve)
  { dataRow = ve; }
  public void initColumn()
  {
   if(colNames == null) colNames = new Vector();
   colNames.add(new String("Ref\nNo."));
   colNames.add(new String("Invoice\nDate"));
   colNames.add(new String("Pay\nDate."));
   colNames.add(new String("Pay\nMethod"));
   colNames.add(new String("Payment\nApply To"));
   colNames.add(new String("Pay\nCurrency"));
   colNames.add(new String("Pay\nAmount"));
   colNames.add(new String("Our\nBank"));
   colNames.add(new String("Their\nBank"));
   colNames.add(new String("No\nCheque/Giro"));
   colNames.add(new String("No\nAccount"));	
  }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.size(); }
  public String getColumnName(int column)
  { return (String)colNames.elementAt(column); }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public int getColumnType(int column)
  {
   if(column==RFNO) return TableSorter.INTEGER; // INTEGER 
   if(column==PAMT) return TableSorter.BIGDEC; // BIG DECIMAL 
   if(column==PDAT || column==PIDT) return TableSorter.DATE; // DATE
   return TableSorter.STRING; // STRING
  }
  public Object getValueAt(int row,int column)
  {
   if(row<0 || row>=getRowCount())
    return " ";
   PayData pay = (PayData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : return pay.getRFNO();
    case PIDT : return pay.getPIDT();
    case PDAT : return pay.getPDAT();
    case PMET : return pay.getPMET();
    case PAPP : return pay.getPAPP();
    case PCUR : return pay.getPCUR();
    case PAMT : return pay.getPAMT();
    case POBK : return pay.getPOBK();
    case PTBK : return pay.getPTBK();
    case PNDC : return pay.getPNDC();
    case PNAT : return pay.getPNAT();
   }
   return " ";
  }
  public void setValueAt(Object val,int row,int column)
  {
   if(row<0 || row>=getRowCount()) return;
   PayData pay = (PayData)dataRow.elementAt(row);
   switch(column)
   {
    case RFNO : pay.setRFNO(((Integer)val).intValue()); break;
    case PIDT : pay.setPIDT((String)val); break;
    case PDAT : pay.setPDAT((String)val); break;
    case PMET : pay.setPMET((String)val); break;
    case PAPP : pay.setPAPP((String)val); break;
    case PCUR : pay.setPCUR((String)val); break;
    case PAMT : pay.setPAMT((String)val); break;
    case POBK : pay.setPOBK((String)val); break;
    case PTBK : pay.setPTBK((String)val); break;
    case PNDC : pay.setPNDC((String)val); break;
    case PNAT : pay.setPNAT((String)val); break;
   }
   dataRow.setElementAt(pay,row);
   fireTableCellUpdated(row,column);
  }
 }

 private class PayData
 {
  private int payRefNo = 0;
  private String payInvoiceDate = null;
  private String payDate = null;
  private String payMethod = null;
  private String payApply = null;
  private String payCurr = null;
  private String payAmt = null;
  private String payOurBank = null;
  private String payTheirBank = null; 
  private String payNoDoc = null;
  private String payNoAcct= null;

  public PayData() { }
  public PayData(int rf,
   String pidt,String pd,String pm,String papp,
   String pc,String pa,String pobk,String ptbk,String pndc,String pnat)
  {
   setRFNO(rf);
   setPIDT(pidt);
   setPDAT(pd);
   setPMET(pm);
   setPAPP(papp);
   setPCUR(pc);
   setPAMT(pa);
   setPOBK(pobk);
   setPTBK(ptbk);
   setPNDC(pndc);
   setPNAT(pnat);
  }

  public void setRFNO(int rf)
  { payRefNo = rf; }
  public void setPIDT(String pidt)
  { payInvoiceDate = pidt; }
  public void setPDAT(String pd)
  { payDate = pd; }
  public void setPMET(String pm) 
  { payMethod = pm; }
  public void setPAPP(String papp) 
  { payApply = papp; }
  public void setPCUR(String pc) 
  { payCurr = pc; }
  public void setPAMT(String pa) 
  { payAmt = pa; }
  public void setPOBK(String pobk)
  { 
   if(pobk == null || pobk.length()<=1)
    payOurBank = new String("NONE");
   else
    payOurBank = pobk; 
  }
  public void setPTBK(String ptbk)
  { 
   if(ptbk == null || ptbk.length()<=1)
    payTheirBank = new String("NONE");
   else
    payTheirBank = ptbk; 
  }
  public void setPNDC(String pndc)
  { 
   if(pndc == null || pndc.length()<=1)
    payNoDoc = new String("NONE");
   else
    payNoDoc = pndc; 
  }
  public void setPNAT(String pnat)
  { 
   if(pnat == null || pnat.length()<=1)
    payNoAcct = new String("NONE");
   else
    payNoAcct = pnat; 
  }
  public Integer getRFNO()
  { return new Integer(payRefNo); }
  public String getPIDT()
  { return payInvoiceDate; }
  public String getPDAT()
  { return payDate; }
  public String getPMET()
  { return payMethod; }
  public String getPCUR()
  { return payCurr; }
  public String getPAMT()
  { return payAmt; }
  public String getPAPP()
  { return payApply; }
  public String getPOBK()
  { return payOurBank; }
  public String getPTBK()
  { return payTheirBank; }
  public String getPNAT()
  { return payNoAcct; }
  public String getPNDC()
  { return payNoDoc; }
 }
}

