import java.math.BigDecimal;
import java.util.Date;

/**
 * @version 1.0 02/25/99
 */
public class TableSorter 
{
 public static final int INTEGER = 0;
 public static final int BIGDEC  = 1; 
 public static final int STRCOMMA= 2;
 public static final int DATE    = 3;
 public static final int RDATE   = 4;
 public static final int BOOLEAN = 5;
 public static final int STRING  = 6;
 public SortedTableModel model;
 
 public TableSorter(SortedTableModel model) 
 {
  this.model = model;
 }
 //n2 selection
 public void sort(int column,int type,boolean isAscent) 
 {   
  int n = model.getRowCount();
  int[] indexes = model.getIndexes();   
  
  for (int i=0; i<n-1; i++) 
  {
   int k = i;
   for (int j=i+1; j<n; j++) 
   {
    if(isAscent) 
    {
     if(compare(column,type,j, k) < 0) 
      k = j;
    } 
    else 
    {
     if(compare(column,type,j, k) > 0) 
      k = j;
    }
   }
   int tmp = indexes[i];
   indexes[i] = indexes[k];
   indexes[k] = tmp;
  }
 }
 // comparaters
 public int compare(int column,int type,int row1,int row2) 
 {
  Object o1 = model.getValueAt(row1, column);
  Object o2 = model.getValueAt(row2, column); 
  if(o1 == null && o2 == null) 
   return  0; 
  else if (o1 == null) 
   return -1; 
  else if (o2 == null)  
   return  1; 
  else 
  {   
   switch(type)
   {
    case INTEGER : return compare((Number)o1,(Number)o2);
    case BIGDEC  : return compare((Number)disect(o1),(Number)disect(o2)); 
    case STRCOMMA: return compareLength((String)o1,(String)o2);
    case DATE    : return compareDate((String)o1,(String)o2);
    case RDATE   : return compare((Date)o1,(Date)o2);
    case BOOLEAN : return compare((Boolean)o1,(Boolean)o2);
    case STRING  :
    default      : return ((String)o1).compareTo((String)o2);
   }
  }
 }
  
 public BigDecimal disect(Object obj)
 {
  StringBuffer tmp = new StringBuffer(20);
  String s = (String)obj;
  int pos1 = s.indexOf(","); 
  if(pos1<0) return new BigDecimal(s);
  int start = 0;
  boolean done = false;
  do
  {
   tmp.append(s.substring(start,pos1)); 
   start = pos1+1;
   pos1 = s.indexOf(",",start);
   if(pos1 < 0) done = true; 
  } while(!done);
  return new BigDecimal(tmp.toString());
 }

 public int compareDate(String s1, String s2)
 {
  int pos1 = s1.indexOf("-");
  int pos2 = s1.indexOf("-",pos1+1);
  int d1 = Integer.parseInt(s1.substring(0,pos1));
  int m1 = Integer.parseInt(s1.substring(pos1+1,pos2));
  int y1 = Integer.parseInt(s1.substring(pos2+1,s1.length()));
  pos1 = s2.indexOf("-");
  pos2 = s2.indexOf("-",pos1+1);
  int d2 = Integer.parseInt(s2.substring(0,pos1));
  int m2 = Integer.parseInt(s2.substring(pos1+1,pos2));
  int y2 = Integer.parseInt(s2.substring(pos2+1,s2.length()));
  if(y1 < y2) return -1;
  if(m1 < m2) return -1;
  if(y1 > y2) return 1;
  if(m1 > m2) return 1;
  if(d1 < d2) return -1;
  if(d1 > d2) return 1;
  return 0;
 }

 public int compare(Number o1, Number o2) 
 {
  double n1 = o1.doubleValue();
  double n2 = o2.doubleValue();
  if (n1 < n2) 
   return -1;
  else if(n1 > n2) 
   return 1;
  return 0;
 }
 
 public int compareLength(String s1,String s2)
 {
  int len1 = s1.length();
  int len2 = s2.length();
  if(len1 < len2)
   return -1;
  else if(len1 > len2)
   return 1;
  return 0;
 }

 public int compare(Date o1, Date o2) 
 {
  long n1 = o1.getTime();
  long n2 = o2.getTime();
  if(n1 < n2) 
   return -1;
  else if(n1 > n2) 
   return 1;
  return 0;
 }
  
 public int compare(Boolean o1, Boolean o2) 
 {
  boolean b1 = o1.booleanValue();
  boolean b2 = o2.booleanValue();
  if(b1 == b2) 
   return 0;
  else if(b1) 
   return 1;
  return -1;
 }
}



