import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import java.math.BigDecimal;
import java.sql.SQLException;

public class ViewByContNoSealNo
{
 private JTable table;
 private JFrame frame;
 private tableData td;
 private JButton refreshB = new JButton("Refresh");
 private JButton closeB = new JButton("Close");
 private String sendCond = null;
 private StringBuffer error = new StringBuffer();
 private StringBuffer msg = new StringBuffer(128);
 private Vector masterData = null;
 private JList head = null;
 private boolean flag = false; // false means IMPORT
 private int action = 0;

 public ViewByContNoSealNo(int act,String cont)
 {
  if(cont==null)
   error.append("Received null condition\n");
  if(act != Module7.VICT && act != Module7.VISN)
  {
   Module7.errorDisplay("No service available for the requested action: "+act,"ERROR");
   return;
  }
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR INPUT");
   return;
  }
  action = act;
  sendCond = new String(cont);
  masterData = fetchData();
  if(masterData == null)
  {
   Module7.infoDisplay("No data available for Container No.:"+sendCond+"\n","INFO");
   return;
  }
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  if(act == Module7.VICT)
   frame = new JFrame("View Info By Container No. "+sendCond);
  else
   frame = new JFrame("View Info By Seal No. "+sendCond);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    JOptionPane.showMessageDialog(frame,"Click on Close in the panel instead",
     "Information",JOptionPane.INFORMATION_MESSAGE);
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 private Vector fetchData()
 {
  if(msg.length()>0) msg.delete(0,msg.length());
  if(action == Module7.VICT) // by Container Number
  {
   msg.append("LEFT JOIN transRecord ON (transRecord.transRefKey=");
   msg.append("transContainer.transContRefNo) ");
   msg.append("LEFT JOIN customer ON (customer.customerKey=");
   msg.append("transRecord.transCustKey) ");
   msg.append("LEFT JOIN truckingCompany ON (truckingCompany.");
   msg.append("truckingCompanyKey=transRecord.transTrucking) ");
   msg.append("LEFT JOIN costRecord ON (costRecord.costFromRefKey=");
   msg.append("transRecord.transRefKey) ");
   msg.append("LEFT JOIN invoiceRecord ON (invoiceRecord.");
   msg.append("invoiceRefKey=transRecord.transRefKey) ");
   msg.append("LEFT JOIN claimableCharges ON (claimableCharges.");
   msg.append("claimableRefKey=transRecord.transRefKey) ");
   msg.append("WHERE transContNo=\""+sendCond+"\";");
  }
  else // by Seal No
  {
   msg.append("LEFT JOIN transRecord ON (transRecord.transRefKey=");
   msg.append("transContainer.transContRefNo) ");
   msg.append("LEFT JOIN customer ON (customer.customerKey=");
   msg.append("transRecord.transCustKey) ");
   msg.append("LEFT JOIN truckingCompany ON (truckingCompany.");
   msg.append("truckingCompanyKey=transRecord.transTrucking) ");
   msg.append("LEFT JOIN costRecord ON (costRecord.costFromRefKey=");
   msg.append("transRecord.transRefKey) ");
   msg.append("LEFT JOIN invoiceRecord ON (invoiceRecord.");
   msg.append("invoiceRefKey=transRecord.transRefKey) ");
   msg.append("LEFT JOIN claimableCharges ON (claimableCharges.");
   msg.append("claimableRefKey=transRecord.transRefKey) ");
   msg.append("WHERE transContSealNo=\""+sendCond+"\";");
  }
  return fetching(msg.toString());
 }

 public void close()
 {
  frame.dispose();
  System.gc();
 }

 private Vector fetching(String str)
 {
  DBConnect db = new DBConnect();
  Vector v = null;
  try
  {
   if(!db.makeConnection("LKB"))
    throw new SQLException("Failure to make connection to database\n");
   v = db.QueryMulti("transContainer","*",str);
   if(v!=null)
    v = refineResult(v,db);
   else
   {
    if(action == Module7.VICT)
     error.append("No available data for Container No."+sendCond+"\n");
    else
     error.append("No available data for Seal No."+sendCond+"\n");
   }
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage());
   if(v!=null) v.removeAllElements();
   v = null;
  }
  finally
  {
   db.close();
  }
  return v;
 }

 private Vector refineResult(Vector v,DBConnect db) throws SQLException
 {
  if(v == null)
  {
   error.append("Received a null Vector in refineResult\n");
   return null;
  }
  System.out.println("refineResult: "+v.size());
  Vector v2 = new Vector();
  Vector v3 = null;
  Encap e   = null;
  Encap e2  = null;
  int r = 0; // Ref No
  do
  {
   e = (Encap)v.remove(0);
   DBConnect.viewEncap(e);
   r = e.extractInteger("transRefKey",0);
   v2.add(new Data("Info : Ref No.",e.extractAll("transRefKey")));

   System.out.println("TransType: "+e.extractAll("transType"));
   if(e.extractAll("transType").equalsIgnoreCase("IMP"))
   {
    flag = false; // mean import
    v2.add(new Data("Info : Transaction Type","Import"));
    System.out.println("Import - flag = "+flag);
   }
   else
   {
    flag = true;
    v2.add(new Data("Info : Transaction Type","Export"));
    System.out.println("Export - flag = "+flag);
   }
   v2.add(new Data("Info : Customer Name",e.extractAll("customerName")));
   if(!flag) // Import
    v2.add(new Data("Info : Customer Address",e.extractAll("customerAddr")));
   v2.add(new Data("Info : Trucking Co.",e.extractAll("truckingName")));
   v2.add(new Data("Info : Door Location",e.extractAll("transDoorLocation")));
   v2.add(new Data("Info : Loading Port",e.extractAll("transLoadingPort")));
   v2.add(new Data("Info : Entry to Database",
    Module7.formNDate(e.extractAll("transDate"))));
   v2.add(new Data("Info : Invoice Date",
    Module7.formNDate(e.extractAll("transInvoiceDate"))));
   System.out.println("Before get imp/exp info flag = "+flag);
   if(!flag)
   {
    System.out.println("Enter Import");
    if(e2!=null && e2.getSize()>0) e2.clear();
    e2 = db.QuerySingle("impInfoRecord","*","WHERE impFromRefKey="+r+";");
    v2.add(new Data("Info : Bill of Lading No.",e2.extractAll("impBLNo")));
    v2.add(new Data("Info : Gate Out Date",
     Module7.formNDate(e2.extractAll("impGateOut"))));
    v2.add(new Data("Info : Arrival Date",
     Module7.formNDate(e2.extractAll("impArrival"))));
    v2.add(new Data("Info : Container Return Date",
     Module7.formNDate(e2.extractAll("impContReturnDate"))));
   }
   else
   {
    System.out.println("Enter Export");
    if(e2!=null && e2.getSize()>0) e2.clear();
    e2 = db.QuerySingle("expInfoRecord","*","WHERE expFromRefKey="+r+";");
    v2.add(new Data("Info : Shipping Instruction No.",
     e2.extractAll("expSINo")));
    v2.add(new Data("Info : Destination Name",e2.extractAll("expDestName")));
    v2.add(new Data("Info : Vessel Name",e2.extractAll("expVesselName")));
    v2.add(new Data("Info : Stuffing Date",
     Module7.formNDate(e2.extractAll("expStuffingDate"))));
    v2.add(new Data("Info : ETD",
     Module7.formNDate(e2.extractAll("expETD"))));
   }
   if(!e.extractAll("transInvoiceRemarks").equalsIgnoreCase("none"))
    v2.add(new Data("Info : Invoice Remarks",e.extractAll("transInvoiceRemarks")));
   if(!e.extractAll("transDebitNoteRemarks").equalsIgnoreCase("none"))
    v2.add(new Data("Info : Debit Note Remarks",e.extractAll("transDebitNoteRemarks")));
   if(!e.extractAll("transLastChange").equalsIgnoreCase("0000-00-00"))
   {
    v2.add(new Data("Info : Last Changed",
     Module7.formNDate(e.extractAll("transLastChange"))+" "+
     getName("authorized","WHERE authorizedKey="+
     e.extractAll("transLastChangeBy")+";","authorizedName",db)));
   }

   // -- Volume & Container --
   e2.clear();
   int index = 1;
   int index2;
   Encap e3 = null;
   int volKey = 0;
   Vector v5 = db.QueryMulti("transVol","*","WHERE transVolRefKey="+r+";");
   if(v5 != null)
   {
    do
    {
     e3 = (Encap)v5.remove(0);
     volKey = e3.extractInteger("transVolKey",0);
     v2.add(new Data("Info : Storage(["+index+"] Volume x Stowage Factor",
     e3.extractAll("transVolVolume")+"x"+e3.extractAll("transVolStowage")));
     index2 = 1;
     v3 = db.QueryMulti("transContainer","*","WHERE transContVolKey="+volKey+";");
     if(v3 == null)
      v2.add(new Data("Info : Storage["+index+"]","None"));
     else
     {
      do
      {
       e2 = (Encap)v3.remove(0);
       v2.add(new Data("Info : Storage["+index+"-"+index2+"] Container No.",
        e2.extractAll("transContNo")));
       v2.add(new Data("Info : Storage["+index+"-"+index2+"]Seal No.",
        e2.extractAll("transContSealNo"))); 
       if(!e2.extractAll("transContLastChange").equalsIgnoreCase("0000-00-00"))
        v2.add(new Data("Info Cont: Last Changed",
         Module7.formNDate(e2.extractAll("transContLastChange"))+" "+
         getName("authorized","WHERE authorizedKey="+
         e2.extractAll("transContLastChangeBy")+";","authorizedName",db)));
        e2.clear();
       index2++;
      }while(v3.size()>0);
     }
     index++;
     e3.clear();
    }while(!v5.isEmpty());
   }
   else
    v2.add(new Data("Info : Storage","Not Available"));

   // -- Cost --
   v2.add(new Data("Cost : Total Operational",
    e.extractAll("costTotalOpCurr")+" "+
    Module7.formNumDelimiter(e.extractAll("costTotalOp"))));
   v2.add(new Data("Cost : Trucking",e.extractAll("costTruckingCurr")+" "+
    Module7.formNumDelimiter(e.extractAll("costTrucking"))));
   if(!e.extractAll("costCommission").equalsIgnoreCase("0.00"))
    v2.add(new Data("Cost : Commission",e.extractAll("costCommissionCurr")+" "+
     Module7.formNumDelimiter(e.extractAll("costCommission"))));
   if(!e.extractAll("costLastChange").equalsIgnoreCase("0000-00-00"))
   {
    v2.add(new Data("Cost : Last Changed ",
     Module7.formNDate(e.extractAll("costLastChange"))+" "+
     getName("authorized","WHERE authorizedKey="+
     e.extractAll("costLastChangeBy")+";","authorizedName",db)));
   }

   // -- Other Cost --
   v3 = db.QueryMulti("otherCost","*","WHERE costOthRefKey="+r+";");
   if(v3!=null && v3.size()>0)
   {
    if(e2!=null&&e2.getSize()>0) e2.clear();
    do
    {
     e2 = (Encap)v3.remove(0);
     v2.add(new Data("Other Cost: "+e2.extractAll("costOthDesc"),
      e2.extractAll("costOthCurr")+" "+
      Module7.formNumDelimiter(e2.extractAll("costOthAmt"))));
     if(!e2.extractAll("costOthLastChange").equalsIgnoreCase("0000-00-00"))
      v2.add(new Data("Other Cost ["+e2.extractAll("costOthDesc")+"]: "+
       "Last Changed ",e2.extractAll("costOthCurr")+" "+
       getName("authorized","WHERE authorizedKey="+
       e2.extractAll("costOthLastChangeBy")+";","authorizedName",db)));
     e2.clear();
    }while(v3.size()>0);
   } // end of Other Cost

   // -- Claimable Charges --
   if(!e.extractAll("claimableTotalLiftOnAmt").equalsIgnoreCase("0.00"))
    v2.add(new Data("Claimable : Total Lift On",
     e.extractAll("claimableTotalLiftOnCurr")+" "+
      Module7.formNumDelimiter(e.extractAll("claimableTotalLiftOnAmt"))));
   if(!e.extractAll("claimableTotalLiftOffAmt").equalsIgnoreCase("0.00"))
    v2.add(new Data("Claimable : Total Lift Off",
     e.extractAll("claimableTotalLiftOffCurr")+" "+
     Module7.formNumDelimiter(e.extractAll("claimableTotalLiftOffAmt"))));

   v2.add(new Data("Claimable : Printable to Debt Note",
    e.extractAll("claimablePrintable")));

   // -- Claimable Other Charges --
   v3 = db.QueryMulti("claimableOtherCharges","*","WHERE claimableOthRefKey="+r+";"); 
   if(v3!=null && v3.size()>0)
   {
    if(e2!=null&&e2.getSize()>0) e2.clear();
    do
    {
     e2 = (Encap)v3.remove(0);
     v2.add(new Data("Other Claimable Charge: "+
      e2.extractAll("claimableOthDesc"),
      e2.extractAll("claimableOthCurr")+" "+
      Module7.formNumDelimiter(e2.extractAll("claimableOthAmt"))));
     if(!e2.extractAll("claimableOthLastChange").equalsIgnoreCase("0000-00-00"))
      v2.add(new Data("Other Claimable Charge ["+
      e2.extractAll("claimableOthDesc")+"]: Last Changed ",
      e2.extractAll("claimableOthLastChange")+" "+
      getName("authorized","WHERE authorizedKey="+
      e2.extractAll("claimableOthLastChangeBy")+";","authorizedName",db)));
     e2.clear();
    }while(v3.size()>0); 
   } // end of Claimable Other Charges

   // -- Invoice Charges --
   v2.add(new Data("Invoice Charge : Selling Rate",
    e.extractAll("invoiceSellCurr")+" "+
    Module7.formNumDelimiter(e.extractAll("invoiceSellAmt"))));
   if(!e.extractAll("invoiceHandleAmt").equalsIgnoreCase("0.00"))
    v2.add(new Data("Invoice Charge : Handling",
     e.extractAll("invoiceHandleCurr")+" "+
     Module7.formNumDelimiter(e.extractAll("invoiceHandleAmt"))));
	
   // -- Invoice Other Charges --
   v3 = db.QueryMulti("invoiceOtherCharges","*","WHERE invoiceOthRefKey="+r+";");
   if(v3!=null && v3.size()>0)
   {
    if(e2!=null&&e2.getSize()>0) e2.clear();
    do
    {
     e2 = (Encap)v3.remove(0);
     v2.add(new Data("Invoice Other Charge : "+
      e2.extractAll("invoiceOthDesc"),
      e2.extractAll("invoiceOthCurr")+" "+
      Module7.formNumDelimiter(e2.extractAll("invoiceOthAmt"))));
     if(!e2.extractAll("invoiceOthLastChange").equalsIgnoreCase("0000-00-00"))
     {
      v2.add(new Data("Other Invoice Charge ["+
       e2.extractAll("invoiceOthDesc")+"]: ",
       e2.extractAll("invoiceOthLastChange")+" "+
       getName("authorized","WHERE authorizedKey="+
       e2.extractAll("invoiceOthLastChangeBy")+";","authorizedName",db)));
     }
     e2.clear();
    }while(v3.size()>0);
   } // end of Invoice Other Charges

   // -- Account Receivable --
   v3 = db.QueryMulti("accountReceivable","*","WHERE acctRecFromRefKey="+r+";");
   if(v3!=null && v3.size()>0)
   {
    if(e2!=null&&e2.getSize()>0) e2.clear();
    do
    {
     e2 = (Encap)v3.remove(0);
     v2.add(new Data("Account Receivable (A/R) Total",
      e2.extractAll("acctRecCurr")+" "+
      Module7.formNumDelimiter(e2.extractAll("acctRecAmt"))));
     v2.add(new Data("Account Receivable (A/R) Balance",
      e2.extractAll("acctRecCurr")+" "+
      Module7.formNumDelimiter(e2.extractAll("acctRecBalance"))));
     if(!e2.extractAll("acctRecLastChange").equalsIgnoreCase("0000-00-00"))
     {
      v2.add(new Data("Account Receivable (above) Last Changed",
       Module7.formNDate(e2.extractAll("acctRecLastChange"))+" "+
       getName("authorized","WHERE authorizedKey="+
       e2.extractAll("acctRecLastChangeBy")+";","authorizedName",db)));
     }
     e2.clear();
    }while(v3.size()>0);
   }

   // -- Account Payable --
   v3 = db.QueryMulti("accountPayable","*","WHERE acctPayToRefKey="+r+";");
   if(v3!=null && v3.size()>0)
   {
    if(e2!=null&&e2.getSize()>0) e2.clear();
    do
    {
     e2 = (Encap)v3.remove(0);
     v2.add(new Data("Account Payable (A/P) Total",
      e2.extractAll("acctPayCurr")+" "+
      Module7.formNumDelimiter(e2.extractAll("acctPayAmt"))));
     v2.add(new Data("Account Payable (A/P) Balance",
      e2.extractAll("acctPayCurr")+" "+
      Module7.formNumDelimiter(e2.extractAll("acctPayBalance"))));
     if(!e2.extractAll("acctPayLastChange").equalsIgnoreCase("0000-00-00"))
     {
      v2.add(new Data("Account Payable (above) Last Changed",
       Module7.formNDate(e2.extractAll("acctPayLastChange"))+" "+
       getName("authorized","WHERE authorizedKey="+
       e2.extractAll("acctPayLastChangeBy")+";","authorizedName",db)));
     }
     e2.clear();
    }while(v3.size()>0);
   }
   e.clear();
  }while(v.size()>0);
  return v2;
 }

 private String getName(String tableName,String cond,String query,DBConnect db) 
	throws SQLException
 {
  Encap e = db.QuerySingle(tableName,"*",cond);
  return e.extractAll(query);
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == refreshB)
   {
    masterData = fetchData();
    if(masterData!=null)
    {
     if(error.length()==0) displayTable(masterData);
    }
   }
   else
    close();
   if(error.length()>0)
   {
    Module7.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
  }

  public void displayTable(Vector v)
  {
   td.initData(v);
   head.setModel(new ListMod(v.size()));
   table.revalidate();
   table.repaint();
   frame.invalidate();
   frame.validate();
   frame.repaint();
  }
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  ButtonListener bl = new ButtonListener();
  refreshB.addActionListener(bl);
  closeB.addActionListener(bl);
  panel.add(refreshB);
  panel.add(closeB);
  return panel;
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  td = new tableData(masterData);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(td);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  int len = td.getColumnCount();
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  head = new JList(new ListMod(masterData.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  return panel;
 }

 private class tableData extends AbstractTableModel
 {
  public final int LABEL = 0;
  public final int VALUE = 1;
  public Vector dataRow = null;
  public final String[] colNames = {"Description","Value"};
  	
  public tableData(Vector v)
  { 
   initData(v); 
   System.out.println("inside of tableData conts: "+dataRow.size());
  }
  public void initData(Vector v)
  { dataRow = v; }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.length; }
  public String getColumnName(int column)
  { return colNames[column]; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public Object getValueAt(int row,int column)
  {
   if(row<0||row>=getRowCount()) return " ";
   Data data = (Data)dataRow.get(row);
   switch(column)
   {
    case LABEL : return data.getLabel();
    case VALUE : return data.getValue();
   }
   return " ";
  }
  public void setValueAt(Object obj,int row,int column)
  {
   if(row<0||row>=getRowCount()) return;
   Data data = (Data)dataRow.get(row);
   switch(column)
   {
    case LABEL : data.setLabel((String)obj); break;
    case VALUE : data.setValue((String)obj); break;
   }
   dataRow.setElementAt(data,row);
   fireTableCellUpdated(row,column);
  }
 }

 private class Data
 {
  StringBuffer label = new StringBuffer(56);
  StringBuffer value = new StringBuffer(56);
  public Data() { }
  public Data(String s1,String s2)
  {
   setLabel(s1);
   setValue(s2);
  }
  public void setLabel(String s1)
  { 
   if(label.length()>0) label.delete(0,label.length());
   label.append(s1);
  }
  public void setValue(String s2)
  {
   if(value.length()>0) value.delete(0,value.length());
   value.append(s2);
  }
  public String getLabel()
  { return label.toString(); }
  public String getValue()
  { return value.toString(); }
 }
}

