import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import java.math.BigDecimal;
import java.sql.SQLException;

public class ViewCostByRefNo
{
 private JTable table;
 private JFrame frame;
 private tableData td;
 private JButton refreshB = null;
 private JButton closeB = null;
// private JButton printB = null;
 private String sendCond = null;
 private Vector masterData = null; 
 // false means IMPORT; true means EXPORT
 private boolean flag = false; 

 private StringBuffer error = new StringBuffer();
 private StringBuffer msg = new StringBuffer(128); // message to query

 public ViewCostByRefNo(String cont)
 {
	if(cont==null)
   error.append("Received null condition\n");
	if(error.length()>0)
  {
   errorDisplay(error.toString(),"ERROR INPUT");
	 return;
	}
	sendCond = new String(cont);
  masterData = fetchData();
	if(masterData == null)
	{
   infoDisplay("No Info available for the requested action\n","ERROR");
	 return;
	}
	else if(error.length()>0)
	{
   errorDisplay(error.toString(),"ERROR");
	 return;
	}
  frame = new JFrame();
	if(flag)
	 frame.setTitle("View Export Cost By Ref No. "+cont);
	else
	 frame.setTitle("View Import Cost By Ref No. "+cont);
	frame.addWindowListener(new WindowAdapter()
	{
   public void windowClosing(WindowEvent e)
	 {
    Module7.infoDisplay("Click on Close in the panel instead",
		 "Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		return;
	 }
	});
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 private Vector fetchData()
 {
	if(msg.length()>0) msg.delete(0,msg.length());
  msg.append("LEFT JOIN customer ON (customer.customerKey=");
	msg.append("transRecord.transCustKey) ");
	msg.append("LEFT JOIN truckingCompany ON (truckingCompany.");
	msg.append("truckingCompanyKey=transRecord.transTrucking) ");
	msg.append("LEFT JOIN transContainer ON (transContainer.transContRefNo=");
	msg.append("transRecord.transRefKey) ");
	msg.append("LEFT JOIN costRecord ON (costRecord.costFromRefKey=");
	msg.append("transRecord.transRefKey) ");
	msg.append("LEFT JOIN invoiceRecord ON (invoiceRecord.");
	msg.append("invoiceRefKey=transRecord.transRefKey) ");
	msg.append("LEFT JOIN claimableCharges ON (claimableCharges.");
	msg.append("claimableRefKey=transRecord.transRefKey) ");
	msg.append("LEFT JOIN accountReceivable ON (accountReceivable.");
	msg.append("acctRecFromRefKey=transRecord.transRefKey) ");
	msg.append("LEFT JOIN accountPayable ON (accountPayable.");
	msg.append("acctPayToRefKey=transRecord.transRefKey) ");
  msg.append("WHERE transRecord.transRefKey="+sendCond+";");
  return fetching(msg.toString());
 }

 private Vector fetching(String q)
 {
  DBConnect db = new DBConnect();
	Vector v = null;
	try
	{
   if(!db.makeConnection("LKB"))
		throw new SQLException("Failure to make connection to database\n");
	 v = db.QueryMulti("transRecord","*",q);
   if(v!=null)
    v = repackageResult(v,db);
	}
	catch(SQLException sqle)
	{
   sqle.printStackTrace(System.out);
	 error.append(sqle.getMessage());
	 if(v!=null) v.removeAllElements();
	 v = null;
	}
	finally
	{
   db.close();
	}
	return v;
 }

 private Vector repackageResult(Vector v,DBConnect db) throws SQLException
 {
	if(v==null)
	{
   error.append("Received a null Vector to repackage\n");
	 return null;
	}
  Vector v2 = new Vector();
	Vector v3 = null;
	Encap e = null;
	Encap e2 = null;
	int r = 0; // ref no
  do
	{
   e = (Encap)v.remove(0);
	 r = e.extractInteger("transRefKey",0); 

   v2.add(new Data("Info : Ref No.",e.extractAll("transRefKey")));
	 v2.add(new Data("Info : Volume",e.extractAll("transVolume")));
	 v2.add(new Data("Info : Stowage Factor",e.extractAll("transStowage")));
	 if(e.extractAll("transType").equalsIgnoreCase("IMP"))
	 {
    flag = false; // mean import
		v2.add(new Data("Info : Transaction Type","Import"));
	 }
	 else
	 {
    flag = true;
		v2.add(new Data("Info : Transaction Type","Export"));
	 }
	 v2.add(new Data("Info : Customer Name",e.extractAll("customerName")));
	 if(!flag) // Import
		v2.add(new Data("Info : Customer Address",e.extractAll("customerAddr")));
	 v2.add(new Data("Info : Trucking Co.",e.extractAll("truckingName")));
	 v2.add(new Data("Info : Door Location",e.extractAll("transDoorLocation")));
	 v2.add(new Data("Info : Loading Port",e.extractAll("transLoadingPort")));
	 v2.add(new Data("Info : Entry to Database",
			Module7.formNDate(e.extractAll("transDate"))));
	 v2.add(new Data("Info : Invoice Date",
			Module7.formNDate(e.extractAll("transInvoiceDate"))));
	 if(!flag)
	 {
		if(e2!=null && e2.getSize()>0) e2.clear();
	  e2 = db.QuerySingle("impInfoRecord","*","WHERE impFromRefKey="+r+";");
    v2.add(new Data("Info : Gate Out Date",
			 Module7.formNDate(e2.extractAll("impGateOut"))));
		v2.add(new Data("Info : Arrival Date",
			 Module7.formNDate(e2.extractAll("impArrival"))));
	 }
	 else
	 {
		if(e2!=null && e2.getSize()>0) e2.clear();
	  e2 = db.QuerySingle("expInfoRecord","*","WHERE expFromRefKey="+r+";");
    v2.add(new Data("Info : Shipping Instruction No.",
			 e2.extractAll("expSINo")));
		v2.add(new Data("Info : Bill of Lading No.",e2.extractAll("expBLNo")));
		v2.add(new Data("Info : Destination Name",e2.extractAll("expDestName")));
		v2.add(new Data("Info : Vessel Name",e2.extractAll("expVesselName")));
		v2.add(new Data("Info : Stuffing Date",
			 Module7.formNDate(e2.extractAll("expStuffingDate"))));
		v2.add(new Data("Info : ETD",
			 Module7.formNDate(e2.extractAll("expETD"))));
	 }
 
	 
   if(!e.extractAll("transLastChange").equalsIgnoreCase("0000-00-00"))
	 {
    v2.add(new Data("Info : Last Changed",
			 Module7.formNDate(e.extractAll("transLastChange"))+" "+
			 getName("authorized","WHERE authorizedKey="+
				e.extractAll("transLastChangeBy")+";","authorizedName",db)));
	 }

	 // -- Cost --
	 v2.add(new Data("Cost : Total Operational",
			e.extractAll("costTotalOpCurr")+" "+
			Module7.formNumDelimiter(e.extractAll("costTotalOp"))));
	 v2.add(new Data("Cost : Trucking",e.extractAll("costTruckingCurr")+" "+
			Module7.formNumDelimiter(e.extractAll("costTrucking"))));
	 if(!e.extractAll("costCommission").equalsIgnoreCase("0.00"))
		v2.add(new Data("Cost : Commission",e.extractAll("costCommissionCurr")+" "+
			 Module7.formNumDelimiter(e.extractAll("costCommission"))));
   if(!e.extractAll("costLastChange").equalsIgnoreCase("0000-00-00"))
	 {
    v2.add(new Data("Cost : Last Changed ",
			 Module7.formNDate(e.extractAll("costLastChange"))+" "+
			 getName("authorized","WHERE authorizedKey="+
				e.extractAll("costLastChangeBy")+";","authorizedName",db)));
	 }

	 // -- Other Cost --
	 v3 = db.QueryMulti("otherCost","*","WHERE costOthRefKey="+r+";");
	 if(v3!=null && v3.size()>0)
	 {
    do
		{
     e2 = (Encap)v3.remove(0);
     v2.add(new Data("Other Cost: "+e2.extractAll("costOthDesc"),
				e2.extractAll("costOthCurr")+" "+
				Module7.formNumDelimiter(e2.extractAll("costOthAmt"))));
		 if(!e2.extractAll("costOthLastChange").equalsIgnoreCase("0000-00-00"))
			v2.add(new Data("Other Cost ["+e2.extractAll("costOthDesc")+"]: "+
				 "Last Changed ",
				 e2.extractAll("costOthCurr")+" "+
				 getName("authorized","WHERE authorizedKey="+
					e2.extractAll("costOthLastChangeBy")+";","authorizedName",db)));
		 e2.clear();
		}while(v3.size()>0);
	 } // end of Other Cost

	 // -- Claimable Charges --
	 if(!e.extractAll("claimableTotalLiftOnAmt").equalsIgnoreCase("0.00"))
    v2.add(new Data("Claimable : Total Lift On",
			e.extractAll("claimableTotalLiftOnCurr")+" "+
			Module7.formNumDelimiter(e.extractAll("claimableTotalLiftOnAmt"))));

	 if(!e.extractAll("claimableTotalLiftOffAmt").equalsIgnoreCase("0.00"))
	  v2.add(new Data("Claimable : Total Lift Off",
			e.extractAll("claimableTotalLiftOffCurr")+" "+
			Module7.formNumDelimiter(e.extractAll("claimableTotalLiftOffAmt"))));

	 v2.add(new Data("Claimable : Printable to Debt Note",
			e.extractAll("claimablePrintable")));

	 // -- Claimable Other Charges --
	 v3 = db.QueryMulti("claimableOtherCharges","*",
		 "WHERE claimableOthRefKey="+r+";");
	 if(v3!=null && v3.size()>0)
	 {
    do
		{
     e2=(Encap)v3.remove(0);
		 v2.add(new Data("Other Claimable Charges: "+
				e2.extractAll("claimableOthDesc"),
				e2.extractAll("claimableOthCurr")+" "+
				Module7.formNumDelimiter(e2.extractAll("claimableOthAmt"))));
		 if(!e2.extractAll("claimableOthLastChange").equalsIgnoreCase("0000-00-00"))
			v2.add(new Data("Claimable Other Charge ["+
				 e2.extractAll("claimableOthDesc")+"]: "+
				 "Last Changed ",
				 e2.extractAll("claimableOthCurr")+" "+
				 getName("authorized","WHERE authorizedKey="+
					e2.extractAll("claimableOthLastChangeBy")+";","authorizedName",db)));
		 e2.clear();
		}while(v3.size()>0);
	 }

	 e.clear();
	}while(v.size()>0);
  return v2;
 }

 private String getName(String tableName,String cond,String query,DBConnect db) 
	throws SQLException
 {
  Encap e = db.QuerySingle(tableName,"*",cond);
	return e.extractAll(query);
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel(new FlowLayout());
	ButtonListener bl = new ButtonListener();
	refreshB = new JButton("Refresh");
	closeB = new JButton("Close");
//	printB = new JButton("Print");
  refreshB.addActionListener(bl);
	closeB.addActionListener(bl);
//	printB.addActionListener(bl);
//	panel.add(printB);
	panel.add(refreshB);
	panel.add(closeB);
	return panel;
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  td = new tableData(masterData);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(td);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  int len = td.getColumnCount();
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(masterData.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  panel.setPreferredSize(Module7.getAndSetDimension());
  panel.setLayout(new BorderLayout());
  JScrollPane jsp = new JScrollPane(table);
	jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
	return panel;
 }

 public void errorDisplay(String content,String title)
 {
  JOptionPane.showMessageDialog(null,content,title,
		JOptionPane.ERROR_MESSAGE);  
 }

 public void infoDisplay(String content,String title)
 {
  JOptionPane.showMessageDialog(null,content,title,
		JOptionPane.INFORMATION_MESSAGE);
 }

 public void close()
 {
  frame.dispose();
	System.gc();
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
	{
   JButton jb = (JButton)e.getSource();
	 if(jb == refreshB)
	 {
    masterData = fetchData();
		if(error.length()==0)
		{
     td.initData(masterData);
		 table.revalidate();
		 table.repaint();
		 frame.invalidate();
		 frame.validate();
		 frame.repaint();
		}
	 }
//	 else if(jb == printB)
//    proceedPrint();
	 else
		close();
	 if(error.length()>0)
	 {
    errorDisplay(error.toString(),"ERROR");
		error.delete(0,error.length());
    close();
	 }
	}

	protected void proceedPrint()
	{
   Thread t = new Thread(new Runnable()
	 {
    public void run()
		{
     PrinterJob pj = PrinterJob.getPrinterJob();
		 if(!pj.printDialog()) return;
		 PageFormat pageF = pj.defaultPage();
		 TablePrinter tablePrint = new TablePrinter(table,pageF);
		 pj.setPrintable(tablePrint);
     try
	   {
      pj.print();
		 }
	   catch(PrinterException pe)
		 {
      errorDisplay(pe.getMessage(),"ERROR");
			pe.printStackTrace(System.out);
		 }
		}
	 });
	 t.start();
	}
 }

 private class TablePrinter implements Printable,Pageable
 {
	public final int ALL_PAGES = 0;
	public final int FIRST_PAGE_ONLY = 1;
	public final int NO_PAGES = 2;

  protected JTable sendTable;
	protected PageFormat pgFormat;
  protected int headerStatus = ALL_PAGES;

	public TablePrinter(JTable tbl,PageFormat pf)
	{ 
	 sendTable = tbl; 
	 pgFormat = pf;
	}

	public int print(Graphics g,PageFormat pf,int index)
	{
	 Dimension size = null;
	 if((sendTable.getWidth()==0)||(sendTable.getHeight()==0))
		sendTable.setSize(sendTable.getPreferredSize());
	 
	 double w = sendTable.getWidth();
	 double h = sendTable.getHeight();
	 System.out.println("print tWidth : "+w);
	 System.out.println("print tHeight : "+h);
	 int posX = 0;
	 int posY = 0;
	 int pIndex = 0;
   double ix = pf.getImageableX();
	 double iy = pf.getImageableY();
	 double iw = pf.getImageableWidth();
	 double ih = pf.getImageableHeight();
	 System.out.println("imageable X = "+ix);
   System.out.println("imageable Y = "+iy);
   System.out.println("imageable Width  = "+iw);
   System.out.println("imageable Height = "+ih);
	 double scaleX = iw / w;
	 double scaleY = ih / h;
	 double scaleFactor = Math.min(scaleX,scaleY);
   System.out.println("scaleX = "+scaleX);
	 System.out.println("scaleY = "+scaleY);

/** scaling
   Graphics2D g2 = (Graphics2D)g;
	 g2.translate(ix,iy);
   g2.scale(scaleFactor,scaleFactor);	
	 disableDoubleBuffering(sendTable);
	 sendTable.paint(g2); 
   enableDoubleBuffering(sendTable);
*/

/**
	 while(posY < tHeight)
	 {
    posX = 0;
		while(posX < tWidth)
		{
     size = getPrintSize(posX,posY);
		 System.out.println("return from getPrintSize: "+size);
		 if(pIndex == index)
		 {
      paintTable(g,posX,posY,size);
			return Printable.PAGE_EXISTS;
		 }
		 pIndex++;
		 posX += size.width;
		}
		posY += size.height;
	 }
*/
	 return Printable.NO_SUCH_PAGE;
	}

  public void disableDoubleBuffering(Component c)
	{
	 RepaintManager current = RepaintManager.currentManager(c);
	 current.setDoubleBufferingEnabled(false);
	}
	public void enableDoubleBuffering(Component c)
	{
	 RepaintManager current = RepaintManager.currentManager(c);
	 current.setDoubleBufferingEnabled(true);
	}

	protected Dimension getPrintSize(int px,int py)
	{
   Rectangle rect;
	 int printWidth;
	 int printHeight;
	 int firstCol = sendTable.columnAtPoint(new Point(px,py));
	 int firstRow = sendTable.rowAtPoint(new Point(px,py));
	 int maxWidth = (int)(pgFormat.getImageableWidth());
	 int maxHeight= (int)(pgFormat.getImageableHeight());
	 if(displayHeaderOnPage(py))
		maxHeight-=sendTable.getTableHeader().getHeight();
	 int lastCol = sendTable.columnAtPoint(new Point(px+maxWidth,py));

	 if(lastCol == -1)
		printWidth = sendTable.getWidth()-px;
	 else
	 {
    rect = sendTable.getCellRect(0,lastCol-1,true);
		printWidth = rect.x+rect.width-px;
	 }
   int lastRow = sendTable.rowAtPoint(new Point(px,py+maxHeight)); 
	 if(lastRow == -1)
	  printHeight = sendTable.getHeight()-py;
	 else
	 {
		rect = sendTable.getCellRect(lastRow-1,0,true);
		printHeight = rect.y + rect.height - py;
   }
	 System.out.println("getPrintSize firstCol : "+firstCol);
	 System.out.println("getPrintSize firstRow : "+firstRow);
	 System.out.println("getPrintSize maxWidth : "+maxWidth);
	 System.out.println("getPrintSize maxHeight: "+maxHeight);
	 System.out.println("getPrintSize lastCol  : "+lastCol);
	 System.out.println("getPrintSize lastRow  : "+lastRow);
   System.out.println("getPrintSize printWidth : "+printWidth);
	 System.out.println("getPrintSize printHeight: "+printHeight);

	 return new Dimension(printWidth,printHeight);
	}

	protected void paintTable(Graphics g,int px,int py,Dimension s)
	{
   int offsetX = (int)(pgFormat.getImageableX());
	 int offsetY = (int)(pgFormat.getImageableY());
	 System.out.println("paintTable offsetX : "+offsetX);
	 System.out.println("paintTable offsetY : "+offsetY);
	 if(displayHeaderOnPage(py))
	 {
		JTableHeader header = table.getTableHeader();
		if(header.getWidth()==0 || header.getHeight()==0)
		 header.setSize(header.getPreferredSize());
    int headerHeight = header.getHeight();
	  g.translate(offsetX - px, offsetY);
	  g.clipRect(px,0,s.width,s.height+headerHeight);
//	  header.paint(g);
	  g.translate(0,headerHeight-py);
	  g.clipRect(px,py,s.width,s.height);
	 }
	 else
	 {
    g.translate(offsetX - px,offsetY - py);
		g.clipRect(px,py,s.width,s.height);
	 }
//	 sendTable.paint(g);
	
	}

	protected boolean displayHeaderOnPage(int py)
	{ 
	 return ((headerStatus==ALL_PAGES)||
		 ((headerStatus==FIRST_PAGE_ONLY)&&py==0));
	}

	public int getNumberOfPages()
	{
   Dimension size = null;
	 int tWidth = sendTable.getWidth();
	 int tHeight= sendTable.getHeight();
	 int px = 0;
	 int py = 0;
	 int pIndex = 0;
	 while(py < tHeight)
	 {
		while(px < tWidth)
		{
     size = getPrintSize(px,py);
		 px+=size.width;
		 pIndex++;
		}
    py+=size.height;
	 }
	 return pIndex;
	}

	public Printable getPrintable(int index)
	{ return this; }
	public PageFormat getPageFormat(int index)
	{ return pgFormat; }

 }

 private class tableData extends AbstractTableModel
 {
	public final int LABEL = 0;
	public final int VALUE = 1;
	public Vector dataRow = null;
  public final String[] colNames = {"Description","Value"};
	
  public tableData(Vector v)
	{ initData(v); }
  public void initData(Vector v)
	{ dataRow = v; }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.length; }
  public String getColumnName(int column)
  { return colNames[column]; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public Object getValueAt(int row,int column)
  {
   if(row<0||row>=getRowCount()) return " ";
   Data data = (Data)dataRow.get(row);
	 switch(column)
	 {
    case LABEL : return data.getLabel();
		case VALUE : return data.getValue();
	 }
	 return " ";
	}
  public void setValueAt(Object obj,int row,int column)
	{
   if(row<0||row>=getRowCount()) return;
   Data data = (Data)dataRow.get(row);
	 switch(column)
	 {
    case LABEL : data.setLabel((String)obj); break;
		case VALUE : data.setValue((String)obj); break;
	 }
	 dataRow.setElementAt(data,row);
	 fireTableCellUpdated(row,column);
	}
 }

 private class Data
 {
  StringBuffer label = new StringBuffer(56);
	StringBuffer value = new StringBuffer(56);
	public Data() { }
  public Data(String s1,String s2)
	{
   setLabel(s1);
	 setValue(s2);
	}
  public void setLabel(String s1)
	{ 
	 if(label.length()>0) label.delete(0,label.length());
	 label.append(s1);
	}
	public void setValue(String s2)
	{
	 if(value.length()>0) value.delete(0,value.length());
   value.append(s2);
	}
	public String getLabel()
	{ return label.toString(); }
	public String getValue()
	{ return value.toString(); }
 }
}
