import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.util.Vector;
import java.util.HashMap;

public class extractDiffStorage
{
 private JFrame frame;
 private JTable table;
 private tableData td;
 private JButton contButton;
 private JButton cancButton;
 private int pnumber = 0;
 private static int action = 0;
 private static HashMap map;
 private StringBuffer error = new StringBuffer(48);

 public extractDiffStorage(HashMap kmap, int act)
 {
  if(kmap == null) 
  {
   Module7.errorDisplay("Received null map","ERROR");
   return;
  }
  map = kmap;
  action = act;
  pnumber = setVolume();
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  frame = new JFrame("Extract Diff Storage");
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createTable(pnumber),BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    JOptionPane.showMessageDialog(frame,"Click on Cancel in the panel instead",
    "Information",JOptionPane.INFORMATION_MESSAGE);
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createTable(int pnumber)
 {
  td = new tableData(pnumber);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor;
   if(i == td.NOSL)
    editor = new DefaultCellEditor(new JComboBox(Module7.measCombo));
   else
    editor = new DefaultCellEditor(new JTextField());

   TableColumn column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(pnumber));
  head.setFixedCellWidth(30);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JPanel panel = new JPanel();
  panel.setLayout(new BorderLayout());
  panel.setPreferredSize(Module7.getAndSetDimension()); // set default size
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  initJButton();
  return panel;
 }

 private int setVolume()
 {
  int i = 0;
  if(action == Module7.IMPORTING)
  {
   if(map.containsKey("ImportNumStorage"))
   {
    if(Integer.parseInt((String)map.get("ImportNumStorage"))<1)
     error.append("Import Number of Storage is less than 1\n");
    else i = Integer.parseInt((String)map.get(new String("ImportNumStorage")));
   }
   else error.append("Import Number of Storage is not found in the map\n");
  }
  else // must be EXPORTING
  {
   if(map.containsKey("ExportNumStorage"))
   {
    if(Integer.parseInt((String)map.get("ExportNumStorage"))<1)
     error.append("Export Number of Storage is less than 1\n");
    else i = Integer.parseInt((String)map.get(new String("ExportNumStorage")));
   }
   else error.append("Export Number of Storage is not found in the map\n");
  }
  return i;
 }

 private void initJButton()
 {
  contButton = new JButton("Continue");
  contButton.addActionListener(new ButtonListener());
  cancButton = new JButton("Cancel");
  cancButton.addActionListener(new ButtonListener());
 }

 public JPanel createBottom()
 {
  JPanel panel = new JPanel();
  panel.setLayout(new FlowLayout());
  panel.add(contButton);
  panel.add(cancButton);
  return panel;
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   if((JButton)e.getSource() == contButton)
   {
    collectAll();
    if(error.length()==0)
    {
     new retrieveStorage(map,action);
     close();
    }
    else 
     JOptionPane.showMessageDialog(null,error.toString(),
     "INPUT ERROR",JOptionPane.ERROR_MESSAGE);
   }
   else // must be cancel button
    close();
   if(error.length()>0) error.delete(0,error.length());
   return;
  }

  private void close()
  {
   frame.dispose();
   System.gc();
  }

  public void collectAll()
  {
   StringBuffer str1 = new StringBuffer("Volume");
   StringBuffer str2 = new StringBuffer("StowageFactor");
   HashMap tmp = new HashMap();
   int len1 = str1.length();
   int len2 = str2.length();
   int row = td.rowLength;
   int col = td.colLength;
   for(int i=0;i<row;i++)
    for(int j=0;j<col;j++)
    {
     if(((String)td.getValueAt(i,j)).length()>=1)
     {
      if(((String)td.getValueAt(i,j)).compareToIgnoreCase("")!=0)
      {
       if(j == td.NOCO)
       {
        str1.append(i+1);
        tmp.put(str1.toString(),((String)td.getValueAt(i,j)).trim()); // value
        str1.delete(len1,str1.length());
       }
       else
       {
        str2.append(i+1);
        tmp.put(str2.toString(),((String)td.getValueAt(i,j)).trim());
        str2.delete(len2,str2.length());
       }
      }
      else // cell has empty content 
      {
       error.append("You must press ENTER for column: "+(i+1));
       if(j == td.NOCO)
        error.append(" of Volume\n");
       else
      	error.append(" of Stowage Factor\n");
      }
     }
     else //user does not enter any input at all
      error.append("You must fill the columns\n");
    }
   if(error.length()==0)
    for(int i=0;i<row;i++)
    {
     str1.append(i+1);
     str2.append(i+1);
     map.put(str1.toString(),(String)tmp.remove(str1.toString()));
     System.out.println("Putting into map: "+str1.toString()+","
     +(String)map.get(str1.toString()));
     map.put(str2.toString(),(String)tmp.remove(str2.toString()));
     System.out.println("Putting into map: "+str2.toString()+","
     +(String)map.get(str2.toString()));
     str1.delete(len1,str1.length());
     str2.delete(len2,str2.length());
    } 
  } // end of collectAll's method
 } // end of ButtonListener's class

 private class tableData extends AbstractTableModel
 {
  public final String[] colNames = {"Volume","Stowage Factor"};
  public final int NOCO = 0;
  public final int NOSL = 1;

  public Vector dataRow;
  public int colLength;
  public int rowLength;

  public tableData(int vol)
  {
   rowLength = vol;
   colLength = colNames.length;
   initialized();
   fillInit();
  }

  public void initialized()
  {
   dataRow = new Vector(rowLength);
   for(int i=0;i<rowLength;i++)
    dataRow.insertElementAt(new Vector(colLength),i);
  } 

  public void fillInit()
  {
   for(int i=0;i<rowLength;i++)
    for(int j=0;j<colLength;j++)
     setValueAt(new String(""),i,j);
  }

  public int getRowCount()
  { return dataRow.size(); }

  public int getColumnCount()
  { return colNames.length; }

  public Object getValueAt(int row, int column)
  { return ((Vector)dataRow.elementAt(row)).elementAt(column); }

  public String getColumnName(int column)
  { return colNames[column]; }

  public boolean isCellEditable(int row, int column)
  { return true; }

  public void setValueAt(Object val, int row, int column)
  { ((Vector)dataRow.elementAt(row)).insertElementAt(val,column); }

 } // end of tableData's private class 

} // end of extractDiffStorage's class
