import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.util.Vector;
import java.util.HashMap;

public class retrieveStorage
{
 private JFrame frame;
 private JTable table;
 private tableData td;
 private JButton contButton;
 private JButton cancButton;
 private int pnumber = 0;
 private int pvol = 0;
 private int count = 0;
 private static int action = 0;
 private static HashMap map;
 private StringBuffer error = new StringBuffer(48);
 private boolean nonFlag = false;
 private boolean directFlag = false;

 public retrieveStorage(HashMap kmap, int act)
 {
  if(kmap == null) 
  {
   Module7.errorDisplay("Received null map","ERROR");
   return;
  }
  map = kmap;
  action = act;
  setCount();
  pnumber = setVolume();
  pvol = setTotal();
  if(directFlag)
  {
   sendToOther();
   close();
   return;
  }
  if(error.length()>0)
  {
   Module7.errorDisplay(error.toString(),"ERROR");
   return;
  }
  frame = new JFrame("Retreive different storage for the "+getCount());
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createTable(pvol),BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    JOptionPane.showMessageDialog(frame,"Click on Cancel in the panel instead",
    "Information",JOptionPane.INFORMATION_MESSAGE);
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createTable(int vol)
 {
  td = new tableData(vol);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column = new TableColumn(i,30,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(vol));
  head.setFixedCellWidth(30);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JPanel panel = new JPanel();
  panel.setLayout(new BorderLayout());
  panel.setPreferredSize(Module7.getAndSetDimension()); // set default size
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  initJButton();
  return panel;
 }

 private int setTotal()
 {
  int result = 0;
  int setP = 0;
  boolean passFlag = false;
  do
  {
   setP = getCount(); 
   if(setP > pnumber)
   {
    passFlag = true;
    directFlag = true;
   }
   if(map.containsKey("StowageFactor"+setP) && !directFlag)
   {
    if(Module7.checkStowageException((String)map.get("StowageFactor"+setP)))
     setCount();
    else
     passFlag = true; 
   }
   else
    setCount();
  }while(!passFlag);

  if(!directFlag)
  {
   if(map.containsKey("Volume"+setP))
    result = Integer.parseInt((String)map.get("Volume"+setP));
   else
    error.append("map can\'t find Volume"+setP+"\n");
  }
  return result;
 }

 private int setVolume()
 {
  int i = 0;
  if(action == Module7.IMPORTING)
  {
   if(map.containsKey("ImportNumStorage"))
   {
    if(Integer.parseInt((String)map.get("ImportNumStorage"))<1)
     error.append("Import Number of Storage is less than 1\n");
    else i = Integer.parseInt((String)map.get(new String("ImportNumStorage")));
   }
   else error.append("Import Number of Storage is not found in the map\n");
  }
  else // must be EXPORTING
  {
   if(map.containsKey("ExportNumStorage"))
   {
    if(Integer.parseInt((String)map.get("ExportNumStorage"))<1)
     error.append("Export Number of Storage is less than 1\n");
    else i = Integer.parseInt((String)map.get(new String("ExportNumStorage")));
   }
   else error.append("Export Number of Storage is not found in the map\n");
  }
  return i;
 }

 private void setCount()
 {
  int tmp = 0;
  if(map.containsKey("IncrementalStorageCount"))
  {
   tmp = Integer.parseInt((String)map.get("IncrementalStorageCount")); 
   map.remove("IncrementalStorageCount");
   map.put("IncrementalStorageCount",String.valueOf(tmp+1));
   count = tmp+1;
  }
  else
  {
   map.put("IncrementalStorageCount","1");
   count = 1;
   tmp = 1;
  }
 }

 private int getCount()
 {
  if(map.containsKey("IncrementalStorageCount"))
   return Integer.parseInt((String)map.get("IncrementalStorageCount"));
  else
   error.append("Incremental Storage Count is not found\n");
  return 0;
 }

 private void initJButton()
 {
  contButton = new JButton("Continue");
  contButton.addActionListener(new ButtonListener());
  cancButton = new JButton("Cancel");
  cancButton.addActionListener(new ButtonListener());
 }

 public JPanel createBottom()
 {
  JPanel panel = new JPanel();
  panel.setLayout(new FlowLayout());
  panel.add(contButton);
  panel.add(cancButton);
  return panel;
 }


 public void sendToOther()
 {
  if(action == Module7.IMPORTING)
  {
   if(map.containsKey("ImportNumberOthCharges") ||
      map.containsKey("ImportNumberOthInvoice") ||
      map.containsKey("ImportNumberOthCost")) 
   {
    System.out.println("retrieveStorage to ProcessOther");
    new ProcessOther((HashMap)map.clone(),action);
   }
   else 
   {
    System.out.println("retrieveStorage To DataKeeper");
    new DataKeeper((HashMap)map.clone(),action);
   }
  }
  else
  {
   if(map.containsKey("ExportNumberOthCost") ||
      map.containsKey("ExportNumberOthCharges") ||
      map.containsKey("ExportNumberOthInvoice")) 
   {
    System.out.println("retrieveStorage to ProcessOther");
    new ProcessOther((HashMap)map.clone(),action);
   }
   else 
   {
    System.out.println("retrieveStorage To DataKeeper");
    new DataKeeper((HashMap)map.clone(),action);
   }
  }
 }

 public void close()
 {
  if(frame!=null) frame.dispose();
  System.gc();
 }

 private class ButtonListener implements ActionListener
 {
  private int incremental = 0;
  public void actionPerformed(ActionEvent e)
  {
   if((JButton)e.getSource() == contButton)
   {
    collectAll();
    if(error.length()==0)
    {
     incremental = getCount();
     if(incremental <= pnumber)
      new retrieveStorage(map,action);
     else
      sendToOther();
     close();
    }
    else 
     JOptionPane.showMessageDialog(null,error.toString(),
     "INPUT ERROR",JOptionPane.ERROR_MESSAGE);
   }
   else // must be cancel button
    close();
   if(error.length()>0) error.delete(0,error.length());
   return;
  }

  public void collectAll()
  {
   StringBuffer str1 = new StringBuffer("Container");
   StringBuffer str2 = new StringBuffer("Seal");
   HashMap tmp = new HashMap();
   int len1 = str1.length();
   int len2 = str2.length();
   int row = td.rowLength;
   int col = td.colLength;
   for(int i=0;i<row;i++)
    for(int j=0;j<col;j++)
    {
     if(((String)td.getValueAt(i,j)).length()>=1)
     {
      if(((String)td.getValueAt(i,j)).compareToIgnoreCase("")!=0)
      {
       if(j == td.NOCO)
       {
        str1.append(i+1);
        tmp.put(str1.toString(),((String)td.getValueAt(i,j)).trim()); // value
        str1.delete(len1,str1.length());
       }
       else
       {
        str2.append(i+1);
        tmp.put(str2.toString(),((String)td.getValueAt(i,j)).trim());
        str2.delete(len2,str2.length());
       }
      }
      else // cell has empty content 
      {
       error.append("You must press ENTER for column: "+(i+1));
       if(j == td.NOCO)
        error.append(" of No. Container\n");
       else
      	error.append(" of No. Seal\n");
      }
     }
     else //user does not enter any input at all
      error.append("You must fill the columns\n");
    }
   if(error.length()==0)
    for(int i=0;i<row;i++)
    {
     str1.append(i+1);
     str2.append(i+1);
     map.put(count+str1.toString(),(String)tmp.remove(str1.toString()));
     map.put(count+str2.toString(),(String)tmp.remove(str2.toString()));
     System.out.println("map has put "+count+str1.toString()+","+
     (String)map.get(count+str1.toString()));
     System.out.println("map has put "+count+str2.toString()+","+
     (String)map.get(count+str2.toString()));
     str1.delete(len1,str1.length());
     str2.delete(len2,str2.length());
    } 
  } // end of collectAll's method
 } // end of ButtonListener's class

 private class tableData extends AbstractTableModel
 {
  public final String[] colNames = {"No. Container","No.Seal"};
  public final int NOCO = 0;
  public final int NOSL = 1;

  public Vector dataRow;
  public int colLength;
  public int rowLength;

  public tableData(int vol)
  {
   rowLength = vol;
   colLength = colNames.length;
   initialized();
   fillInit();
  }

  public void initialized()
  {
   dataRow = new Vector(rowLength);
   for(int i=0;i<rowLength;i++)
    dataRow.insertElementAt(new Vector(colLength),i);
  } 

  public void fillInit()
  {
   for(int i=0;i<rowLength;i++)
    for(int j=0;j<colLength;j++)
     setValueAt(new String(""),i,j);
  }

  public int getRowCount()
  { return dataRow.size(); }

  public int getColumnCount()
  { return colNames.length; }

  public Object getValueAt(int row, int column)
  { return ((Vector)dataRow.elementAt(row)).elementAt(column); }

  public String getColumnName(int column)
  { return colNames[column]; }

  public boolean isCellEditable(int row, int column)
  { return true; }

  public void setValueAt(Object val, int row, int column)
  { ((Vector)dataRow.elementAt(row)).insertElementAt(val,column); }

 } // end of tableData's private class 

} // end of retrieveStorage's class
